(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;

(function(){

/////////////////////////////////////////////////////////////////////////////////////////
//                                                                                     //
// packages/fongandrew_find-and-modify/packages/fongandrew_find-and-modify.js          //
//                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////
                                                                                       //
(function () {

//////////////////////////////////////////////////////////////////////////////////
//                                                                              //
// packages/fongandrew:find-and-modify/find_and_modify.js                       //
//                                                                              //
//////////////////////////////////////////////////////////////////////////////////
                                                                                //
(function() {                                                                   // 1
  'use strict';                                                                 // 2
  // Code adapted from https://github.com/meteor/meteor/issues/1070             // 3
                                                                                // 4
  // Helper func to run shared validation code                                  // 5
  function validate(collection, args) {                                         // 6
    if(!collection._name)                                                       // 7
        throw new Meteor.Error(405,                                             // 8
                               "findAndModify: Must have collection name.");    // 9
                                                                                // 10
    if(!args)                                                                   // 11
      throw new Meteor.Error(405, "findAndModify: Must have args.");            // 12
                                                                                // 13
    if(!args.query)                                                             // 14
      throw new Meteor.Error(405, "findAndModify: Must have query.");           // 15
                                                                                // 16
    if(!args.update && !args.remove)                                            // 17
      throw new Meteor.Error(405,                                               // 18
                             "findAndModify: Must have update or remove.");     // 19
  };                                                                            // 20
                                                                                // 21
  if (Meteor.isServer) {                                                        // 22
    Mongo.Collection.prototype.findAndModify = function(args){                  // 23
      validate(this, args);                                                     // 24
                                                                                // 25
      var q = {};                                                               // 26
      q.query = args.query || {};                                               // 27
      q.sort = args.sort || {};                                                 // 28
      if (args.update)                                                          // 29
        q.update = args.update;                                                 // 30
                                                                                // 31
      q.options = {};                                                           // 32
      if (args.new !== undefined)                                               // 33
        q.options.new = args.new;                                               // 34
      if (args.remove !== undefined)                                            // 35
        q.options.remove = args.remove;                                         // 36
      if (args.upsert !== undefined)                                            // 37
        q.options.upsert = args.upsert;                                         // 38
      if (args.fields !== undefined)                                            // 39
        q.options.fields = args.fields;                                         // 40
                                                                                // 41
      var db = MongoInternals.defaultRemoteCollectionDriver().mongo.db;         // 42
      var collectionObj = db.collection(this._name);                            // 43
                                                                                // 44
      var wrappedFunc = Meteor.wrapAsync(collectionObj.findAndModify,           // 45
                                         collectionObj);                        // 46
      return wrappedFunc(                                                       // 47
        q.query,                                                                // 48
        q.sort,                                                                 // 49
        q.update,                                                               // 50
        q.options                                                               // 51
      );                                                                        // 52
    };                                                                          // 53
  }                                                                             // 54
                                                                                // 55
  if (Meteor.isClient) {                                                        // 56
    Mongo.Collection.prototype.findAndModify = function(args) {                 // 57
      validate(this, args);                                                     // 58
                                                                                // 59
      var findOptions = {};                                                     // 60
      if (args.sort !== undefined)                                              // 61
        findOptions.sort = args.sort;                                           // 62
      if (args.fields !== undefined)                                            // 63
        findOptions.fields = args.fields;                                       // 64
      if (args.skip !== undefined)                                              // 65
        findOptions.skip = args.skip;                                           // 66
                                                                                // 67
      var ret = this.findOne(args.query, findOptions);                          // 68
      if (args.remove) {                                                        // 69
        if (ret) this.remove({_id: ret._id});                                   // 70
      }                                                                         // 71
                                                                                // 72
      else {                                                                    // 73
        if (args.upsert && !ret) {                                              // 74
          var writeResult = this.upsert(args.query, args.update);               // 75
          if (writeResult.insertedId && args.new)                               // 76
            return this.findOne({_id: writeResult.insertedId}, findOptions);    // 77
          else if (findOptions.sort)                                            // 78
            return {};                                                          // 79
          return null;                                                          // 80
        }                                                                       // 81
                                                                                // 82
        else if (ret) {                                                         // 83
                                                                                // 84
          // If we're in a simulation, it's safe to call update with normal     // 85
          // selectors (which is needed, e.g., for modifiers with positional    // 86
          // operators). Otherwise, we'll have to do an _id only update to      // 87
          // get around the restriction that lets untrusted (e.g. client)       // 88
          // code update collections by _id only.                               // 89
          var enclosing = DDP._CurrentInvocation.get();                         // 90
          var alreadyInSimulation = enclosing && enclosing.isSimulation;        // 91
          if (alreadyInSimulation) {                                            // 92
            // Add _id to query because Meteor's update doesn't include certain // 93
            // options that the full findAndModify does (like sort). Create     // 94
            // shallow copy before update so as not to mess with user's         // 95
            // original query object                                            // 96
            var updatedQuery = {};                                              // 97
            for (var prop in args.query) {                                      // 98
              updatedQuery[prop] = args.query[prop];                            // 99
            }                                                                   // 100
            updatedQuery._id = ret._id;                                         // 101
            this.update(updatedQuery, args.update);                             // 102
          }                                                                     // 103
                                                                                // 104
          else {                                                                // 105
            this.update({_id: ret._id}, args.update);                           // 106
          }                                                                     // 107
                                                                                // 108
          if (args.new)                                                         // 109
            return this.findOne({_id: ret._id}, findOptions);                   // 110
        }                                                                       // 111
      }                                                                         // 112
                                                                                // 113
      return ret;                                                               // 114
    };                                                                          // 115
  }                                                                             // 116
                                                                                // 117
})();                                                                           // 118
                                                                                // 119
                                                                                // 120
                                                                                // 121
//////////////////////////////////////////////////////////////////////////////////

}).call(this);

/////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['fongandrew:find-and-modify'] = {};

})();
