var require = meteorInstall({"server":{"lib":{"constants.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/lib/constants.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// A collection of some global variables used in multiple places.                                                      //
SANDSTORM_ALTHOME = Meteor.settings && Meteor.settings.home;                                                           // 18
SANDSTORM_LOGDIR = (SANDSTORM_ALTHOME || "") + "/var/log";                                                             // 19
SANDSTORM_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandstorm";                                                       // 20
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"admin":{"system-status-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin/system-status-server.js                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 1
                                                                                                                       //
var hashSessionId = function hashSessionId(sessionId) {                                                                // 3
  return Crypto.createHash("sha256").update(sessionId).digest("base64");                                               // 4
};                                                                                                                     //
                                                                                                                       //
Meteor.publish("systemStatus", function () {                                                                           // 7
  // A pseudocollection containing the number of active grain sessions and unique                                      //
  // userIds associated with these sessions                                                                            //
  var db = this.connection.sandstormDb;                                                                                // 10
  if (!db.isAdminById(this.userId)) {                                                                                  // 11
    throw new Meteor.Error(403, "User must be admin to view system status.");                                          // 12
  }                                                                                                                    //
                                                                                                                       //
  var _this = this;                                                                                                    // 15
  var userIdToSessionHashes = {}; // Maps userId => list of (sha256(sessionId))                                        // 16
  var grainIdToSessionHashes = {}; // Maps grainId => list of (sha256(sessionId))                                      // 7
                                                                                                                       //
  var userIdCount = 0;                                                                                                 // 7
  var grainIdCount = 0;                                                                                                // 20
                                                                                                                       //
  this.added("systemStatus", "globalStatus", {                                                                         // 22
    activeUsers: userIdCount,                                                                                          // 23
    activeGrains: grainIdCount                                                                                         // 24
  });                                                                                                                  //
                                                                                                                       //
  var query = db.collections.sessions.find();                                                                          // 27
  var handle = query.observe({                                                                                         // 28
    added: function () {                                                                                               // 29
      function added(session) {                                                                                        //
        var hashedSessionId = hashSessionId(session._id);                                                              // 30
        var changed = {};                                                                                              // 31
                                                                                                                       //
        // Update userId cache.                                                                                        //
        if (session.userId) {                                                                                          // 29
          if (userIdToSessionHashes[session.userId] === undefined) {                                                   // 35
            userIdToSessionHashes[session.userId] = [];                                                                // 36
            userIdCount = userIdCount + 1;                                                                             // 37
            changed.activeUsers = userIdCount;                                                                         // 38
          }                                                                                                            //
                                                                                                                       //
          userIdToSessionHashes[session.userId] = _.union(userIdToSessionHashes[session.userId], [hashedSessionId]);   // 41
        }                                                                                                              //
                                                                                                                       //
        // Update grainId cache.                                                                                       //
        if (grainIdToSessionHashes[session.grainId] === undefined) {                                                   // 29
          grainIdToSessionHashes[session.grainId] = [];                                                                // 47
          grainIdCount = grainIdCount + 1;                                                                             // 48
          changed.activeGrains = grainIdCount;                                                                         // 49
        }                                                                                                              //
                                                                                                                       //
        grainIdToSessionHashes[session.grainId] = _.union(grainIdToSessionHashes[session.grainId], [hashedSessionId]);
                                                                                                                       //
        if (!_.isEmpty(changed)) {                                                                                     // 55
          _this.changed("systemStatus", "globalStatus", changed);                                                      // 56
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
    removed: function () {                                                                                             // 60
      function removed(session) {                                                                                      //
        var hashedSessionId = hashSessionId(session._id);                                                              // 61
        var changed = {};                                                                                              // 62
                                                                                                                       //
        if (session.userId) {                                                                                          // 64
          userIdToSessionHashes[session.userId] = _.without(userIdToSessionHashes[session.userId], hashedSessionId);   // 65
                                                                                                                       //
          if (userIdToSessionHashes[session.userId].length === 0) {                                                    // 68
            userIdToSessionHashes[session.userId] = undefined;                                                         // 69
            userIdCount = userIdCount - 1;                                                                             // 70
            changed.activeUsers = userIdCount;                                                                         // 71
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        grainIdToSessionHashes[session.grainId] = _.without(grainIdToSessionHashes[session.grainId], hashedSessionId);
                                                                                                                       //
        if (grainIdToSessionHashes[session.grainId].length === 0) {                                                    // 78
          grainIdToSessionHashes[session.grainId] = undefined;                                                         // 79
          grainIdCount = grainIdCount - 1;                                                                             // 80
          changed.activeGrains = grainIdCount;                                                                         // 81
        }                                                                                                              //
                                                                                                                       //
        if (!_.isEmpty(changed)) {                                                                                     // 84
          _this.changed("systemStatus", "globalStatus", changed);                                                      // 85
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
  this.onStop(function () {                                                                                            // 89
    handle.stop();                                                                                                     // 90
  });                                                                                                                  //
  this.ready();                                                                                                        // 92
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"drivers":{"external-ui-view.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/external-ui-view.js                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Promise = Npm.require("es6-promise").Promise;                                                                      // 18
var Capnp = Npm.require("capnp");                                                                                      // 19
var Url = Npm.require("url");                                                                                          // 20
var Http = Npm.require("http");                                                                                        // 21
var Https = Npm.require("https");                                                                                      // 22
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 23
                                                                                                                       //
WrappedUiView = function () {                                                                                          // 25
  function WrappedUiView(token, proxy) {                                                                               // 26
    (0, _classCallCheck3["default"])(this, WrappedUiView);                                                             //
                                                                                                                       //
    // TODO(someday): handle the fact that these proxies will be garbage collected every 2 minutes,                    //
    // even if it's in use.                                                                                            //
    this.token = token;                                                                                                // 29
    this.proxy = proxy;                                                                                                // 30
  }                                                                                                                    //
                                                                                                                       //
  WrappedUiView.prototype.newSession = function () {                                                                   // 25
    function newSession(userInfo, context, sessionType, sessionParams, retryCount) {                                   //
      if (sessionType !== ApiSession.typeId) {                                                                         // 34
        throw new Error("SessionType must be ApiSession.");                                                            // 35
      }                                                                                                                //
                                                                                                                       //
      retryCount = retryCount || 0;                                                                                    // 38
      var _this = this;                                                                                                // 39
                                                                                                                       //
      return this.proxy.keepAlive().then(function () {                                                                 // 41
        // ignore the passed userInfo and instead use the one associated with this                                     //
        // token TODO(someday): Merge / intersect the two userInfo objects                                             //
        // (especially permissions) rather than only taking the token's user info.                                     //
        // This will allow the caller to request only a subset of the permissions                                      //
        // granted by the token, which is useful to protect against bugs.                                              //
        var session = _this.proxy.uiView.newSession(_this.proxy.userInfo, context, sessionType, sessionParams).session;
        return { session: session };                                                                                   // 49
      })["catch"](function (error) {                                                                                   //
        return _this.proxy.maybeRetryAfterError(error, retryCount).then(function () {                                  // 51
          return _this.newSession(userInfo, context, sessionType, sessionParams, retryCount + 1);                      // 52
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return newSession;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return WrappedUiView;                                                                                                //
}();                                                                                                                   //
                                                                                                                       //
getWrappedUiViewForToken = function getWrappedUiViewForToken(token) {                                                  // 58
  var proxyPromise = getProxyForApiToken(token);                                                                       // 59
                                                                                                                       //
  return proxyPromise.then(function (proxy) {                                                                          // 61
    return { view: new WrappedUiView(token, proxy) };                                                                  // 62
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
ExternalUiView = function () {                                                                                         // 66
  function ExternalUiView(url, grainId, token) {                                                                       // 67
    (0, _classCallCheck3["default"])(this, ExternalUiView);                                                            //
                                                                                                                       //
    this.url = url;                                                                                                    // 68
    this.grainId = grainId;                                                                                            // 69
    this.token = token;                                                                                                // 70
  }                                                                                                                    //
                                                                                                                       //
  ExternalUiView.prototype.newSession = function () {                                                                  // 66
    function newSession(userInfo, context, sessionType, sessionParams) {                                               //
      if (sessionType !== ApiSession.typeId) {                                                                         // 74
        throw new Error("SessionType must be ApiSession.");                                                            // 75
      }                                                                                                                //
                                                                                                                       //
      var options = {};                                                                                                // 78
                                                                                                                       //
      if (this.token) {                                                                                                // 80
        options.headers = {                                                                                            // 81
          authorization: "Bearer " + this.token                                                                        // 82
        };                                                                                                             //
      }                                                                                                                //
                                                                                                                       //
      return { session: new Capnp.Capability(new ExternalWebSession(this.url, this.grainId, options), ApiSession) };   // 86
    }                                                                                                                  //
                                                                                                                       //
    return newSession;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return ExternalUiView;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
var responseCodes = {                                                                                                  // 90
  200: { type: "content", code: "ok" },                                                                                // 91
  201: { type: "content", code: "created" },                                                                           // 92
  202: { type: "content", code: "accepted" },                                                                          // 93
  204: { type: "noContent", shouldResetForm: false },                                                                  // 94
  205: { type: "noContent", shouldResetForm: true },                                                                   // 95
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 206: {type: 'noContent'},                                                                                         //
  // 300: {type: 'redirect'},                                                                                          //
  301: { type: "redirect", switchToGet: true, isPermanent: true },                                                     // 100
  302: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 101
  303: { type: "redirect", switchToGet: true, isPermanent: false },                                                    // 102
                                                                                                                       //
  // Unsupported until something demonstrates need.                                                                    //
  // 304: {type: 'redirect'},                                                                                          //
  // 305: {type: 'redirect'},                                                                                          //
  307: { type: "redirect", switchToGet: false, isPermanent: false },                                                   // 107
  308: { type: "redirect", switchToGet: false, isPermanent: true },                                                    // 108
  400: { type: "clientError", clientErrorCode: "badRequest", descriptionHtml: "Bad Request" },                         // 109
  403: { type: "clientError", clientErrorCode: "forbidden", descriptionHtml: "Forbidden" },                            // 110
  404: { type: "clientError", clientErrorCode: "notFound", descriptionHtml: "Not Found" },                             // 111
  405: { type: "clientError", clientErrorCode: "methodNotAllowed", descriptionHtml: "Method Not Allowed" },            // 112
  406: { type: "clientError", clientErrorCode: "notAcceptable", descriptionHtml: "Not Acceptable" },                   // 113
  409: { type: "clientError", clientErrorCode: "conflict", descriptionHtml: "Conflict" },                              // 114
  410: { type: "clientError", clientErrorCode: "gone", descriptionHtml: "Gone" },                                      // 115
  413: { type: "clientError", clientErrorCode: "requestEntityTooLarge", descriptionHtml: "Request Entity Too Large" },
  414: { type: "clientError", clientErrorCode: "requestUriTooLong", descriptionHtml: "Request-URI Too Long" },         // 117
  415: { type: "clientError", clientErrorCode: "unsupportedMediaType", descriptionHtml: "Unsupported Media Type" },    // 118
  418: { type: "clientError", clientErrorCode: "imATeapot", descriptionHtml: "I'm a teapot" },                         // 119
  500: { type: "serverError" },                                                                                        // 120
  501: { type: "serverError" },                                                                                        // 121
  502: { type: "serverError" },                                                                                        // 122
  503: { type: "serverError" },                                                                                        // 123
  504: { type: "serverError" },                                                                                        // 124
  505: { type: "serverError" }                                                                                         // 125
};                                                                                                                     //
                                                                                                                       //
ExternalWebSession = function () {                                                                                     // 128
  function ExternalWebSession(url, grainId, options) {                                                                 // 129
    (0, _classCallCheck3["default"])(this, ExternalWebSession);                                                        //
                                                                                                                       //
    var parsedUrl = Url.parse(url);                                                                                    // 130
    this.host = parsedUrl.hostname;                                                                                    // 131
    this.port = parsedUrl.port;                                                                                        // 132
    this.protocol = parsedUrl.protocol;                                                                                // 133
    this.grainId = grainId;                                                                                            // 134
    this.options = options || {};                                                                                      // 135
  }                                                                                                                    //
                                                                                                                       //
  ExternalWebSession.prototype.get = function () {                                                                     // 128
    function get(path, context) {                                                                                      //
      return this._requestHelper("GET", path, context);                                                                // 139
    }                                                                                                                  //
                                                                                                                       //
    return get;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ExternalWebSession.prototype.post = function () {                                                                    // 128
    function post(path, content, context) {                                                                            //
      return this._requestHelper("POST", path, context, content.content, content.mimeType);                            // 143
    }                                                                                                                  //
                                                                                                                       //
    return post;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  ExternalWebSession.prototype.put = function () {                                                                     // 128
    function put(path, content, context) {                                                                             //
      return this._requestHelper("PUT", path, context, content.content, content.mimeType);                             // 147
    }                                                                                                                  //
                                                                                                                       //
    return put;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ExternalWebSession.prototype["delete"] = function () {                                                               // 128
    function _delete(path, context) {                                                                                  //
      return this._requestHelper("DELETE", path, context);                                                             // 151
    }                                                                                                                  //
                                                                                                                       //
    return _delete;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  // TODO(someday): implement streaming and websockets for ExternalWebSession                                          //
  // postStreaming(path, mimeType, context) {                                                                          //
  // }                                                                                                                 //
                                                                                                                       //
  // putStreaming(path, mimeType, context) {                                                                           //
  // }                                                                                                                 //
                                                                                                                       //
  // openWebSocket(path, context, protocol, clientStream) {                                                            //
  // }                                                                                                                 //
                                                                                                                       //
  ExternalWebSession.prototype._requestHelper = function () {                                                          // 128
    function _requestHelper(method, path, context, content, contentType) {                                             //
      var _this = this;                                                                                                // 165
      var session = _this;                                                                                             // 166
      return new Promise(function (resolve, reject) {                                                                  // 167
        var options = _.clone(session.options);                                                                        // 168
        options.headers = options.headers || {};                                                                       // 169
        options.path = path;                                                                                           // 170
        options.method = method;                                                                                       // 171
        if (contentType) {                                                                                             // 172
          options.headers["content-type"] = contentType;                                                               // 173
        }                                                                                                              //
                                                                                                                       //
        // set accept header                                                                                           //
        if ("accept" in context) {                                                                                     // 167
          options.headers.accept = context.accept.map(function (acceptedType) {                                        // 178
            return acceptedType.mimeType + "; " + acceptedType.qValue;                                                 // 179
          }).join(", ");                                                                                               //
        } else if (!("accept" in options.headers)) {                                                                   //
          options.headers.accept = "*/*";                                                                              // 182
        }                                                                                                              //
                                                                                                                       //
        // set cookies                                                                                                 //
        if (context.cookies && context.cookies.length > 0) {                                                           // 167
          options.headers.cookies = options.headers.cookies || "";                                                     // 187
          context.cookies.forEach(function (keyVal) {                                                                  // 188
            options.headers.cookies += keyVal.key + "=" + keyVal.val + ",";                                            // 189
          });                                                                                                          //
          options.headers.cookies = options.headers.cookies.slice(0, -1);                                              // 191
        }                                                                                                              //
                                                                                                                       //
        options.host = session.host;                                                                                   // 194
        options.port = session.port;                                                                                   // 195
                                                                                                                       //
        var requestMethod = Http.request;                                                                              // 197
        if (session.protocol === "https:") {                                                                           // 198
          requestMethod = Https.request;                                                                               // 199
        }                                                                                                              //
                                                                                                                       //
        req = requestMethod(options, function (resp) {                                                                 // 202
          var buffers = [];                                                                                            // 203
          var statusInfo = responseCodes[resp.statusCode];                                                             // 204
                                                                                                                       //
          var rpcResponse = {};                                                                                        // 206
                                                                                                                       //
          switch (statusInfo.type) {                                                                                   // 208
            case "content":                                                                                            // 209
              resp.on("data", function (buf) {                                                                         // 210
                buffers.push(buf);                                                                                     // 211
              });                                                                                                      //
                                                                                                                       //
              resp.on("end", function () {                                                                             // 214
                var content = {};                                                                                      // 215
                rpcResponse.content = content;                                                                         // 216
                                                                                                                       //
                content.statusCode = statusInfo.code;                                                                  // 218
                if ("content-encoding" in resp.headers) content.encoding = resp.headers["content-encoding"];           // 219
                if ("content-language" in resp.headers) content.language = resp.headers["content-language"];           // 220
                if ("content-type" in resp.headers) content.language = resp.headers["content-type"];                   // 221
                if ("content-disposition" in resp.headers) {                                                           // 222
                  var disposition = resp.headers["content-disposition"];                                               // 223
                  var parts = disposition.split(";");                                                                  // 224
                  if (parts[0].toLowerCase().trim() === "attachment") {                                                // 225
                    parts.forEach(function (part) {                                                                    // 226
                      var splitPart = part.split("=");                                                                 // 227
                      if (splitPart[0].toLowerCase().trim() === "filename") {                                          // 228
                        content.disposition = { download: splitPart[1].trim() };                                       // 229
                      }                                                                                                //
                    });                                                                                                //
                  }                                                                                                    //
                }                                                                                                      //
                                                                                                                       //
                content.body = {};                                                                                     // 235
                content.body.bytes = Buffer.concat(buffers);                                                           // 236
                                                                                                                       //
                resolve(rpcResponse);                                                                                  // 238
              });                                                                                                      //
              break;                                                                                                   // 240
            case "noContent":                                                                                          // 208
              var noContent = {};                                                                                      // 242
              rpcResponse.noContent = noContent;                                                                       // 243
              noContent.setShouldResetForm = statusInfo.shouldResetForm;                                               // 244
              resolve(rpcResponse);                                                                                    // 245
              break;                                                                                                   // 246
            case "redirect":                                                                                           // 208
              var redirect = {};                                                                                       // 248
              rpcResponse.redirect = redirect;                                                                         // 249
              redirect.isPermanent = statusInfo.isPermanent;                                                           // 250
              redirect.switchToGet = statusInfo.switchToGet;                                                           // 251
              if ("location" in resp.headers) redirect.location = resp.headers.location;                               // 252
              resolve(rpcResponse);                                                                                    // 253
              break;                                                                                                   // 254
            case "clientError":                                                                                        // 208
              var clientError = {};                                                                                    // 256
              rpcResponse.clientError = clientError;                                                                   // 257
              clientError.statusCode = statusInfo.clientErrorCode;                                                     // 258
              clientError.descriptionHtml = statusInfo.descriptionHtml;                                                // 259
              resolve(rpcResponse);                                                                                    // 260
              break;                                                                                                   // 261
            case "serverError":                                                                                        // 208
              var serverError = {};                                                                                    // 263
              rpcResponse.serverError = serverError;                                                                   // 264
              clientError.descriptionHtml = statusInfo.descriptionHtml;                                                // 265
              resolve(rpcResponse);                                                                                    // 266
              break;                                                                                                   // 267
            default:                                                                                                   // 208
              // ???                                                                                                   //
              err = new Error("Invalid status code " + resp.statusCode + " received in response.");                    // 269
              reject(err);                                                                                             // 270
              break;                                                                                                   // 271
          }                                                                                                            // 208
        });                                                                                                            //
                                                                                                                       //
        req.on("error", function (e) {                                                                                 // 275
          reject(e);                                                                                                   // 276
        });                                                                                                            //
                                                                                                                       //
        req.setTimeout(15000, function () {                                                                            // 279
          req.abort();                                                                                                 // 280
          err = new Error("Request timed out.");                                                                       // 281
          err.kjType = "overloaded";                                                                                   // 282
          reject(err);                                                                                                 // 283
        });                                                                                                            //
                                                                                                                       //
        if (content) {                                                                                                 // 286
          req.end(content);                                                                                            // 287
        } else {                                                                                                       //
          req.end();                                                                                                   // 289
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return _requestHelper;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  return ExternalWebSession;                                                                                           //
}();                                                                                                                   //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"ip.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/ip.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Future = Npm.require("fibers/future");                                                                             // 17
var Net = Npm.require("net");                                                                                          // 18
var Dgram = Npm.require("dgram");                                                                                      // 19
var Promise = Npm.require("es6-promise").Promise;                                                                      // 20
var Capnp = Npm.require("capnp");                                                                                      // 21
                                                                                                                       //
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 23
                                                                                                                       //
ByteStreamConnection = function () {                                                                                   // 25
  function ByteStreamConnection(connection) {                                                                          // 26
    (0, _classCallCheck3["default"])(this, ByteStreamConnection);                                                      //
                                                                                                                       //
    this.connection = connection;                                                                                      // 27
  }                                                                                                                    //
                                                                                                                       //
  ByteStreamConnection.prototype.done = function () {                                                                  // 25
    function done() {                                                                                                  //
      this.connection.end();                                                                                           // 31
    }                                                                                                                  //
                                                                                                                       //
    return done;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  ByteStreamConnection.prototype.write = function () {                                                                 // 25
    function write(data) {                                                                                             //
      this.connection.write(data);                                                                                     // 35
    }                                                                                                                  //
                                                                                                                       //
    return write;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  // expectSize not implemented                                                                                        //
  // expectSize(size) { }                                                                                              //
                                                                                                                       //
                                                                                                                       //
  return ByteStreamConnection;                                                                                         //
}();                                                                                                                   //
                                                                                                                       //
IpInterfaceImpl = function () {                                                                                        // 42
  function IpInterfaceImpl(persistentMethods) {                                                                        // 43
    (0, _classCallCheck3["default"])(this, IpInterfaceImpl);                                                           //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 44
  }                                                                                                                    //
                                                                                                                       //
  IpInterfaceImpl.prototype.listenTcp = function () {                                                                  // 42
    function listenTcp(portNum, port) {                                                                                //
      return new Promise(function (resolve, reject) {                                                                  // 48
        var resolved = false;                                                                                          // 49
        var server = Net.createServer(function (connection) {                                                          // 50
          var wrappedConnection = new ByteStreamConnection(connection);                                                // 51
          var upstream = port.connect(wrappedConnection).upstream;                                                     // 52
                                                                                                                       //
          connection.on("data", function (data) {                                                                      // 54
            upstream.write(data);                                                                                      // 55
          });                                                                                                          //
                                                                                                                       //
          connection.on("close", function (hadError) {                                                                 // 58
            upstream.done();                                                                                           // 59
          });                                                                                                          //
                                                                                                                       //
          connection.on("error", function (err) {                                                                      // 62
            if (resolved) {                                                                                            // 63
              connection.write = errorWrite;                                                                           // 64
            } else {                                                                                                   //
              // upstream hasn't been resolved yet, so it's safe to reject                                             //
              reject(err);                                                                                             // 67
            }                                                                                                          //
          });                                                                                                          //
        });                                                                                                            //
                                                                                                                       //
        server.listen(portNum, function () {                                                                           // 72
          resolved = true;                                                                                             // 73
          resolve({ handle: server }); // server has a close method which is all we want from a handle                 // 74
        });                                                                                                            // 72
                                                                                                                       //
        server.on("error", function (err) {                                                                            // 77
          if (!resolved) {                                                                                             // 78
            reject(err);                                                                                               // 79
          }                                                                                                            //
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return listenTcp;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  IpInterfaceImpl.prototype.listenUdp = function () {                                                                  // 42
    function listenUdp(portNum, port) {                                                                                //
      return new Promise(function (resolve, reject) {                                                                  // 86
        var portMap = {};                                                                                              // 87
        var resolved = false;                                                                                          // 88
        var server = Dgram.createSocket("udp4"); // TODO(someday): handle ipv6 sockets too                             // 89
        server.bind(portNum);                                                                                          // 86
                                                                                                                       //
        server.on("listening", function () {                                                                           // 92
          // Although UDP is connectionless, we don't resolve until here so that we can handle bind                    //
          // errors such as invalid host                                                                               //
          resolved = true;                                                                                             // 95
          resolve({ handle: server }); // server has a close method which is all we want from a handle                 // 96
        });                                                                                                            // 92
                                                                                                                       //
        server.on("error", function (err) {                                                                            // 99
          // TODO(someday): do something about errors after the promise is resolved                                    //
          if (!resolved) {                                                                                             // 101
            reject(err);                                                                                               // 102
          } else {                                                                                                     //
            console.error("error in listenUdp: " + err);                                                               // 104
          }                                                                                                            //
        });                                                                                                            //
                                                                                                                       //
        var returnMap = {};                                                                                            // 108
        server.on("message", function (msg, rinfo) {                                                                   // 109
          var address = rinfo.address + "]:" + rinfo.port;                                                             // 110
          var returnPort = returnMap[address];                                                                         // 111
                                                                                                                       //
          if (!returnPort) {                                                                                           // 113
            returnMap[address] = returnPort = new BoundUdpPortImpl(server, rinfo.address, rinfo.port);                 // 114
          }                                                                                                            //
                                                                                                                       //
          port.send(msg, returnPort);                                                                                  // 117
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return listenUdp;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  return IpInterfaceImpl;                                                                                              //
}();                                                                                                                   //
                                                                                                                       //
makeIpInterface = function makeIpInterface(persistentMethods) {                                                        // 123
  return new Capnp.Capability(new IpInterfaceImpl(persistentMethods), IpRpc.PersistentIpInterface);                    // 124
};                                                                                                                     //
                                                                                                                       //
BoundUdpPortImpl = function () {                                                                                       // 127
  function BoundUdpPortImpl(server, address, port) {                                                                   // 128
    (0, _classCallCheck3["default"])(this, BoundUdpPortImpl);                                                          //
                                                                                                                       //
    this.server = server;                                                                                              // 129
    this.address = address;                                                                                            // 130
    this.port = port;                                                                                                  // 131
  }                                                                                                                    //
                                                                                                                       //
  BoundUdpPortImpl.prototype.send = function () {                                                                      // 127
    function send(message, returnPort) {                                                                               //
      // TODO(someday): this whole class is a hack to deal with the fact that we can't compare                         //
      // capabilities or build a map with them. What we should be doing is mapping all ports to                        //
      // their raw physical address/port, and using that here                                                          //
      this.server.send(message, 0, message.length, this.port, this.address);                                           // 138
    }                                                                                                                  //
                                                                                                                       //
    return send;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return BoundUdpPortImpl;                                                                                             //
}();                                                                                                                   //
                                                                                                                       //
var bits16 = Bignum(1).shiftLeft(16).sub(1);                                                                           // 142
var bits32 = Bignum(1).shiftLeft(32).sub(1);                                                                           // 143
                                                                                                                       //
var intToIpv4 = function intToIpv4(num) {                                                                              // 145
  var part1 = num & 255;                                                                                               // 146
  var part2 = num >> 8 & 255;                                                                                          // 147
  var part3 = num >> 16 & 255;                                                                                         // 148
  var part4 = num >> 24 & 255;                                                                                         // 149
                                                                                                                       //
  return part4 + "." + part3 + "." + part2 + "." + part1;                                                              // 151
};                                                                                                                     //
                                                                                                                       //
var addressToString = function addressToString(address) {                                                              // 154
  var ipv6num = Bignum(address.upper64).shiftLeft(64).add(Bignum(address.lower64));                                    // 155
                                                                                                                       //
  if (ipv6num.shiftRight(32).eq(bits16)) {                                                                             // 157
    // this is an ipv4 address, we should return it as such                                                            //
    var ipv4num = ipv6num.and(bits32).toNumber();                                                                      // 159
    return intToIpv4(ipv4num);                                                                                         // 160
  }                                                                                                                    //
                                                                                                                       //
  var hex = ipv6num.toString(16);                                                                                      // 163
  var numColons = 0;                                                                                                   // 164
  var out = "";                                                                                                        // 165
                                                                                                                       //
  for (var i = 0; i < hex.length; ++i) {                                                                               // 167
    // start with lower bits of address and build the output in reverse                                                //
    // this ensures that we can place a colon every 4 characters                                                       //
    out += hex[hex.length - 1 - i];                                                                                    // 170
    if ((i + 1) % 4 === 0) {                                                                                           // 171
      out += ":";                                                                                                      // 172
      ++numColons;                                                                                                     // 173
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Double colon represents all bits being 0                                                                          //
  if (numColons < 7) {                                                                                                 // 154
    out += "::";                                                                                                       // 179
  }                                                                                                                    //
                                                                                                                       //
  return out.split("").reverse().join("");                                                                             // 182
};                                                                                                                     //
                                                                                                                       //
var addressType = function addressType(address) {                                                                      // 185
  var type = "udp4";                                                                                                   // 186
                                                                                                                       //
  // Check if it's an ipv6 address                                                                                     //
  // TODO(someday): make this less hacky and change address to explicitly pass this information                        //
  if (address.indexOf(":") != -1) {                                                                                    // 185
    type = "udp6";                                                                                                     // 191
  }                                                                                                                    //
                                                                                                                       //
  return type;                                                                                                         // 194
};                                                                                                                     //
                                                                                                                       //
IpNetworkImpl = function () {                                                                                          // 197
  function IpNetworkImpl(persistentMethods) {                                                                          // 198
    (0, _classCallCheck3["default"])(this, IpNetworkImpl);                                                             //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 199
  }                                                                                                                    //
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHost = function () {                                                                // 197
    function getRemoteHost(address) {                                                                                  //
      return { host: new IpRemoteHostImpl(address) };                                                                  // 203
    }                                                                                                                  //
                                                                                                                       //
    return getRemoteHost;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  IpNetworkImpl.prototype.getRemoteHostByName = function () {                                                          // 197
    function getRemoteHostByName(address) {                                                                            //
      return { host: new IpRemoteHostImpl(address) };                                                                  // 207
    }                                                                                                                  //
                                                                                                                       //
    return getRemoteHostByName;                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  return IpNetworkImpl;                                                                                                //
}();                                                                                                                   //
                                                                                                                       //
makeIpNetwork = function makeIpNetwork(persistentMethods) {                                                            // 211
  return new Capnp.Capability(new IpNetworkImpl(persistentMethods), IpRpc.PersistentIpNetwork);                        // 212
};                                                                                                                     //
                                                                                                                       //
IpRemoteHostImpl = function () {                                                                                       // 215
  function IpRemoteHostImpl(address) {                                                                                 // 216
    (0, _classCallCheck3["default"])(this, IpRemoteHostImpl);                                                          //
                                                                                                                       //
    if (address.upper64 || address.upper64 === 0) {                                                                    // 217
      // address is an ip.capnp:IpAddress, we need to convert it                                                       //
      this.address = addressToString(address);                                                                         // 219
    } else {                                                                                                           //
      this.address = address;                                                                                          // 221
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  IpRemoteHostImpl.prototype.getTcpPort = function () {                                                                // 215
    function getTcpPort(portNum) {                                                                                     //
      return { port: new TcpPortImpl(this.address, portNum) };                                                         // 226
    }                                                                                                                  //
                                                                                                                       //
    return getTcpPort;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  IpRemoteHostImpl.prototype.getUdpPort = function () {                                                                // 215
    function getUdpPort(portNum) {                                                                                     //
      return { port: new UdpPortImpl(this.address, portNum) };                                                         // 230
    }                                                                                                                  //
                                                                                                                       //
    return getUdpPort;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return IpRemoteHostImpl;                                                                                             //
}();                                                                                                                   //
                                                                                                                       //
TcpPortImpl = function () {                                                                                            // 234
  function TcpPortImpl(address, portNum) {                                                                             // 235
    (0, _classCallCheck3["default"])(this, TcpPortImpl);                                                               //
                                                                                                                       //
    this.address = address;                                                                                            // 236
    this.port = portNum;                                                                                               // 237
  }                                                                                                                    //
                                                                                                                       //
  TcpPortImpl.prototype.connect = function () {                                                                        // 234
    function connect(downstream) {                                                                                     //
      var _this = this;                                                                                                // 241
      var resolved = false;                                                                                            // 242
      return new Promise(function (resolve, reject) {                                                                  // 243
        var client = Net.connect({ host: _this.address, port: _this.port }, function () {                              // 244
          resolved = true;                                                                                             // 245
          resolve({ upstream: new ByteStreamConnection(client) });                                                     // 246
        });                                                                                                            //
                                                                                                                       //
        client.on("data", function (data) {                                                                            // 249
          downstream.write(data);                                                                                      // 250
        });                                                                                                            //
                                                                                                                       //
        client.on("close", function (hadError) {                                                                       // 253
          downstream.done();                                                                                           // 254
        });                                                                                                            //
                                                                                                                       //
        client.on("error", function (err) {                                                                            // 257
          if (resolved) {                                                                                              // 258
            client.write = errorWrite;                                                                                 // 259
          } else {                                                                                                     //
            // upstream hasn't been resolved yet, so it's safe to reject                                               //
            reject(err);                                                                                               // 262
          }                                                                                                            //
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return connect;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  return TcpPortImpl;                                                                                                  //
}();                                                                                                                   //
                                                                                                                       //
var errorWrite = function errorWrite(data) {                                                                           // 269
  throw new Error("error occurred in connection");                                                                     // 270
};                                                                                                                     //
                                                                                                                       //
UdpPortImpl = function () {                                                                                            // 273
  function UdpPortImpl(address, portNum) {                                                                             // 274
    (0, _classCallCheck3["default"])(this, UdpPortImpl);                                                               //
                                                                                                                       //
    this.address = address;                                                                                            // 275
    this.port = portNum;                                                                                               // 276
                                                                                                                       //
    var type = addressType(address);                                                                                   // 278
    this.socket = Dgram.createSocket(type);                                                                            // 279
                                                                                                                       //
    // TODO(someday): close socket after a certain time of inactivity?                                                 //
    // This may be pointless since grains are killed frequently when not in use anyways                                //
                                                                                                                       //
    // Temporary hack. We only expect clients to pass in a single return port, so we'll store it                       //
    // and only send replies here.                                                                                     //
    // This will be changed to be correct when equality comparisons are added to capabilities.                         //
    this.returnPort = null;                                                                                            // 274
                                                                                                                       //
    var _this = this;                                                                                                  // 289
    this.socket.on("message", function (msg, rinfo) {                                                                  // 290
      if (_this.returnPort) {                                                                                          // 291
        _this.returnPort.send(msg, _this);                                                                             // 292
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  UdpPortImpl.prototype.send = function () {                                                                           // 273
    function send(message, returnPort) {                                                                               //
      this.returnPort = returnPort;                                                                                    // 298
      this.socket.send(message, 0, message.length, this.port, this.address);                                           // 299
                                                                                                                       //
      // TODO(someday): use callback to catch errors and do something with them                                        //
    }                                                                                                                  // 297
                                                                                                                       //
    return send;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return UdpPortImpl;                                                                                                  //
}();                                                                                                                   //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"mail.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/drivers/mail.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Promise = Npm.require("es6-promise").Promise;                                                                      // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 22
var EmailImpl = Capnp.importSystem("sandstorm/email-impl.capnp");                                                      // 23
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 24
var SupervisorCapnp = Capnp.importSystem("sandstorm/supervisor.capnp");                                                // 25
var Supervisor = SupervisorCapnp.Supervisor;                                                                           // 26
var SystemPersistent = SupervisorCapnp.SystemPersistent;                                                               // 27
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 28
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 30
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 32
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 33
                                                                                                                       //
var DAILY_LIMIT = 50;                                                                                                  // 35
var RECIPIENT_LIMIT = 20;                                                                                              // 36
                                                                                                                       //
var CLIENT_TIMEOUT = 15000; // 15s                                                                                     // 38
                                                                                                                       //
// Every day, reset all per-user sent counts to zero.                                                                  //
// TODO(cleanup): Consider a more granular approach. For example, each user could have a timer                         //
//   after which their count will reset. We'd only check the timer when that user is trying to                         //
//   send a new message. This avoids a global query.                                                                   //
if (!Meteor.settings.replicaNumber) {                                                                                  // 44
  // only first replica                                                                                                //
  SandstormDb.periodicCleanup(86400000, function () {                                                                  // 45
    Meteor.users.update({ dailySentMailCount: { $exists: true } }, { $unset: { dailySentMailCount: "" } }, { multi: true });
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 52
  var SANDSTORM_SMTP_PORT = parseInt(process.env.SANDSTORM_SMTP_PORT, 10) || 30025;                                    // 53
  var BIND_IP = process.env.BIND_IP || "127.0.0.1";                                                                    // 54
                                                                                                                       //
  simplesmtp.createSimpleServer({ SMTPBanner: "Sandstorm Mail Server" }, function (req) {                              // 56
    var mailparser = new MailParser();                                                                                 // 57
    req.pipe(mailparser);                                                                                              // 58
                                                                                                                       //
    mailparser.on("end", function (mail) {                                                                             // 60
      // Wrap in outer promise for easier error handling.                                                              //
      Promise.resolve().then(function () {                                                                             // 62
        // Extract the 'from' address.                                                                                 //
        var from = void 0;                                                                                             // 64
        if (mail.from && mail.from.length > 0) {                                                                       // 65
          // It's theoretically possible for the message to have multiple 'from' headers, but this                     //
          // never really happens in legitimate practice so we'll just take the first one.                             //
          from = mail.from[0];                                                                                         // 68
        } else {                                                                                                       //
          // The mail body is missing a 'From:' header. We'll use req.from instead. Note that                          //
          // req.from is actually the bounce address, which is sometimes *not* the original sender                     //
          // but rather some intermediate agent (e.g. a mailing list daemon). See:                                     //
          //   http://en.wikipedia.org/wiki/Bounce_address                                                             //
          // TODO(someday): Is this really right, or should we report a blank address instead?                         //
          from = { address: req.from, name: false };                                                                   // 75
        }                                                                                                              //
                                                                                                                       //
        var attachments = [];                                                                                          // 78
        if (mail.attachments) {                                                                                        // 79
          attachments = mail.attachments.map(function (attachment) {                                                   // 80
            var disposition = attachment.contentDisposition || "attachment";                                           // 81
            disposition += ';\n\tfilename="' + (attachment.fileName || attachment.generatedFileName) + '"';            // 82
            return {                                                                                                   // 83
              contentType: attachment.contentType,                                                                     // 84
              contentDisposition: disposition,                                                                         // 85
              contentId: attachment.contentId,                                                                         // 86
              content: attachment.content                                                                              // 87
            };                                                                                                         //
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        if (mail.replyTo && mail.replyTo.length > 1) {                                                                 // 92
          console.error("More than one reply-to address address was received in an email.");                           // 93
        }                                                                                                              //
                                                                                                                       //
        var mailMessage = {                                                                                            // 96
          // Note that converting the date to nanoseconds actually goes outside the range of                           //
          // integers that Javascript can represent precisely. But this is OK because dates aren't                     //
          // precise anyway.                                                                                           //
          date: (mail.date || new Date()).getTime() * 1000000,                                                         // 100
          from: from,                                                                                                  // 101
          to: mail.to,                                                                                                 // 102
          cc: mail.cc || [],                                                                                           // 103
          bcc: mail.bcc || [],                                                                                         // 104
          replyTo: mail.replyTo && mail.replyTo[0] || {},                                                              // 105
          messageId: mail.headers["message-id"] || Meteor.uuid() + "@" + HOSTNAME,                                     // 106
          references: mail.references || [],                                                                           // 107
          inReplyTo: mail.inReplyTo || [],                                                                             // 108
          subject: mail.subject || "",                                                                                 // 109
          text: mail.text || null,                                                                                     // 110
          html: mail.html || null,                                                                                     // 111
          attachments: attachments                                                                                     // 112
        };                                                                                                             //
                                                                                                                       //
        // Get list of grain IDs.                                                                                      //
        var grainPublicIds = _.uniq(req.to.map(function (deliverTo) {                                                  // 62
          // simplesmtp already validates that the address contains an @.                                              //
          // To simplify things, we ignore the hostname part of the address and assume that the                        //
          // message would not have been sent here if it weren't intended for our host. Usually                        //
          // there will be an nginx frontend verifying hostnames anyway. Grain public IDs are                          //
          // globally unique anyway, so an e-mail meant for another server presumably won't match                      //
          // any ID at this one anyway.                                                                                //
          return deliverTo.slice(0, deliverTo.indexOf("@"));                                                           // 123
        }));                                                                                                           //
                                                                                                                       //
        // Deliver to each grain in parallel.                                                                          //
        return Promise.all(grainPublicIds.map(function (publicId) {                                                    // 62
          // Wrap in a function so that we can call it recursively to retry.                                           //
          var tryDeliver = function tryDeliver(retryCount) {                                                           // 129
            var grainId = void 0;                                                                                      // 130
            return inMeteor(function () {                                                                              // 131
              var grain = Grains.findOne({ publicId: publicId }, { fields: {} });                                      // 132
              if (grain) {                                                                                             // 133
                grainId = grain._id;                                                                                   // 134
                return globalBackend.continueGrain(grainId, retryCount > 0);                                           // 135
              } else {                                                                                                 //
                // TODO(someday): We really ought to rig things up so that the 'RCPT TO' SMTP command                  //
                //   fails in this case, but simplesmtp doesn't appear to support that.                                //
                throw new Error("No such grain: " + publicId);                                                         // 139
              }                                                                                                        //
            }).then(function (grainInfo) {                                                                             //
              var supervisor = grainInfo.supervisor;                                                                   // 142
              var uiView = supervisor.getMainView().view;                                                              // 143
                                                                                                                       //
              // Create an arbitrary struct to use as the session params. E-mail sessions actually                     //
              // require no params, but node-capnp won't let us pass null and we don't have an                         //
              // EmptyStruct type available, so we just use EmailAddress, but any struct type would                    //
              // work.                                                                                                 //
              // TODO(cleanup): Fix node-capnp to accept null.                                                         //
              var emptyParams = Capnp.serialize(EmailRpc.EmailAddress, {});                                            // 141
                                                                                                                       //
              // Create a new session of type HackEmailSession. This is a short-term hack until                        //
              // persistent capabilities and the Powerbox are implemented. We need to pass along a                     //
              // HackSessionContext because old versions of sandstorm-http-bridge always use                           //
              // the context of the most recent session; if an old RoundCube grain has a                               //
              // WebSession open, receives an email, and then tries to send an email, the request                      //
              // will go out on the SessionContext associated with the HackEmailSession that                           //
              // delivered the email.                                                                                  //
              var session = uiView.newSession({}, makeHackSessionContext(grainId), "0xc3b5ced7344b04a6", emptyParams).session.castAs(EmailSendPort);
              return session.send(mailMessage);                                                                        // 163
            })["catch"](function (err) {                                                                               //
              if (SandstormBackend.shouldRestartGrain(err, retryCount)) {                                              // 165
                return tryDeliver(retryCount + 1);                                                                     // 166
              } else {                                                                                                 //
                throw err;                                                                                             // 168
              }                                                                                                        //
            });                                                                                                        //
          };                                                                                                           //
                                                                                                                       //
          return tryDeliver(0);                                                                                        // 173
        }));                                                                                                           //
      }).then(function () {                                                                                            //
        req.accept();                                                                                                  // 176
      }, function (err) {                                                                                              //
        console.error("E-mail delivery failure:", err.stack);                                                          // 178
        req.reject(err.message);                                                                                       // 179
      });                                                                                                              //
    });                                                                                                                //
  }).listen(SANDSTORM_SMTP_PORT, BIND_IP);                                                                             //
});                                                                                                                    //
                                                                                                                       //
function formatAddress(field) {                                                                                        // 185
  if (!field) {                                                                                                        // 186
    return null;                                                                                                       // 187
  }                                                                                                                    //
                                                                                                                       //
  if (Array.isArray(field)) {                                                                                          // 190
    return field.map(formatAddress);                                                                                   // 191
  }                                                                                                                    //
                                                                                                                       //
  if (field.name) {                                                                                                    // 194
    return field.name + " <" + field.address + ">";                                                                    // 195
  }                                                                                                                    //
                                                                                                                       //
  return field.address;                                                                                                // 198
}                                                                                                                      //
                                                                                                                       //
hackSendEmail = function hackSendEmail(session, email) {                                                               // 201
  return inMeteor(function () {                                                                                        // 202
    var recipientCount = 0;                                                                                            // 203
    recipientCount += email.to ? email.to.length : 0;                                                                  // 204
    recipientCount += email.cc ? email.cc.length : 0;                                                                  // 205
    recipientCount += email.bcc ? email.bcc.length : 0;                                                                // 206
    if (recipientCount > RECIPIENT_LIMIT) {                                                                            // 207
      throw new Error("Sorry, Sandstorm currently only allows you to send an e-mail to " + RECIPIENT_LIMIT + " recipients at a time, for spam control. Consider setting up a mailing list. " + "Please feel free to contact us if this is a problem for you.");
    }                                                                                                                  //
                                                                                                                       //
    // Overwrite the 'from' address with the grain's address.                                                          //
    if (!email.from) {                                                                                                 // 202
      email.from = {};                                                                                                 // 216
    }                                                                                                                  //
                                                                                                                       //
    var grainAddress = session._getAddress();                                                                          // 219
    var userAddress = session._getUserAddress();                                                                       // 220
                                                                                                                       //
    // First check if we're changing the from address, and if so, move it to reply-to                                  //
    if (email.from.address !== grainAddress && email.from.address !== userAddress.address) {                           // 202
      throw new Error("FROM header in outgoing emails need to equal either " + grainAddress + " or " + userAddress.address + ". Yours was: " + email.from.address);
    }                                                                                                                  //
                                                                                                                       //
    var mc = new MailComposer();                                                                                       // 229
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 231
      from: formatAddress(email.from),                                                                                 // 232
      to: formatAddress(email.to),                                                                                     // 233
      cc: formatAddress(email.cc),                                                                                     // 234
      bcc: formatAddress(email.bcc),                                                                                   // 235
      replyTo: formatAddress(email.replyTo),                                                                           // 236
      subject: email.subject,                                                                                          // 237
      text: email.text,                                                                                                // 238
      html: email.html                                                                                                 // 239
    });                                                                                                                //
                                                                                                                       //
    var envelope = mc.getEnvelope();                                                                                   // 242
    envelope.from = grainAddress;                                                                                      // 243
                                                                                                                       //
    mc.setMessageOption({                                                                                              // 245
      envelope: envelope                                                                                               // 246
    });                                                                                                                //
                                                                                                                       //
    var headers = {};                                                                                                  // 249
    if (email.messageId) {                                                                                             // 250
      mc.addHeader("message-id", email.messageId);                                                                     // 251
    }                                                                                                                  //
                                                                                                                       //
    if (email.references) {                                                                                            // 254
      mc.addHeader("references", email.references);                                                                    // 255
    }                                                                                                                  //
                                                                                                                       //
    if (email.messageId) {                                                                                             // 258
      mc.addHeader("in-reply-to", email.inReplyTo);                                                                    // 259
    }                                                                                                                  //
                                                                                                                       //
    if (email.date) {                                                                                                  // 262
      var date = new Date(email.date / 1000000);                                                                       // 263
      if (!isNaN(date.getTime())) {                                                                                    // 264
        // Check to make sure date is valid                                                                            //
        mc.addHeader("date", date.toUTCString());                                                                      // 265
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    if (email.attachments) {                                                                                           // 269
      email.attachments.forEach(function (attachment) {                                                                // 270
        mc.addAttachment({                                                                                             // 271
          cid: attachment.contentId,                                                                                   // 272
          contentType: attachment.contentType,                                                                         // 273
          contentDisposition: attachment.contentDisposition,                                                           // 274
          contents: attachment.content                                                                                 // 275
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    var grain = Grains.findOne(session.grainId);                                                                       // 280
    if (!grain) throw new Error("Grain does not exist.");                                                              // 281
                                                                                                                       //
    var user = Meteor.users.findAndModify({                                                                            // 283
      query: { _id: grain.userId },                                                                                    // 284
      update: {                                                                                                        // 285
        $inc: {                                                                                                        // 286
          dailySentMailCount: 1                                                                                        // 287
        }                                                                                                              //
      },                                                                                                               //
      fields: { dailySentMailCount: 1 }                                                                                // 290
    });                                                                                                                //
    if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                      // 292
      throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
    }                                                                                                                  //
                                                                                                                       //
    SandstormEmail.rawSend(mc);                                                                                        // 299
  }.bind(_this))["catch"](function (err) {                                                                             //
    console.error("Error sending e-mail:", err.stack);                                                                 // 301
    throw err;                                                                                                         // 302
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
var EmailVerifierImpl = function () {                                                                                  //
  function EmailVerifierImpl(persistentMethods, id, params) {                                                          // 307
    (0, _classCallCheck3["default"])(this, EmailVerifierImpl);                                                         //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 308
    this._id = id;                                                                                                     // 309
    this._services = params.services;                                                                                  // 310
  }                                                                                                                    //
                                                                                                                       //
  EmailVerifierImpl.prototype.getId = function () {                                                                    // 306
    function getId() {                                                                                                 //
      return { id: new Buffer(this._id, "base64") };                                                                   // 314
    }                                                                                                                  //
                                                                                                                       //
    return getId;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  EmailVerifierImpl.prototype.verifyEmail = function () {                                                              // 306
    function verifyEmail(tabId, verification) {                                                                        //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      // For now, we save() the verification and then dig through ApiTokens to find where it leads.                    //
      // TODO(cleanup): In theory we should be using something like CapabilityServerSet, but it is                     //
      //   not available in Javascript yet and even if it were, it wouldn't work in the case where                     //
      //   there are multiple front-end replicas, since the verification could be on a different                       //
      //   replica.                                                                                                    //
      return verification.castAs(SystemPersistent).save({ frontend: null }).then(function (saveResult) {               // 323
        return inMeteor(function () {                                                                                  // 324
          var tokenId = hashSturdyRef(saveResult.sturdyRef);                                                           // 325
          var tokenInfo = ApiTokens.findOne(tokenId);                                                                  // 326
                                                                                                                       //
          // Delete the token now since it's not needed.                                                               //
          ApiTokens.remove(tokenId);                                                                                   // 324
                                                                                                                       //
          for (;;) {                                                                                                   // 331
            if (!tokenInfo) throw new Error("missing token?");                                                         // 332
            if (!tokenInfo.parentToken) break;                                                                         // 333
            tokenInfo = ApiTokens.findOne(tokenInfo.parentToken);                                                      // 334
          }                                                                                                            //
                                                                                                                       //
          if (!tokenInfo.frontendRef || !tokenInfo.frontendRef.verifiedEmail) {                                        // 337
            throw new Error("not a VerifiedEmail capability");                                                         // 338
          }                                                                                                            //
                                                                                                                       //
          var verification = tokenInfo.frontendRef.verifiedEmail;                                                      // 341
          if (verification.tabId !== tabId.toString("hex")) {                                                          // 342
            throw new Error("VerifiedEmail is from a different tab");                                                  // 343
          }                                                                                                            //
                                                                                                                       //
          if (_this2._services) {                                                                                      // 346
            // Since this verifier is restricted to specific services, only indicate a match if the                    //
            // VerifiedEmail was for the correct verifier ID. (If our _services is null, then we                       //
            // match all services, and therefore all VerifiedEmails.)                                                  //
            if (verification.verifierId !== _this2._id) {                                                              // 350
              throw new Error("VerifierEmail is for a different EmailVerifier.");                                      // 351
            }                                                                                                          //
          }                                                                                                            //
                                                                                                                       //
          return verification.address;                                                                                 // 355
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return verifyEmail;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  return EmailVerifierImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 359
                                                                                                                       //
var VerifiedEmailImpl = function () {                                                                                  //
  function VerifiedEmailImpl(persistentMethods, id) {                                                                  // 362
    (0, _classCallCheck3["default"])(this, VerifiedEmailImpl);                                                         //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 363
  }                                                                                                                    //
                                                                                                                       //
  return VerifiedEmailImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
makeEmailVerifier = function makeEmailVerifier(persistentMethods, id, params) {                                        // 367
  return new Capnp.Capability(new EmailVerifierImpl(persistentMethods, id, params), EmailImpl.PersistentEmailVerifier);
};                                                                                                                     //
                                                                                                                       //
makeVerifiedEmail = function makeVerifiedEmail(persistentMethods) {                                                    // 372
  return new Capnp.Capability(new VerifiedEmailImpl(persistentMethods), EmailImpl.PersistentVerifiedEmail);            // 373
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]},"admin-server.js":["babel-runtime/helpers/objectWithoutProperties",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/admin-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");                              //
                                                                                                                       //
var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);                                     //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var ADMIN_TOKEN_EXPIRATION_TIME = 15 * 60 * 1000;                                                                      // 17
var publicAdminSettings = ["google", "github", "ldap", "saml", "emailToken", "splashUrl", "signupDialog", "adminAlert", "adminAlertTime", "adminAlertUrl", "termsUrl", "privacyUrl", "appMarketUrl", "appIndexUrl", "appUpdatesEnabled", "serverTitle", "returnAddress", "ldapNameField", "organizationMembership", "organizationSettings"];
                                                                                                                       //
var FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS = ["customer", "expires", "features", "isElasticBilling", "isTrial", "issued", "userLimit"];
                                                                                                                       //
var PUBLIC_FEATURE_KEY_FIELDS = ["expires", "features"];                                                               // 30
                                                                                                                       //
var Fs = Npm.require("fs");                                                                                            // 34
var Crypto = Npm.require("crypto");                                                                                    // 35
var SANDSTORM_ADMIN_TOKEN = SANDSTORM_VARDIR + "/adminToken";                                                          // 36
                                                                                                                       //
var tokenIsValid = function tokenIsValid(token) {                                                                      // 38
  if (token && Fs.existsSync(SANDSTORM_ADMIN_TOKEN)) {                                                                 // 39
    var stats = Fs.statSync(SANDSTORM_ADMIN_TOKEN);                                                                    // 40
    var expireTime = new Date(Date.now() - ADMIN_TOKEN_EXPIRATION_TIME);                                               // 41
    if (stats.mtime < expireTime) {                                                                                    // 42
      return false;                                                                                                    // 43
    } else {                                                                                                           //
      return Fs.readFileSync(SANDSTORM_ADMIN_TOKEN, { encoding: "utf8" }) === token;                                   // 45
    }                                                                                                                  //
  } else {                                                                                                             //
    return false;                                                                                                      // 48
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
var tokenIsSetupSession = function tokenIsSetupSession(token) {                                                        // 52
  if (token) {                                                                                                         // 53
    var setupSession = globalDb.collections.setupSession.findOne({ _id: "current-session" });                          // 54
    if (setupSession) {                                                                                                // 55
      var hash = Crypto.createHash("sha256").update(token).digest("base64");                                           // 56
      var now = new Date();                                                                                            // 57
      var sessionLifetime = 24 * 60 * 60 * 1000; // length of setup session validity, in milliseconds: 1 day           // 58
      if (setupSession.hashedSessionId === hash && now - setupSession.creationDate < sessionLifetime) {                // 55
        return true;                                                                                                   // 60
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return false;                                                                                                        // 65
};                                                                                                                     //
                                                                                                                       //
// Export for use in other admin/ routes                                                                               //
checkAuth = function checkAuth(token) {                                                                                // 69
  check(token, Match.OneOf(undefined, null, String));                                                                  // 70
  if (!isAdmin() && !tokenIsValid(token) && !tokenIsSetupSession(token)) {                                             // 71
    throw new Meteor.Error(403, "User must be admin or provide a valid token");                                        // 72
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
var clearAdminToken = function clearAdminToken(token) {                                                                // 76
  if (tokenIsSetupSession(token)) {                                                                                    // 77
    var hash = Crypto.createHash("sha256").update(token).digest("base64");                                             // 78
    globalDb.collections.setupSession.remove({                                                                         // 79
      _id: "current-session",                                                                                          // 80
      hashedSessionId: hash                                                                                            // 81
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  if (tokenIsValid(token)) {                                                                                           // 85
    Fs.unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                              // 86
    console.log("Admin token deleted.");                                                                               // 87
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
var smtpConfigShape = {                                                                                                // 91
  hostname: String,                                                                                                    // 92
  port: Number,                                                                                                        // 93
  auth: {                                                                                                              // 94
    user: String,                                                                                                      // 95
    pass: String                                                                                                       // 96
  },                                                                                                                   //
  returnAddress: String                                                                                                // 98
};                                                                                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 101
  setAccountSetting: function () {                                                                                     // 102
    function setAccountSetting(token, serviceName, value) {                                                            // 102
      checkAuth(token);                                                                                                // 103
      check(serviceName, String);                                                                                      // 104
      check(value, Boolean);                                                                                           // 105
                                                                                                                       //
      // TODO(someday): currently this relies on the fact that an account is tied to a single                          //
      // identity, and thus has only that entry in "services". This will need to be looked at when                     //
      // multiple login methods/identities are allowed for a single account.                                           //
      if (!value && !tokenIsValid(token) && !tokenIsSetupSession(token) && serviceName in Meteor.user().services) {    // 102
        throw new Meteor.Error(403, "You can not disable the login service that your account uses.");                  // 111
      }                                                                                                                //
                                                                                                                       //
      // Only check configurations for OAuth services.                                                                 //
      var oauthServices = ["google", "github"];                                                                        // 102
      if (value && oauthServices.indexOf(serviceName) != -1) {                                                         // 117
        var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                              // 118
        var config = ServiceConfiguration.configurations.findOne({ service: serviceName });                            // 119
        if (!config) {                                                                                                 // 120
          throw new Meteor.Error(403, "You must configure the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
        }                                                                                                              //
                                                                                                                       //
        if (!config.clientId || !config.secret) {                                                                      // 125
          throw new Meteor.Error(403, "You must provide a non-empty clientId and secret for the " + serviceName + " service before you can enable it. Click the \"configure\" link.");
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      Settings.upsert({ _id: serviceName }, { $set: { value: value } });                                               // 131
      if (value) {                                                                                                     // 132
        Settings.update({ _id: serviceName }, { $unset: { automaticallyReset: 1 } });                                  // 133
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return setAccountSetting;                                                                                          //
  }(),                                                                                                                 //
                                                                                                                       //
  setSmtpConfig: function () {                                                                                         // 137
    function setSmtpConfig(token, config) {                                                                            // 137
      checkAuth(token);                                                                                                // 138
      check(config, smtpConfigShape);                                                                                  // 139
                                                                                                                       //
      Settings.upsert({ _id: "smtpConfig" }, { $set: { value: config } });                                             // 141
    }                                                                                                                  //
                                                                                                                       //
    return setSmtpConfig;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  setSetting: function () {                                                                                            // 144
    function setSetting(token, name, value) {                                                                          // 144
      checkAuth(token);                                                                                                // 145
      check(name, String);                                                                                             // 146
      check(value, Match.OneOf(null, String, Date, Boolean));                                                          // 147
                                                                                                                       //
      Settings.upsert({ _id: name }, { $set: { value: value } });                                                      // 149
    }                                                                                                                  //
                                                                                                                       //
    return setSetting;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  submitFeatureKey: function () {                                                                                      // 152
    function submitFeatureKey(token, textBlock) {                                                                      // 152
      checkAuth(token);                                                                                                // 153
      check(textBlock, Match.OneOf(null, String));                                                                     // 154
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 156
                                                                                                                       //
      if (!textBlock) {                                                                                                // 158
        // Delete the feature key.                                                                                     //
        db.collections.featureKey.remove("currentFeatureKey");                                                         // 160
        return;                                                                                                        // 161
      }                                                                                                                //
                                                                                                                       //
      // textBlock is a base64'd string, possibly with newlines and comment lines starting with "-"                    //
      var featureKeyBase64 = _.chain(textBlock.split("\n")).filter(function (line) {                                   // 152
        return line.length > 0 && line[0] !== "-";                                                                     //
      }).value().join("");                                                                                             //
                                                                                                                       //
      var buf = new Buffer(featureKeyBase64, "base64");                                                                // 170
      if (buf.length < 64) {                                                                                           // 171
        throw new Meteor.Error(401, "Invalid feature key");                                                            // 172
      }                                                                                                                //
                                                                                                                       //
      // loadSignedFeatureKey is provided in feature-key.js                                                            //
      var featureKey = loadSignedFeatureKey(buf);                                                                      // 152
      if (!featureKey) {                                                                                               // 177
        throw new Meteor.Error(401, "Invalid feature key");                                                            // 178
      }                                                                                                                //
                                                                                                                       //
      // Persist the feature key in the database.                                                                      //
      db.collections.featureKey.upsert("currentFeatureKey", {                                                          // 152
        _id: "currentFeatureKey",                                                                                      // 185
        value: buf                                                                                                     // 186
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return submitFeatureKey;                                                                                           //
  }(),                                                                                                                 //
                                                                                                                       //
  saveOrganizationSettings: function () {                                                                              // 191
    function saveOrganizationSettings(token, params) {                                                                 //
      checkAuth(token);                                                                                                // 192
      check(params, {                                                                                                  // 193
        membership: {                                                                                                  // 194
          emailToken: {                                                                                                // 195
            enabled: Boolean,                                                                                          // 196
            domain: String                                                                                             // 197
          },                                                                                                           //
          google: {                                                                                                    // 199
            enabled: Boolean,                                                                                          // 200
            domain: String                                                                                             // 201
          },                                                                                                           //
          ldap: {                                                                                                      // 203
            enabled: Boolean                                                                                           // 204
          },                                                                                                           //
          saml: {                                                                                                      // 206
            enabled: Boolean                                                                                           // 207
          }                                                                                                            //
        },                                                                                                             //
        settings: {                                                                                                    // 210
          disallowGuests: Boolean,                                                                                     // 211
          shareContacts: Boolean                                                                                       // 212
        }                                                                                                              //
      });                                                                                                              //
                                                                                                                       //
      this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationMembership" }, { value: params.membership });
      this.connection.sandstormDb.collections.settings.upsert({ _id: "organizationSettings" }, { value: params.settings });
    }                                                                                                                  //
                                                                                                                       //
    return saveOrganizationSettings;                                                                                   //
  }(),                                                                                                                 //
                                                                                                                       //
                                                                                                                       //
  adminConfigureLoginService: function () {                                                                            // 220
    function adminConfigureLoginService(token, options) {                                                              // 220
      checkAuth(token);                                                                                                // 221
      check(options, Match.ObjectIncluding({ service: String }));                                                      // 222
                                                                                                                       //
      var ServiceConfiguration = Package["service-configuration"].ServiceConfiguration;                                // 224
                                                                                                                       //
      ServiceConfiguration.configurations.upsert({ service: options.service }, options);                               // 226
    }                                                                                                                  //
                                                                                                                       //
    return adminConfigureLoginService;                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  clearResumeTokensForService: function () {                                                                           // 229
    function clearResumeTokensForService(token, serviceName) {                                                         // 229
      checkAuth(token);                                                                                                // 230
      check(serviceName, String);                                                                                      // 231
                                                                                                                       //
      var query = {};                                                                                                  // 233
      query["services." + serviceName] = { $exists: true };                                                            // 234
      Meteor.users.find(query).forEach(function (identity) {                                                           // 235
        if (identity.services.resume && identity.services.resume.loginTokens && identity.services.resume.loginTokens.length > 0) {
          Meteor.users.update({ _id: identity._id }, { $set: { "services.resume.loginTokens": [] } });                 // 238
        }                                                                                                              //
                                                                                                                       //
        Meteor.users.update({ "loginIdentities.id": identity._id }, { $set: { "services.resume.loginTokens": [] } });  // 241
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return clearResumeTokensForService;                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  adminUpdateUser: function () {                                                                                       // 246
    function adminUpdateUser(token, userInfo) {                                                                        // 246
      checkAuth(token);                                                                                                // 247
      check(userInfo, {                                                                                                // 248
        userId: String,                                                                                                // 249
        signupKey: Boolean,                                                                                            // 250
        isAdmin: Boolean                                                                                               // 251
      });                                                                                                              //
                                                                                                                       //
      var userId = userInfo.userId;                                                                                    // 254
      if (userId === Meteor.userId() && !userInfo.isAdmin) {                                                           // 255
        throw new Meteor.Error(403, "User cannot remove admin permissions from itself.");                              // 256
      }                                                                                                                //
                                                                                                                       //
      Meteor.users.update({ _id: userId }, { $set: _.omit(userInfo, ["_id", "userId"]) });                             // 259
    }                                                                                                                  //
                                                                                                                       //
    return adminUpdateUser;                                                                                            //
  }(),                                                                                                                 //
                                                                                                                       //
  testSend: function () {                                                                                              // 262
    function testSend(token, smtpConfig, to) {                                                                         // 262
      checkAuth(token);                                                                                                // 263
      check(smtpConfig, smtpConfigShape);                                                                              // 264
      check(to, String);                                                                                               // 265
      var returnAddress = smtpConfig.returnAddress;                                                                    //
      var restConfig = (0, _objectWithoutProperties3["default"])(smtpConfig, ["returnAddress"]);                       //
                                                                                                                       //
                                                                                                                       //
      SandstormEmail.send({                                                                                            // 268
        to: to,                                                                                                        // 269
        from: globalDb.getServerTitle() + " <" + returnAddress + ">",                                                  // 270
        subject: "Testing your Sandstorm's SMTP setting",                                                              // 271
        text: "Success! Your outgoing SMTP is working.",                                                               // 272
        smtpConfig: restConfig                                                                                         // 273
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return testSend;                                                                                                   //
  }(),                                                                                                                 //
                                                                                                                       //
  createSignupKey: function () {                                                                                       // 277
    function createSignupKey(token, note, quota) {                                                                     // 277
      checkAuth(token);                                                                                                // 278
      check(note, String);                                                                                             // 279
      check(quota, Match.OneOf(undefined, null, Number));                                                              // 280
                                                                                                                       //
      var key = Random.id();                                                                                           // 282
      var content = { _id: key, used: false, note: note };                                                             // 283
      if (typeof quota === "number") content.quota = quota;                                                            // 284
      SignupKeys.insert(content);                                                                                      // 285
      return key;                                                                                                      // 286
    }                                                                                                                  //
                                                                                                                       //
    return createSignupKey;                                                                                            //
  }(),                                                                                                                 //
                                                                                                                       //
  sendInvites: function () {                                                                                           // 289
    function sendInvites(token, origin, from, list, subject, message, quota) {                                         // 289
      checkAuth(token);                                                                                                // 290
      check([origin, from, list, subject, message], [String]);                                                         // 291
      check(quota, Match.OneOf(undefined, null, Number));                                                              // 292
                                                                                                                       //
      if (!from.trim()) {                                                                                              // 294
        throw new Meteor.Error(403, "Must enter 'from' address.");                                                     // 295
      }                                                                                                                //
                                                                                                                       //
      if (!list.trim()) {                                                                                              // 298
        throw new Meteor.Error(403, "Must enter 'to' addresses.");                                                     // 299
      }                                                                                                                //
                                                                                                                       //
      this.unblock();                                                                                                  // 302
                                                                                                                       //
      list = list.split("\n");                                                                                         // 304
      for (var i in meteorBabelHelpers.sanitizeForInObject(list)) {                                                    // 305
        var email = list[i].trim();                                                                                    // 306
                                                                                                                       //
        if (email) {                                                                                                   // 308
          var key = Random.id();                                                                                       // 309
                                                                                                                       //
          var content = {                                                                                              // 311
            _id: key,                                                                                                  // 312
            used: false,                                                                                               // 313
            note: "E-mail invite to " + email,                                                                         // 314
            email: email,                                                                                              // 315
            definitelySent: false                                                                                      // 316
          };                                                                                                           //
          if (typeof quota === "number") content.quota = quota;                                                        // 318
          SignupKeys.insert(content);                                                                                  // 319
          SandstormEmail.send({                                                                                        // 320
            to: email,                                                                                                 // 321
            from: from,                                                                                                // 322
            envelopeFrom: globalDb.getReturnAddress(),                                                                 // 323
            subject: subject,                                                                                          // 324
            text: message.replace(/\$KEY/g, origin + "/signup/" + key)                                                 // 325
          });                                                                                                          //
          SignupKeys.update(key, { $set: { definitelySent: true } });                                                  // 327
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return { sent: true };                                                                                           // 331
    }                                                                                                                  //
                                                                                                                       //
    return sendInvites;                                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  offerIpNetwork: function () {                                                                                        // 334
    function offerIpNetwork(token) {                                                                                   // 334
      checkAuth(token);                                                                                                // 335
      if (!isAdmin()) {                                                                                                // 336
        throw new Meteor.Error(403, "Offering IpNetwork is only allowed for logged in users " + "(a token is not sufficient). Please sign in with an admin account");
      }                                                                                                                //
                                                                                                                       //
      var requirements = [{ userIsAdmin: Meteor.userId() }];                                                           // 341
      var sturdyRef = waitPromise(saveFrontendRef({ ipNetwork: true }, { webkey: null }, requirements)).sturdyRef;     // 344
      return ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef;                             // 347
    }                                                                                                                  //
                                                                                                                       //
    return offerIpNetwork;                                                                                             //
  }(),                                                                                                                 //
                                                                                                                       //
  offerIpInterface: function () {                                                                                      // 350
    function offerIpInterface(token) {                                                                                 // 350
      checkAuth(token);                                                                                                // 351
      if (!isAdmin()) {                                                                                                // 352
        throw new Meteor.Error(403, "Offering IpInterface is only allowed for logged in users " + "(a token is not sufficient). Please sign in with an admin account");
      }                                                                                                                //
                                                                                                                       //
      var requirements = [{ userIsAdmin: Meteor.userId() }];                                                           // 357
      var sturdyRef = waitPromise(saveFrontendRef({ ipInterface: true }, { webkey: null }, requirements)).sturdyRef;   // 360
      return ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef;                             // 363
    }                                                                                                                  //
                                                                                                                       //
    return offerIpInterface;                                                                                           //
  }(),                                                                                                                 //
                                                                                                                       //
  adminToggleDisableCap: function () {                                                                                 // 366
    function adminToggleDisableCap(token, capId, value) {                                                              // 366
      checkAuth(token);                                                                                                // 367
      check(capId, String);                                                                                            // 368
      check(value, Boolean);                                                                                           // 369
                                                                                                                       //
      if (value) {                                                                                                     // 371
        ApiTokens.update({ _id: capId }, { $set: { revoked: true } });                                                 // 372
      } else {                                                                                                         //
        ApiTokens.update({ _id: capId }, { $set: { revoked: false } });                                                // 374
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return adminToggleDisableCap;                                                                                      //
  }(),                                                                                                                 //
                                                                                                                       //
  updateQuotas: function () {                                                                                          // 378
    function updateQuotas(token, list, quota) {                                                                        // 378
      checkAuth(token);                                                                                                // 379
      check(list, String);                                                                                             // 380
      check(quota, Match.OneOf(undefined, null, Number));                                                              // 381
                                                                                                                       //
      if (!list.trim()) {                                                                                              // 383
        throw new Meteor.Error(400, "Must enter addresses.");                                                          // 384
      }                                                                                                                //
                                                                                                                       //
      var items = list.split("\n");                                                                                    // 387
      var invalid = [];                                                                                                // 388
      for (var i in meteorBabelHelpers.sanitizeForInObject(items)) {                                                   // 389
        var modifier = typeof quota === "number" ? { $set: { quota: quota } } : { $unset: { quota: "" } };             // 390
        var n = SignupKeys.update({ email: items[i] }, modifier, { multi: true });                                     // 392
        n += Meteor.users.update({ signupEmail: items[i] }, modifier, { multi: true });                                // 393
                                                                                                                       //
        if (n < 1) invalid.push(items[i]);                                                                             // 395
      }                                                                                                                //
                                                                                                                       //
      if (invalid.length > 0) {                                                                                        // 398
        throw new Meteor.Error(404, "These addresses did not map to any user nor invite: " + invalid.join(", "));      // 399
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return updateQuotas;                                                                                               //
  }(),                                                                                                                 //
                                                                                                                       //
  dismissAdminStatsNotifications: function () {                                                                        // 404
    function dismissAdminStatsNotifications(token) {                                                                   // 404
      checkAuth(token);                                                                                                // 405
      globalDb.collections.notifications.remove({ "admin.type": "reportStats" });                                      // 406
    }                                                                                                                  //
                                                                                                                       //
    return dismissAdminStatsNotifications;                                                                             //
  }(),                                                                                                                 //
                                                                                                                       //
  signUpAsAdmin: function () {                                                                                         // 409
    function signUpAsAdmin(token) {                                                                                    // 409
      check(token, String);                                                                                            // 410
      checkAuth(token);                                                                                                // 411
      if (!this.userId) {                                                                                              // 412
        throw new Meteor.Error(403, "Must be logged in to sign up as admin.");                                         // 413
      }                                                                                                                //
                                                                                                                       //
      if (!Meteor.user().loginIdentities) {                                                                            // 416
        throw new Meteor.Error(403, "Must be logged into an account to sign up as admin.");                            // 417
      }                                                                                                                //
                                                                                                                       //
      Meteor.users.update({ _id: this.userId }, { $set: { isAdmin: true, signupKey: "admin" } });                      // 420
      clearAdminToken(token);                                                                                          // 421
    }                                                                                                                  //
                                                                                                                       //
    return signUpAsAdmin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  redeemSetupToken: function () {                                                                                      // 424
    function redeemSetupToken(token) {                                                                                 //
      // Redeem an admin token into a setup session.                                                                   //
      check(token, String);                                                                                            // 426
      if (tokenIsValid(token)) {                                                                                       // 427
        var sessId = Random.secret();                                                                                  // 428
        var creationDate = new Date();                                                                                 // 429
        var hashedSessionId = Crypto.createHash("sha256").update(sessId).digest("base64");                             // 430
        this.connection.sandstormDb.collections.setupSession.upsert({                                                  // 431
          _id: "current-session"                                                                                       // 432
        }, {                                                                                                           //
          creationDate: creationDate,                                                                                  // 434
          hashedSessionId: hashedSessionId                                                                             // 435
        });                                                                                                            //
        // Then, invalidate the token, so one one else can use it.                                                     //
        Fs.unlinkSync(SANDSTORM_ADMIN_TOKEN);                                                                          // 427
        return sessId;                                                                                                 // 439
      } else {                                                                                                         //
        throw new Meteor.Error(401, "Invalid setup token");                                                            // 441
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return redeemSetupToken;                                                                                           //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
var authorizedAsAdmin = function authorizedAsAdmin(token, userId) {                                                    // 446
  return Match.test(token, Match.OneOf(undefined, null, String)) && (userId && isAdminById(userId) || tokenIsValid(token) || tokenIsSetupSession(token));
};                                                                                                                     //
                                                                                                                       //
Meteor.publish("admin", function (token) {                                                                             // 451
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 452
  return Settings.find();                                                                                              // 453
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("adminServiceConfiguration", function (token) {                                                         // 456
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 457
  return Package["service-configuration"].ServiceConfiguration.configurations.find();                                  // 458
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("publicAdminSettings", function () {                                                                    // 461
  return Settings.find({ _id: { $in: publicAdminSettings } });                                                         // 462
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("adminToken", function (token) {                                                                        // 465
  check(token, String);                                                                                                // 466
  this.added("adminToken", "adminToken", { tokenIsValid: tokenIsValid(token) || tokenIsSetupSession(token) });         // 467
  this.ready();                                                                                                        // 468
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("allUsers", function (token) {                                                                          // 471
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 472
  return Meteor.users.find();                                                                                          // 473
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("activityStats", function (token) {                                                                     // 476
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 477
  return ActivityStats.find();                                                                                         // 478
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("statsTokens", function (token) {                                                                       // 481
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 482
  return StatsTokens.find();                                                                                           // 483
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("allPackages", function (token) {                                                                       // 486
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 487
  return Packages.find({ manifest: { $exists: true } }, { fields: { appId: 1, "manifest.appVersion": 1,                // 488
      "manifest.actions": 1, "manifest.appTitle": 1 } });                                                              // 490
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("realTimeStats", function (token) {                                                                     // 493
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 494
                                                                                                                       //
  // Last five minutes.                                                                                                //
  this.added("realTimeStats", "now", computeStats(new Date(Date.now() - 5 * 60 * 1000)));                              // 493
                                                                                                                       //
  // Since last sample.                                                                                                //
  var lastSample = ActivityStats.findOne({}, { sort: { timestamp: -1 } });                                             // 493
  var lastSampleTime = lastSample ? lastSample.timestamp : new Date(0);                                                // 501
  this.added("realTimeStats", "today", computeStats(lastSampleTime));                                                  // 502
                                                                                                                       //
  // TODO(someday): Update every few minutes?                                                                          //
                                                                                                                       //
  this.ready();                                                                                                        // 493
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("adminLog", function (token) {                                                                          // 509
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 510
                                                                                                                       //
  var logfile = SANDSTORM_LOGDIR + "/sandstorm.log";                                                                   // 512
                                                                                                                       //
  var fd = Fs.openSync(logfile, "r");                                                                                  // 514
  var startSize = Fs.fstatSync(fd).size;                                                                               // 515
                                                                                                                       //
  // Start tailing at EOF - 8k.                                                                                        //
  var offset = Math.max(0, startSize - 8192);                                                                          // 509
                                                                                                                       //
  var _this = this;                                                                                                    // 520
  function doTail() {                                                                                                  // 521
    for (;;) {                                                                                                         // 522
      var buf = new Buffer(Math.max(1024, startSize - offset));                                                        // 523
      var n = Fs.readSync(fd, buf, 0, buf.length, offset);                                                             // 524
      if (n <= 0) break;                                                                                               // 525
      _this.added("adminLog", offset, { text: buf.toString("utf8", 0, n) });                                           // 526
      offset += n;                                                                                                     // 527
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Watch the file for changes.                                                                                       //
  var watcher = Fs.watch(logfile, { persistent: false }, Meteor.bindEnvironment(doTail));                              // 509
                                                                                                                       //
  // When the subscription stops, stop watching the file.                                                              //
  this.onStop(function () {                                                                                            // 509
    watcher.close();                                                                                                   // 536
    Fs.closeSync(fd);                                                                                                  // 537
  });                                                                                                                  //
                                                                                                                       //
  // Read initial 8k tail data immediately.                                                                            //
  doTail();                                                                                                            // 509
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 509
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("adminApiTokens", function (token) {                                                                    // 547
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 548
  return ApiTokens.find({                                                                                              // 549
    $or: [{ "frontendRef.ipNetwork": { $exists: true } }, { "frontendRef.ipInterface": { $exists: true } }]            // 550
  }, {                                                                                                                 //
    fields: {                                                                                                          // 555
      frontendRef: 1,                                                                                                  // 556
      created: 1,                                                                                                      // 557
      requirements: 1,                                                                                                 // 558
      revoked: 1                                                                                                       // 559
    }                                                                                                                  //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("featureKey", function (forAdmin, token) {                                                              // 564
  var _this2 = this;                                                                                                   //
                                                                                                                       //
  if (forAdmin && !authorizedAsAdmin(token, this.userId)) return [];                                                   // 565
                                                                                                                       //
  var fields = forAdmin ? FEATURE_KEY_FIELDS_PUBLISHED_TO_ADMINS : PUBLIC_FEATURE_KEY_FIELDS;                          // 567
                                                                                                                       //
  var db = this.connection.sandstormDb;                                                                                // 570
  var featureKeyQuery = db.collections.featureKey.find({ _id: "currentFeatureKey" });                                  // 571
  var observeHandle = featureKeyQuery.observe({                                                                        // 572
    added: function () {                                                                                               // 573
      function added(doc) {                                                                                            // 573
        // Load and verify the signed feature key.                                                                     //
        var buf = new Buffer(doc.value);                                                                               // 575
        var featureKey = loadSignedFeatureKey(buf);                                                                    // 576
                                                                                                                       //
        if (featureKey) {                                                                                              // 578
          var _ref;                                                                                                    //
                                                                                                                       //
          // If the signature is valid, publish the feature key information.                                           //
          var filteredFeatureKey = (_ref = _).pick.apply(_ref, [featureKey].concat(fields));                           // 580
          _this2.added("featureKey", doc._id, filteredFeatureKey);                                                     // 581
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
                                                                                                                       //
    changed: function () {                                                                                             // 585
      function changed(newDoc, oldDoc) {                                                                               // 585
        // Load and reverify the new signed feature key.                                                               //
        var buf = new Buffer(newDoc.value);                                                                            // 587
        var featureKey = loadSignedFeatureKey(buf);                                                                    // 588
                                                                                                                       //
        if (featureKey) {                                                                                              // 590
          var _ref2;                                                                                                   //
                                                                                                                       //
          // If the signature is valid, call this.changed() with the interesting fields.                               //
          var filteredFeatureKey = (_ref2 = _).pick.apply(_ref2, [featureKey].concat(fields));                         // 592
          _this2.changed("featureKey", newDoc._id, filteredFeatureKey);                                                // 593
        } else {                                                                                                       //
          // Otherwise, call this.removed(), since the new feature key is invalid.                                     //
          _this2.removed("featureKey", oldDoc._id);                                                                    // 596
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }(),                                                                                                               //
                                                                                                                       //
    removed: function () {                                                                                             // 600
      function removed(oldDoc) {                                                                                       // 600
        _this2.removed("featureKey", oldDoc._id);                                                                      // 601
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  this.onStop(function () {                                                                                            // 605
    observeHandle.stop();                                                                                              // 606
  });                                                                                                                  //
                                                                                                                       //
  this.ready();                                                                                                        // 609
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("hasAdmin", function (token) {                                                                          // 612
  var _this3 = this;                                                                                                   //
                                                                                                                       //
  // Like hasUsers, but for admins, and with token auth required.                                                      //
  if (!authorizedAsAdmin(token, this.userId)) return [];                                                               // 614
                                                                                                                       //
  // Query if there are any admin users.                                                                               //
  var cursor = Meteor.users.find({ isAdmin: true });                                                                   // 612
  if (cursor.count() > 0) {                                                                                            // 618
    this.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                            // 619
  } else {                                                                                                             //
    (function () {                                                                                                     //
      var handle = cursor.observeChanges({                                                                             // 621
        added: function () {                                                                                           // 622
          function added(id) {                                                                                         // 622
            _this3.added("hasAdmin", "hasAdmin", { hasAdmin: true });                                                  // 623
            handle.stop();                                                                                             // 624
            handle = null;                                                                                             // 625
          }                                                                                                            //
                                                                                                                       //
          return added;                                                                                                //
        }()                                                                                                            //
      });                                                                                                              //
      _this3.onStop(function () {                                                                                      // 628
        if (handle) handle.stop();                                                                                     // 629
      });                                                                                                              //
    })();                                                                                                              //
  }                                                                                                                    //
                                                                                                                       //
  this.ready();                                                                                                        // 633
});                                                                                                                    //
                                                                                                                       //
function observeOauthService(name) {                                                                                   // 636
  Settings.find({ _id: name, value: true }).observe({                                                                  // 637
    added: function () {                                                                                               // 638
      function added() {                                                                                               // 638
        // Tell the oauth library it should accept login attempts from this service.                                   //
        Accounts.oauth.registerService(name);                                                                          // 640
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
                                                                                                                       //
    removed: function () {                                                                                             // 643
      function removed() {                                                                                             // 643
        // Tell the oauth library it should deny login attempts from this service.                                     //
        Accounts.oauth.unregisterService(name);                                                                        // 645
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
observeOauthService("github");                                                                                         // 650
observeOauthService("google");                                                                                         // 651
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"backup.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/backup.js                                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var ChildProcess = Npm.require("child_process");                                                                       // 17
var Future = Npm.require("fibers/future");                                                                             // 18
var Promise = Npm.require("es6-promise").Promise;                                                                      // 19
var Capnp = Npm.require("capnp");                                                                                      // 20
                                                                                                                       //
var GrainInfo = Capnp.importSystem("sandstorm/grain.capnp").GrainInfo;                                                 // 22
                                                                                                                       //
var TOKEN_CLEANUP_MINUTES = 15;                                                                                        // 24
var TOKEN_CLEANUP_TIMER = TOKEN_CLEANUP_MINUTES * 60 * 1000;                                                           // 25
                                                                                                                       //
function cleanupToken(tokenId) {                                                                                       // 27
  check(tokenId, String);                                                                                              // 28
  waitPromise(globalBackend.cap().deleteBackup(tokenId));                                                              // 29
  FileTokens.remove({ _id: tokenId });                                                                                 // 30
}                                                                                                                      //
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 33
  // Cleanup tokens every TOKEN_CLEANUP_MINUTES                                                                        //
  SandstormDb.periodicCleanup(TOKEN_CLEANUP_TIMER, function () {                                                       // 35
    var queryDate = new Date(Date.now() - TOKEN_CLEANUP_TIMER);                                                        // 36
                                                                                                                       //
    FileTokens.find({ timestamp: { $lt: queryDate } }).forEach(function (token) {                                      // 38
      cleanupToken(token._id);                                                                                         // 39
    });                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Meteor.methods({                                                                                                       // 44
  backupGrain: function () {                                                                                           // 45
    function backupGrain(grainId) {                                                                                    //
      check(grainId, String);                                                                                          // 46
      var grain = Grains.findOne(grainId);                                                                             // 47
      if (!grain || !this.userId || grain.userId !== this.userId) {                                                    // 48
        throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                            // 49
      }                                                                                                                //
                                                                                                                       //
      this.unblock();                                                                                                  // 52
                                                                                                                       //
      var token = {                                                                                                    // 54
        _id: Random.id(),                                                                                              // 55
        timestamp: new Date(),                                                                                         // 56
        name: grain.title                                                                                              // 57
      };                                                                                                               //
                                                                                                                       //
      // TODO(soon): does the grain need to be offline?                                                                //
                                                                                                                       //
      var grainInfo = _.pick(grain, "appId", "appVersion", "title");                                                   // 45
                                                                                                                       //
      FileTokens.insert(token);                                                                                        // 64
      waitPromise(globalBackend.cap().backupGrain(token._id, this.userId, grainId, grainInfo));                        // 65
                                                                                                                       //
      return token._id;                                                                                                // 67
    }                                                                                                                  //
                                                                                                                       //
    return backupGrain;                                                                                                //
  }(),                                                                                                                 //
  restoreGrain: function () {                                                                                          // 70
    function restoreGrain(tokenId, identityId) {                                                                       //
      check(tokenId, String);                                                                                          // 71
      check(identityId, String);                                                                                       // 72
      var token = FileTokens.findOne(tokenId);                                                                         // 73
      if (!token || !isSignedUpOrDemo()) {                                                                             // 74
        throw new Meteor.Error(403, "Unauthorized", "Token was not found, or user cannot create grains");              // 75
      }                                                                                                                //
                                                                                                                       //
      if (isUserOverQuota(Meteor.user())) {                                                                            // 79
        throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");         // 80
      }                                                                                                                //
                                                                                                                       //
      this.unblock();                                                                                                  // 84
                                                                                                                       //
      var grainId = Random.id(22);                                                                                     // 86
                                                                                                                       //
      try {                                                                                                            // 88
        var grainInfo = waitPromise(globalBackend.cap().restoreGrain(tokenId, this.userId, grainId)["catch"](function (err) {
          console.error("Unzip failure:", err.message);                                                                // 91
          throw new Meteor.Error(500, "Invalid backup file.");                                                         // 92
        })).info;                                                                                                      //
        if (!grainInfo.appId) {                                                                                        // 94
          globalBackend.deleteGrain(grainId, this.userId);                                                             // 95
          throw new Meteor.Error(500, "Metadata object for uploaded grain has no AppId");                              // 96
        }                                                                                                              //
                                                                                                                       //
        var action = UserActions.findOne({ appId: grainInfo.appId, userId: this.userId });                             // 99
                                                                                                                       //
        // Create variables we'll use for later Mongo query.                                                           //
        var packageId = void 0;                                                                                        // 88
        var appVersion = void 0;                                                                                       // 103
                                                                                                                       //
        // DevPackages are system-wide, so we do not check the user ID.                                                //
        var devPackage = DevPackages.findOne({ appId: grainInfo.appId });                                              // 88
        if (devPackage) {                                                                                              // 107
          // If the dev app package exists, it should override the user action.                                        //
          packageId = devPackage.packageId;                                                                            // 109
          appVersion = devPackage.manifest.appVersion;                                                                 // 110
        } else if (action) {                                                                                           //
          // The app is installed, so we can continue restoring this                                                   //
          // grain.                                                                                                    //
          packageId = action.packageId;                                                                                // 114
          appVersion = action.appVersion;                                                                              // 115
        } else {                                                                                                       //
          // If the package isn't installed at all, bail out.                                                          //
          globalBackend.deleteGrain(grainId, this.userId);                                                             // 118
          throw new Meteor.Error(500, "App id for uploaded grain not installed", "App Id: " + grainInfo.appId);        // 119
        }                                                                                                              //
                                                                                                                       //
        if (appVersion < grainInfo.appVersion) {                                                                       // 124
          globalBackend.deleteGrain(grainId, this.userId);                                                             // 125
          throw new Meteor.Error(500, "App version for uploaded grain is newer than any " + "installed version. You need to upgrade your app first", "New version: " + grainInfo.appVersion + ", Old version: " + appVersion);
        }                                                                                                              //
                                                                                                                       //
        Grains.insert({                                                                                                // 133
          _id: grainId,                                                                                                // 134
          packageId: packageId,                                                                                        // 135
          appId: grainInfo.appId,                                                                                      // 136
          appVersion: appVersion,                                                                                      // 137
          userId: this.userId,                                                                                         // 138
          identityId: identityId,                                                                                      // 139
          title: grainInfo.title,                                                                                      // 140
          "private": true                                                                                              // 141
        });                                                                                                            //
      } finally {                                                                                                      //
        cleanupToken(tokenId);                                                                                         // 144
      }                                                                                                                //
                                                                                                                       //
      return grainId;                                                                                                  // 147
    }                                                                                                                  //
                                                                                                                       //
    return restoreGrain;                                                                                               //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Router.map(function () {                                                                                               // 151
  this.route("downloadBackup", {                                                                                       // 152
    where: "server",                                                                                                   // 153
    path: "/downloadBackup/:tokenId",                                                                                  // 154
    action: function () {                                                                                              // 155
      function action() {                                                                                              //
        var token = FileTokens.findOne(this.params.tokenId);                                                           // 156
        var response = this.response;                                                                                  // 157
        if (!token) {                                                                                                  // 158
          response.writeHead(404, { "Content-Type": "text/plain" });                                                   // 159
          return response.end("File does not exist");                                                                  // 160
        }                                                                                                              //
                                                                                                                       //
        var started = false;                                                                                           // 163
        var filename = (token.name.replace(/["\n]/g, "") || "backup") + ".zip";                                        // 164
        var sawEnd = false;                                                                                            // 165
                                                                                                                       //
        var stream = {                                                                                                 // 167
          expectSize: function () {                                                                                    // 168
            function expectSize(size) {                                                                                //
              if (!started) {                                                                                          // 169
                started = true;                                                                                        // 170
                response.writeHead(200, {                                                                              // 171
                  "Content-Length": size,                                                                              // 172
                  "Content-Type": "application/zip",                                                                   // 173
                  "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                    // 174
                });                                                                                                    //
              }                                                                                                        //
            }                                                                                                          //
                                                                                                                       //
            return expectSize;                                                                                         //
          }(),                                                                                                         //
          write: function () {                                                                                         // 179
            function write(data) {                                                                                     //
              if (!started) {                                                                                          // 180
                started = true;                                                                                        // 181
                response.writeHead(200, {                                                                              // 182
                  "Content-Type": "application/zip",                                                                   // 183
                  "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                    // 184
                });                                                                                                    //
              }                                                                                                        //
                                                                                                                       //
              response.write(data);                                                                                    // 188
            }                                                                                                          //
                                                                                                                       //
            return write;                                                                                              //
          }(),                                                                                                         //
          done: function () {                                                                                          // 191
            function done(data) {                                                                                      //
              if (!started) {                                                                                          // 192
                started = true;                                                                                        // 193
                response.writeHead(200, {                                                                              // 194
                  "Content-Length": 0,                                                                                 // 195
                  "Content-Type": "application/zip",                                                                   // 196
                  "Content-Disposition": 'attachment;filename=\"' + filename + '\"'                                    // 197
                });                                                                                                    //
              }                                                                                                        //
                                                                                                                       //
              sawEnd = true;                                                                                           // 201
              response.end();                                                                                          // 202
            }                                                                                                          //
                                                                                                                       //
            return done;                                                                                               //
          }()                                                                                                          //
        };                                                                                                             //
                                                                                                                       //
        waitPromise(globalBackend.cap().downloadBackup(this.params.tokenId, stream));                                  // 206
                                                                                                                       //
        if (!sawEnd) {                                                                                                 // 208
          console.error("backend failed to call done() when downloading backup");                                      // 209
          if (!started) {                                                                                              // 210
            throw new Meteor.Error(500, "backend failed to produce data");                                             // 211
          }                                                                                                            //
                                                                                                                       //
          response.end();                                                                                              // 214
        }                                                                                                              //
                                                                                                                       //
        cleanupToken(this.params.tokenId);                                                                             // 217
      }                                                                                                                //
                                                                                                                       //
      return action;                                                                                                   //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  this.route("uploadBackup", {                                                                                         // 221
    where: "server",                                                                                                   // 222
    path: "/uploadBackup",                                                                                             // 223
    action: function () {                                                                                              // 224
      function action() {                                                                                              //
        var _this = this;                                                                                              //
                                                                                                                       //
        if (this.request.method === "POST") {                                                                          // 225
          (function () {                                                                                               //
            var request = _this.request;                                                                               // 226
            try {                                                                                                      // 227
              (function () {                                                                                           //
                var token = {                                                                                          // 228
                  _id: Random.id(),                                                                                    // 229
                  timestamp: new Date()                                                                                // 230
                };                                                                                                     //
                var stream = globalBackend.cap().uploadBackup(token._id).stream;                                       // 232
                                                                                                                       //
                FileTokens.insert(token);                                                                              // 234
                                                                                                                       //
                waitPromise(new Promise(function (resolve, reject) {                                                   // 236
                  request.on("data", function (data) {                                                                 // 237
                    stream.write(data);                                                                                // 238
                  });                                                                                                  //
                  request.on("end", function () {                                                                      // 240
                    resolve(stream.done());                                                                            // 241
                  });                                                                                                  //
                  request.on("error", function (err) {                                                                 // 243
                    stream.close();                                                                                    // 244
                  });                                                                                                  //
                }));                                                                                                   //
                                                                                                                       //
                _this.response.writeHead(200, {                                                                        // 248
                  "Content-Length": token._id.length,                                                                  // 249
                  "Content-Type": "text/plain"                                                                         // 250
                });                                                                                                    //
                _this.response.write(token._id);                                                                       // 252
                _this.response.end();                                                                                  // 253
              })();                                                                                                    //
            } catch (error) {                                                                                          //
              console.error(error.stack);                                                                              // 255
              _this.response.writeHead(500, {                                                                          // 256
                "Content-Type": "text/plain"                                                                           // 257
              });                                                                                                      //
              _this.response.write(error.stack);                                                                       // 259
              _this.response.end();                                                                                    // 260
            }                                                                                                          //
          })();                                                                                                        //
        } else {                                                                                                       //
          this.response.writeHead(405, {                                                                               // 263
            "Content-Type": "text/plain"                                                                               // 264
          });                                                                                                          //
          this.response.write("You can only POST here.");                                                              // 266
          this.response.end();                                                                                         // 267
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return action;                                                                                                   //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"core.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/core.js                                                                                                      //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Capnp = Npm.require("capnp");                                                                                      // 18
                                                                                                                       //
var PersistentHandle = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentHandle;                              // 20
var SandstormCore = Capnp.importSystem("sandstorm/supervisor.capnp").SandstormCore;                                    // 21
var SandstormCoreFactory = Capnp.importSystem("sandstorm/backend.capnp").SandstormCoreFactory;                         // 22
var PersistentOngoingNotification = Capnp.importSystem("sandstorm/supervisor.capnp").PersistentOngoingNotification;    // 23
var PersistentUiView = Capnp.importSystem("sandstorm/persistentuiview.capnp").PersistentUiView;                        // 24
                                                                                                                       //
var SandstormCoreImpl = function () {                                                                                  //
  function SandstormCoreImpl(grainId) {                                                                                // 27
    (0, _classCallCheck3["default"])(this, SandstormCoreImpl);                                                         //
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 28
  }                                                                                                                    //
                                                                                                                       //
  SandstormCoreImpl.prototype.restore = function () {                                                                  // 26
    function restore(sturdyRef, requiredPermissions) {                                                                 //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      var _this = this;                                                                                                // 32
      return inMeteor(function () {                                                                                    // 33
        var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                // 34
        var token = ApiTokens.findOne({                                                                                // 35
          _id: hashedSturdyRef,                                                                                        // 36
          "owner.grain.grainId": _this2.grainId                                                                        // 37
        });                                                                                                            //
                                                                                                                       //
        if (!token) {                                                                                                  // 40
          throw new Error("no such token");                                                                            // 41
        }                                                                                                              //
                                                                                                                       //
        // Honor `requiredPermissions`.                                                                                //
        var requirements = [];                                                                                         // 33
        if (requiredPermissions && token.owner.grain.introducerIdentity) {                                             // 46
          requirements.push({                                                                                          // 47
            permissionsHeld: {                                                                                         // 48
              permissions: requiredPermissions,                                                                        // 49
              identityId: token.owner.grain.introducerIdentity,                                                        // 50
              grainId: _this.grainId                                                                                   // 51
            }                                                                                                          //
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        return restoreInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this.grainId }) }, requirements, hashedSturdyRef);
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return restore;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.drop = function () {                                                                     // 26
    function drop(sturdyRef) {                                                                                         //
      var _this = this;                                                                                                // 63
      return inMeteor(function () {                                                                                    // 64
        return dropInternal(sturdyRef, { grain: Match.ObjectIncluding({ grainId: _this.grainId }) });                  // 65
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return drop;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.makeToken = function () {                                                                // 26
    function makeToken(ref, owner, requirements) {                                                                     //
      var _this = this;                                                                                                // 70
      return inMeteor(function () {                                                                                    // 71
        var sturdyRef = new Buffer(generateSturdyRef());                                                               // 72
        var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                // 73
        ApiTokens.insert({                                                                                             // 74
          _id: hashedSturdyRef,                                                                                        // 75
          grainId: _this.grainId,                                                                                      // 76
          objectId: ref,                                                                                               // 77
          owner: owner,                                                                                                // 78
          created: new Date(),                                                                                         // 79
          requirements: requirements                                                                                   // 80
        });                                                                                                            //
                                                                                                                       //
        return {                                                                                                       // 83
          token: sturdyRef                                                                                             // 84
        };                                                                                                             //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return makeToken;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.makeChildToken = function () {                                                           // 26
    function makeChildToken(parent, owner, requirements) {                                                             //
      var _this = this;                                                                                                // 90
      return inMeteor(function () {                                                                                    // 91
        return {                                                                                                       // 92
          token: new Buffer(makeChildTokenInternal(parent, owner, requirements))                                       // 93
        };                                                                                                             //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return makeChildToken;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  SandstormCoreImpl.prototype.getOwnerNotificationTarget = function () {                                               // 26
    function getOwnerNotificationTarget() {                                                                            //
      var grainId = this.grainId;                                                                                      // 99
      return {                                                                                                         // 100
        owner: {                                                                                                       // 101
          addOngoing: function () {                                                                                    // 102
            function addOngoing(displayInfo, notification) {                                                           // 102
              return inMeteor(function () {                                                                            // 103
                var grain = Grains.findOne({ _id: grainId });                                                          // 104
                if (!grain) {                                                                                          // 105
                  throw new Error("Grain not found.");                                                                 // 106
                }                                                                                                      //
                                                                                                                       //
                var castedNotification = notification.castAs(PersistentOngoingNotification);                           // 109
                var wakelockToken = waitPromise(castedNotification.save()).sturdyRef;                                  // 110
                                                                                                                       //
                // We have to close both the casted cap and the original. Perhaps this should be fixed in              //
                // node-capnp?                                                                                         //
                castedNotification.close();                                                                            // 103
                notification.close();                                                                                  // 115
                var notificationId = Notifications.insert({                                                            // 116
                  ongoing: wakelockToken,                                                                              // 117
                  grainId: grainId,                                                                                    // 118
                  userId: grain.userId,                                                                                // 119
                  text: displayInfo.caption,                                                                           // 120
                  timestamp: new Date(),                                                                               // 121
                  isUnread: true                                                                                       // 122
                });                                                                                                    //
                                                                                                                       //
                var persistentMethods = {                                                                              // 125
                  save: function () {                                                                                  // 126
                    function save(params) {                                                                            //
                      return saveFrontendRef({ notificationHandle: notificationId }, params.sealFor);                  // 127
                    }                                                                                                  //
                                                                                                                       //
                    return save;                                                                                       //
                  }()                                                                                                  //
                };                                                                                                     //
                                                                                                                       //
                return { handle: makeNotificationHandle(notificationId, false, persistentMethods) };                   // 131
              });                                                                                                      //
            }                                                                                                          //
                                                                                                                       //
            return addOngoing;                                                                                         //
          }()                                                                                                          //
        }                                                                                                              //
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    return getOwnerNotificationTarget;                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  return SandstormCoreImpl;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var makeSandstormCore = function makeSandstormCore(grainId) {                                                          // 139
  return new Capnp.Capability(new SandstormCoreImpl(grainId), SandstormCore);                                          // 140
};                                                                                                                     //
                                                                                                                       //
var NotificationHandle = function () {                                                                                 //
  function NotificationHandle(notificationId, saved, persistentMethods) {                                              // 144
    (0, _classCallCheck3["default"])(this, NotificationHandle);                                                        //
                                                                                                                       //
    this.notificationId = notificationId;                                                                              // 145
    this.saved = saved;                                                                                                // 146
    _.extend(this, persistentMethods);                                                                                 // 147
  }                                                                                                                    //
                                                                                                                       //
  NotificationHandle.prototype.close = function () {                                                                   // 143
    function close() {                                                                                                 //
      var _this = this;                                                                                                // 151
      return inMeteor(function () {                                                                                    // 152
        if (!_this.saved) {                                                                                            // 153
          _dismissNotification(_this.notificationId);                                                                  // 154
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  return NotificationHandle;                                                                                           //
}();                                                                                                                   //
                                                                                                                       //
var PersistentUiViewImpl = function () {                                                                               //
  function PersistentUiViewImpl(persistentMethods) {                                                                   // 161
    (0, _classCallCheck3["default"])(this, PersistentUiViewImpl);                                                      //
                                                                                                                       //
    _.extend(this, persistentMethods);                                                                                 // 162
  }                                                                                                                    //
                                                                                                                       //
  return PersistentUiViewImpl;                                                                                         //
}()                                                                                                                    //
                                                                                                                       //
// All other UiView methods are currently unimplemented, which, while not strictly correct,                            //
// results in the same overall behavior, since users can't call restore() on a PersistentUiView,                       //
// and grains can't call methods on UiViews because they lack the "is human" pseudopermission.                         //
;                                                                                                                      //
                                                                                                                       //
var makePersistentUiView = function makePersistentUiView(persistentMethods) {                                          // 170
  return new Capnp.Capability(new PersistentUiViewImpl(persistentMethods), PersistentUiView);                          // 171
};                                                                                                                     //
                                                                                                                       //
function makeNotificationHandle(notificationId, saved, persistentMethods) {                                            // 174
  return new Capnp.Capability(new NotificationHandle(notificationId, saved, persistentMethods), PersistentHandle);     // 175
}                                                                                                                      //
                                                                                                                       //
function dropWakelock(grainId, wakeLockNotificationId) {                                                               // 179
  waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                                  // 180
    return supervisor.drop({ wakeLockNotification: wakeLockNotificationId });                                          // 181
  }));                                                                                                                 //
}                                                                                                                      //
                                                                                                                       //
function _dismissNotification(notificationId, callCancel) {                                                            // 185
  var notification = Notifications.findOne({ _id: notificationId });                                                   // 186
  if (notification) {                                                                                                  // 187
    Notifications.remove({ _id: notificationId });                                                                     // 188
    if (notification.ongoing) {                                                                                        // 189
      // For some reason, Mongo returns an object that looks buffer-like, but isn't a buffer.                          //
      // Only way to fix seems to be to copy it.                                                                       //
      var id = new Buffer(notification.ongoing);                                                                       // 192
                                                                                                                       //
      if (!callCancel) {                                                                                               // 194
        dropInternal(id, { frontend: null });                                                                          // 195
      } else {                                                                                                         //
        var notificationCap = restoreInternal(id, { frontend: null }, []).cap;                                         // 197
        var castedNotification = notificationCap.castAs(PersistentOngoingNotification);                                // 198
        dropInternal(id, { frontend: null });                                                                          // 199
        try {                                                                                                          // 200
          waitPromise(castedNotification.cancel());                                                                    // 201
          castedNotification.close();                                                                                  // 202
          notificationCap.close();                                                                                     // 203
        } catch (err) {                                                                                                //
          if (err.kjType !== "disconnected") {                                                                         // 205
            // ignore disconnected errors, since cancel may shutdown the grain before the supervisor                   //
            // responds.                                                                                               //
            throw err;                                                                                                 // 208
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
    } else if (notification.appUpdates) {                                                                              //
      _.forEach(notification.appUpdates, function (app, appId) {                                                       // 213
        deletePackage(app.packageId);                                                                                  // 214
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
hashSturdyRef = function hashSturdyRef(sturdyRef) {                                                                    // 220
  return Crypto.createHash("sha256").update(sturdyRef).digest("base64");                                               // 221
};                                                                                                                     //
                                                                                                                       //
function generateSturdyRef() {                                                                                         // 224
  return Random.secret();                                                                                              // 225
}                                                                                                                      //
                                                                                                                       //
Meteor.methods({                                                                                                       // 228
  dismissNotification: function () {                                                                                   // 229
    function dismissNotification(notificationId) {                                                                     //
      // This will remove notifications from the database and from view of the user.                                   //
      // For ongoing notifications, it will begin the process of cancelling and dropping them from                     //
      // the app.                                                                                                      //
                                                                                                                       //
      check(notificationId, String);                                                                                   // 234
                                                                                                                       //
      var notification = Notifications.findOne({ _id: notificationId });                                               // 236
      if (!notification) {                                                                                             // 237
        throw new Meteor.Error(404, "Notification id not found.");                                                     // 238
      } else if (notification.userId !== Meteor.userId()) {                                                            //
        throw new Meteor.Error(403, "Notification does not belong to current user.");                                  // 240
      } else {                                                                                                         //
        _dismissNotification(notificationId, true);                                                                    // 242
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return dismissNotification;                                                                                        //
  }(),                                                                                                                 //
  readAllNotifications: function () {                                                                                  // 246
    function readAllNotifications() {                                                                                  //
      // Marks all notifications as read for the current user.                                                         //
      if (!Meteor.userId()) {                                                                                          // 248
        throw new Meteor.Error(403, "User not logged in.");                                                            // 249
      }                                                                                                                //
                                                                                                                       //
      Notifications.update({ userId: Meteor.userId() }, { $set: { isUnread: false } }, { multi: true });               // 252
    }                                                                                                                  //
                                                                                                                       //
    return readAllNotifications;                                                                                       //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
saveFrontendRef = function saveFrontendRef(frontendRef, owner, requirements) {                                         // 256
  return inMeteor(function () {                                                                                        // 257
    var sturdyRef = new Buffer(generateSturdyRef());                                                                   // 258
    var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                    // 259
    ApiTokens.insert({                                                                                                 // 260
      _id: hashedSturdyRef,                                                                                            // 261
      frontendRef: frontendRef,                                                                                        // 262
      owner: owner,                                                                                                    // 263
      created: new Date(),                                                                                             // 264
      requirements: requirements                                                                                       // 265
    });                                                                                                                //
    return { sturdyRef: sturdyRef };                                                                                   // 267
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
checkRequirements = function (_checkRequirements) {                                                                    // 271
  function checkRequirements(_x) {                                                                                     //
    return _checkRequirements.apply(this, arguments);                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  checkRequirements.toString = function () {                                                                           //
    return _checkRequirements.toString();                                                                              //
  };                                                                                                                   //
                                                                                                                       //
  return checkRequirements;                                                                                            //
}(function (requirements) {                                                                                            //
  if (!requirements) {                                                                                                 // 272
    return true;                                                                                                       // 273
  }                                                                                                                    //
                                                                                                                       //
  for (var i in meteorBabelHelpers.sanitizeForInObject(requirements)) {                                                // 276
    var requirement = requirements[i];                                                                                 // 277
    if (requirement.tokenValid) {                                                                                      // 278
      var token = ApiTokens.findOne({ _id: requirement.tokenValid }, { fields: { requirements: 1 } });                 // 279
      if (!checkRequirements(token.requirements)) {                                                                    // 280
        return false;                                                                                                  // 281
      }                                                                                                                //
    } else if (requirement.permissionsHeld) {                                                                          //
      var p = requirement.permissionsHeld;                                                                             // 284
      var viewInfo = Grains.findOne(p.grainId, { fields: { cachedViewInfo: 1 } }).cachedViewInfo;                      // 285
      var currentPermissions = SandstormPermissions.grainPermissions(globalDb, { grain: { _id: p.grainId, identityId: p.identityId } }, viewInfo || {});
      if (!currentPermissions) {                                                                                       // 288
        return false;                                                                                                  // 289
      }                                                                                                                //
                                                                                                                       //
      for (var ii = 0; ii < p.permissions.length; ++ii) {                                                              // 292
        if (p.permissions[ii] && !currentPermissions[ii]) {                                                            // 293
          return false;                                                                                                // 294
        }                                                                                                              //
      }                                                                                                                //
    } else if (requirement.userIsAdmin) {                                                                              //
      if (!isAdminById(requirement.userIsAdmin)) {                                                                     // 298
        return false;                                                                                                  // 299
      }                                                                                                                //
    } else {                                                                                                           //
      throw new Meteor.Error(403, "Unknown requirement");                                                              // 302
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return true;                                                                                                         // 306
});                                                                                                                    //
                                                                                                                       //
restoreInternal = function (_restoreInternal) {                                                                        // 309
  function restoreInternal(_x2, _x3, _x4, _x5) {                                                                       //
    return _restoreInternal.apply(this, arguments);                                                                    //
  }                                                                                                                    //
                                                                                                                       //
  restoreInternal.toString = function () {                                                                             //
    return _restoreInternal.toString();                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  return restoreInternal;                                                                                              //
}(function (originalToken, ownerPattern, requirements, tokenId) {                                                      //
  // Restores the token `originalToken`, which is a Buffer.                                                            //
  //                                                                                                                   //
  // `ownerPattern` is a match pattern (i.e. used with check()) that the token's owner must match.                     //
  // This is used to enforce than an entity can't use tokens owned by some other entity.                               //
  //                                                                                                                   //
  // `requirements` is a list of additional MembraneRequirements to add to the returned capability,                    //
  // beyond what's already stored in ApiTokens. This is often an empty list.                                           //
  //                                                                                                                   //
  // `tokenId` is optional. If specified, it should be hashSturdyRef(originalToken); only specify                      //
  // it if you happen to have computed this already.                                                                   //
  //                                                                                                                   //
  // (When the token turns out to have a parent, this function will call itself recursively. When                      //
  // it does, `originalToken` stays the same, but `tokenId` is replaced with the parent. This is                       //
  // because the capability we ultimately restore needs to become a child of the token that is                         //
  // being restored.)                                                                                                  //
                                                                                                                       //
  tokenId = tokenId || hashSturdyRef(originalToken);                                                                   // 326
  requirements = requirements || [];                                                                                   // 327
                                                                                                                       //
  var token = ApiTokens.findOne(tokenId);                                                                              // 329
  if (!token) {                                                                                                        // 330
    throw new Meteor.Error(403, "No token found to restore");                                                          // 331
  }                                                                                                                    //
                                                                                                                       //
  if (token.revoked) {                                                                                                 // 334
    throw new Meteor.Error(403, "Token has been revoked");                                                             // 335
  }                                                                                                                    //
                                                                                                                       //
  // The ownerPattern should specify the appropriate user or grain involved, if appropriate.                           //
  check(token.owner, ownerPattern);                                                                                    // 309
                                                                                                                       //
  // Check requirements on the token.                                                                                  //
  if (!checkRequirements(token.requirements)) {                                                                        // 309
    throw new Meteor.Error(403, "Requirements not satisfied.");                                                        // 343
  }                                                                                                                    //
                                                                                                                       //
  // Check expiration.                                                                                                 //
  if (token.expires && token.expires.getTime() <= Date.now()) {                                                        // 309
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 348
  }                                                                                                                    //
                                                                                                                       //
  if (token.expiresIfUnused) {                                                                                         // 351
    if (token.expiresIfUnused.getTime() <= Date.now()) {                                                               // 352
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 353
    } else {                                                                                                           //
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(token._id, { $unset: { expiresIfUnused: "" } });                                                // 356
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // If this token has a parent, go ahead and recurse to it now.                                                       //
  if (token.parentToken) {                                                                                             // 309
    // A token which chains to some parent token.  Restore the parent token (possibly recursively),                    //
    // checking requirements on the way up.                                                                            //
    return restoreInternal(originalToken, Match.Any, requirements, token.parentToken);                                 // 364
  }                                                                                                                    //
                                                                                                                       //
  // Check the passed-in `requirements`.                                                                               //
  if (!checkRequirements(requirements)) {                                                                              // 309
    throw new Meteor.Error(403, "Requirements not satisfied.");                                                        // 369
  }                                                                                                                    //
                                                                                                                       //
  // The capability we restore must implement SystemPersistent, and we already know what the                           //
  // implementation will look like. So, construct it here.                                                             //
  //                                                                                                                   //
  // TODO(cleanup): It would probably be a lot cleaner to have a common base class that these                          //
  //   inherit, and to pass down some common parameters to the constructor.                                            //
  var persistentMethods = {                                                                                            // 309
    save: function () {                                                                                                // 378
      function save(params) {                                                                                          //
        return inMeteor(function () {                                                                                  // 379
          var sturdyRef = new Buffer(makeChildTokenInternal(originalToken, params.sealFor, requirements, token));      // 380
          return { sturdyRef: sturdyRef };                                                                             // 382
        });                                                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return save;                                                                                                     //
    }()                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  // TODO(someday): Implement SystemPersistent.addRequirements().                                                      //
  if (token.frontendRef) {                                                                                             // 389
    // A token which represents a capability implemented by a pseudo-driver.                                           //
                                                                                                                       //
    if (token.frontendRef.notificationHandle) {                                                                        // 392
      var notificationId = token.frontendRef.notificationHandle;                                                       // 393
      return { cap: makeNotificationHandle(notificationId, true, persistentMethods) };                                 // 394
    } else if (token.frontendRef.ipNetwork) {                                                                          //
      return { cap: makeIpNetwork(persistentMethods) };                                                                // 396
    } else if (token.frontendRef.ipInterface) {                                                                        //
      return { cap: makeIpInterface(persistentMethods) };                                                              // 398
    } else if (token.frontendRef.emailVerifier) {                                                                      //
      return { cap: makeEmailVerifier(persistentMethods, tokenId, token.frontendRef.emailVerifier) };                  // 400
    } else if (token.frontendRef.verifiedEmail) {                                                                      //
      return { cap: makeVerifiedEmail(persistentMethods) };                                                            // 403
    } else {                                                                                                           //
      throw new Meteor.Error(500, "Unknown frontend token type.");                                                     // 405
    }                                                                                                                  //
  } else if (token.objectId) {                                                                                         //
    // A token which represents a specific capability exported by a grain.                                             //
                                                                                                                       //
    // Fix Mongo converting Buffers to Uint8Arrays.                                                                    //
    if (token.objectId.appRef) {                                                                                       // 411
      token.objectId.appRef = new Buffer(token.objectId.appRef);                                                       // 412
    }                                                                                                                  //
                                                                                                                       //
    // Ensure the grain is running, then restore the capability.                                                       //
    return waitPromise(globalBackend.useGrain(token.grainId, function (supervisor) {                                   // 407
      // Note that in this case it is the supervisor's job to implement SystemPersistent, so we                        //
      // discard persistentMethods.                                                                                    //
      return supervisor.restore(token.objectId, requirements, originalToken);                                          // 419
    }));                                                                                                               //
  } else if (token.grainId) {                                                                                          //
    // It's a UiView.                                                                                                  //
                                                                                                                       //
    // If a grain is attempting to restore a UiView, it gets a UiView which filters out all                            //
    // the method calls.  In the future, we may allow grains to restore UiViews that pass along the                    //
    // "is human" pseudopermission (say, to allow an app to proxy all requests to some grain and                       //
    // do some transformation), which will return a different capability.                                              //
    return { cap: makePersistentUiView(persistentMethods) };                                                           // 428
  } else {                                                                                                             //
    throw new Meteor.Error(500, "Unknown token type. ID: " + token._id);                                               // 430
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
function dropInternal(sturdyRef, ownerPattern) {                                                                       // 434
  // Drops `sturdyRef`, checking first that its owner matches `ownerPattern`.                                          //
                                                                                                                       //
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 437
  var token = ApiTokens.findOne({ _id: hashedSturdyRef });                                                             // 438
  if (!token) {                                                                                                        // 439
    return;                                                                                                            // 440
  }                                                                                                                    //
                                                                                                                       //
  check(token.owner, ownerPattern);                                                                                    // 443
                                                                                                                       //
  if (token.frontendRef) {                                                                                             // 445
    if (token.frontendRef.notificationHandle) {                                                                        // 446
      var notificationId = token.frontendRef.notificationHandle;                                                       // 447
      globalDb.removeApiTokens({ _id: hashedSturdyRef });                                                              // 448
      var anyToken = ApiTokens.findOne({ "frontendRef.notificationHandle": notificationId });                          // 449
      if (!anyToken) {                                                                                                 // 450
        // No other tokens referencing this notification exist, so dismiss the notification                            //
        _dismissNotification(notificationId);                                                                          // 452
      }                                                                                                                //
    } else {                                                                                                           //
      throw new Error("Unknown frontend token type.");                                                                 // 455
    }                                                                                                                  //
  } else if (token.objectId) {                                                                                         //
    if (token.objectId.wakeLockNotification) {                                                                         // 458
      dropWakelock(token.grainId, token.objectId.wakeLockNotification);                                                // 459
    } else {                                                                                                           //
      throw new Error("Unknown objectId token type.");                                                                 // 461
    }                                                                                                                  //
  } else {                                                                                                             //
    throw new Error("Unknown token type.");                                                                            // 464
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
function makeChildTokenInternal(rawParentToken, owner, requirements, tokenInfo) {                                      // 468
  var hashedParent = hashSturdyRef(rawParentToken);                                                                    // 469
                                                                                                                       //
  // If we don't have tokenInfo (we were called from SandstormCore.makeChildToken()), look up                          //
  // the parent token now and use that.                                                                                //
  // TODO(someday): I think this makeChildToken() will lose titles because of this.                                    //
  //   Option 1: Somehow pass info through the supervisor for it to pass back through                                  //
  //       makeChildToken().                                                                                           //
  //   Option 2: Follow the chain of parentTokens here.                                                                //
  //   Option 3: Maybe the title should actually be passed in a PowerboxDescriptor which the app                       //
  //       is expected to thread through to offer(). This is analogous to how file transfers                           //
  //       work: the file name is not normally stored in the content. Our petname system for                           //
  //       grains already matches that model better -- and if we decide to get rid of said petname                     //
  //       system and instead have everyone see the author's title, then we'd presumably stop                          //
  //       storing it in the token `owner` field altogether, so this becomes moot.                                     //
  tokenInfo = tokenInfo || ApiTokens.findOne(hashedParent);                                                            // 468
  if (!tokenInfo) {                                                                                                    // 484
    throw new Error("parent token doesn't exist");                                                                     // 485
  }                                                                                                                    //
                                                                                                                       //
  if (tokenInfo.identityId) {                                                                                          // 488
    // This is a UiView capability. We need to use SandstormPermissions to create it in order                          //
    // to properly denormalize fields.                                                                                 //
                                                                                                                       //
    if (owner.user) {                                                                                                  // 492
      // Initialize the grain's title to a copy of the title set by the human user closest in the                      //
      // sharing graph. It turns out that the "root token" is actually the token representing that                     //
      // user, not the grain owner, because user-to-user sharing relationships are not parent-child                    //
      // token relationships.                                                                                          //
      var rootTitle = (((tokenInfo.owner || {}).grain || {}).saveLabel || {}).defaultText;                             // 497
      if (!owner.user.title && rootTitle) {                                                                            // 498
        owner.user.title = rootTitle;                                                                                  // 499
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: rawParentToken }, tokenInfo.grainId, tokenInfo.petname, { allAccess: null }, owner).token;
  }                                                                                                                    //
                                                                                                                       //
  if (owner.user) {                                                                                                    // 507
    throw new Error("can't save non-UiView with user as owner");                                                       // 508
  }                                                                                                                    //
                                                                                                                       //
  var sturdyRef = generateSturdyRef();                                                                                 // 511
  var hashedSturdyRef = hashSturdyRef(sturdyRef);                                                                      // 512
                                                                                                                       //
  var newTokenInfo = {                                                                                                 // 514
    _id: hashedSturdyRef,                                                                                              // 515
    parentToken: hashedParent,                                                                                         // 516
    owner: owner,                                                                                                      // 517
    created: new Date(),                                                                                               // 518
    requirements: requirements                                                                                         // 519
  };                                                                                                                   //
                                                                                                                       //
  // For non-UiView capabilities, we need not denormalize grainId, identityId, etc. into the child                     //
  // token.                                                                                                            //
                                                                                                                       //
  ApiTokens.insert(newTokenInfo);                                                                                      // 468
                                                                                                                       //
  return sturdyRef;                                                                                                    // 527
};                                                                                                                     //
                                                                                                                       //
function SandstormCoreFactoryImpl() {}                                                                                 // 530
                                                                                                                       //
SandstormCoreFactoryImpl.prototype.getSandstormCore = function (grainId) {                                             // 533
  return { core: makeSandstormCore(grainId) };                                                                         // 534
};                                                                                                                     //
                                                                                                                       //
makeSandstormCoreFactory = function makeSandstormCoreFactory() {                                                       // 537
  return new Capnp.Capability(new SandstormCoreFactoryImpl(), SandstormCoreFactory);                                   // 538
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"demo-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/demo-server.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var DEMO_EXPIRATION_MS = 60 * 60 * 1000;                                                                               // 17
var DEMO_GRACE_MS = 10 * 60 * 1000; // time between expiration and deletion                                            // 18
                                                                                                                       //
Accounts.validateLoginAttempt(function (attempt) {                                                                     // 20
  // Enforce expiration times for demo accounts.                                                                       //
                                                                                                                       //
  if (attempt.user && attempt.user.expires) {                                                                          // 23
    (function () {                                                                                                     //
      var expireIn = attempt.user.expires.getTime() - Date.now() + DEMO_GRACE_MS;                                      // 24
      if (expireIn < 0) {                                                                                              // 25
        throw new Meteor.Error(403, "This demo account has expired.");                                                 // 26
      }                                                                                                                //
                                                                                                                       //
      if (!allowDemo) {                                                                                                // 29
        // An expiration time implies that this is a demo account, but those have been disabled.                       //
        // Perhaps the config was just changed.                                                                        //
        throw new Meteor.Error(403, "Demo accounts have been disabled.");                                              // 32
      }                                                                                                                //
                                                                                                                       //
      // Force connection close when account expires, so that the client reconnects and                                //
      // re-authenticates, which fails.                                                                                //
      var connection = attempt.connection;                                                                             // 37
      var handle = Meteor.setTimeout(function () {                                                                     // 38
        connection.close();                                                                                            // 38
      }, expireIn);                                                                                                    //
                                                                                                                       //
      connection.onClose(function () {                                                                                 // 40
        Meteor.clearTimeout(handle);                                                                                   // 40
      });                                                                                                              //
    })();                                                                                                              //
  }                                                                                                                    //
                                                                                                                       //
  return true;                                                                                                         // 43
});                                                                                                                    //
                                                                                                                       //
function cleanupExpiredUsers() {                                                                                       // 46
  // Delete expired demo accounts and all their grains.                                                                //
                                                                                                                       //
  var now = new Date(Date.now() - DEMO_GRACE_MS);                                                                      // 49
  Meteor.users.find({ expires: { $lt: now } }, { fields: { _id: 1, loginIdentities: 1, lastActive: 1, appDemoId: 1 } }).forEach(function (user) {
    Grains.find({ userId: user._id }, { fields: { _id: 1, lastUsed: 1, appId: 1 } }).forEach(function (grain) {        // 53
      console.log("delete grain: " + grain._id);                                                                       // 55
      globalDb.removeApiTokens({ grainId: grain._id });                                                                // 56
      Grains.remove(grain._id);                                                                                        // 57
      if (grain.lastUsed) {                                                                                            // 58
        DeleteStats.insert({ type: "demoGrain", lastActive: grain.lastUsed, appId: grain.appId });                     // 59
      }                                                                                                                //
                                                                                                                       //
      globalBackend.deleteGrain(grain._id, user._id);                                                                  // 62
    });                                                                                                                //
                                                                                                                       //
    console.log("delete user: " + user._id);                                                                           // 65
    // We intentionally do not do `ApiTokens.remove({accountId: user._id})`, because some such                         //
    // tokens might still play an active role in the sharing graph.                                                    //
    Contacts.remove({ ownerId: user._id });                                                                            // 52
    UserActions.remove({ userId: user._id });                                                                          // 69
    Notifications.remove({ userId: user._id });                                                                        // 70
    Meteor.users.remove(user._id);                                                                                     // 71
    waitPromise(globalBackend.cap().deleteUser(user._id));                                                             // 72
    if (user.loginIdentities && user.lastActive) {                                                                     // 73
      // When deleting a user, we can specify it as a "normal" user                                                    //
      // (type: user) or as a user who started out by using the app                                                    //
      // demo feature (type: appDemoUser).                                                                             //
      var deleteStatsType = "demoUser";                                                                                // 77
      var isAppDemoUser = !!user.appDemoId;                                                                            // 78
      if (isAppDemoUser) {                                                                                             // 79
        deleteStatsType = "appDemoUser";                                                                               // 80
      }                                                                                                                //
                                                                                                                       //
      // Intentionally record deleted users at time of deletion to avoid miscounting users that                        //
      // were demoing just before the day rolled over.                                                                 //
      DeleteStats.insert({ type: deleteStatsType, lastActive: new Date(), appId: user.appDemoId });                    // 73
    }                                                                                                                  //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
if (allowDemo) {                                                                                                       // 90
  Meteor.methods({                                                                                                     // 91
    createDemoUser: function () {                                                                                      // 92
      function createDemoUser(displayName, appDemoId) {                                                                // 92
        // This is a login method that creates a new temporary user                                                    //
        // every time it is used.                                                                                      //
        //                                                                                                             //
        // appDemoId is important for stats; see cleanupExpiredUsers().                                                //
        check(displayName, String);                                                                                    // 97
        check(appDemoId, Match.OneOf(undefined, null, String));                                                        // 98
                                                                                                                       //
        // Create the new user.                                                                                        //
        var newUser = { expires: new Date(Date.now() + DEMO_EXPIRATION_MS) };                                          // 92
        if (appDemoId) {                                                                                               // 102
          newUser.appDemoId = appDemoId;                                                                               // 103
        }                                                                                                              //
                                                                                                                       //
        var userId = Accounts.insertUserDoc({ profile: { name: displayName } }, newUser);                              // 106
                                                                                                                       //
        // Log them in on this connection.                                                                             //
        return Accounts._loginMethod(this, "createDemoUser", arguments, "demo", function () {                          // 92
          return { userId: userId };                                                                                   // 110
        });                                                                                                            //
      }                                                                                                                //
                                                                                                                       //
      return createDemoUser;                                                                                           //
    }(),                                                                                                               //
                                                                                                                       //
    testExpireDemo: function () {                                                                                      // 113
      function testExpireDemo() {                                                                                      // 113
        if (!isDemoUser()) throw new Meteor.Error(403, "not a demo user");                                             // 114
                                                                                                                       //
        var newExpires = new Date(Date.now() + 15000);                                                                 // 116
        if (Meteor.user().expires.getTime() < newExpires.getTime()) {                                                  // 117
          throw new Meteor.Error(403, "can't exend demo");                                                             // 118
        }                                                                                                              //
                                                                                                                       //
        Meteor.users.update(this.userId, { $set: { expires: newExpires } });                                           // 121
      }                                                                                                                //
                                                                                                                       //
      return testExpireDemo;                                                                                           //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  // If demo mode is enabled, we permit the client to subscribe to                                                     //
  // information about an app by appId. If this were available in                                                      //
  // non-demo mode, then anonymous users could effectively ask the                                                     //
  // server which apps are installed.                                                                                  //
  Meteor.publish("appInfo", function (appId) {                                                                         // 90
    // This publishes info about an app, including the latest                                                          //
    // version of it. Once you log in, it also publishes your                                                          //
    // list of UserActions.                                                                                            //
    check(appId, String);                                                                                              // 133
                                                                                                                       //
    var packageCursor = Packages.find({ appId: appId }, { sort: { "manifest.appVersion": -1 } });                      // 135
                                                                                                                       //
    var pkg = packageCursor.fetch()[0];                                                                                // 139
                                                                                                                       //
    // This allows us to avoid creating duplicate UserActions.                                                         //
    if (this.userId) {                                                                                                 // 129
      return [packageCursor, UserActions.find({ userId: this.userId, appId: appId })];                                 // 143
    }                                                                                                                  //
                                                                                                                       //
    return packageCursor;                                                                                              // 149
  });                                                                                                                  //
                                                                                                                       //
  SandstormDb.periodicCleanup(DEMO_EXPIRATION_MS, cleanupExpiredUsers);                                                // 152
} else {                                                                                                               //
  // Just run once, in case the config just changed from allowing demos to prohibiting them.                           //
  Meteor.setTimeout(cleanupExpiredUsers, DEMO_EXPIRATION_MS + DEMO_GRACE_MS);                                          // 155
}                                                                                                                      //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/dev-accounts-server.js                                                                                       //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
Meteor.methods({                                                                                                       // 19
  createDevAccount: function () {                                                                                      // 20
    function createDevAccount(displayName, isAdmin, profile, unverifiedEmail) {                                        // 20
      // This is a login method that creates or logs in a dev account with the given displayName                       //
                                                                                                                       //
      check(displayName, String);                                                                                      // 23
      check(isAdmin, Match.OneOf(undefined, null, Boolean));                                                           // 24
      check(profile, Match.OneOf(undefined, null, Object));                                                            // 25
      check(unverifiedEmail, Match.OneOf(undefined, null, String));                                                    // 26
                                                                                                                       //
      if (!this.connection.sandstormDb.allowDevAccounts()) {                                                           // 28
        throw new Meteor.Error(404, "Dev accounts are not enabled on this server");                                    // 29
      }                                                                                                                //
                                                                                                                       //
      isAdmin = isAdmin || false;                                                                                      // 32
                                                                                                                       //
      profile = profile || {};                                                                                         // 34
      profile.name = profile.name || displayName;                                                                      // 35
      var hasCompletedSignup = !!unverifiedEmail && !!profile.pronoun && !!profile.handle;                             // 36
                                                                                                                       //
      var user = Meteor.users.findOne({ "services.dev.name": displayName });                                           // 38
      var userId = void 0;                                                                                             // 39
                                                                                                                       //
      if (user) {                                                                                                      // 41
        userId = user._id;                                                                                             // 42
      } else {                                                                                                         //
        userId = Accounts.insertUserDoc({ profile: profile,                                                            // 44
          unverifiedEmail: unverifiedEmail }, { services: { dev: { name: displayName,                                  // 45
              isAdmin: isAdmin,                                                                                        // 48
              hasCompletedSignup: hasCompletedSignup } } });                                                           // 49
      }                                                                                                                //
      // Log them in on this connection.                                                                               //
      return Accounts._loginMethod(this, "createDevAccount", arguments, "dev", function () {                           // 20
        return { userId: userId };                                                                                     // 53
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return createDevAccount;                                                                                           //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"feature-key.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/feature-key.js                                                                                               //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Capnp = Npm.require("capnp");                                                                                      // 17
var FeatureKey = Capnp.importSystem("sandstorm/feature-key.capnp").FeatureKey;                                         // 18
                                                                                                                       //
// We don't currently have a way of reading the raw bytes of a capnp struct in Javascript the                          //
// way we do in C++. Awkwardly, what we end up with is four 64-bit ints that have been stringified                     //
// since JS can't actually deal with 64-bit ints. We have to laboriously reconstruct the underlying                    //
// bytes using Bignum. Don't forget that everything is little-endian, as DJBeesus intended.                            //
var bits0 = Bignum(FeatureKey.signingKey.key0);                                                                        // 24
var bits1 = Bignum(FeatureKey.signingKey.key1);                                                                        // 25
var bits2 = Bignum(FeatureKey.signingKey.key2);                                                                        // 26
var bits3 = Bignum(FeatureKey.signingKey.key3);                                                                        // 27
var signingKey = bits0.add(bits1.shiftLeft(64 * 1)).add(bits2.shiftLeft(64 * 2)).add(bits3.shiftLeft(64 * 3)).toBuffer({ endian: "little", size: 32 });
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 34
                                                                                                                       //
function verifyFeatureKeySignature(buf) {                                                                              // 37
  // buf is a Buffer containing an feature key with attached signature.                                                //
  // This function returns the signed data if the signature is valid,                                                  //
  // or undefined if the signature is invalid.                                                                         //
                                                                                                                       //
  // Per crypto_sign, the first 64 bytes are the ed25519 signature                                                     //
  // and the rest of the blob is the signed data.                                                                      //
  var signature = buf.slice(0, 64);                                                                                    // 44
  var signedData = buf.slice(64);                                                                                      // 45
                                                                                                                       //
  if (!Ed25519.Verify(signedData, signature, signingKey)) {                                                            // 47
    console.error("feature key failed signature check", bits0, bits1, bits2, bits3);                                   // 48
    return undefined;                                                                                                  // 49
  } else {                                                                                                             //
    return signedData;                                                                                                 // 51
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
// Export for use in db.js and server/admin.js                                                                         //
loadSignedFeatureKey = function loadSignedFeatureKey(buf) {                                                            // 56
  // Given a Buffer containing a signed feature key, verifies and parses the feature key.                              //
  // Returns the parsed FeatureKey if it was signed by a trusted key, or                                               //
  // undefined if the signature did not pass verification.                                                             //
  var verifiedFeatureKeyBlob = verifyFeatureKeySignature(buf);                                                         // 60
  if (verifiedFeatureKeyBlob) {                                                                                        // 61
    var featureKey = Capnp.parsePacked(FeatureKey, verifiedFeatureKeyBlob);                                            // 62
    if (featureKey.isForTesting && !isTesting) {                                                                       // 63
      // This key is for testing only, but the server is not running in testing mode. Note that                        //
      // enabling testing mode forfeits up all security.                                                               //
      return undefined;                                                                                                // 66
    }                                                                                                                  //
                                                                                                                       //
    return featureKey;                                                                                                 // 69
  } else {                                                                                                             //
    return undefined;                                                                                                  // 71
  }                                                                                                                    //
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"grain-server.js":["babel-runtime/helpers/typeof",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/grain-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
                                                                                                                       //
var emailLinkWithInlineStyle = function emailLinkWithInlineStyle(url, text) {                                          // 19
  return "<a href='" + url + "' style='display:inline-block;text-decoration:none;" + "font-family:sans-serif;width:200px;min-height:30px;line-height:30px;" + "border-radius:4px;text-align:center;background:#762F87;color:white'>" + text + "</a>";
};                                                                                                                     //
                                                                                                                       //
Meteor.publish("grainTopBar", function (grainId) {                                                                     // 26
  check(grainId, String);                                                                                              // 27
                                                                                                                       //
  var result = [Grains.find({                                                                                          // 29
    _id: grainId,                                                                                                      // 31
    $or: [{ userId: this.userId }, { "private": { $ne: true } }]                                                       // 32
  }, {                                                                                                                 //
    fields: {                                                                                                          // 37
      title: 1,                                                                                                        // 38
      userId: 1,                                                                                                       // 39
      identityId: 1,                                                                                                   // 40
      "private": 1                                                                                                     // 41
    }                                                                                                                  //
  })];                                                                                                                 //
  if (this.userId) {                                                                                                   // 45
    var myIdentityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                 // 46
    result.push(ApiTokens.find({                                                                                       // 47
      grainId: grainId,                                                                                                // 48
      $or: [{ "owner.user.identityId": { $in: myIdentityIds } }, { identityId: { $in: myIdentityIds } }]               // 49
    }));                                                                                                               //
  }                                                                                                                    //
                                                                                                                       //
  return result;                                                                                                       // 56
});                                                                                                                    //
                                                                                                                       //
// We allow users to learn package information about a grain they own.                                                 //
// This is used for obtaining icon and app title information for grains                                                //
// you own, which is used in the sidebar. It is not a security/privacy                                                 //
// risk since it only exposes this information for grains the user owns.                                               //
Meteor.publish("packageByGrainId", function (grainId) {                                                                // 63
  check(grainId, String);                                                                                              // 64
  var publishThis = [];                                                                                                // 65
  // We need to publish the packageId so that client-side code can                                                     //
  // find the right package.                                                                                           //
  var thisGrainCursor = Grains.find({                                                                                  // 63
    _id: grainId,                                                                                                      // 69
    userId: this.userId                                                                                                // 70
  }, {                                                                                                                 //
    fields: { packageId: 1 }                                                                                           // 72
  });                                                                                                                  //
  publishThis.push(thisGrainCursor);                                                                                   // 74
                                                                                                                       //
  if (thisGrainCursor.count()) {                                                                                       // 76
    var thisGrain = thisGrainCursor.fetch()[0];                                                                        // 77
    var thisPackageCursor = Packages.find({ _id: thisGrain.packageId });                                               // 78
    publishThis.push(thisPackageCursor);                                                                               // 79
  }                                                                                                                    //
                                                                                                                       //
  return publishThis;                                                                                                  // 82
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("tokenInfo", function (token) {                                                                         // 85
  // Allows the client side to map a raw token to its entry in ApiTokens, and the additional                           //
  // metadata that it will need to display the app icon and title.  We do not care about making                        //
  // the metadata reactive.                                                                                            //
  check(token, String);                                                                                                // 89
                                                                                                                       //
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 91
  var apiToken = ApiTokens.findOne({                                                                                   // 92
    _id: hashedToken                                                                                                   // 93
  }, {                                                                                                                 //
    fields: {                                                                                                          // 95
      grainId: 1,                                                                                                      // 96
      identityId: 1,                                                                                                   // 97
      owner: 1,                                                                                                        // 98
      revoked: 1                                                                                                       // 99
    }                                                                                                                  //
  });                                                                                                                  //
  if (!apiToken) {                                                                                                     // 102
    this.added("tokenInfo", token, { invalidToken: true });                                                            // 103
  } else if (apiToken.revoked) {                                                                                       //
    this.added("tokenInfo", token, { revoked: true });                                                                 // 105
  } else {                                                                                                             //
    var grainId = apiToken.grainId;                                                                                    // 107
    var grain = Grains.findOne({                                                                                       // 108
      _id: grainId                                                                                                     // 109
    }, {                                                                                                               //
      fields: {                                                                                                        // 111
        packageId: 1,                                                                                                  // 112
        appId: 1,                                                                                                      // 113
        userId: 1                                                                                                      // 114
      }                                                                                                                //
    });                                                                                                                //
    if (!grain) {                                                                                                      // 117
      this.added("tokenInfo", token, { invalidToken: true });                                                          // 118
    } else {                                                                                                           //
      if (apiToken.owner && apiToken.owner.user) {                                                                     // 120
        var identity = globalDb.getIdentity(apiToken.owner.user.identityId);                                           // 121
        var metadata = apiToken.owner.user.denormalizedGrainMetadata;                                                  // 122
        if (identity && metadata) {                                                                                    // 123
          SandstormDb.fillInLoginId(identity);                                                                         // 124
          this.added("tokenInfo", token, { identityOwner: _.pick(identity, "_id", "profile", "loginId"),               // 125
            grainId: grainId,                                                                                          // 127
            grainMetadata: metadata                                                                                    // 128
          });                                                                                                          //
        } else {                                                                                                       //
          this.added("tokenInfo", token, { invalidToken: true });                                                      // 131
        }                                                                                                              //
      } else if (!apiToken.owner || "webkey" in apiToken.owner) {                                                      //
        if (this.userId) {                                                                                             // 134
          var user = Meteor.users.findOne({ _id: this.userId });                                                       // 135
          var identityIds = SandstormDb.getUserIdentityIds(user);                                                      // 136
          var childToken = ApiTokens.findOne({ "owner.user.identityId": { $in: identityIds },                          // 137
            parentToken: apiToken._id });                                                                              // 138
          if (childToken || this.userId === grain.userId || identityIds.indexOf(apiToken.identityId) >= 0) {           // 139
            this.added("tokenInfo", token, { alreadyRedeemed: true, grainId: apiToken.grainId });                      // 141
            this.ready();                                                                                              // 142
            return;                                                                                                    // 143
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        var pkg = Packages.findOne({ _id: grain.packageId }, { fields: { manifest: 1 } });                             // 147
        var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                            // 148
        var appIcon = undefined;                                                                                       // 149
        if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                             // 150
          var icons = pkg.manifest.metadata.icons;                                                                     // 151
          appIcon = icons.grain || icons.appGrid;                                                                      // 152
        }                                                                                                              //
                                                                                                                       //
        var denormalizedGrainMetadata = {                                                                              // 155
          appTitle: appTitle,                                                                                          // 156
          icon: appIcon,                                                                                               // 157
          appId: appIcon ? undefined : grain.appId                                                                     // 158
        };                                                                                                             //
        this.added("tokenInfo", token, { webkey: true,                                                                 // 160
          grainId: grainId,                                                                                            // 162
          grainMetadata: denormalizedGrainMetadata });                                                                 // 163
      } else {                                                                                                         //
        this.added("tokenInfo", token, { invalidToken: true });                                                        // 165
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  this.ready();                                                                                                        // 170
  return;                                                                                                              // 171
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("requestingAccess", function (grainId) {                                                                // 174
  check(grainId, String);                                                                                              // 175
                                                                                                                       //
  if (!this.userId) {                                                                                                  // 177
    throw new Meteor.Error(403, "Must be logged in to request access.");                                               // 178
  }                                                                                                                    //
                                                                                                                       //
  var grain = globalDb.getGrain(grainId);                                                                              // 181
  if (!grain) {                                                                                                        // 182
    throw new Meteor.Error(404, "Grain not found.");                                                                   // 183
  }                                                                                                                    //
                                                                                                                       //
  if (grain.userId === this.userId) {                                                                                  // 186
    this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: grain.identityId });              // 187
  }                                                                                                                    //
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: this.userId }));                        // 191
  var ownerIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: grain.userId }));                  // 192
                                                                                                                       //
  var _this = this;                                                                                                    // 195
  var query = ApiTokens.find({ grainId: grainId, identityId: { $in: ownerIdentityIds },                                // 196
    parentToken: { $exists: false },                                                                                   // 197
    "owner.user.identityId": { $in: identityIds },                                                                     // 198
    revoked: { $ne: true } });                                                                                         // 199
  var handle = query.observe({                                                                                         // 200
    added: function () {                                                                                               // 201
      function added(apiToken) {                                                                                       //
        _this.added("grantedAccessRequests", Random.id(), { grainId: grainId, identityId: apiToken.owner.user.identityId });
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  this.onStop(function () {                                                                                            // 207
    return handle.stop();                                                                                              //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("grainSize", function (grainId) {                                                                       // 210
  // Publish pseudo-collection containing the size of the grain opened in the given session.                           //
  check(grainId, String);                                                                                              // 212
                                                                                                                       //
  var grain = Grains.findOne(grainId);                                                                                 // 214
  if (!grain || grain.userId !== this.userId) {                                                                        // 215
    return [];                                                                                                         // 216
  }                                                                                                                    //
                                                                                                                       //
  var supervisor = globalBackend.cap().getGrain(this.userId, grainId).supervisor;                                      // 219
                                                                                                                       //
  var _this = this;                                                                                                    // 221
  var stopped = false;                                                                                                 // 222
  var promise = getGrainSize(supervisor);                                                                              // 223
                                                                                                                       //
  function getNext(oldSize) {                                                                                          // 225
    promise = getGrainSize(supervisor, oldSize);                                                                       // 226
    promise.then(function (size) {                                                                                     // 227
      if (!stopped) {                                                                                                  // 228
        if (size !== oldSize) {                                                                                        // 229
          // sometimes there are false alarms                                                                          //
          _this.changed("grainSizes", grainId, { size: size });                                                        // 230
        }                                                                                                              //
                                                                                                                       //
        getNext(size);                                                                                                 // 233
      }                                                                                                                //
    }, function (err) {                                                                                                //
                                                                                                                       //
      if (!stopped) {                                                                                                  // 237
        if (err.kjType === "disconnected") {                                                                           // 238
          _this.stop();                                                                                                // 239
        } else {                                                                                                       //
          _this.error(err);                                                                                            // 241
        }                                                                                                              //
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  promise.then(function (size) {                                                                                       // 247
    if (!stopped) {                                                                                                    // 248
      _this.added("grainSizes", grainId, { size: size });                                                              // 249
      _this.ready();                                                                                                   // 250
      getNext(size);                                                                                                   // 251
    }                                                                                                                  //
  }, function (err) {                                                                                                  //
                                                                                                                       //
    if (!stopped) {                                                                                                    // 255
      if (err.kjType === "disconnected") {                                                                             // 256
        _this.stop();                                                                                                  // 257
      } else {                                                                                                         //
        _this.error(err);                                                                                              // 259
      }                                                                                                                //
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  _this.onStop(function () {                                                                                           // 264
    stopped = true;                                                                                                    // 265
    promise.cancel();                                                                                                  // 266
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Meteor.methods({                                                                                                       // 270
  deleteGrain: function () {                                                                                           // 271
    function deleteGrain(grainId) {                                                                                    // 271
      check(grainId, String);                                                                                          // 272
                                                                                                                       //
      if (this.userId) {                                                                                               // 274
        var grain = Grains.findOne({ _id: grainId, userId: this.userId });                                             // 275
        if (grain) {                                                                                                   // 276
          Grains.remove(grainId);                                                                                      // 277
          globalDb.removeApiTokens({                                                                                   // 278
            grainId: grainId,                                                                                          // 279
            $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                          // 280
          });                                                                                                          //
          if (grain.lastUsed) {                                                                                        // 285
            DeleteStats.insert({ type: isDemoUser() ? "demoGrain" : "grain",                                           // 286
              lastActive: grain.lastUsed, appId: grain.appId });                                                       // 287
          }                                                                                                            //
                                                                                                                       //
          if (!this.isSimulation) {                                                                                    // 290
            waitPromise(globalBackend.deleteGrain(grainId, this.userId));                                              // 291
            Meteor.call("deleteUnusedPackages", grain.appId);                                                          // 292
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return deleteGrain;                                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  forgetGrain: function () {                                                                                           // 298
    function forgetGrain(grainId, identityId) {                                                                        // 298
      // TODO(cleanup): For now we are ignoring `identityId`, but maybe we should expose finer-grained                 //
      //  forgetting.                                                                                                  //
                                                                                                                       //
      check(grainId, String);                                                                                          // 302
      check(identityId, String);                                                                                       // 303
                                                                                                                       //
      if (!this.userId) {                                                                                              // 305
        throw new Meteor.Error(403, "Must be logged in to forget a grain.");                                           // 306
      }                                                                                                                //
                                                                                                                       //
      SandstormDb.getUserIdentityIds(Meteor.user()).forEach(function (identityId) {                                    // 309
        globalDb.removeApiTokens({ grainId: grainId, "owner.user.identityId": identityId });                           // 310
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return forgetGrain;                                                                                                //
  }(),                                                                                                                 //
                                                                                                                       //
  updateGrainPreferredIdentity: function () {                                                                          // 314
    function updateGrainPreferredIdentity(grainId, identityId) {                                                       // 314
      check(grainId, String);                                                                                          // 315
      check(identityId, String);                                                                                       // 316
      if (!this.userId) {                                                                                              // 317
        throw new Meteor.Error(403, "Must be logged in.");                                                             // 318
      }                                                                                                                //
                                                                                                                       //
      var grain = globalDb.getGrain(grainId) || {};                                                                    // 321
      if (!grain.userId === this.userId) {                                                                             // 322
        throw new Meteor.Error(403, "Grain not owned by current user.");                                               // 323
      }                                                                                                                //
                                                                                                                       //
      Grains.update({ _id: grainId }, { $set: { identityId: identityId } });                                           // 326
    }                                                                                                                  //
                                                                                                                       //
    return updateGrainPreferredIdentity;                                                                               //
  }(),                                                                                                                 //
                                                                                                                       //
  updateGrainTitle: function () {                                                                                      // 329
    function updateGrainTitle(grainId, newTitle, identityId) {                                                         // 329
      check(grainId, String);                                                                                          // 330
      check(newTitle, String);                                                                                         // 331
      check(identityId, String);                                                                                       // 332
      if (this.userId) {                                                                                               // 333
        var grain = Grains.findOne(grainId);                                                                           // 334
        if (grain) {                                                                                                   // 335
          if (grain.userId === this.userId) {                                                                          // 336
            Grains.update({ _id: grainId, userId: this.userId }, { $set: { title: newTitle } });                       // 337
          } else {                                                                                                     //
            if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                  // 339
              throw new Meteor.Error(403, "Current user does not have identity " + identityId);                        // 340
            }                                                                                                          //
                                                                                                                       //
            var token = ApiTokens.findOne({                                                                            // 343
              grainId: grainId,                                                                                        // 344
              objectId: { $exists: false },                                                                            // 345
              "owner.user.identityId": identityId                                                                      // 346
            }, {                                                                                                       //
              sort: { created: 1 }                                                                                     // 348
            });                                                                                                        //
            if (token) {                                                                                               // 350
              ApiTokens.update(token._id, { $set: { "owner.user.title": newTitle } });                                 // 351
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return updateGrainTitle;                                                                                           //
  }(),                                                                                                                 //
                                                                                                                       //
  privatizeGrain: function () {                                                                                        // 358
    function privatizeGrain(grainId) {                                                                                 // 358
      check(grainId, String);                                                                                          // 359
      if (this.userId) {                                                                                               // 360
        Grains.update({ _id: grainId, userId: this.userId }, { $set: { "private": true } });                           // 361
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return privatizeGrain;                                                                                             //
  }(),                                                                                                                 //
                                                                                                                       //
  inviteUsersToGrain: function () {                                                                                    // 365
    function inviteUsersToGrain(origin, identityId, grainId, title, roleAssignment, contacts, message) {               // 365
      var _this2 = this;                                                                                               //
                                                                                                                       //
      if (!this.isSimulation) {                                                                                        // 367
        var _ret = function () {                                                                                       //
          check(origin, String);                                                                                       // 368
          check(identityId, String);                                                                                   // 369
          check(grainId, String);                                                                                      // 370
          check(title, String);                                                                                        // 371
          check(roleAssignment, roleAssignmentPattern);                                                                // 372
          check(contacts, [{                                                                                           // 373
            _id: String,                                                                                               // 375
            isDefault: Match.Optional(Boolean),                                                                        // 376
            profile: Match.ObjectIncluding({                                                                           // 377
              service: String,                                                                                         // 378
              name: String,                                                                                            // 379
              intrinsicName: String                                                                                    // 380
            })                                                                                                         //
          }]);                                                                                                         //
          check(message, { text: String, html: String });                                                              // 384
          if (!_this2.userId) {                                                                                        // 385
            throw new Meteor.Error(403, "Must be logged in to share by email.");                                       // 386
          }                                                                                                            //
                                                                                                                       //
          if (!globalDb.userHasIdentity(_this2.userId, identityId)) {                                                  // 389
            throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                         // 390
          }                                                                                                            //
                                                                                                                       //
          if (contacts.length === 0) {                                                                                 // 393
            throw new Meteor.Error(400, "No contacts were provided.");                                                 // 394
          }                                                                                                            //
                                                                                                                       //
          var accountId = _this2.userId;                                                                               // 397
          var outerResult = { successes: [], failures: [] };                                                           // 398
          var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                        // 399
          var replyTo = globalDb.getPrimaryEmail(accountId, identityId);                                               // 400
          contacts.forEach(function (contact) {                                                                        // 401
            if (contact.isDefault && contact.profile.service === "email") {                                            // 402
              var emailAddress = contact.profile.intrinsicName;                                                        // 403
              var result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "email invitation for " + emailAddress, roleAssignment, { webkey: { forSharing: true } });
              var url = origin + "/shared/" + result.token;                                                            // 408
              var html = message.html + "<br><br>" + emailLinkWithInlineStyle(url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: If you forward this email to other people, they will be able to access " + "the share as well. To prevent this, remove the button before forwarding.</div>";
              try {                                                                                                    // 414
                SandstormEmail.send({                                                                                  // 415
                  to: emailAddress,                                                                                    // 416
                  from: fromEmail,                                                                                     // 417
                  replyTo: replyTo,                                                                                    // 418
                  subject: title + " - Invitation to collaborate",                                                     // 419
                  text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + url + "\n\nNote: If you forward this email to other people, they will be able to " + "access the share as well. To prevent this, remove the link before forwarding.",
                  html: html                                                                                           // 423
                });                                                                                                    //
              } catch (e) {                                                                                            //
                outerResult.failures.push({ contact: contact, error: e.toString() });                                  // 426
              }                                                                                                        //
            } else {                                                                                                   //
              var _result = SandstormPermissions.createNewApiToken(globalDb, { identityId: identityId, accountId: accountId }, grainId, "direct invitation to " + contact.profile.intrinsicName, roleAssignment, { user: { identityId: contact._id, title: title } });
              var _url = origin + "/shared/" + _result.token;                                                          // 433
              try {                                                                                                    // 434
                var identity = Meteor.users.findOne({ _id: contact._id });                                             // 435
                var email = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                   // 436
                if (email) {                                                                                           // 438
                  var intrinsicName = contact.profile.intrinsicName;                                                   // 439
                  var loginNote = void 0;                                                                              // 440
                  if (contact.profile.service === "google") {                                                          // 441
                    loginNote = "Google account with address " + email.email;                                          // 442
                  } else if (contact.profile.service === "github") {                                                   //
                    loginNote = "Github account with username " + intrinsicName;                                       // 444
                  } else if (contact.profile.service === "email") {                                                    //
                    loginNote = "email address " + intrinsicName;                                                      // 446
                  } else if (contact.profile.service === "ldap") {                                                     //
                    loginNote = "LDAP username " + intrinsicName;                                                      // 448
                  } else if (contact.profile.service === "saml") {                                                     //
                    loginNote = "SAML ID " + intrinsicName;                                                            // 450
                  } else {                                                                                             //
                    throw new Meteor.Error(500, "Unknown service to email share link.");                               // 452
                  }                                                                                                    //
                                                                                                                       //
                  var _html = message.html + "<br><br>" + emailLinkWithInlineStyle(_url, "Open Shared Grain") + "<div style='font-size:8pt;font-style:italic;color:gray'>" + "Note: You will need to log in with your " + loginNote + " to access this grain.";
                  SandstormEmail.send({                                                                                // 460
                    to: email.email,                                                                                   // 461
                    from: fromEmail,                                                                                   // 462
                    replyTo: replyTo,                                                                                  // 463
                    subject: title + " - Invitation to collaborate",                                                   // 464
                    text: message.text + "\n\nFollow this link to open the shared grain:\n\n" + _url + "\n\nNote: You will need to log in with your " + loginNote + " to access this grain.",
                    html: _html                                                                                        // 468
                  });                                                                                                  //
                } else {                                                                                               //
                  outerResult.failures.push({ contact: contact, warning: "User does not have a " + "verified email, so notification of this share was not sent to them. Please " + "manually share " + _url + " with them." });
                }                                                                                                      //
              } catch (e) {                                                                                            //
                outerResult.failures.push({ contact: contact, error: e.toString(),                                     // 476
                  warning: "Share succeeded, but there was an error emailing the user. Please " + "manually share " + _url + " with them." });
              }                                                                                                        //
            }                                                                                                          //
          });                                                                                                          //
                                                                                                                       //
          return {                                                                                                     // 483
            v: outerResult                                                                                             //
          };                                                                                                           //
        }();                                                                                                           //
                                                                                                                       //
        if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret)) === "object") return _ret.v;  //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return inviteUsersToGrain;                                                                                         //
  }(),                                                                                                                 //
                                                                                                                       //
  requestAccess: function () {                                                                                         // 487
    function requestAccess(origin, grainId, identityId) {                                                              // 487
      check(origin, String);                                                                                           // 488
      check(grainId, String);                                                                                          // 489
      check(identityId, String);                                                                                       // 490
      if (!this.isSimulation) {                                                                                        // 491
        if (!this.userId) {                                                                                            // 492
          throw new Meteor.Error(403, "Must be logged in to request access.");                                         // 493
        }                                                                                                              //
                                                                                                                       //
        if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                      // 496
          throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                           // 497
        }                                                                                                              //
                                                                                                                       //
        var grain = Grains.findOne(grainId);                                                                           // 500
        if (!grain) {                                                                                                  // 501
          throw new Meteor.Error(404, "No such grain");                                                                // 502
        }                                                                                                              //
                                                                                                                       //
        var grainOwner = globalDb.getUser(grain.userId);                                                               // 505
        var email = _.findWhere(SandstormDb.getUserEmails(grainOwner), { primary: true });                             // 506
        if (!email) {                                                                                                  // 507
          throw new Meteor.Error("no email", "Grain owner has no email address.");                                     // 508
        }                                                                                                              //
                                                                                                                       //
        var emailAddress = email.email;                                                                                // 511
                                                                                                                       //
        var identity = globalDb.getIdentity(identityId);                                                               // 513
        globalDb.addContact(grainOwner._id, identityId);                                                               // 514
                                                                                                                       //
        var fromEmail = globalDb.getReturnAddressWithDisplayName(identityId);                                          // 516
        var replyTo = globalDb.getPrimaryEmail(Meteor.userId(), identityId);                                           // 517
                                                                                                                       //
        // TODO(soon): In the HTML version, we should display an identity card.                                        //
        var identityNote = "";                                                                                         // 491
        if (identity.profile.service === "google") {                                                                   // 521
          identityNote = " (" + identity.privateIntrinsicName + ")";                                                   // 522
        } else if (identity.profile.service === "github") {                                                            //
          identityNote = " (" + identity.profile.intrinsicName + " on GitHub)";                                        // 524
        } else if (identity.profile.service === "email") {                                                             //
          identityNote = " (" + identity.profile.intrinsicName + ")";                                                  // 526
        } else if (identity.profile.service === "ldap") {                                                              //
          identityNote = " (" + identity.profile.intrinsicName + " on LDAP)";                                          // 528
        } else if (identity.profile.service === "saml") {                                                              //
          identityNote = " (" + identity.profile.intrinsicName + " on SAML)";                                          // 530
        }                                                                                                              //
                                                                                                                       //
        var message = identity.profile.name + identityNote + " is requesting access to your grain: " + grain.title + ".";
                                                                                                                       //
        var url = origin + "/share/" + grainId + "/" + identityId;                                                     // 536
                                                                                                                       //
        var html = message + "<br><br>" + emailLinkWithInlineStyle(url, "Open Sharing Menu");                          // 538
                                                                                                                       //
        var user = Meteor.user();                                                                                      // 541
        var ACCESS_REQUEST_LIMIT = 10;                                                                                 // 542
        var resetCount = true;                                                                                         // 543
        if (user.accessRequests) {                                                                                     // 544
          if (user.accessRequests.resetOn < new Date()) {                                                              // 545
            Meteor.users.update({ _id: user._id }, { $unset: { accessRequests: 1 } });                                 // 546
          } else if (user.accessRequests.count >= ACCESS_REQUEST_LIMIT) {                                              //
            throw new Meteor.Error(403, "For spam control reasons, you are not allowed to make " + "more than " + ACCESS_REQUEST_LIMIT + " access requests per day.");
          } else {                                                                                                     //
            resetCount = false;                                                                                        // 552
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        var modifier = { $inc: { "accessRequests.count": 1 } };                                                        // 556
        if (resetCount) {                                                                                              // 557
          var tomorrow = new Date(Date.now() + 86400000);                                                              // 558
          modifier.$set = { "accessRequests.resetOn": tomorrow };                                                      // 559
        }                                                                                                              //
                                                                                                                       //
        Meteor.users.update({ _id: user._id }, modifier);                                                              // 562
                                                                                                                       //
        SandstormEmail.send({                                                                                          // 564
          to: emailAddress,                                                                                            // 565
          from: fromEmail,                                                                                             // 566
          replyTo: replyTo,                                                                                            // 567
          subject: grain.title + " - Request for access",                                                              // 568
          text: message + "\n\nFollow this link to share access:\n\n" + url,                                           // 569
          html: html                                                                                                   // 570
        });                                                                                                            //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return requestAccess;                                                                                              //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"hack-session.js":["babel-runtime/helpers/possibleConstructorReturn","babel-runtime/helpers/inherits","babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/hack-session.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");                          //
                                                                                                                       //
var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);                                 //
                                                                                                                       //
var _inherits2 = require("babel-runtime/helpers/inherits");                                                            //
                                                                                                                       //
var _inherits3 = _interopRequireDefault(_inherits2);                                                                   //
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var Http = Npm.require("http");                                                                                        // 18
var Https = Npm.require("https");                                                                                      // 19
var Future = Npm.require("fibers/future");                                                                             // 20
var Net = Npm.require("net");                                                                                          // 21
var Dgram = Npm.require("dgram");                                                                                      // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Capnp = Npm.require("capnp");                                                                                      // 24
                                                                                                                       //
var EmailRpc = Capnp.importSystem("sandstorm/email.capnp");                                                            // 26
var HackSessionContext = Capnp.importSystem("sandstorm/hack-session.capnp").HackSessionContext;                        // 27
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 28
var SystemPersistent = Capnp.importSystem("sandstorm/supervisor.capnp").SystemPersistent;                              // 29
var IpRpc = Capnp.importSystem("sandstorm/ip.capnp");                                                                  // 30
var EmailSendPort = EmailRpc.EmailSendPort;                                                                            // 31
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                               // 32
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 34
                                                                                                                       //
ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                            // 36
HOSTNAME = ROOT_URL.hostname;                                                                                          // 37
                                                                                                                       //
SessionContextImpl = function () {                                                                                     // 39
  function SessionContextImpl(grainId, sessionId, identityId, tabId) {                                                 // 40
    (0, _classCallCheck3["default"])(this, SessionContextImpl);                                                        //
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 41
    this.sessionId = sessionId;                                                                                        // 42
    this.identityId = identityId;                                                                                      // 43
    this.tabId = tabId;                                                                                                // 44
  }                                                                                                                    //
                                                                                                                       //
  SessionContextImpl.prototype.offer = function () {                                                                   // 39
    function offer(cap, requiredPermissions, descriptor, displayInfo) {                                                //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 48
        if (!_this2.identityId) {                                                                                      // 49
          // TODO(soon): allow non logged in users?                                                                    //
          throw new Meteor.Error(400, "Only logged in users can offer capabilities.");                                 // 51
        }                                                                                                              //
                                                                                                                       //
        var castedCap = cap.castAs(SystemPersistent);                                                                  // 54
        var apiTokenOwner = { webkey: null };                                                                          // 55
        var isUiView = descriptor && descriptor.tags && descriptor.tags.length === 1 && descriptor.tags[0] && descriptor.tags[0].id && descriptor.tags[0].id === Grain.UiView.typeId;
        if (isUiView) {                                                                                                // 59
          apiTokenOwner = {                                                                                            // 60
            user: {                                                                                                    // 61
              identityId: _this2.identityId                                                                            // 62
            }                                                                                                          //
          };                                                                                                           //
        }                                                                                                              //
                                                                                                                       //
        // TODO(soon): This will eventually use SystemPersistent.addRequirements when membranes                        //
        // are fully implemented for supervisors.                                                                      //
        // The following fields will be overwritten by PersistentUiView.save(), so no need to                          // 48
        // pass them in:                                                                                               //
        //lastUsed: new Date(),                                                                                        //
        //title: "", // This will be replaced by the token's title                                                     //
        //denormalizedGrainMetadata: {}, // This will look up the package for the grain referenced.                    //
        var requirement = {                                                                                            // 74
          permissionsHeld: {                                                                                           // 75
            grainId: _this2.grainId,                                                                                   // 76
            identityId: _this2.identityId,                                                                             // 77
            permissions: requiredPermissions                                                                           // 78
          }                                                                                                            //
        };                                                                                                             //
                                                                                                                       //
        if (!checkRequirements([requirement])) {                                                                       // 82
          throw new Meteor.Error(403, "Permissions not satisfied.");                                                   // 83
        }                                                                                                              //
                                                                                                                       //
        var save = castedCap.save(apiTokenOwner);                                                                      // 86
        var sturdyRef = waitPromise(save).sturdyRef;                                                                   // 87
        ApiTokens.update({ _id: hashSturdyRef(sturdyRef) }, { $push: { requirements: requirement } });                 // 88
        var powerboxView = isUiView ? {                                                                                // 89
          offer: {                                                                                                     // 90
            uiView: {                                                                                                  // 91
              token: sturdyRef.toString(),                                                                             // 92
              tokenId: hashSturdyRef(sturdyRef.toString())                                                             // 93
            }                                                                                                          //
          }                                                                                                            //
        } : {                                                                                                          //
          offer: {                                                                                                     // 97
            url: ROOT_URL.protocol + "//" + globalDb.makeApiHost(sturdyRef) + "#" + sturdyRef                          // 98
          }                                                                                                            //
        };                                                                                                             //
        Sessions.update({ _id: _this2.sessionId }, {                                                                   // 101
          $set: {                                                                                                      // 103
            powerboxView: powerboxView                                                                                 // 104
          }                                                                                                            //
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return offer;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  return SessionContextImpl;                                                                                           //
}();                                                                                                                   //
                                                                                                                       //
Meteor.methods({                                                                                                       // 112
  finishPowerboxRequest: function () {                                                                                 // 113
    function finishPowerboxRequest(webkeyUrl, saveLabel, identityId, grainId) {                                        //
      check(webkeyUrl, String);                                                                                        // 114
      check(saveLabel, Match.OneOf(undefined, null, String));                                                          // 115
      check(identityId, String);                                                                                       // 116
      check(grainId, String);                                                                                          // 117
                                                                                                                       //
      var userId = Meteor.userId();                                                                                    // 119
      if (!userId || !globalDb.userHasIdentity(userId, identityId)) {                                                  // 120
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                             // 121
      }                                                                                                                //
                                                                                                                       //
      var parsedWebkey = Url.parse(webkeyUrl.trim());                                                                  // 124
      var hostId = matchWildcardHost(parsedWebkey.host);                                                               // 125
      if (!hostId || !globalDb.isApiHostId(hostId)) {                                                                  // 126
        throw new Meteor.Error(500, "Hostname does not match this server. External webkeys are not " + "supported (yet)");
      }                                                                                                                //
                                                                                                                       //
      var token = parsedWebkey.hash;                                                                                   // 131
      if (!token) {                                                                                                    // 132
        throw new Meteor.Error(400, "Invalid webkey. You must pass in the full webkey, " + "including domain name and hash fragment");
      }                                                                                                                //
                                                                                                                       //
      token = token.slice(1);                                                                                          // 137
      if (globalDb.isTokenSpecificHostId(hostId) && hostId !== globalDb.apiHostIdForToken(token)) {                    // 138
        // Note: This case is not security-sensitive. The client could easily compute the correct                      //
        //   host ID for this token. But since they've passed one that doesn't match, we assume                        //
        //   something is wrong and stop here.                                                                         //
        throw new Meteor.Error(400, "Invalid webkey: token doesn't match hostname.");                                  // 142
      }                                                                                                                //
                                                                                                                       //
      var cap = restoreInternal(new Buffer(token), Match.Optional({ webkey: Match.Optional(Match.Any) }), []).cap;     // 145
      var castedCap = cap.castAs(SystemPersistent);                                                                    // 147
      var grainOwner = {                                                                                               // 148
        grainId: grainId,                                                                                              // 149
        introducerIdentity: identityId                                                                                 // 150
      };                                                                                                               //
      if (saveLabel) {                                                                                                 // 152
        grainOwner.saveLabel = {                                                                                       // 153
          defaultText: saveLabel                                                                                       // 154
        };                                                                                                             //
      }                                                                                                                //
                                                                                                                       //
      var save = castedCap.save({ grain: grainOwner });                                                                // 158
      var sturdyRef = waitPromise(save).sturdyRef;                                                                     // 159
                                                                                                                       //
      return sturdyRef.toString();                                                                                     // 161
    }                                                                                                                  //
                                                                                                                       //
    return finishPowerboxRequest;                                                                                      //
  }(),                                                                                                                 //
  finishPowerboxOffer: function () {                                                                                   // 164
    function finishPowerboxOffer(sessionId) {                                                                          //
      check(sessionId, String);                                                                                        // 165
                                                                                                                       //
      Sessions.update({ _id: sessionId }, { $unset: { powerboxView: null } });                                         // 167
    }                                                                                                                  //
                                                                                                                       //
    return finishPowerboxOffer;                                                                                        //
  }(),                                                                                                                 //
  getViewInfoForApiToken: function () {                                                                                // 170
    function getViewInfoForApiToken(apiTokenId) {                                                                      //
      check(apiTokenId, String);                                                                                       // 171
      var token = globalDb.collections.apiTokens.findOne(apiTokenId);                                                  // 172
      if (!token) {                                                                                                    // 173
        throw new Meteor.Error(400, "No such token.");                                                                 // 174
      }                                                                                                                //
                                                                                                                       //
      var grain = globalDb.collections.grains.findOne(token.grainId);                                                  // 177
      if (!grain) {                                                                                                    // 178
        throw new Meteor.Error(500, "No grain found for token.");                                                      // 179
      }                                                                                                                //
                                                                                                                       //
      return grain.cachedViewInfo;                                                                                     // 182
    }                                                                                                                  //
                                                                                                                       //
    return getViewInfoForApiToken;                                                                                     //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
HackSessionContextImpl = function (_SessionContextImpl) {                                                              // 186
  (0, _inherits3["default"])(HackSessionContextImpl, _SessionContextImpl);                                             //
                                                                                                                       //
  function HackSessionContextImpl(grainId, sessionId, identityId, tabId) {                                             // 187
    (0, _classCallCheck3["default"])(this, HackSessionContextImpl);                                                    //
    return (0, _possibleConstructorReturn3["default"])(this, _SessionContextImpl.call(this, grainId, sessionId, identityId, tabId));
  }                                                                                                                    //
                                                                                                                       //
  HackSessionContextImpl.prototype._getPublicId = function () {                                                        // 186
    function _getPublicId() {                                                                                          //
      // Get the grain's public ID, assigning a new one if it doesn't yet have one.                                    //
      //                                                                                                               //
      // Must be called in a Meteor context.                                                                           //
                                                                                                                       //
      while (!this.publicId) {                                                                                         // 196
        // We haven't looked up the public ID yet.                                                                     //
        var grain = Grains.findOne(this.grainId, { fields: { publicId: 1 } });                                         // 198
        if (!grain) throw new Error("Grain does not exist.");                                                          // 199
                                                                                                                       //
        if (grain.publicId) {                                                                                          // 201
          this.publicId = grain.publicId;                                                                              // 202
        } else {                                                                                                       //
          // The grain doesn't have a public ID yet. Generate one.                                                     //
          var candidate = generateRandomHostname(20);                                                                  // 205
                                                                                                                       //
          if (Grains.findOne({ publicId: candidate })) {                                                               // 207
            // This should never ever happen.                                                                          //
            console.error("CRITICAL PROBLEM: Public ID collision. " + "CSPRNG is bad or has insufficient entropy.");   // 209
            continue;                                                                                                  // 211
          }                                                                                                            //
                                                                                                                       //
          // Carefully perform an update that becomes a no-op if anyone else has assigned a public ID                  //
          // simultaneously.                                                                                           //
          if (Grains.update({ _id: this.grainId, publicId: { $exists: false } }, { $set: { publicId: candidate } }) > 0) {
            // We won the race.                                                                                        //
            this.publicId = candidate;                                                                                 // 219
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return this.publicId;                                                                                            // 224
    }                                                                                                                  //
                                                                                                                       //
    return _getPublicId;                                                                                               //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype._getAddress = function () {                                                         // 186
    function _getAddress() {                                                                                           //
      // Get the grain's outgoing e-mail address.                                                                      //
      //                                                                                                               //
      // Must be called in a Meteor context.                                                                           //
                                                                                                                       //
      return this._getPublicId() + "@" + HOSTNAME;                                                                     // 232
    }                                                                                                                  //
                                                                                                                       //
    return _getAddress;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype._getUserAddress = function () {                                                     // 186
    function _getUserAddress() {                                                                                       //
      // Get the user's e-mail address.                                                                                //
      //                                                                                                               //
      // Must be called in a Meteor context.                                                                           //
                                                                                                                       //
      var grain = Grains.findOne(this.grainId, { fields: { identityId: 1 } });                                         // 240
                                                                                                                       //
      var identity = globalDb.getIdentity(grain.identityId);                                                           // 242
                                                                                                                       //
      var primaryEmail = _.findWhere(SandstormDb.getVerifiedEmails(identity), { primary: true });                      // 244
      var email = primaryEmail && primaryEmail.email || identity.unverifiedEmail;                                      // 245
                                                                                                                       //
      var result = {};                                                                                                 // 247
      if (email) {                                                                                                     // 248
        result.address = email;                                                                                        // 249
      }                                                                                                                //
                                                                                                                       //
      if (identity.profile.name) {                                                                                     // 252
        result.name = identity.profile.name;                                                                           // 253
      }                                                                                                                //
                                                                                                                       //
      return result;                                                                                                   // 256
    }                                                                                                                  //
                                                                                                                       //
    return _getUserAddress;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.send = function () {                                                                // 186
    function send(email) {                                                                                             //
      return hackSendEmail(this, email);                                                                               // 260
    }                                                                                                                  //
                                                                                                                       //
    return send;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.getPublicId = function () {                                                         // 186
    function getPublicId() {                                                                                           //
      return inMeteor(function () {                                                                                    // 264
        var result = {};                                                                                               // 265
                                                                                                                       //
        result.publicId = this._getPublicId();                                                                         // 267
        result.hostname = HOSTNAME;                                                                                    // 268
        result.autoUrl = ROOT_URL.protocol + "//" + makeWildcardHost(result.publicId);                                 // 269
                                                                                                                       //
        var grain = Grains.findOne(this.grainId, { fields: { userId: 1 } });                                           // 271
        result.isDemoUser = Meteor.users.findOne(grain.userId).expires ? true : false;                                 // 272
                                                                                                                       //
        return result;                                                                                                 // 274
      }.bind(this));                                                                                                   //
    }                                                                                                                  //
                                                                                                                       //
    return getPublicId;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.httpGet = function () {                                                             // 186
    function httpGet(url) {                                                                                            //
      var _this = this;                                                                                                // 279
      var session = _this;                                                                                             // 280
                                                                                                                       //
      return new Promise(function (resolve, reject) {                                                                  // 282
        var requestMethod = Http.request;                                                                              // 283
        if (url.indexOf("https://") === 0) {                                                                           // 284
          requestMethod = Https.request;                                                                               // 285
        } else if (url.indexOf("http://") !== 0) {                                                                     //
          err = new Error("Protocol not recognized.");                                                                 // 287
          err.nature = "precondition";                                                                                 // 288
          reject(err);                                                                                                 // 289
        }                                                                                                              //
                                                                                                                       //
        req = requestMethod(url, function (resp) {                                                                     // 292
          var buffers = [];                                                                                            // 293
          var err = void 0;                                                                                            // 294
                                                                                                                       //
          switch (Math.floor(resp.statusCode / 100)) {                                                                 // 296
            case 2:                                                                                                    // 297
              // 2xx response -- OK.                                                                                   //
              resp.on("data", function (buf) {                                                                         // 298
                buffers.push(buf);                                                                                     // 299
              });                                                                                                      //
                                                                                                                       //
              resp.on("end", function () {                                                                             // 302
                resolve({                                                                                              // 303
                  content: Buffer.concat(buffers),                                                                     // 304
                  mimeType: resp.headers["content-type"] || null                                                       // 305
                });                                                                                                    //
              });                                                                                                      //
              break;                                                                                                   // 308
            case 3:                                                                                                    // 296
              // 3xx response -- redirect.                                                                             //
              resolve(session.httpGet(resp.headers.location));                                                         // 310
              break;                                                                                                   // 311
            case 4:                                                                                                    // 296
              // 4xx response -- client error.                                                                         //
              err = new Error("Status code " + resp.statusCode + " received in response.");                            // 313
              err.nature = "precondition";                                                                             // 314
              reject(err);                                                                                             // 315
              break;                                                                                                   // 316
            case 5:                                                                                                    // 296
              // 5xx response -- internal server error.                                                                //
              err = new Error("Status code " + resp.statusCode + " received in response.");                            // 318
              err.nature = "localBug";                                                                                 // 319
              reject(err);                                                                                             // 320
              break;                                                                                                   // 321
            default:                                                                                                   // 296
              // ???                                                                                                   //
              err = new Error("Invalid status code " + resp.statusCode + " received in response.");                    // 323
              err.nature = "localBug";                                                                                 // 324
              reject(err);                                                                                             // 325
              break;                                                                                                   // 326
          }                                                                                                            // 296
        });                                                                                                            //
                                                                                                                       //
        req.on("error", function (e) {                                                                                 // 330
          e.nature = "networkFailure";                                                                                 // 331
          reject(e);                                                                                                   // 332
        });                                                                                                            //
                                                                                                                       //
        req.setTimeout(15000, function () {                                                                            // 335
          req.abort();                                                                                                 // 336
          err = new Error("Request timed out.");                                                                       // 337
          err.nature = "localBug";                                                                                     // 338
          err.durability = "overloaded";                                                                               // 339
          reject(err);                                                                                                 // 340
        });                                                                                                            //
                                                                                                                       //
        req.end();                                                                                                     // 343
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return httpGet;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.getUserAddress = function () {                                                      // 186
    function getUserAddress() {                                                                                        //
      return inMeteor(function () {                                                                                    // 348
        return this._getUserAddress();                                                                                 // 349
      }.bind(this));                                                                                                   //
    }                                                                                                                  //
                                                                                                                       //
    return getUserAddress;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteGenerateApiToken = function () {                                            // 186
    function obsoleteGenerateApiToken(petname, userInfo, expires) {                                                    //
      throw new Error("generateApiToken() has been removed. Use offer templates instead.");                            // 354
    }                                                                                                                  //
                                                                                                                       //
    return obsoleteGenerateApiToken;                                                                                   //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteListApiTokens = function () {                                               // 186
    function obsoleteListApiTokens() {                                                                                 //
      throw new Error("listApiTokens() has been removed. Use offer templates instead.");                               // 358
    }                                                                                                                  //
                                                                                                                       //
    return obsoleteListApiTokens;                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.obsoleteRevokeApiToken = function () {                                              // 186
    function obsoleteRevokeApiToken(tokenId) {                                                                         //
      throw new Error("revokeApiToken() has been removed. Use offer templates instead.");                              // 362
    }                                                                                                                  //
                                                                                                                       //
    return obsoleteRevokeApiToken;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  HackSessionContextImpl.prototype.getUiViewForEndpoint = function () {                                                // 186
    function getUiViewForEndpoint(url) {                                                                               //
      var parsedUrl = Url.parse(url);                                                                                  // 366
                                                                                                                       //
      if (parsedUrl.hash) {                                                                                            // 368
        // Assume that anything with a fragment is a webkey                                                            //
        if (parsedUrl.pathname) {                                                                                      // 369
          throw new Error("Webkey urls cannot contain a path.");                                                       // 370
        }                                                                                                              //
                                                                                                                       //
        var token = parsedUrl.hash.slice(1); // Get rid of # which is always the first character                       // 373
        var hostId = matchWildcardHost(parsedUrl.host);                                                                // 368
        if (hostId && globalDb.isApiHostId(hostId)) {                                                                  // 375
          // Connecting to a local capability.                                                                         //
          return getWrappedUiViewForToken(token);                                                                      // 377
        } else {                                                                                                       //
          // Connecting to a remote server with a bearer token.                                                        //
          // TODO(someday): Negotiate server-to-server Cap'n Proto connection.                                         //
          return { view: new ExternalUiView(url, this.grainId, token) };                                               // 381
        }                                                                                                              //
      } else {                                                                                                         //
        return { view: new ExternalUiView(url, this.grainId) };                                                        // 384
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return getUiViewForEndpoint;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return HackSessionContextImpl;                                                                                       //
}(SessionContextImpl);                                                                                                 //
                                                                                                                       //
makeHackSessionContext = function makeHackSessionContext(grainId, sessionId, identityId, tabId) {                      // 389
  return new Capnp.Capability(new HackSessionContextImpl(grainId, sessionId, identityId, tabId), HackSessionContext);  // 390
};                                                                                                                     //
                                                                                                                       //
var HOSTNAME_CHARS = "abcdefghijklmnopqrstuvwxyz0123456789";                                                           // 394
                                                                                                                       //
generateRandomHostname = function generateRandomHostname(length) {                                                     // 396
  // Generate a random unique name suitable for use in a hostname.                                                     //
                                                                                                                       //
  var digits = [];                                                                                                     // 399
  for (var i = 0; i < length; i++) {                                                                                   // 400
    digits[i] = Random.choice(HOSTNAME_CHARS);                                                                         // 401
  }                                                                                                                    //
                                                                                                                       //
  return digits.join("");                                                                                              // 404
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"install-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/install-server.js                                                                                            //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var localizedTextPattern = {                                                                                           // 17
  defaultText: String,                                                                                                 // 18
  localizations: Match.Optional([{ locale: String, text: String }])                                                    // 19
};                                                                                                                     //
                                                                                                                       //
var uploadTokens = {};                                                                                                 // 22
                                                                                                                       //
UserActions.allow({                                                                                                    // 24
  insert: function () {                                                                                                // 25
    function insert(userId, action) {                                                                                  // 25
      // TODO(cleanup): This check keeps breaking. Use a method instead that takes the package                         //
      //   ID as an argument.                                                                                          //
      check(action, {                                                                                                  // 28
        userId: String,                                                                                                // 29
        packageId: String,                                                                                             // 30
        appId: String,                                                                                                 // 31
        appTitle: Match.Optional(localizedTextPattern),                                                                // 32
        appMarketingVersion: Match.Optional(Object),                                                                   // 33
        appVersion: Match.Integer,                                                                                     // 34
        title: localizedTextPattern,                                                                                   // 35
        nounPhrase: Match.Optional(localizedTextPattern),                                                              // 36
        command: {                                                                                                     // 37
          executablePath: Match.Optional(String),                                                                      // 38
          deprecatedExecutablePath: Match.Optional(String),                                                            // 39
          args: Match.Optional([String]),                                                                              // 40
          argv: Match.Optional([String]),                                                                              // 41
          environ: Match.Optional([{ key: String, value: String }])                                                    // 42
        }                                                                                                              //
      });                                                                                                              //
      return userId && isSignedUpOrDemo() && action.userId === userId;                                                 // 45
    }                                                                                                                  //
                                                                                                                       //
    return insert;                                                                                                     //
  }(),                                                                                                                 //
                                                                                                                       //
  remove: function () {                                                                                                // 48
    function remove(userId, action) {                                                                                  // 48
      return userId && action.userId === userId;                                                                       // 49
    }                                                                                                                  //
                                                                                                                       //
    return remove;                                                                                                     //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
// Not all users are allowed to upload apps. We need to manually implement authorization                               //
// because Meteor.userId() is not available in server-side routes.                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 56
  cancelDownload: function (_cancelDownload) {                                                                         // 57
    function cancelDownload(_x) {                                                                                      //
      return _cancelDownload.apply(this, arguments);                                                                   //
    }                                                                                                                  //
                                                                                                                       //
    cancelDownload.toString = function () {                                                                            //
      return _cancelDownload.toString();                                                                               //
    };                                                                                                                 //
                                                                                                                       //
    return cancelDownload;                                                                                             //
  }(function (packageId) {                                                                                             //
    check(packageId, String);                                                                                          // 58
                                                                                                                       //
    // TODO(security):  Only let user cancel download if they initiated it.                                            //
    cancelDownload(packageId);                                                                                         // 57
  }),                                                                                                                  //
                                                                                                                       //
  newUploadToken: function () {                                                                                        // 64
    function newUploadToken() {                                                                                        // 64
      if (!isSignedUp()) {                                                                                             // 65
        throw new Meteor.Error(403, "Unauthorized", "Only invited users can upload apps.");                            // 66
      }                                                                                                                //
                                                                                                                       //
      if (globalDb.isUninvitedFreeUser()) {                                                                            // 69
        throw new Meteor.Error(403, "Unauthorized", "Only paid users can upload apps.");                               // 70
      }                                                                                                                //
                                                                                                                       //
      var token = Random.id();                                                                                         // 73
      uploadTokens[token] = setTimeout(function () {                                                                   // 74
        delete uploadTokens[token];                                                                                    // 75
      }, 20 * 60 * 1000);                                                                                              //
                                                                                                                       //
      return token;                                                                                                    // 78
    }                                                                                                                  //
                                                                                                                       //
    return newUploadToken;                                                                                             //
  }(),                                                                                                                 //
                                                                                                                       //
  upgradeGrains: function () {                                                                                         // 81
    function upgradeGrains(appId, version, packageId) {                                                                // 81
      this.connection.sandstormDb.upgradeGrains(appId, version, packageId, globalBackend);                             // 82
    }                                                                                                                  //
                                                                                                                       //
    return upgradeGrains;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  ensureInstalled: function () {                                                                                       // 85
    function ensureInstalled(packageId, url, isRetry) {                                                                // 85
      check(packageId, String);                                                                                        // 86
      check(url, Match.OneOf(String, undefined, null));                                                                // 87
      check(isRetry, Boolean);                                                                                         // 88
                                                                                                                       //
      if (!packageId.match(/^[a-zA-Z0-9]*$/)) {                                                                        // 90
        throw new Meteor.Error(400, "The package ID contains illegal characters.");                                    // 91
      }                                                                                                                //
                                                                                                                       //
      if (!this.userId) {                                                                                              // 94
        if (allowDemo && isSafeDemoAppUrl(url)) {                                                                      // 95
          // continue on                                                                                               //
        } else {                                                                                                       //
            // jscs:ignore disallowEmptyBlocks                                                                         //
            throw new Meteor.Error(403, "You must be logged in to install packages.");                                 // 98
          }                                                                                                            //
      } else if (!isSignedUp() && !isDemoUser()) {                                                                     //
        throw new Meteor.Error(403, "This Sandstorm server requires you to get an invite before installing apps.");    // 101
      } else if (isUserOverQuota(Meteor.user())) {                                                                     //
        throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");         // 104
      }                                                                                                                //
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 108
                                                                                                                       //
      if (!pkg || pkg.status !== "ready") {                                                                            // 110
        if (!this.userId || isDemoUser() || globalDb.isUninvitedFreeUser()) {                                          // 111
          if (!isSafeDemoAppUrl(url)) {                                                                                // 112
            // TODO(someday): Billing prompt on client side.                                                           //
            throw new Meteor.Error(403, "Sorry, demo and free users cannot upload custom apps; " + "they may only install apps from apps.sandstorm.io.");
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (!pkg || isRetry) {                                                                                           // 120
        globalDb.startInstall(packageId, url, isRetry);                                                                // 121
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return ensureInstalled;                                                                                            //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Router.map(function () {                                                                                               // 126
  this.route("upload", {                                                                                               // 127
    where: "server",                                                                                                   // 128
    path: "/upload/:token",                                                                                            // 129
                                                                                                                       //
    action: function () {                                                                                              // 131
      function action() {                                                                                              // 131
        if (!this.params.token || !uploadTokens[this.params.token]) {                                                  // 132
          this.response.writeHead(403, {                                                                               // 133
            "Content-Type": "text/plain"                                                                               // 134
          });                                                                                                          //
          this.response.write("Invalid upload token.");                                                                // 136
          this.response.end();                                                                                         // 137
        } else if (this.request.method === "POST") {                                                                   //
          try {                                                                                                        // 139
            var packageId = promiseToFuture(doClientUpload(this.request)).wait();                                      // 140
            this.response.writeHead(200, {                                                                             // 141
              "Content-Length": packageId.length,                                                                      // 142
              "Content-Type": "text/plain"                                                                             // 143
            });                                                                                                        //
            this.response.write(packageId);                                                                            // 145
            this.response.end();                                                                                       // 146
            clearTimeout(uploadTokens[this.params.token]);                                                             // 147
            delete uploadTokens[this.params.token];                                                                    // 148
          } catch (error) {                                                                                            //
            console.error(error.stack);                                                                                // 150
            this.response.writeHead(500, {                                                                             // 151
              "Content-Type": "text/plain"                                                                             // 152
            });                                                                                                        //
            this.response.write("Unpacking SPK failed; is it valid?");                                                 // 154
            this.response.end();                                                                                       // 155
          };                                                                                                           //
        } else {                                                                                                       //
          this.response.writeHead(405, {                                                                               // 158
            "Content-Type": "text/plain"                                                                               // 159
          });                                                                                                          //
          this.response.write("You can only POST here.");                                                              // 161
          this.response.end();                                                                                         // 162
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return action;                                                                                                   //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"installer.js":["babel-runtime/helpers/classCallCheck",function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/installer.js                                                                                                 //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Fs = Npm.require("fs");                                                                                            // 17
var Path = Npm.require("path");                                                                                        // 18
var Crypto = Npm.require("crypto");                                                                                    // 19
var ChildProcess = Npm.require("child_process");                                                                       // 20
var Http = Npm.require("http");                                                                                        // 21
var Https = Npm.require("https");                                                                                      // 22
var Url = Npm.require("url");                                                                                          // 23
var Promise = Npm.require("es6-promise").Promise;                                                                      // 24
var Capnp = Npm.require("capnp");                                                                                      // 25
                                                                                                                       //
var Manifest = Capnp.importSystem("sandstorm/package.capnp").Manifest;                                                 // 27
                                                                                                                       //
var installers = void 0; // set to {} on main replica                                                                  // 29
// To protect against race conditions, we require that each row in the Packages                                        //
// collection have at most one writer at a time, as tracked by this `installers`                                       //
// map. Each key is a package ID and each value is either an AppInstaller object                                       //
// or the string 'uninstalling', indicating that some fiber is working on                                              //
// uninstalling the package.                                                                                           //
                                                                                                                       //
var verifyIsMainReplica = function verifyIsMainReplica() {                                                             // 36
  if (Meteor.settings.replicaNumber) {                                                                                 // 37
    throw new Error("This can only be called on the main front-end replica.");                                         // 38
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Meteor.methods({                                                                                                       // 42
  deleteUnusedPackages: function () {                                                                                  // 43
    function deleteUnusedPackages(appId) {                                                                             //
      check(appId, String);                                                                                            // 44
      Packages.find({ appId: appId }).forEach(function (pkg) {                                                         // 45
        deletePackage(pkg._id);                                                                                        // 45
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return deleteUnusedPackages;                                                                                       //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
deletePackage = function deletePackage(packageId) {                                                                    // 49
  // Mark package for possible deletion;                                                                               //
  Packages.update({ _id: packageId, status: "ready" }, { $set: { shouldCleanup: true } });                             // 51
};                                                                                                                     //
                                                                                                                       //
var deletePackageInternal = function deletePackageInternal(pkg) {                                                      // 54
  verifyIsMainReplica();                                                                                               // 55
                                                                                                                       //
  var packageId = pkg._id;                                                                                             // 57
                                                                                                                       //
  if (packageId in installers) {                                                                                       // 59
    return;                                                                                                            // 60
  }                                                                                                                    //
                                                                                                                       //
  installers[packageId] = "uninstalling";                                                                              // 63
                                                                                                                       //
  try {                                                                                                                // 65
    var action = UserActions.findOne({ packageId: packageId });                                                        // 66
    var grain = Grains.findOne({ packageId: packageId });                                                              // 67
    var notificationQuery = {};                                                                                        // 68
    notificationQuery["appUpdates." + pkg.appId] = { $exists: true };                                                  // 69
    if (!grain && !action && !(pkg.isAutoUpdated && Notifications.findOne(notificationQuery))) {                       // 70
      Packages.update({ _id: packageId }, { $set: { status: "delete" }, $unset: { shouldCleanup: "" } });              // 71
      waitPromise(globalBackend.cap().deletePackage(packageId));                                                       // 72
      Packages.remove(packageId);                                                                                      // 73
                                                                                                                       //
      // Clean up assets (icon, etc).                                                                                  //
      getAllManifestAssets(pkg.manifest).forEach(function (assetId) {                                                  // 70
        globalDb.unrefStaticAsset(assetId);                                                                            // 77
      });                                                                                                              //
    } else {                                                                                                           //
      Packages.update({ _id: packageId }, { $unset: { shouldCleanup: "" } });                                          // 80
    }                                                                                                                  //
                                                                                                                       //
    delete installers[packageId];                                                                                      // 83
  } catch (error) {                                                                                                    //
    delete installers[packageId];                                                                                      // 85
    throw error;                                                                                                       // 86
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
var startInstallInternal = function startInstallInternal(pkg) {                                                        // 90
  verifyIsMainReplica();                                                                                               // 91
                                                                                                                       //
  if (pkg._id in installers) {                                                                                         // 93
    return;                                                                                                            // 94
  }                                                                                                                    //
                                                                                                                       //
  var installer = new AppInstaller(pkg._id, pkg.url, pkg.appId, pkg.isAutoUpdated);                                    // 97
  installers[pkg._id] = installer;                                                                                     // 98
  installer.start();                                                                                                   // 99
};                                                                                                                     //
                                                                                                                       //
cancelDownload = function cancelDownload(packageId) {                                                                  // 102
  Packages.remove({ _id: packageId, status: "download" });                                                             // 103
};                                                                                                                     //
                                                                                                                       //
var cancelDownloadInternal = function cancelDownloadInternal(pkg) {                                                    // 106
  verifyIsMainReplica();                                                                                               // 107
                                                                                                                       //
  var installer = installers[pkg._id];                                                                                 // 109
                                                                                                                       //
  // Don't do anything unless a download is in progress.                                                               //
  if (installer && installer.downloadRequest) {                                                                        // 106
    // OK, effect cancellation by faking an error.                                                                     //
    installer.wrapCallback(function () {                                                                               // 114
      throw new Error("Canceled");                                                                                     // 115
    })();                                                                                                              //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 120
  installers = {};                                                                                                     // 121
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 123
    // Restart any deletions that were killed while in-progress.                                                       //
    Packages.find({ status: "delete" }).forEach(deletePackageInternal);                                                // 125
                                                                                                                       //
    // Watch for new installation requests and fulfill them.                                                           //
    Packages.find({ status: { $in: ["download", "verify", "unpack", "analyze"] } }).observe({                          // 123
      added: startInstallInternal,                                                                                     // 129
      removed: cancelDownloadInternal                                                                                  // 130
    });                                                                                                                //
                                                                                                                       //
    // Watch for new cleanup requests and fulfill them.                                                                //
    Packages.find({ status: "ready", shouldCleanup: true }).observe({                                                  // 123
      added: deletePackageInternal                                                                                     // 135
    });                                                                                                                //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
doClientUpload = function doClientUpload(stream) {                                                                     // 140
  return new Promise(function (resolve, reject) {                                                                      // 141
    var id = Random.id();                                                                                              // 142
                                                                                                                       //
    var backendStream = globalBackend.cap().installPackage().stream;                                                   // 144
    var hasher = Crypto.createHash("sha256");                                                                          // 145
                                                                                                                       //
    stream.on("data", function (chunk) {                                                                               // 147
      try {                                                                                                            // 148
        hasher.update(chunk);                                                                                          // 149
        backendStream.write(chunk);                                                                                    // 150
      } catch (err) {                                                                                                  //
        reject(err);                                                                                                   // 152
      }                                                                                                                //
    });                                                                                                                //
                                                                                                                       //
    stream.on("end", function () {                                                                                     // 156
      try {                                                                                                            // 157
        (function () {                                                                                                 //
          backendStream.done();                                                                                        // 158
          var packageId = hasher.digest("hex").slice(0, 32);                                                           // 159
          resolve(backendStream.saveAs(packageId).then(function () {                                                   // 160
            return packageId;                                                                                          // 161
          }));                                                                                                         //
          backendStream.close();                                                                                       // 163
        })();                                                                                                          //
      } catch (err) {                                                                                                  //
        reject(err);                                                                                                   // 165
      }                                                                                                                //
    });                                                                                                                //
                                                                                                                       //
    stream.on("error", function (err) {                                                                                // 169
      // TODO(soon):  This event does't seem to fire if the user leaves the page mid-upload.                           //
      try {                                                                                                            // 171
        backendStream.close();                                                                                         // 172
        reject(err);                                                                                                   // 173
      } catch (err2) {                                                                                                 //
        reject(err2);                                                                                                  // 175
      }                                                                                                                //
    });                                                                                                                //
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
AppInstaller = function () {                                                                                           // 181
  function AppInstaller(packageId, url, appId, isAutoUpdated) {                                                        // 182
    (0, _classCallCheck3["default"])(this, AppInstaller);                                                              //
                                                                                                                       //
    verifyIsMainReplica();                                                                                             // 183
                                                                                                                       //
    this.packageId = packageId;                                                                                        // 185
    this.url = url;                                                                                                    // 186
    this.failed = false;                                                                                               // 187
    this.appId = appId;                                                                                                // 188
    this.isAutoUpdated = isAutoUpdated;                                                                                // 189
                                                                                                                       //
    // Serializes database writes.                                                                                     //
    this.writeChain = Promise.resolve();                                                                               // 182
  }                                                                                                                    //
                                                                                                                       //
  AppInstaller.prototype.updateProgress = function () {                                                                // 181
    function updateProgress(status, progress, error, manifest) {                                                       //
      // TODO(security):  On error, we should actually delete the package from the database and only                   //
      //   display the error to whomever was watching at the time.  Otherwise it's easy to confuse                     //
      //   people by 'pre-failing' packages.  (Actually, perhaps if a user tries to download an                        //
      //   already-downloading package but specifies a different URL, we really should initiate an                     //
      //   entirely separate download...  but cancel it if the first download succeeds.)                               //
                                                                                                                       //
      this.status = status;                                                                                            // 202
      this.progress = progress || -1;                                                                                  // 203
      this.error = error;                                                                                              // 204
      this.manifest = manifest || null;                                                                                // 205
                                                                                                                       //
      var _this = this;                                                                                                // 207
                                                                                                                       //
      // The callback passed to inMeteor() runs in a new fiber. We need to make sure database writes                   //
      // occur in exactly the order in which we generate them, so we use a promise chain to serialize                  //
      // them.                                                                                                         //
      this.writeChain = this.writeChain.then(function () {                                                             // 195
        return inMeteor(function () {                                                                                  // 213
          if (manifest) extractManifestAssets(manifest);                                                               // 214
                                                                                                                       //
          Packages.update(_this.packageId, {                                                                           // 216
            $set: {                                                                                                    // 217
              status: _this.status,                                                                                    // 218
              progress: _this.progress,                                                                                // 219
              error: _this.error ? _this.error.message : null,                                                         // 220
              manifest: _this.manifest,                                                                                // 221
              appId: _this.appId,                                                                                      // 222
              authorPgpKeyFingerprint: _this.authorPgpKeyFingerprint                                                   // 223
            }                                                                                                          //
          });                                                                                                          //
                                                                                                                       //
          if (_this.authorPgpKeyFingerprint) {                                                                         // 227
            globalDb.updateKeybaseProfileAsync(_this.authorPgpKeyFingerprint);                                         // 228
          }                                                                                                            //
        })["catch"](function (err) {                                                                                   //
          console.error(err.stack);                                                                                    // 231
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return updateProgress;                                                                                             //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.wrapCallback = function () {                                                                  // 181
    function wrapCallback(method) {                                                                                    //
      // Note that the function below must not be an arrow function, since arrow functions do not have                 //
      // access to the context's arguments array.                                                                      //
      var _this = this;                                                                                                // 239
      return function () {                                                                                             // 240
        if (_this.failed) return;                                                                                      // 241
        try {                                                                                                          // 242
          return method.apply(_this, _.toArray(arguments));                                                            // 243
        } catch (err) {                                                                                                //
          _this.failed = true;                                                                                         // 245
          _this.cleanup();                                                                                             // 246
          _this.updateProgress("failed", 0, err);                                                                      // 247
          _this.writeChain = _this.writeChain.then(function () {                                                       // 248
            delete installers[_this.packageId];                                                                        // 249
          });                                                                                                          //
          console.error("Failed to install app:", err.stack);                                                          // 251
        }                                                                                                              //
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    return wrapCallback;                                                                                               //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.cleanup = function () {                                                                       // 181
    function cleanup() {                                                                                               //
      if (this.uploadStream) {                                                                                         // 257
        try {                                                                                                          // 258
          this.uploadStream.close();                                                                                   // 259
        } catch (err) {}                                                                                               //
                                                                                                                       //
        delete this.uploadStream;                                                                                      // 262
      }                                                                                                                //
                                                                                                                       //
      if (this.downloadRequest) {                                                                                      // 265
        try {                                                                                                          // 266
          this.downloadRequest.abort();                                                                                // 267
        } catch (err) {}                                                                                               //
                                                                                                                       //
        delete this.downloadRequest;                                                                                   // 270
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return cleanup;                                                                                                    //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.start = function () {                                                                         // 181
    function start() {                                                                                                 //
      var _this2 = this;                                                                                               //
                                                                                                                       //
      return this.wrapCallback(function () {                                                                           // 275
        _this2.cleanup();                                                                                              // 276
                                                                                                                       //
        globalBackend.cap().tryGetPackage(_this2.packageId).then(_this2.wrapCallback(function (info) {                 // 278
          if (info.appId) {                                                                                            // 279
            _this2.appId = info.appId;                                                                                 // 280
            _this2.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                             // 281
            _this2.done(info.manifest);                                                                                // 282
          } else {                                                                                                     //
            _this2.doDownload();                                                                                       // 284
          }                                                                                                            //
        }), _this2.wrapCallback(function (err) {                                                                       //
          throw err;                                                                                                   // 287
        }));                                                                                                           //
      })();                                                                                                            //
    }                                                                                                                  //
                                                                                                                       //
    return start;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.doDownload = function () {                                                                    // 181
    function doDownload() {                                                                                            //
      if (!this.url) {                                                                                                 // 293
        throw new Error("Unknown package ID, and no URL was provided.");                                               // 294
      }                                                                                                                //
                                                                                                                       //
      console.log("Downloading app:", this.url);                                                                       // 297
      this.updateProgress("download");                                                                                 // 298
                                                                                                                       //
      this.uploadStream = globalBackend.cap().installPackage().stream;                                                 // 300
      return this.doDownloadTo(this.uploadStream);                                                                     // 301
    }                                                                                                                  //
                                                                                                                       //
    return doDownload;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.doDownloadTo = function () {                                                                  // 181
    function doDownloadTo(out) {                                                                                       //
      var _this3 = this;                                                                                               //
                                                                                                                       //
      var url = Url.parse(this.url);                                                                                   // 305
      var options = {                                                                                                  // 306
        hostname: url.hostname,                                                                                        // 307
        port: url.port,                                                                                                // 308
        path: url.path                                                                                                 // 309
      };                                                                                                               //
                                                                                                                       //
      var protocol = void 0;                                                                                           // 312
      if (url.protocol === "http:" || url.protocol === "https:") {                                                     // 313
        protocol = Request.defaults({                                                                                  // 314
          maxRedirects: 20,                                                                                            // 315
          // Since we will verify the download against a hash anyway, we don't need to verify the                      //
          // server's certificate. In fact, the only reason we support HTTPS at all here is because                    //
          // some servers refuse to serve over HTTP (which is, in general, a good thing). Skipping the                 //
          // certificate check here is helpful in that it means we don't have to worry about having a                  //
          // reasonable list of trusted CAs available to Sandstorm.                                                    //
          strictSSL: false                                                                                             // 321
        });                                                                                                            //
      } else {                                                                                                         //
        throw new Error("Protocol not supported: " + url.protocol);                                                    // 324
      }                                                                                                                //
                                                                                                                       //
      // TODO(security):  It could arguably be a security problem that it's possible to probe the                      //
      //   server's local network (behind any firewalls) by presenting URLs here.                                      //
      var bytesExpected = undefined;                                                                                   // 304
      var bytesReceived = 0;                                                                                           // 330
      var hasher = Crypto.createHash("sha256");                                                                        // 331
      var done = false;                                                                                                // 332
      var updateDownloadProgress = _.throttle(this.wrapCallback(function () {                                          // 333
        if (!done) {                                                                                                   // 334
          if (bytesExpected) {                                                                                         // 335
            _this3.updateProgress("download", bytesReceived / bytesExpected);                                          // 336
          } else {                                                                                                     //
            _this3.updateProgress("download", bytesReceived);                                                          // 338
          }                                                                                                            //
        }                                                                                                              //
      }), 500);                                                                                                        //
                                                                                                                       //
      var request = protocol.get(this.url);                                                                            // 343
                                                                                                                       //
      request.on("response", this.wrapCallback(function (response) {                                                   // 345
        if ("content-length" in response.headers) {                                                                    // 346
          bytesExpected = parseInt(response.headers["content-length"]);                                                // 347
        }                                                                                                              //
      }));                                                                                                             //
                                                                                                                       //
      request.on("data", this.wrapCallback(function (chunk) {                                                          // 351
        hasher.update(chunk);                                                                                          // 352
        out.write(chunk);                                                                                              // 353
        bytesReceived += chunk.length;                                                                                 // 354
        updateDownloadProgress();                                                                                      // 355
      }));                                                                                                             //
                                                                                                                       //
      request.on("end", this.wrapCallback(function () {                                                                // 358
        out.done();                                                                                                    // 359
                                                                                                                       //
        if (hasher.digest("hex").slice(0, 32) !== _this3.packageId) {                                                  // 361
          throw new Error("Package hash did not match.");                                                              // 362
        }                                                                                                              //
                                                                                                                       //
        done = true;                                                                                                   // 365
        delete _this3.downloadRequest;                                                                                 // 366
                                                                                                                       //
        _this3.updateProgress("unpack");                                                                               // 368
        out.saveAs(_this3.packageId).then(_this3.wrapCallback(function (info) {                                        // 369
          _this3.appId = info.appId;                                                                                   // 370
          _this3.authorPgpKeyFingerprint = info.authorPgpKeyFingerprint;                                               // 371
          _this3.done(info.manifest);                                                                                  // 372
        }), _this3.wrapCallback(function (err) {                                                                       //
          throw err;                                                                                                   // 374
        }));                                                                                                           //
      }));                                                                                                             //
                                                                                                                       //
      request.on("error", this.wrapCallback(function (err) {                                                           // 378
        throw err;                                                                                                     // 378
      }));                                                                                                             //
                                                                                                                       //
      this.downloadRequest = request;                                                                                  // 380
    }                                                                                                                  //
                                                                                                                       //
    return doDownloadTo;                                                                                               //
  }();                                                                                                                 //
                                                                                                                       //
  AppInstaller.prototype.done = function () {                                                                          // 181
    function done(manifest) {                                                                                          //
      console.log("App ready:", this.packageId);                                                                       // 384
      this.updateProgress("ready", 1, undefined, manifest);                                                            // 385
      var _this = this;                                                                                                // 386
      _this.writeChain = _this.writeChain.then(function () {                                                           // 387
        return inMeteor(function () {                                                                                  // 388
          if (_this.isAutoUpdated) {                                                                                   // 389
            globalDb.sendAppUpdateNotifications(_this.appId, _this.packageId, manifest.appTitle && manifest.appTitle.defaultText, manifest.appVersion, manifest.appMarketingVersion && manifest.appMarketingVersion.defaultText);
          }                                                                                                            //
        });                                                                                                            //
      }).then(function () {                                                                                            //
        delete installers[_this.packageId];                                                                            // 396
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return done;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return AppInstaller;                                                                                                 //
}();                                                                                                                   //
                                                                                                                       //
extractManifestAssets = function extractManifestAssets(manifest) {                                                     // 401
  var metadata = manifest.metadata;                                                                                    // 402
  if (!metadata) return;                                                                                               // 403
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 405
  if (icons) {                                                                                                         // 406
    var handleIcon = function handleIcon(icon) {                                                                       // 407
      if (icon.svg) {                                                                                                  // 408
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/svg+xml" }, icon.svg);                               // 409
        icon.format = "svg";                                                                                           // 410
        delete icon.svg;                                                                                               // 411
        return true;                                                                                                   // 412
      } else if (icon.png) {                                                                                           //
        // Use the 1x version for 'normal' DPI, unless 1x isn't provided, in which case use 2x.                        //
        var normalDpi = icon.png.dpi1x || icon.png.dpi2x;                                                              // 415
        if (!normalDpi) return false;                                                                                  // 416
        icon.format = "png";                                                                                           // 417
        icon.assetId = globalDb.addStaticAsset({ mimeType: "image/png" }, normalDpi);                                  // 418
                                                                                                                       //
        if (icon.png.dpi1x && icon.png.dpi2x) {                                                                        // 420
          // Icon specifies both resolutions, so also record a 2x DPI option.                                          //
          icon.assetId2xDpi = globalDb.addStaticAsset({ mimeType: "image/png" }, icon.png.dpi2x);                      // 422
        }                                                                                                              //
                                                                                                                       //
        delete icon.png;                                                                                               // 425
        return true;                                                                                                   // 426
      } else {                                                                                                         //
        // Unknown icon. Filter it.                                                                                    //
        return false;                                                                                                  // 429
      }                                                                                                                //
    };                                                                                                                 //
                                                                                                                       //
    if (icons.appGrid && !handleIcon(icons.appGrid)) delete icons.appGrid;                                             // 433
    if (icons.grain && !handleIcon(icons.grain)) delete icons.grain;                                                   // 434
                                                                                                                       //
    // We don't need the market icons.                                                                                 //
    if (icons.market) delete icons.market;                                                                             // 406
    if (icons.marketBig) delete icons.marketBig;                                                                       // 438
  }                                                                                                                    //
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 441
    if (text.defaultText) {                                                                                            // 442
      text.defaultTextAssetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, text.defaultText);                 // 443
      delete text.defaultText;                                                                                         // 444
    }                                                                                                                  //
                                                                                                                       //
    if (text.localizations) {                                                                                          // 447
      text.localizations.forEach(function (localization) {                                                             // 448
        if (localization.text) {                                                                                       // 449
          localization.assetId = globalDb.addStaticAsset({ mimeType: "text/plain" }, localization.text);               // 450
          delete localization.text;                                                                                    // 452
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  var license = metadata.license;                                                                                      // 458
  if (license) {                                                                                                       // 459
    if (license.proprietary) license.proprietary = handleLocalizedText(license.proprietary);                           // 460
    if (license.publicDomain) license.publicDomain = handleLocalizedText(license.proprietary);                         // 461
    if (license.notices) license.notices = handleLocalizedText(license.notices);                                       // 462
  }                                                                                                                    //
                                                                                                                       //
  var author = metadata.author;                                                                                        // 465
  if (author) {                                                                                                        // 466
    // We remove the PGP signature since it was already verified down to a key ID in the back-end.                     //
    if (author.pgpSignature) delete author.pgpSignature;                                                               // 468
  }                                                                                                                    //
                                                                                                                       //
  // Don't need the keyring either.                                                                                    //
  if (metadata.pgpKeyring) delete metadata.pgpKeyring;                                                                 // 401
                                                                                                                       //
  // Perhaps used by the 'about' page?                                                                                 //
  if (metadata.description) metadata.description = handleLocalizedText(metadata.description);                          // 401
                                                                                                                       //
  // Screenshots are for app marketing; we don't use them post-install.                                                //
  if (metadata.screenshots) delete metadata.screenshots;                                                               // 401
                                                                                                                       //
  // We might allow the user to view the changelog.                                                                    //
  if (metadata.changeLog) metadata.changeLog = handleLocalizedText(metadata.changeLog);                                // 401
};                                                                                                                     //
                                                                                                                       //
getAllManifestAssets = function getAllManifestAssets(manifest) {                                                       // 484
  // Returns a list of all asset IDs in the given manifest.                                                            //
                                                                                                                       //
  var metadata = manifest.metadata;                                                                                    // 487
  if (!metadata) return [];                                                                                            // 488
                                                                                                                       //
  var result = [];                                                                                                     // 490
                                                                                                                       //
  var icons = metadata.icons;                                                                                          // 492
  if (icons) {                                                                                                         // 493
    var handleIcon = function handleIcon(icon) {                                                                       // 494
      if (icon.assetId) {                                                                                              // 495
        result.push(icon.assetId);                                                                                     // 496
      }                                                                                                                //
    };                                                                                                                 //
                                                                                                                       //
    if (icons.appGrid) handleIcon(icons.appGrid);                                                                      // 500
    if (icons.grain) handleIcon(icons.grain);                                                                          // 501
  }                                                                                                                    //
                                                                                                                       //
  var handleLocalizedText = function handleLocalizedText(text) {                                                       // 504
    if (text.defaultTextAssetId) {                                                                                     // 505
      result.push(defaultTextAssetId);                                                                                 // 506
    }                                                                                                                  //
                                                                                                                       //
    if (text.localizations) {                                                                                          // 509
      text.localizations.forEach(function (localization) {                                                             // 510
        if (localization.assetId) {                                                                                    // 511
          result.push(localization.assetId);                                                                           // 512
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  var license = metadata.license;                                                                                      // 518
  if (license) {                                                                                                       // 519
    if (license.proprietary) handleLocalizedText(license.proprietary);                                                 // 520
    if (license.publicDomain) handleLocalizedText(license.publicDomain);                                               // 521
    if (license.notices) handleLocalizedText(license.notices);                                                         // 522
  }                                                                                                                    //
                                                                                                                       //
  if (metadata.description) handleLocalizedText(metadata.description);                                                 // 525
  if (metadata.changeLog) handleLocalizedText(metadata.changeLog);                                                     // 526
                                                                                                                       //
  return result;                                                                                                       // 528
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"pre-meteor.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/pre-meteor.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file implements logic that we place in front of our main Meteor application,                                   //
// including routing of requests to proxies and handling of static web publishing.                                     //
                                                                                                                       //
var Url = Npm.require("url");                                                                                          // 20
var Fs = Npm.require("fs");                                                                                            // 21
var Dns = Npm.require("dns");                                                                                          // 22
var Promise = Npm.require("es6-promise").Promise;                                                                      // 23
var Future = Npm.require("fibers/future");                                                                             // 24
var Http = Npm.require("http");                                                                                        // 25
                                                                                                                       //
var HOSTNAME = Url.parse(process.env.ROOT_URL).hostname;                                                               // 27
var DDP_HOSTNAME = process.env.DDP_DEFAULT_CONNECTION_URL && Url.parse(process.env.DDP_DEFAULT_CONNECTION_URL).hostname;
var CACHE_TTL_SECONDS = 30; // 30 seconds.  Cache-Control expects units of seconds, not millis.                        // 30
var DNS_CACHE_TTL = CACHE_TTL_SECONDS * 1000; // DNS cache is in millis.                                               // 31
                                                                                                                       //
var staticHandlers = {};                                                                                               // 33
// Maps grain public IDs to Connect handlers.                                                                          //
// TODO(perf): Garbage-collect this map?                                                                               //
                                                                                                                       //
var dnsCache = {};                                                                                                     // 37
// Unfortunately, node's DNS library doesn't cache results, so we do our own caching.                                  //
// Unfortunately, node's DNS library also dosen't give us TTLs. So, we'll cache for                                    //
// DNS_CACHE_TTL (a relatively small value) and rely on the upstream DNS server to implement                           //
// better caching.                                                                                                     //
                                                                                                                       //
function isSandstormShell(hostname) {                                                                                  // 43
  // Is this hostname mapped to the Sandstorm shell?                                                                   //
                                                                                                                       //
  return hostname === HOSTNAME || DDP_HOSTNAME && hostname === DDP_HOSTNAME;                                           // 46
}                                                                                                                      //
                                                                                                                       //
var mime = Connect["static"].mime;                                                                                     // 49
                                                                                                                       //
function wwwHandlerForGrain(grainId) {                                                                                 // 51
  return function (request, response, cb) {                                                                            // 52
    var path = request.url;                                                                                            // 53
                                                                                                                       //
    // If a directory, open 'index.html'.                                                                              //
    if (path.slice(-1) === "/") {                                                                                      // 52
      path = path + "index.html";                                                                                      // 57
    }                                                                                                                  //
                                                                                                                       //
    // Strip leading '/'.                                                                                              //
    if (path[0] === "/") path = path.slice(1);                                                                         // 52
                                                                                                                       //
    // Strip query.                                                                                                    //
    path = path.split("?")[0];                                                                                         // 52
                                                                                                                       //
    var type = mime.lookup(path);                                                                                      // 66
    var charset = mime.charsets.lookup(type);                                                                          // 67
    if (charset) {                                                                                                     // 68
      type = type + "; charset=" + charset;                                                                            // 69
    } else if (type === "application/json") {                                                                          //
      // HACK: Apparently the MIME module does not assume UTF-8 for JSON. :(                                           //
      type = type + "; charset=utf-8";                                                                                 // 72
    }                                                                                                                  //
                                                                                                                       //
    var started = false;                                                                                               // 75
    var sawEnd = false;                                                                                                // 76
                                                                                                                       //
    // TODO(perf): Automatically gzip text content? Use Express's 'compress' middleware for this?                      //
    //   Note that nginx will also auto-compress things...                                                             //
                                                                                                                       //
    var headers = {                                                                                                    // 52
      "Content-Type": type,                                                                                            // 82
      "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                          // 83
    };                                                                                                                 //
                                                                                                                       //
    if (path === "apps/index.json" || path.match(/apps\/[a-z0-9]{52}[.]json/) || path === "experimental/index.json" || path.match(/experimental\/[a-z0-9]{52}[.]json/)) {
      // TODO(cleanup): Extra special terrible hack: The app index needs to serve these JSON files                     //
      //   cross-origin. We could almost just make all web sites allow cross-origin since generally                    //
      //   web publishing is meant to publish public content. There is one case where this is                          //
      //   problematic, though: sites behind a firewall. Those sites could potentially be read                         //
      //   by outside sites if CORS is enabled on them. Some day we should make it so apps can                         //
      //   explicitly opt-in to allowing cross-origin queries but that day is not today.                               //
      headers["Access-Control-Allow-Origin"] = "*";                                                                    // 96
    }                                                                                                                  //
                                                                                                                       //
    var stream = {                                                                                                     // 99
      expectSize: function () {                                                                                        // 100
        function expectSize(size) {                                                                                    //
          if (!started) {                                                                                              // 101
            started = true;                                                                                            // 102
            response.writeHead(200, _.extend(headers, { "Content-Length": size }));                                    // 103
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        return expectSize;                                                                                             //
      }(),                                                                                                             //
      write: function () {                                                                                             // 107
        function write(data) {                                                                                         //
          if (!started) {                                                                                              // 108
            started = true;                                                                                            // 109
            response.writeHead(200, headers);                                                                          // 110
          }                                                                                                            //
                                                                                                                       //
          response.write(data);                                                                                        // 113
        }                                                                                                              //
                                                                                                                       //
        return write;                                                                                                  //
      }(),                                                                                                             //
      done: function () {                                                                                              // 116
        function done(data) {                                                                                          //
          if (!started) {                                                                                              // 117
            started = true;                                                                                            // 118
            response.writeHead(200, _.extend(headers, { "Content-Length": 0 }));                                       // 119
          }                                                                                                            //
                                                                                                                       //
          sawEnd = true;                                                                                               // 122
          response.end();                                                                                              // 123
        }                                                                                                              //
                                                                                                                       //
        return done;                                                                                                   //
      }()                                                                                                              //
    };                                                                                                                 //
                                                                                                                       //
    globalBackend.useGrain(grainId, function (supervisor) {                                                            // 127
      return supervisor.getWwwFileHack(path, stream).then(function (result) {                                          // 128
        // jscs:disable disallowQuotedKeysInObjects                                                                    //
        var status = result.status;                                                                                    // 130
        if (status === "file") {                                                                                       // 131
          if (!sawEnd) {                                                                                               // 132
            console.error("getWwwFileHack didn't write file to stream");                                               // 133
            if (!started) {                                                                                            // 134
              response.writeHead(500, {                                                                                // 135
                "Content-Type": "text/plain"                                                                           // 136
              });                                                                                                      //
              response.end("Internal server error");                                                                   // 138
            }                                                                                                          //
                                                                                                                       //
            response.end();                                                                                            // 141
          }                                                                                                            //
        } else if (status === "directory") {                                                                           //
          if (started) {                                                                                               // 144
            console.error("getWwwFileHack wrote to stream for directory");                                             // 145
            if (!sawEnd) {                                                                                             // 146
              response.end();                                                                                          // 147
            }                                                                                                          //
          } else {                                                                                                     //
            response.writeHead(303, {                                                                                  // 150
              "Content-Type": "text/plain",                                                                            // 151
              "Location": "/" + path + "/",                                                                            // 152
              "Cache-Control": "public, max-age=" + CACHE_TTL_SECONDS                                                  // 153
            });                                                                                                        //
            response.end("redirect: /" + path + "/");                                                                  // 155
          }                                                                                                            //
        } else if (status === "notFound") {                                                                            //
          if (started) {                                                                                               // 158
            console.error("getWwwFileHack wrote to stream for notFound");                                              // 159
            if (!sawEnd) {                                                                                             // 160
              response.end();                                                                                          // 161
            }                                                                                                          //
          } else {                                                                                                     //
            response.writeHead(404, {                                                                                  // 164
              "Content-Type": "text/plain"                                                                             // 165
            });                                                                                                        //
            response.end("404 not found: /" + path);                                                                   // 167
          }                                                                                                            //
        } else {                                                                                                       //
          console.error("didn't understand result of getWwwFileHack:", status);                                        // 170
          if (!started) {                                                                                              // 171
            response.writeHead(500, {                                                                                  // 172
              "Content-Type": "text/plain"                                                                             // 173
            });                                                                                                        //
            response.end("Internal server error");                                                                     // 175
          }                                                                                                            //
        }                                                                                                              //
      });                                                                                                              //
    })["catch"](function (err) {                                                                                       //
      console.error(err.stack);                                                                                        // 180
    });                                                                                                                //
  };                                                                                                                   //
}                                                                                                                      //
                                                                                                                       //
function writeErrorResponse(res, err) {                                                                                // 185
  var status = 500;                                                                                                    // 186
  if (err instanceof Meteor.Error && typeof err.error === "number" && err.error >= 400 && err.error < 600) {           // 187
    status = err.error;                                                                                                // 189
  } else if (err.httpErrorCode) {                                                                                      //
    status = err.httpErrorCode;                                                                                        // 191
  }                                                                                                                    //
                                                                                                                       //
  // Log errors that are our fault, but not errors that are the client's fault.                                        //
  if (status >= 500) console.error(err.stack);                                                                         // 185
                                                                                                                       //
  res.writeHead(status, { "Content-Type": err.htmlMessage ? "text/html" : "text/plain" });                             // 197
  res.end(err.htmlMessage || err.message);                                                                             // 198
}                                                                                                                      //
                                                                                                                       //
var PNG_MAGIC = new Buffer([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A]);                                          // 201
var JPEG_MAGIC = new Buffer([0xFF, 0xD8, 0xFF]);                                                                       // 202
                                                                                                                       //
function checkMagic(buf, magic) {                                                                                      // 204
  if (buf.length < magic.length) return false;                                                                         // 205
                                                                                                                       //
  for (var i = 0; i < magic.length; i++) {                                                                             // 207
    if (buf[i] != magic[i]) return false;                                                                              // 208
  }                                                                                                                    //
                                                                                                                       //
  return true;                                                                                                         // 211
}                                                                                                                      //
                                                                                                                       //
function serveSelfTest(req, res) {                                                                                     // 214
  try {                                                                                                                // 215
    if (req.method === "GET" && req.url === "/") {                                                                     // 216
      var content = new Buffer("Self-test OK.");                                                                       // 218
                                                                                                                       //
      // Convert the ROOT_URL to something that is a valid origin.                                                     //
      var rootUrlAsOrigin = process.env.ROOT_URL;                                                                      // 217
      if (rootUrlAsOrigin.slice(-1) === "/") {                                                                         // 222
        rootUrlAsOrigin = rootUrlAsOrigin.slice(0, -1);                                                                // 223
      }                                                                                                                //
                                                                                                                       //
      res.writeHead(200, {                                                                                             // 226
        "Content-Type": "text/plain",                                                                                  // 227
        "Content-Length": content.length,                                                                              // 228
        "Access-Control-Allow-Origin": rootUrlAsOrigin                                                                 // 229
      });                                                                                                              //
      res.end(content);                                                                                                // 231
    } else {                                                                                                           //
      res.writeHead(400, { "Content-Type": "text/plain" });                                                            // 233
      res.end("Bad request to self-test subdomain.");                                                                  // 234
      return;                                                                                                          // 235
    }                                                                                                                  //
  } catch (err) {                                                                                                      //
    console.log("WARNING: An error occurred while serving self-test; proceeding anyway:", err);                        // 238
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
function serveStaticAsset(req, res) {                                                                                  // 242
  inMeteor(function () {                                                                                               // 243
    if (req.method === "GET") {                                                                                        // 244
      // jscs:disable validateQuoteMarks                                                                               //
      var assetCspHeader = "default-src 'none'; style-src 'unsafe-inline'; sandbox";                                   // 246
      if (req.headers['if-none-match'] === 'permanent') {                                                              // 247
        // Cache never invalidates since we use a new URL for every resource.                                          //
        res.writeHead(304, {                                                                                           // 249
          'Cache-Control': 'public, max-age=31536000',                                                                 // 250
          'ETag': 'permanent',                                                                                         // 251
                                                                                                                       //
          // To be safe, send these again, although it shouldn't be necessary.                                         //
          'Content-Security-Policy': assetCspHeader,                                                                   // 254
          'Access-Control-Allow-Origin': '*',                                                                          // 255
          'X-Content-Type-Options': 'nosniff'                                                                          // 256
        });                                                                                                            //
        res.end();                                                                                                     // 258
        return;                                                                                                        // 259
      }                                                                                                                //
                                                                                                                       //
      var url = Url.parse(req.url);                                                                                    // 262
      var asset = globalDb.getStaticAsset(url.pathname.slice(1));                                                      // 263
                                                                                                                       //
      if (asset) {                                                                                                     // 265
        var headers = {                                                                                                // 266
          'Content-Type': asset.mimeType,                                                                              // 267
          'Content-Length': asset.content.length,                                                                      // 268
                                                                                                                       //
          // Assets can be cached forever because each one has a unique ID.                                            //
          'Cache-Control': 'public, max-age=31536000',                                                                 // 271
                                                                                                                       //
          // Since different resources get different URLs, we can use a static etag.                                   //
          'ETag': 'permanent',                                                                                         // 274
                                                                                                                       //
          // Set strict Content-Security-Policy to prevent static assets from executing any script                     //
          // or doing basically anything when browsed to directly. The static assets host is not                       //
          // intended to serve HTML. Mostly, it serves images and javascript -- note that setting                      //
          // the CSP header on Javascript files does not prevent other hosts from voluntarily                          //
          // specifying these scripts in <script> tags.                                                                //
          'Content-Security-Policy': assetCspHeader,                                                                   // 281
                                                                                                                       //
          // Allow any host to fetch these assets. This is safe since requests to this host are                        //
          // totally side-effect-free and the asset ID acts as a capability to prevent loading                         //
          // assets you're not supposed to know about.                                                                 //
          'Access-Control-Allow-Origin': '*',                                                                          // 286
                                                                                                                       //
          // Extra protection against content type trickery.                                                           //
          'X-Content-Type-Options': 'nosniff'                                                                          // 289
        };                                                                                                             //
                                                                                                                       //
        if (asset.encoding) {                                                                                          // 292
          headers['Content-Encoding'] = asset.encoding;                                                                // 293
        }                                                                                                              //
                                                                                                                       //
        res.writeHead(200, headers);                                                                                   // 296
        res.end(asset.content);                                                                                        // 297
      } else {                                                                                                         //
        res.writeHead(404, { 'Content-Type': 'text/plain' });                                                          // 299
        res.end('not found');                                                                                          // 300
      }                                                                                                                //
    } else if (req.method === 'POST') {                                                                                //
      var _ret = function () {                                                                                         //
        res.setHeader('Access-Control-Allow-Origin', '*');                                                             // 303
                                                                                                                       //
        var url = Url.parse(req.url);                                                                                  // 305
        var purpose = globalDb.fulfillAssetUpload(url.pathname.slice(1));                                              // 306
        if (!purpose) {                                                                                                // 307
          res.writeHead(404, { 'Content-Type': 'text/plain' });                                                        // 308
          res.end('Upload token not found or expired.');                                                               // 309
          return {                                                                                                     // 310
            v: void 0                                                                                                  //
          };                                                                                                           //
        }                                                                                                              //
                                                                                                                       //
        var userId = purpose.profilePicture.userId;                                                                    // 313
        var identityId = purpose.profilePicture.identityId;                                                            // 314
        check(userId, String);                                                                                         // 315
        check(identityId, String);                                                                                     // 316
                                                                                                                       //
        var buffers = [];                                                                                              // 318
        var totalSize = 0;                                                                                             // 319
        var done = new Future();                                                                                       // 320
        req.on('data', function (buf) {                                                                                // 321
          totalSize += buf.length;                                                                                     // 322
          if (totalSize <= 64 * 1024) {                                                                                // 323
            buffers.push(buf);                                                                                         // 324
          }                                                                                                            //
        });                                                                                                            //
        req.on('end', done["return"].bind(done));                                                                      // 327
        req.on('error', done["throw"].bind(done));                                                                     // 328
        done.wait();                                                                                                   // 329
                                                                                                                       //
        if (totalSize > 64 * 1024) {                                                                                   // 331
          // TODO(soon): Resize the image ourselves.                                                                   //
          res.writeHead(400, { 'Content-Type': 'text/plain' });                                                        // 333
          res.end('Picture too large; please use an image under 64 KiB.');                                             // 334
          return {                                                                                                     // 335
            v: void 0                                                                                                  //
          };                                                                                                           //
        }                                                                                                              //
                                                                                                                       //
        var content = Buffer.concat(buffers);                                                                          // 338
        var type = void 0;                                                                                             // 339
        if (checkMagic(content, PNG_MAGIC)) {                                                                          // 340
          type = 'image/png';                                                                                          // 341
        } else if (checkMagic(content, JPEG_MAGIC)) {                                                                  //
          type = 'image/jpeg';                                                                                         // 343
        } else {                                                                                                       //
          res.writeHead(400, { 'Content-Type': 'text/plain' });                                                        // 345
          res.end('Image must be PNG or JPEG.');                                                                       // 346
          return {                                                                                                     // 347
            v: void 0                                                                                                  //
          };                                                                                                           //
        }                                                                                                              //
                                                                                                                       //
        var assetId = globalDb.addStaticAsset({ mimeType: type }, content);                                            // 350
        var old = Meteor.users.findAndModify({                                                                         // 351
          query: { '_id': identityId },                                                                                // 352
          update: { $set: { 'profile.picture': assetId } },                                                            // 353
          fields: { 'profile.picture': 1 }                                                                             // 354
        });                                                                                                            //
                                                                                                                       //
        if (old && old.profile && old.profile.picture) {                                                               // 357
          globalDb.unrefStaticAsset(old.profile.picture);                                                              // 358
        }                                                                                                              //
                                                                                                                       //
        res.writeHead(204, {});                                                                                        // 361
        res.end();                                                                                                     // 362
      }();                                                                                                             //
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret)) === "object") return _ret.v;    //
    } else if (req.method === 'OPTIONS') {                                                                             //
      var requestedHeaders = req.headers['access-control-request-headers'];                                            // 364
      if (requestedHeaders) {                                                                                          // 365
        res.setHeader('Access-Control-Allow-Headers', requestedHeaders);                                               // 366
      }                                                                                                                //
                                                                                                                       //
      res.writeHead(204, {                                                                                             // 369
        'Access-Control-Allow-Origin': '*',                                                                            // 370
        'Access-Control-Allow-Methods': 'GET, HEAD, POST, OPTIONS',                                                    // 371
        'Access-Control-Max-Age': '3600'                                                                               // 372
      });                                                                                                              //
      res.end();                                                                                                       // 374
    } else {                                                                                                           //
      res.writeHead(405, 'Method Not Allowed', {                                                                       // 376
        'Allow': 'GET, POST, OPTIONS',                                                                                 // 377
        'Content-Type': 'text/plain'                                                                                   // 378
      });                                                                                                              //
      res.end('405 Method Not Allowed: ' + req.method);                                                                // 380
    }                                                                                                                  //
  })["catch"](function (err) {                                                                                         //
    writeErrorResponse(res, err);                                                                                      // 383
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 387
                                                                                                                       //
  var meteorUpgradeListeners = WebApp.httpServer.listeners('upgrade');                                                 // 389
  WebApp.httpServer.removeAllListeners('upgrade');                                                                     // 390
                                                                                                                       //
  WebApp.httpServer.on('upgrade', function (req, socket, head) {                                                       // 392
    Promise.resolve(undefined).then(function () {                                                                      // 393
      if (!req.headers.host) {                                                                                         // 394
        throw new Meteor.Error(400, 'Missing Host header');                                                            // 395
      } else if (isSandstormShell(req.headers.host.split(':')[0])) {                                                   //
        // Go on to Meteor.                                                                                            //
        for (var ii = 0; ii < meteorUpgradeListeners.length; ++ii) {                                                   // 398
          meteorUpgradeListeners[ii](req, socket, head);                                                               // 399
        }                                                                                                              //
                                                                                                                       //
        return true;                                                                                                   // 402
      } else {                                                                                                         //
        var id = matchWildcardHost(req.headers.host);                                                                  // 404
        if (id) {                                                                                                      // 405
          return tryProxyUpgrade(id, req, socket, head);                                                               // 406
        } else {                                                                                                       //
          return false;                                                                                                // 408
        }                                                                                                              //
      }                                                                                                                //
    }).then(function (handled) {                                                                                       //
      if (!handled) socket.destroy();                                                                                  // 412
    })["catch"](function (err) {                                                                                       //
      console.error('WebSocket event handler failed:', err.stack);                                                     // 414
      socket.destroy();                                                                                                // 415
    });                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  // BlackrockPayments is only defined in the Blackrock build of Sandstorm.                                            //
  if (global.BlackrockPayments) {                                                                                      // 387
    // Have to check with global, because it could be undefined.                                                       //
    WebApp.rawConnectHandlers.use(BlackrockPayments.makeConnectHandler(globalDb));                                     // 421
  }                                                                                                                    //
                                                                                                                       //
  // This function serves responses on Sandstorm's main HTTP/HTTPS                                                     //
  // port.                                                                                                             //
  var serveMeteorOrStaticPublishing = function serveMeteorOrStaticPublishing(req, res, next) {                         // 387
    return dispatchToMeteorOrStaticPublishing(req, res, next, false);                                                  // 427
  };                                                                                                                   //
                                                                                                                       //
  // "Alternate ports" are ports other than the main HTTP or HTTPS                                                     //
  // port. For requests to the shell & grains, we redirect to the main                                                 //
  // port. For static publishing, we serve it.                                                                         //
  //                                                                                                                   //
  // They are bound to FD #4 and higher.                                                                               //
                                                                                                                       //
  function getNumberOfAlternatePorts() {                                                                               // 387
    var numPorts = process.env.PORT.split(',').length;                                                                 // 437
    var numAlternatePorts = numPorts - 1;                                                                              // 438
    return numAlternatePorts;                                                                                          // 439
  };                                                                                                                   //
                                                                                                                       //
  var canonicalizeShellOrWildcardUrl = function canonicalizeShellOrWildcardUrl(hostname, url) {                        // 442
    // Start with ROOT_URL, apply host & path from inbound URL, then                                                   //
    // redirect.                                                                                                       //
    var targetUrl = Url.parse(process.env.ROOT_URL);                                                                   // 445
                                                                                                                       //
    // Retain the protocol & port from ROOT_URL but use the inbound                                                    //
    // hostname.                                                                                                       //
    targetUrl.host = hostname + ':' + targetUrl.port;                                                                  // 442
                                                                                                                       //
    // The following allows to avoid decoding + re-encoding query                                                      //
    // string parameters, if provided.                                                                                 //
    targetUrl = Url.resolve(Url.format(targetUrl), url);                                                               // 442
    return targetUrl;                                                                                                  // 454
  };                                                                                                                   //
                                                                                                                       //
  var redirectToMeteorOrServeStaticPublishing = function redirectToMeteorOrServeStaticPublishing(req, res, next) {     // 457
    return dispatchToMeteorOrStaticPublishing(req, res, next, true);                                                   // 458
  };                                                                                                                   //
                                                                                                                       //
  for (var i = 0; i < getNumberOfAlternatePorts(); i++) {                                                              // 461
    // Call createServerForSandstorm() to skip our monkey patching.                                                    //
    var alternatePortServer = Http.createServerForSandstorm(redirectToMeteorOrServeStaticPublishing);                  // 463
    alternatePortServer.listen({ fd: i + 4 });                                                                         // 464
  }                                                                                                                    //
                                                                                                                       //
  var dispatchToMeteorOrStaticPublishing = function dispatchToMeteorOrStaticPublishing(req, res, next, redirectRatherThanServeShell) {
    if (!req.headers.host) {                                                                                           // 468
      res.writeHead(400, { 'Content-Type': 'text/plain' });                                                            // 469
      res.end('Missing Host header');                                                                                  // 470
      return;                                                                                                          // 471
    }                                                                                                                  //
                                                                                                                       //
    var hostname = req.headers.host.split(':')[0];                                                                     // 474
    if (isSandstormShell(hostname)) {                                                                                  // 475
      // Go on to Meteor, or serve a redirect.                                                                         //
      if (redirectRatherThanServeShell) {                                                                              // 477
        res.writeHead(302, { 'Location': canonicalizeShellOrWildcardUrl(hostname, req.url) });                         // 478
        res.end();                                                                                                     // 479
        return;                                                                                                        // 480
      } else {                                                                                                         //
        return next();                                                                                                 // 482
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    // This is not our main host. See if it's a member of the wildcard.                                                //
    var publicIdPromise = void 0;                                                                                      // 467
                                                                                                                       //
    var id = matchWildcardHost(req.headers.host);                                                                      // 489
    if (id) {                                                                                                          // 490
      // Match!                                                                                                        //
      if (redirectRatherThanServeShell) {                                                                              // 492
        res.writeHead(302, { 'Location': canonicalizeShellOrWildcardUrl(hostname, req.url) });                         // 493
        res.end();                                                                                                     // 494
        return;                                                                                                        // 495
      }                                                                                                                //
                                                                                                                       //
      if (id === 'static') {                                                                                           // 498
        // Static assets domain.                                                                                       //
        serveStaticAsset(req, res);                                                                                    // 500
        return;                                                                                                        // 501
      }                                                                                                                //
                                                                                                                       //
      if (id.match(/^selftest-/)) {                                                                                    // 504
        // Self test domain pattern. Starts w/ hyphen to avoid ambiguity with grain session/static                     //
        // publishing wildcard hosts.                                                                                  //
        serveSelfTest(req, res);                                                                                       // 507
        return;                                                                                                        // 508
      }                                                                                                                //
                                                                                                                       //
      // Try to route the request to a session.                                                                        //
      publicIdPromise = tryProxyRequest(id, req, res).then(function (handled) {                                        // 490
        if (handled) {                                                                                                 // 513
          return null;                                                                                                 // 514
        } else {                                                                                                       //
          return id;                                                                                                   // 516
        }                                                                                                              //
      });                                                                                                              //
    } else {                                                                                                           //
      // Not a wildcard host. Perhaps it is a custom host.                                                             //
      publicIdPromise = lookupPublicIdFromDns(hostname);                                                               // 521
    }                                                                                                                  //
                                                                                                                       //
    publicIdPromise.then(function (publicId) {                                                                         // 524
      if (publicId) {                                                                                                  // 525
        return Promise.resolve(undefined).then(function () {                                                           // 526
          var handler = staticHandlers[publicId];                                                                      // 527
          if (handler) {                                                                                               // 528
            return handler;                                                                                            // 529
          } else {                                                                                                     //
            // We don't have a handler for this publicId, so look it up in the grain DB.                               //
            return inMeteor(function () {                                                                              // 532
              var grain = Grains.findOne({ publicId: publicId }, { fields: { _id: 1 } });                              // 533
              if (!grain) {                                                                                            // 534
                throw new Meteor.Error(404, 'No such grain for public ID: ' + publicId);                               // 535
              }                                                                                                        //
                                                                                                                       //
              var grainId = grain._id;                                                                                 // 538
              return staticHandlers[publicId] = wwwHandlerForGrain(grainId);                                           // 539
            });                                                                                                        //
          }                                                                                                            //
        }).then(function (handler) {                                                                                   //
          handler(req, res, function (err) {                                                                           // 543
            if (err) {                                                                                                 // 544
              next(err);                                                                                               // 545
            } else {                                                                                                   //
              res.writeHead(404, { 'Content-Type': 'text/plain' });                                                    // 547
              res.end('404 not found: ' + req.url);                                                                    // 548
            }                                                                                                          //
          });                                                                                                          //
        });                                                                                                            //
      } else {                                                                                                         //
        return Promise.resolve(undefined);                                                                             // 553
      }                                                                                                                //
    })["catch"](function (err) {                                                                                       //
      writeErrorResponse(res, err);                                                                                    // 556
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  WebApp.rawConnectHandlers.use(serveMeteorOrStaticPublishing);                                                        // 560
});                                                                                                                    //
                                                                                                                       //
var errorTxtMapping = {};                                                                                              // 563
errorTxtMapping[Dns.NOTFOUND] = '<p>' + 'If you were trying to configure static publishing for a blog or website, powered ' + 'by a Sandstorm app hosted at this server, you either have not added DNS TXT records ' + 'correctly, or the DNS cache has not updated yet (may take a while, like 5 minutes to one ' + 'hour).</p>';
errorTxtMapping[Dns.NODATA] = errorTxtMapping[Dns.NOTFOUND];                                                           // 569
errorTxtMapping[Dns.TIMEOUT] = '<p>' + 'The DNS query has timed out, which may be a sign of poorly configured DNS on the server.</p>';
errorTxtMapping[Dns.CONNREFUSED] = '<p>' + 'The DNS server refused the connection, which means either your DNS server is down/unreachable, ' + 'or the server has misconfigured their DNS.</p>';
                                                                                                                       //
function lookupPublicIdFromDns(hostname) {                                                                             // 576
  // Given a hostname, determine its public ID.                                                                        //
  // We look for a TXT record indicating the public ID. Unfortunately, according to spec, a single                     //
  // hostname cannot have both a CNAME and a TXT record, because a TXT lookup on a CNAME'd host                        //
  // should actually be redirected to the CNAME, just like an A lookup would be. In practice lots                      //
  // of DNS software actually allows TXT records on CNAMEs, and it seems to work, but some software                    //
  // does not allow it and it's explicitly disallowed by the spec. Therefore, we instead look for                      //
  // the TXT record on a subdomain.                                                                                    //
  //                                                                                                                   //
  // I also considered having the CNAME itself point to <publicId>.<hostname>, where                                   //
  // *.<hostname> is in turn a CNAME for the Sandstorm server. This approach seemed elegant at                         //
  // first, but has a number of problems, the biggest being that it breaks the ability to place a                      //
  // CDN like CloudFlare in front of the site.                                                                         //
                                                                                                                       //
  var cache = dnsCache[hostname];                                                                                      // 590
  if (cache && Date.now() < cache.expiration) {                                                                        // 591
    return Promise.resolve(cache.value);                                                                               // 592
  }                                                                                                                    //
                                                                                                                       //
  return new Promise(function (resolve, reject) {                                                                      // 595
    Dns.resolveTxt('sandstorm-www.' + hostname, function (err, records) {                                              // 596
      if (err) {                                                                                                       // 597
        var errorMsg = errorTxtMapping[err.code] || '';                                                                // 598
        var error = new Error('Error looking up DNS TXT records for host "' + hostname + '": ' + err.message);         // 599
        error.htmlMessage = '<style type="text/css">h2, h3, p { max-width: 600px; }</style>' + '<h2>Sandstorm static publishing needs further configuration (or wrong URL)</h2>' + errorMsg + '<p>To visit this Sandstorm server\'s main interface, go to: <a href=\'' + process.env.ROOT_URL + '\'>' + process.env.ROOT_URL + '</a></p>' + '<h3>DNS details</h3>' + '<p>Error looking up DNS TXT records for host "' + hostname + '": ' + err.message + '</p>' + '<p>If you have the <tt>dig</tt> tool, you can run this command to learn more:</p>' + '<p><tt>dig TXT sandstorm-www.' + hostname + '</tt></p>' + '<h3>Changing the server URL, or troubleshooting OAuth login</h3>' + '<p>If you are the server admin and want to use this address as the main interface, ' + 'edit /opt/sandstorm/sandstorm.conf, modify the BASE_URL setting, and restart ' + 'Sandstorm.</p>' + '<p>If you got here after trying to log in via OAuth (e.g. through GitHub or Google), ' + 'the problem is probably that the OAuth callback URL was set wrong. You need to ' + 'update it through the respective login provider\'s management console. The ' + 'easiest way to do that is to run <tt>sudo sandstorm admin-token</tt>, then ' + 'reconfigure the OAuth provider.</p>';
        error.httpErrorCode = _.contains(['ENOTFOUND', 'ENODATA'], err.code) ? 404 : 500;                              // 620
        reject(error);                                                                                                 // 621
      } else if (records.length !== 1) {                                                                               //
        reject(new Error('Host "sandstorm-www.' + hostname + '" must have exactly one TXT record.'));                  // 623
      } else {                                                                                                         //
        var result = records[0];                                                                                       // 625
        dnsCache[hostname] = { value: result, expiration: Date.now() + DNS_CACHE_TTL };                                // 626
        resolve(result);                                                                                               // 627
      }                                                                                                                //
    });                                                                                                                //
  });                                                                                                                  //
}                                                                                                                      //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"proxy.js":["babel-runtime/helpers/typeof","babel-runtime/helpers/classCallCheck",function(require,exports){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/proxy.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                                //
                                                                                                                       //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                       //
                                                                                                                       //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                                //
                                                                                                                       //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                       //
                                                                                                                       //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var Crypto = Npm.require("crypto");                                                                                    // 17
var ChildProcess = Npm.require("child_process");                                                                       // 18
var Fs = Npm.require("fs");                                                                                            // 19
var Path = Npm.require("path");                                                                                        // 20
var Future = Npm.require("fibers/future");                                                                             // 21
var Http = Npm.require("http");                                                                                        // 22
var Url = Npm.require("url");                                                                                          // 23
var Promise = Npm.require("es6-promise").Promise;                                                                      // 24
var Capnp = Npm.require("capnp");                                                                                      // 25
var Net = Npm.require("net");                                                                                          // 26
                                                                                                                       //
var ByteStream = Capnp.importSystem("sandstorm/util.capnp").ByteStream;                                                // 28
var ApiSession = Capnp.importSystem("sandstorm/api-session.capnp").ApiSession;                                         // 29
var WebSession = Capnp.importSystem("sandstorm/web-session.capnp").WebSession;                                         // 30
var HackSession = Capnp.importSystem("sandstorm/hack-session.capnp");                                                  // 31
var Supervisor = Capnp.importSystem("sandstorm/supervisor.capnp").Supervisor;                                          // 32
var Backend = Capnp.importSystem("sandstorm/backend.capnp").Backend;                                                   // 33
                                                                                                                       //
var storeReferralProgramInfoApiTokenCreated = function storeReferralProgramInfoApiTokenCreated(db, accountId, identityId, apiTokenAccountId) {
  // From the Referral program's perspective, if Bob's Account has no referredByComplete, then we                      //
  // update Bob's Identity to say it's referredBy Alice's Account (which is apiTokenAccountId).                        //
  check(accountId, String);                                                                                            // 38
  check(identityId, String);                                                                                           // 39
  check(apiTokenAccountId, String);                                                                                    // 40
                                                                                                                       //
  // Bail out early if quota enforcement is disabled.                                                                  //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 35
    return;                                                                                                            // 44
  }                                                                                                                    //
                                                                                                                       //
  var aliceAccountId = apiTokenAccountId;                                                                              // 47
  var bobAccountId = accountId;                                                                                        // 48
  var bobIdentityId = identityId;                                                                                      // 49
                                                                                                                       //
  if (Meteor.users.find({                                                                                              // 51
    _id: bobAccountId,                                                                                                 // 52
    referredByComplete: { $exists: true }                                                                              // 53
  }).count() > 0) {                                                                                                    //
    return;                                                                                                            // 55
  }                                                                                                                    //
                                                                                                                       //
  // Only actually update Bob's Identity ID if there is no referredBy.                                                 //
  Meteor.users.update({ _id: bobIdentityId, referredBy: { $exists: false } }, { $set: { referredBy: aliceAccountId } });
};                                                                                                                     //
                                                                                                                       //
function referralProgramLogSharingTokenUse(db, bobAccountId) {                                                         // 64
  // Hooray! The sharing token is valid! Someone (let's call them Charlie) is going to get a UiView                    //
  // to this grain!  This means that the user who created this apiToken knows how to use the 'share                    //
  // access' interface. Let's call them Bob.                                                                           //
  //                                                                                                                   //
  // If Bob's Account.referredByComplete is not yet set, then look at Bob's Identities and take the                    //
  // first referredBy we find -- let's call that Alice.                                                                //
  //                                                                                                                   //
  // We copy Alice's account ID to Bob's Account.referredByComplete, and then update Alice's                           //
  // referredIdentityIds to point at Bob's Identity, and then remove the referredBy from Bob's                         //
  // Identity since it has become redundant.                                                                           //
  //                                                                                                                   //
  // Implementation note: this does mean that Alice can get referral credit for Bob by sharing a                       //
  // link with Bob, even if Bob already had an account.                                                                //
                                                                                                                       //
  // Bail out early if quota support is not enabled.                                                                   //
  if (!Meteor.settings["public"].quotaEnabled) {                                                                       // 80
    return;                                                                                                            // 81
  }                                                                                                                    //
                                                                                                                       //
  // Bail out if Bob has a referredByComplete.                                                                         //
  if (Meteor.users.find({ _id: bobAccountId, referredByComplete: { $exists: true } }).count() > 0) {                   // 64
    return;                                                                                                            // 86
  }                                                                                                                    //
                                                                                                                       //
  // Look for a referredBy on any of Bob's identities.                                                                 //
  var bobIdentityIds = SandstormDb.getUserIdentityIds(Meteor.users.findOne({ _id: bobAccountId }));                    // 64
  var bobIdentityWithReferredBy = Meteor.users.findOne({                                                               // 91
    _id: { $in: bobIdentityIds },                                                                                      // 92
    referredBy: { $exists: true }                                                                                      // 93
  });                                                                                                                  //
                                                                                                                       //
  if (!bobIdentityWithReferredBy) {                                                                                    // 96
    return;                                                                                                            // 97
  }                                                                                                                    //
                                                                                                                       //
  var aliceAccountId = bobIdentityWithReferredBy.referredBy;                                                           // 100
                                                                                                                       //
  // Store Bob's Account.referralCompletedBy.                                                                          //
  var now = new Date();                                                                                                // 64
  Meteor.users.update({                                                                                                // 104
    _id: bobAccountId,                                                                                                 // 105
    referredByComplete: { $exists: false }                                                                             // 106
  }, {                                                                                                                 //
    $set: {                                                                                                            // 108
      referredByComplete: bobIdentityWithReferredBy.referredBy,                                                        // 109
      referredCompleteDate: now                                                                                        // 110
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  // Update Alice's Account.referredIdentityIds.                                                                       //
  Meteor.users.update({ _id: aliceAccountId }, {                                                                       // 64
    $push: { referredIdentityIds: bobIdentityWithReferredBy._id }                                                      // 116
  });                                                                                                                  //
                                                                                                                       //
  // Remove now-redundant Bob identity referredBy.                                                                     //
  Meteor.users.update({ _id: bobIdentityWithReferredBy._id }, {                                                        // 64
    $unset: { referredBy: true }                                                                                       // 121
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
// User-agent strings that should be allowed to use http basic authentication.                                         //
// These are regex matches, so ensure they are escaped properly with double                                            //
// backslashes. For security reasons, we MUST NOT whitelist any user-agents                                            //
// that may render html and execute embedded scripts.                                                                  //
BASIC_AUTH_USER_AGENTS = ["git\\/", "GitHub-Hookshot\\/", "mirall\\/", "Mozilla\\/5\\.0 \\([^\\\\]*\\) mirall\\/", "Mozilla\\/5\\.0 \\(iOS\\) ownCloud-iOS\\/", "Mozilla\\/5\\.0 \\(Android\\) ownCloud-android\\/", "litmus\\/"];
BASIC_AUTH_USER_AGENTS_REGEX = new RegExp("^(" + BASIC_AUTH_USER_AGENTS.join("|") + ")", "");                          // 138
                                                                                                                       //
var SESSION_PROXY_TIMEOUT = 60000;                                                                                     // 140
                                                                                                                       //
var sandstormCoreFactory = makeSandstormCoreFactory();                                                                 // 142
var backendAddress = "unix:" + (SANDSTORM_ALTHOME || "") + Backend.socketPath;                                         // 143
var sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 144
var sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 145
                                                                                                                       //
// TODO(cleanup): This initilization belongs with the rest of our package initialization in                            //
//   db-deprecated.js. We can't put it there now because we need to contruct sandstormCoreFactory first.               //
globalBackend = new SandstormBackend(globalDb, sandstormBackend);                                                      // 149
Meteor.onConnection(function (connection) {                                                                            // 150
  connection.sandstormBackend = globalBackend;                                                                         // 151
});                                                                                                                    //
                                                                                                                       //
// We've observed a problem in production where occasionally the front-end stops talking to the                        //
// back-end. It happens very rarely -- like once a month -- and we've been unable to reproduce it                      //
// in testing, making it very hard to debug. The problem appears both on Sandstorm and Blackrock.                      //
// Restarting the node process (and only the node process) always fixes the problem.                                   //
//                                                                                                                     //
// Here, I've added some code that attempts to detect the problem by doing a health check                              //
// periodically and then remaking the connection if it seems broken. We'll see if this helps!                          //
var backendHealthy = true;                                                                                             // 161
var disconnectCount = 0;                                                                                               // 162
Meteor.setInterval(function () {                                                                                       // 163
  if (!backendHealthy) {                                                                                               // 164
    if (disconnectCount++ > 2) process.abort();                                                                        // 165
    console.error("error: Backend hasn't responded in 30 seconds! Reconnecting.");                                     // 166
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(true);                                        // 167
    sandstormBackendConnection.close();                                                                                // 168
    sandstormBackendConnection = Capnp.connect(backendAddress, sandstormCoreFactory);                                  // 169
    sandstormBackend = sandstormBackendConnection.restore(null, Backend);                                              // 170
    globalBackend._backendCap = sandstormBackend;                                                                      // 171
  }                                                                                                                    //
                                                                                                                       //
  var debugLog = !backendHealthy;                                                                                      // 174
  backendHealthy = false;                                                                                              // 175
  var promise = sandstormBackend.ping().then(function () {                                                             // 176
    backendHealthy = true;                                                                                             // 177
    if (Capnp.enableVerboseDebugLogging) Capnp.enableVerboseDebugLogging(false);                                       // 178
  }, function (err) {                                                                                                  //
    console.error("error: Backend ping threw error!", err.stack);                                                      // 180
    // The connection will be remade on the next interval. Note that we do NOT normally observe                        //
    // exceptions being thrown for this problem; we see the connection simply stop responding.                         //
    // So we don't expect this branch to execute in any case.                                                          //
  });                                                                                                                  // 179
                                                                                                                       //
  if (debugLog) {                                                                                                      // 186
    console.log("capnp.js: outer promise:", promise);                                                                  // 187
  }                                                                                                                    //
}, 30000);                                                                                                             //
                                                                                                                       //
// =======================================================================================                             //
// Meteor context <-> Async Node.js context adapters                                                                   //
// TODO(cleanup):  Move to a different file.                                                                           //
                                                                                                                       //
var inMeteorInternal = Meteor.bindEnvironment(function (callback) {                                                    // 195
  callback();                                                                                                          // 196
});                                                                                                                    //
                                                                                                                       //
inMeteor = function inMeteor(callback) {                                                                               // 199
  // Calls the callback in a Meteor context.  Returns a Promise for its result.                                        //
  return new Promise(function (resolve, reject) {                                                                      // 201
    inMeteorInternal(function () {                                                                                     // 202
      try {                                                                                                            // 203
        resolve(callback());                                                                                           // 204
      } catch (err) {                                                                                                  //
        reject(err);                                                                                                   // 206
      }                                                                                                                //
    });                                                                                                                //
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
promiseToFuture = function promiseToFuture(promise) {                                                                  // 212
  var result = new Future();                                                                                           // 213
  promise.then(result["return"].bind(result), result["throw"].bind(result));                                           // 214
  return result;                                                                                                       // 215
};                                                                                                                     //
                                                                                                                       //
waitPromise = function waitPromise(promise) {                                                                          // 218
  return promiseToFuture(promise).wait();                                                                              // 219
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// API for creating / starting grains from Meteor methods.                                                             //
                                                                                                                       //
var proxiesByHostId = {};                                                                                              // 225
                                                                                                                       //
Meteor.methods({                                                                                                       // 227
  newGrain: function () {                                                                                              // 228
    function newGrain(packageId, command, title, identityId) {                                                         //
      // Create and start a new grain.                                                                                 //
                                                                                                                       //
      check(packageId, String);                                                                                        // 231
      check(command, Object); // Manifest.Command from package.capnp.                                                  // 232
      check(title, String);                                                                                            // 228
      check(identityId, String);                                                                                       // 234
                                                                                                                       //
      if (!this.userId) {                                                                                              // 236
        throw new Meteor.Error(403, "Unauthorized", "Must be logged in to create grains.");                            // 237
      }                                                                                                                //
                                                                                                                       //
      if (!globalDb.userHasIdentity(this.userId, identityId)) {                                                        // 240
        throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                          // 241
      }                                                                                                                //
                                                                                                                       //
      if (!isSignedUpOrDemo()) {                                                                                       // 244
        throw new Meteor.Error(403, "Unauthorized", "Only invited users or demo users can create grains.");            // 245
      }                                                                                                                //
                                                                                                                       //
      if (isUserOverQuota(Meteor.user())) {                                                                            // 249
        throw new Meteor.Error(402, "You are out of storage space. Please delete some things and try again.");         // 250
      }                                                                                                                //
                                                                                                                       //
      var pkg = Packages.findOne(packageId);                                                                           // 254
      var isDev = false;                                                                                               // 255
      if (!pkg) {                                                                                                      // 256
        // Maybe they wanted a dev package.  Check there too.                                                          //
        pkg = DevPackages.findOne(packageId);                                                                          // 258
        isDev = true;                                                                                                  // 259
      }                                                                                                                //
                                                                                                                       //
      if (!pkg) {                                                                                                      // 262
        throw new Meteor.Error(404, "Not Found", "No such package is installed.");                                     // 263
      }                                                                                                                //
                                                                                                                       //
      var appId = pkg.appId;                                                                                           // 266
      var manifest = pkg.manifest;                                                                                     // 267
      var grainId = Random.id(22); // 128 bits of entropy                                                              // 268
      Grains.insert({                                                                                                  // 228
        _id: grainId,                                                                                                  // 270
        packageId: packageId,                                                                                          // 271
        appId: appId,                                                                                                  // 272
        appVersion: manifest.appVersion,                                                                               // 273
        userId: this.userId,                                                                                           // 274
        identityId: identityId,                                                                                        // 275
        title: title,                                                                                                  // 276
        "private": true                                                                                                // 277
      });                                                                                                              //
                                                                                                                       //
      globalBackend.startGrainInternal(packageId, grainId, this.userId, command, true, isDev);                         // 280
      globalBackend.updateLastActive(grainId, this.userId, identityId);                                                // 281
      return grainId;                                                                                                  // 282
    }                                                                                                                  //
                                                                                                                       //
    return newGrain;                                                                                                   //
  }(),                                                                                                                 //
  openSession: function () {                                                                                           // 285
    function openSession(grainId, identityId, cachedSalt) {                                                            //
      // Open a new UI session on an existing grain.  Starts the grain if it is not already                            //
      // running.                                                                                                      //
                                                                                                                       //
      check(grainId, String);                                                                                          // 289
      check(identityId, Match.OneOf(undefined, null, String));                                                         // 290
      check(cachedSalt, Match.OneOf(undefined, null, String));                                                         // 291
                                                                                                                       //
      if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                           // 293
        throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                          // 294
      }                                                                                                                //
                                                                                                                       //
      if (!Grains.findOne({ _id: grainId })) {                                                                         // 297
        throw new Meteor.Error(404, "Grain not found", "Grain ID: " + grainId);                                        // 298
      }                                                                                                                //
                                                                                                                       //
      var db = this.connection.sandstormDb;                                                                            // 301
      check(cachedSalt, Match.OneOf(undefined, null, String));                                                         // 302
      if (!SandstormPermissions.mayOpenGrain(db, { grain: { _id: grainId, identityId: identityId } })) {               // 303
        throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                     // 305
      }                                                                                                                //
                                                                                                                       //
      var opened = globalBackend.openSessionInternal(grainId, this.userId, identityId, null, null, cachedSalt);        // 308
      var result = opened.methodResult;                                                                                // 310
      var proxy = new Proxy(grainId, this.userId, result.sessionId, result.hostId, result.tabId, identityId, false, opened.supervisor);
      proxiesByHostId[result.hostId] = proxy;                                                                          // 313
      return result;                                                                                                   // 314
    }                                                                                                                  //
                                                                                                                       //
    return openSession;                                                                                                //
  }(),                                                                                                                 //
  openSessionFromApiToken: function () {                                                                               // 317
    function openSessionFromApiToken(params, identityId, cachedSalt) {                                                 //
      // Given an API token, either opens a new WebSession to the underlying grain or returns a                        //
      // path to which the client should redirect in order to open such a session.                                     //
                                                                                                                       //
      check(params, {                                                                                                  // 321
        token: String,                                                                                                 // 322
        incognito: Boolean                                                                                             // 323
      });                                                                                                              //
      check(identityId, Match.OneOf(undefined, null, String));                                                         // 325
      check(cachedSalt, Match.OneOf(undefined, null, String));                                                         // 326
                                                                                                                       //
      if (this.userId && identityId && !globalDb.userHasIdentity(this.userId, identityId)) {                           // 328
        throw new Meteor.Error(403, "Current user does not own the identity: " + identityId);                          // 329
      }                                                                                                                //
                                                                                                                       //
      if (!identityId && globalDb.getOrganizationDisallowGuests()) {                                                   // 332
        throw new Meteor.Error("guestDisallowed", "This Sandstorm server does not allow " + "guests or anonymous users");
      }                                                                                                                //
                                                                                                                       //
      var token = params.token;                                                                                        // 337
      var incognito = params.incognito;                                                                                // 338
      var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                    // 339
      var apiToken = ApiTokens.findOne(hashedToken);                                                                   // 340
      validateWebkey(apiToken);                                                                                        // 341
      var grain = Grains.findOne({ _id: apiToken.grainId });                                                           // 342
      if (!grain) {                                                                                                    // 343
        throw new Meteor.Error(404, "Grain not found", "Grain ID: " + apiToken.grainId);                               // 344
      }                                                                                                                //
                                                                                                                       //
      if (apiToken.accountId) {                                                                                        // 347
        referralProgramLogSharingTokenUse(globalDb, apiToken.accountId);                                               // 348
      }                                                                                                                //
                                                                                                                       //
      var title = void 0;                                                                                              // 351
      if (grain.userId === apiToken.accountId) {                                                                       // 352
        title = grain.title;                                                                                           // 353
      } else {                                                                                                         //
        var sharerToken = apiToken.identityId && ApiTokens.findOne({                                                   // 355
          grainId: apiToken.grainId,                                                                                   // 357
          "owner.user.identityId": apiToken.identityId                                                                 // 358
        }, {                                                                                                           //
          sort: {                                                                                                      // 360
            "owner.user.lastUsed": -1                                                                                  // 361
          }                                                                                                            //
        });                                                                                                            //
        if (sharerToken) {                                                                                             // 364
          title = sharerToken.owner.user.title;                                                                        // 365
        } else {                                                                                                       //
          title = "shared grain";                                                                                      // 367
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      if (this.userId && !incognito) {                                                                                 // 371
        if (identityId != apiToken.identityId && identityId != grain.identityId && !ApiTokens.findOne({ "owner.user.identityId": identityId, parentToken: hashedToken })) {
          var owner = { user: { identityId: identityId, title: title } };                                              // 374
                                                                                                                       //
          // Create a new API token for the identity redeeming this token.                                             //
          var result = SandstormPermissions.createNewApiToken(globalDb, { rawParentToken: token }, apiToken.grainId, apiToken.petname, { allAccess: null }, owner);
          globalDb.addContact(apiToken.accountId, identityId);                                                         // 379
                                                                                                                       //
          // If the parent API token is forSharing and it has an accountId, then the logged-in user (call              //
          // them Bob) is about to access a grain owned by someone (call them Alice) and save a reference              //
          // to it as a new ApiToken. (For share-by-link, this occurs when viewing the grain. For                      //
          // share-by-identity, this happens immediately.)                                                             //
          if (result.parentApiToken) {                                                                                 // 373
            var parentApiToken = result.parentApiToken;                                                                // 386
            if (parentApiToken.forSharing && parentApiToken.accountId) {                                               // 387
              storeReferralProgramInfoApiTokenCreated(globalDb, this.userId, owner.user.identityId, parentApiToken.accountId);
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        return { redirectToGrain: apiToken.grainId };                                                                  // 394
      } else {                                                                                                         //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: apiToken })) {                                       // 396
          throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                   // 397
        }                                                                                                              //
                                                                                                                       //
        var opened = globalBackend.openSessionInternal(apiToken.grainId, null, null, title, apiToken, cachedSalt);     // 401
                                                                                                                       //
        var _result = opened.methodResult;                                                                             // 404
        var proxy = new Proxy(apiToken.grainId, grain.userId, _result.sessionId, _result.hostId, _result.tabId, identityId, false);
        proxy.apiToken = apiToken;                                                                                     // 407
        proxiesByHostId[_result.hostId] = proxy;                                                                       // 408
        return _result;                                                                                                // 409
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return openSessionFromApiToken;                                                                                    //
  }(),                                                                                                                 //
  keepSessionAlive: function () {                                                                                      // 413
    function keepSessionAlive(sessionId) {                                                                             //
      // TODO(security):  Prevent draining someone else's quota by holding open several grains shared                  //
      //   by them.                                                                                                    //
      check(sessionId, String);                                                                                        // 416
                                                                                                                       //
      var session = Sessions.findAndModify({                                                                           // 418
        query: { _id: sessionId },                                                                                     // 419
        update: { $set: { timestamp: new Date().getTime() } },                                                         // 420
        fields: { grainId: 1, identityId: 1, hostId: 1 }                                                               // 421
      });                                                                                                              //
                                                                                                                       //
      if (session) {                                                                                                   // 424
        // Session still present in database, so send keep-alive to backend.                                           //
        try {                                                                                                          // 426
          var grainId = session.grainId;                                                                               // 427
          var hostId = session.hostId;                                                                                 // 428
          var supervisor = proxiesByHostId[hostId] && proxiesByHostId[hostId].supervisor;                              // 429
          if (!supervisor) {                                                                                           // 430
            supervisor = globalBackend.continueGrain(grainId).supervisor;                                              // 431
          }                                                                                                            //
                                                                                                                       //
          waitPromise(supervisor.keepAlive());                                                                         // 434
          globalBackend.updateLastActive(grainId, this.userId, session.identityId);                                    // 435
        } catch (err) {                                                                                                //
          // Ignore disconnects, which imply that the grain shut down already. It'll start back up on                  //
          // the next request, so whatever.                                                                            //
          if (err.kjType !== "disconnected") {                                                                         // 439
            throw err;                                                                                                 // 440
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        return true;                                                                                                   // 444
      } else {                                                                                                         //
        return false;                                                                                                  // 446
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return keepSessionAlive;                                                                                           //
  }(),                                                                                                                 //
  shutdownGrain: function () {                                                                                         // 450
    function shutdownGrain(grainId) {                                                                                  //
      check(grainId, String);                                                                                          // 451
      var grain = Grains.findOne(grainId);                                                                             // 452
      if (!grain || !this.userId || grain.userId !== this.userId) {                                                    // 453
        throw new Meteor.Error(403, "Unauthorized", "User is not the owner of this grain");                            // 454
      }                                                                                                                //
                                                                                                                       //
      waitPromise(globalBackend.shutdownGrain(grainId, grain.userId, true));                                           // 457
    }                                                                                                                  //
                                                                                                                       //
    return shutdownGrain;                                                                                              //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
var validateWebkey = function validateWebkey(apiToken, refreshedExpiration) {                                          // 461
  // Validates that `apiToken` is a valid UiView webkey, throwing an exception if it is not. If                        //
  // `refreshedExpiration` is set and if the token has an `expiresIfUnused` field, then the                            //
  // `expiresIfUnused` field is reset to `refreshedExpiration`.                                                        //
                                                                                                                       //
  if (!apiToken) {                                                                                                     // 466
    throw new Meteor.Error(403, "Invalid authorization token");                                                        // 467
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.revoked) {                                                                                              // 470
    throw new Meteor.Error(403, "Authorization token has been revoked");                                               // 471
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.owner && !("webkey" in apiToken.owner)) {                                                               // 474
    throw new Meteor.Error(403, "Unauthorized to open non-webkey token.");                                             // 475
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.expires && apiToken.expires.getTime() <= Date.now()) {                                                  // 478
    throw new Meteor.Error(403, "Authorization token expired");                                                        // 479
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.expiresIfUnused) {                                                                                      // 482
    if (apiToken.expiresIfUnused.getTime() <= Date.now()) {                                                            // 483
      throw new Meteor.Error(403, "Authorization token expired");                                                      // 484
    } else if (refreshedExpiration) {                                                                                  //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: refreshedExpiration } });                              // 486
    } else {                                                                                                           //
      // It's getting used now, so clear the expiresIfUnused field.                                                    //
      ApiTokens.update(apiToken._id, { $set: { expiresIfUnused: null } });                                             // 489
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  if (apiToken.objectId || apiToken.frontendRef) {                                                                     // 493
    throw new Meteor.Error(403, "ApiToken refers to a non-webview Capability.");                                       // 494
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
// Used by shared/grain.js (which sounds like a broken dependency, since this code is only available                   //
// on the server)                                                                                                      //
getGrainSize = function getGrainSize(supervisor, oldSize) {                                                            // 500
  var promise = void 0;                                                                                                // 501
  if (oldSize === undefined) {                                                                                         // 502
    promise = supervisor.getGrainSize();                                                                               // 503
  } else {                                                                                                             //
    promise = supervisor.getGrainSizeWhenDifferent(oldSize);                                                           // 505
  }                                                                                                                    //
                                                                                                                       //
  var promise2 = promise.then(function (result) {                                                                      // 508
    return parseInt(result.size);                                                                                      // 508
  });                                                                                                                  //
  promise2.cancel = function () {                                                                                      // 509
    promise.cancel();                                                                                                  // 509
  };                                                                                                                   //
                                                                                                                       //
  return promise2;                                                                                                     // 511
};                                                                                                                     //
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 514
  var shutdownApp = function shutdownApp(appId) {                                                                      // 515
    Grains.find({ appId: appId }).forEach(function (grain) {                                                           // 516
      waitPromise(globalBackend.shutdownGrain(grain._id, grain.userId));                                               // 517
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  DevPackages.find().observe({                                                                                         // 521
    removed: function () {                                                                                             // 522
      function removed(devPackage) {                                                                                   //
        shutdownApp(devPackage.appId);                                                                                 // 522
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }(),                                                                                                               //
    changed: function () {                                                                                             // 524
      function changed(oldDevPackage, newDevPackage) {                                                                 //
        shutdownApp(oldDevPackage.appId);                                                                              // 525
        if (oldDevPackage.appId !== newDevPackage.appId) {                                                             // 526
          shutdownApp(newDevPackage.appId);                                                                            // 527
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }(),                                                                                                               //
    added: function () {                                                                                               // 531
      function added(devPackage) {                                                                                     //
        shutdownApp(devPackage.appId);                                                                                 // 531
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  Sessions.find().observe({                                                                                            // 534
    removed: function () {                                                                                             // 535
      function removed(session) {                                                                                      //
        var proxy = proxiesByHostId[session.hostId];                                                                   // 536
        delete proxiesByHostId[session.hostId];                                                                        // 537
        if (proxy) {                                                                                                   // 538
          proxy.close();                                                                                               // 539
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
// Kill off sessions idle for >~3 minutes.                                                                             //
var TIMEOUT_MS = 180000;                                                                                               // 546
var gcSessions = function gcSessions() {                                                                               // 547
  var now = new Date().getTime();                                                                                      // 548
  Sessions.remove({ timestamp: { $lt: now - TIMEOUT_MS } });                                                           // 549
};                                                                                                                     //
                                                                                                                       //
SandstormDb.periodicCleanup(TIMEOUT_MS, gcSessions);                                                                   // 552
                                                                                                                       //
var getProxyForHostId = function getProxyForHostId(hostId, isAlreadyOpened) {                                          // 554
  // Get the Proxy corresponding to the given grain session host, possibly (re)creating it if it                       //
  // doesn't already exist. The first request on the session host will always create a new proxy.                      //
  // Later requests may create a proxy if they go to a different front-end replica or if the                           //
  // front-end was restarted.                                                                                          //
  check(hostId, String);                                                                                               // 559
                                                                                                                       //
  return Promise.resolve(undefined).then(function () {                                                                 // 561
    var proxy = proxiesByHostId[hostId];                                                                               // 562
    if (proxy) {                                                                                                       // 563
      return proxy;                                                                                                    // 564
    } else {                                                                                                           //
      // Set table entry to null for now so that we can detect if it is concurrently deleted.                          //
      proxiesByHostId[hostId] = null;                                                                                  // 567
                                                                                                                       //
      return inMeteor(function () {                                                                                    // 569
        var session = Sessions.findOne({ hostId: hostId });                                                            // 570
        if (!session) {                                                                                                // 571
          if (isAlreadyOpened) {                                                                                       // 572
            return new Promise(function (resolve, reject) {                                                            // 573
              var observer = void 0;                                                                                   // 574
              var task = Meteor.setTimeout(function () {                                                               // 575
                observer.stop();                                                                                       // 576
                reject(new Meteor.Error(504, "Requested session that no longer exists, and " + "timed out waiting for client to restore it. This can happen if you have " + "opened an app's content in a new window and then closed it in the " + "UI. If you see this error *inside* the Sandstorm UI, please report a " + "bug and describe the circumstances of the error."));
              }, SESSION_PROXY_TIMEOUT);                                                                               //
              observer = Sessions.find({ hostId: hostId }).observe({                                                   // 583
                added: function () {                                                                                   // 584
                  function added() {                                                                                   //
                    observer.stop();                                                                                   // 585
                    Meteor.clearTimeout(task);                                                                         // 586
                    resolve(getProxyForHostId(hostId, false));                                                         // 587
                  }                                                                                                    //
                                                                                                                       //
                  return added;                                                                                        //
                }()                                                                                                    //
              });                                                                                                      //
            });                                                                                                        //
          } else {                                                                                                     //
            // Does not appear to be a valid session host.                                                             //
            return undefined;                                                                                          // 593
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        var apiToken = void 0;                                                                                         // 597
        if (session.hashedToken) {                                                                                     // 598
          apiToken = ApiTokens.findOne({ _id: session.hashedToken });                                                  // 599
          // We don't have to fully validate the API token here because if it changed the session                      //
          // would have been deleted.                                                                                  //
          if (!apiToken) {                                                                                             // 598
            throw new Meteor.Error(410, "ApiToken has been deleted");                                                  // 603
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        var grain = Grains.findOne(session.grainId);                                                                   // 607
        if (!grain) {                                                                                                  // 608
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 610
        }                                                                                                              //
                                                                                                                       //
        // Note that we don't need to call mayOpenGrain() because the existence of a session                           //
        // implies this check was already performed.                                                                   //
                                                                                                                       //
        var proxy = new Proxy(grain._id, grain.userId, session._id, hostId, session.tabId, session.identityId, false);
        if (apiToken) proxy.apiToken = apiToken;                                                                       // 618
                                                                                                                       //
        // Only add the proxy to the table if it was not concurrently deleted (which could happen                      //
        // e.g. if the user's access was revoked).                                                                     //
        if (hostId in proxiesByHostId) {                                                                               // 569
          proxiesByHostId[hostId] = proxy;                                                                             // 623
        } else {                                                                                                       //
          throw new Meteor.Error(403, "Session was concurrently closed.");                                             // 625
        }                                                                                                              //
                                                                                                                       //
        return proxy;                                                                                                  // 628
      });                                                                                                              //
    }                                                                                                                  //
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// API tokens                                                                                                          //
                                                                                                                       //
var ApiSessionProxies = function () {                                                                                  //
  // Class that caches proxies for requests that come in through HTTP API endpoints. Such                              //
  // requests are not associated with any entry in the `Sessions` collection, so we need                               //
  // some other means of detecting unused proxies and closing them. This class works by keeping                        //
  // the proxies in two buckets. When a proxy is used, it is put in the new bucket. Periodically,                      //
  // the old bucket is emptied and the contents of new bucket are moved to the old bucket.                             //
  //                                                                                                                   //
  // Each bucket is a two-level map, keyed by hashes of the tokens and their `ApiSession.Params`                       //
  // structs.                                                                                                          //
                                                                                                                       //
  function ApiSessionProxies(intervalMillis) {                                                                         // 647
    var _this2 = this;                                                                                                 //
                                                                                                                       //
    (0, _classCallCheck3["default"])(this, ApiSessionProxies);                                                         //
                                                                                                                       //
    check(intervalMillis, Number);                                                                                     // 648
    this.newBucket = {};                                                                                               // 649
    this.oldBucket = {};                                                                                               // 650
    this.interval = Meteor.setInterval(function () {                                                                   // 651
      for (var oldHashedToken in meteorBabelHelpers.sanitizeForInObject(_this2.oldBucket)) {                           // 652
        for (var oldHashedParams in meteorBabelHelpers.sanitizeForInObject(_this2.oldBucket[oldHashedToken])) {        // 653
          var newProxy = _this2.newBucket[oldHashedToken] && _this2.newBucket[oldHashedToken][oldHashedParams];        // 654
          var oldProxy = _this2.oldBucket[oldHashedToken][oldHashedParams];                                            // 656
          if (oldProxy && !newProxy) {                                                                                 // 657
            if (Object.keys(oldProxy.websockets).length > 0) {                                                         // 658
              // A client has an open websocket. Keep the proxy around.                                                //
              _this2.put(oldHashedToken, oldHashedParams, oldProxy);                                                   // 660
            } else {                                                                                                   //
              // We can close this proxy and forget about it.                                                          //
              oldProxy.close();                                                                                        // 663
            }                                                                                                          //
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      _this2.oldBucket = _this2.newBucket;                                                                             // 669
      _this2.newBucket = {};                                                                                           // 670
    }, intervalMillis);                                                                                                //
  }                                                                                                                    //
                                                                                                                       //
  ApiSessionProxies.prototype.get = function () {                                                                      // 637
    function get(hashedToken, hashedParams) {                                                                          //
      if (this.newBucket[hashedToken] && this.newBucket[hashedToken][hashedParams]) {                                  // 675
        return this.newBucket[hashedToken][hashedParams];                                                              // 676
      } else if (this.oldBucket[hashedToken] && this.oldBucket[hashedToken][hashedParams]) {                           //
        var proxy = this.oldBucket[hashedToken][hashedParams];                                                         // 678
        delete this.oldBucket[hashedToken][hashedParams];                                                              // 679
        this.put(hashedToken, hashedParams, proxy);                                                                    // 680
        return proxy;                                                                                                  // 681
      } else {                                                                                                         //
        return null;                                                                                                   // 683
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return get;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ApiSessionProxies.prototype.put = function () {                                                                      // 637
    function put(hashedToken, hashedParams, proxy) {                                                                   //
      if (!this.newBucket[hashedToken]) {                                                                              // 688
        this.newBucket[hashedToken] = {};                                                                              // 689
      }                                                                                                                //
                                                                                                                       //
      this.newBucket[hashedToken][hashedParams] = proxy;                                                               // 692
    }                                                                                                                  //
                                                                                                                       //
    return put;                                                                                                        //
  }();                                                                                                                 //
                                                                                                                       //
  ApiSessionProxies.prototype.removeProxiesOfToken = function () {                                                     // 637
    function removeProxiesOfToken(hashedToken) {                                                                       //
      if (hashedToken in this.oldBucket) {                                                                             // 696
        for (var hashedParams in meteorBabelHelpers.sanitizeForInObject(this.oldBucket[hashedToken])) {                // 697
          this.oldBucket[hashedToken][hashedParams].close();                                                           // 698
        }                                                                                                              //
                                                                                                                       //
        delete this.oldBucket[hashedToken];                                                                            // 701
      }                                                                                                                //
                                                                                                                       //
      if (hashedToken in this.newBucket) {                                                                             // 704
        for (var _hashedParams in meteorBabelHelpers.sanitizeForInObject(this.newBucket[hashedToken])) {               // 705
          this.newBucket[hashedToken][_hashedParams].close();                                                          // 706
        }                                                                                                              //
                                                                                                                       //
        delete this.newBucket[hashedToken];                                                                            // 709
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return removeProxiesOfToken;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  return ApiSessionProxies;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
var apiSessionProxies = new ApiSessionProxies(3 * 60 * 1000);                                                          // 714
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 716
  var clearSessionsAndProxies = function clearSessionsAndProxies(token) {                                              // 717
    // Clears all sessions and API proxies associated with `token` or any token that is downstream                     //
    // in the sharing graph.                                                                                           //
    // TODO(soon): Only clear sessions and proxies for which the permissions have changed.                             //
    var downstream = SandstormPermissions.downstreamTokens(globalDb, { token: token });                                // 721
    downstream.push(token);                                                                                            // 722
    var identityIds = [];                                                                                              // 723
    var tokenIds = [];                                                                                                 // 724
                                                                                                                       //
    downstream.forEach(function (token) {                                                                              // 726
      apiSessionProxies.removeProxiesOfToken(token._id);                                                               // 727
                                                                                                                       //
      tokenIds.push(token._id);                                                                                        // 729
      if (token.owner && token.owner.user) {                                                                           // 730
        identityIds.push(token.owner.user.identityId);                                                                 // 731
      }                                                                                                                //
    });                                                                                                                //
                                                                                                                       //
    Sessions.find({                                                                                                    // 735
      grainId: token.grainId,                                                                                          // 736
      $or: [{ identityId: { $in: identityIds } }, { hashedToken: { $in: tokenIds } }]                                  // 737
    }, {                                                                                                               //
      fields: { hostId: 1 }                                                                                            // 741
    }).forEach(function (session) {                                                                                    //
      var proxy = proxiesByHostId[session.hostId];                                                                     // 743
      if (proxy) {                                                                                                     // 744
        proxy.close();                                                                                                 // 745
      }                                                                                                                //
                                                                                                                       //
      delete proxiesByHostId[session.hostId];                                                                          // 748
    });                                                                                                                //
                                                                                                                       //
    Sessions.remove({                                                                                                  // 751
      grainId: token.grainId,                                                                                          // 752
      $or: [{ identityId: { $in: identityIds } }, { hashedToken: { $in: tokenIds } }]                                  // 753
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  Grains.find().observe({                                                                                              // 760
    changed: function () {                                                                                             // 761
      function changed(newGrain, oldGrain) {                                                                           //
        if (oldGrain["private"] != newGrain["private"]) {                                                              // 762
          Sessions.remove({ grainId: oldGrain._id, identityId: { $ne: oldGrain.identityId } });                        // 763
          ApiTokens.find({ grainId: oldGrain._id }).forEach(function (apiToken) {                                      // 764
            apiSessionProxies.removeProxiesOfToken(apiToken._id);                                                      // 765
          });                                                                                                          //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  ApiTokens.find({ grainId: { $exists: true }, objectId: { $exists: false } }).observe({                               // 771
    added: function () {                                                                                               // 772
      function added(newApiToken) {                                                                                    //
        // TODO(soon): Unfortunately, added() gets called for all existing role assignments when the                   //
        //   front-end restarts, meaning clearing sessions here will cause people's views to refresh                   //
        //   on server upgrade, which is not a nice user experience. It's also sad to force-refresh                    //
        //   people when they gained new permissions since they might be in the middle of something,                   //
        //   and it's not strictly necessary for security. OTOH, it's sad to be non-reactive. Maybe                    //
        //   we should notify people that they have new permissions and let them click a thing to                      //
        //   refresh?                                                                                                  //
        //clearSessions(roleAssignment.grainId, roleAssignment.recipient);                                             //
        //clearApiProxies(roleAssignment.grainId);                                                                     //
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
    changed: function () {                                                                                             // 784
      function changed(newApiToken, oldApiToken) {                                                                     //
        if (!_.isEqual(newApiToken.roleAssignment, oldApiToken.roleAssignment) || !_.isEqual(newApiToken.revoked, oldApiToken.revoked)) {
          clearSessionsAndProxies(newApiToken);                                                                        // 787
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }(),                                                                                                               //
    removed: function () {                                                                                             // 791
      function removed(oldApiToken) {                                                                                  //
        clearSessionsAndProxies(oldApiToken);                                                                          // 792
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
function getApiSessionParams(request) {                                                                                // 797
  var params = {};                                                                                                     // 798
  if ("x-sandstorm-passthrough" in request.headers) {                                                                  // 799
    var optIns = request.headers["x-sandstorm-passthrough"].split(",").map(function (s) {                              // 800
      return s.trim();                                                                                                 // 802
    });                                                                                                                //
    // The only currently supported passthrough value is 'address', but others could be useful in                      //
    // the future.                                                                                                     //
                                                                                                                       //
    if (optIns.indexOf("address") !== -1) {                                                                            // 799
      // Sadly, we can't use request.socket.remoteFamily because it's not available in the                             //
      // (rather-old) version of node that comes in the Meteor bundle we're using. Hence this                          //
      // hackery.                                                                                                      //
      var addressToPass = request.socket.remoteAddress;                                                                // 810
      if (isRfc1918OrLocal(addressToPass) && "x-real-ip" in request.headers) {                                         // 811
        // Allow overriding the socket's remote address with X-Real-IP header if the request comes                     //
        // from either localhost or an RFC1918 address. These are not useful for geolocation anyway.                   //
        addressToPass = request.headers["x-real-ip"];                                                                  // 814
      }                                                                                                                //
                                                                                                                       //
      if (Net.isIPv4(addressToPass)) {                                                                                 // 817
        // Map IPv4 addresses in IPv6.                                                                                 //
        // This conveniently comes out to a 48-bit number, which is precisely representable in a                       //
        // double (which has 53 mantissa bits). Thus we can avoid using Bignum/strings, which we                       //
        // might otherwise need to precisely represent 64-bit fields.                                                  //
        var v4Int = 0xFFFF00000000 + addressToPass.split(".").map(function (x) {                                       // 822
          return parseInt(x, 10);                                                                                      // 823
        }).reduce(function (a, b) {                                                                                    //
          return 256 * a + b;                                                                                          // 824
        });                                                                                                            //
        params.remoteAddress = {                                                                                       // 825
          lower64: v4Int,                                                                                              // 826
          upper64: 0                                                                                                   // 827
        };                                                                                                             //
      } else if (Net.isIPv6(addressToPass)) {                                                                          //
        // TODO(test): Unit test this                                                                                  //
        // Parse a valid v6 address.                                                                                   //
        // Split into groups, then insert an appropriate number of 0's if :: was used.                                 //
        var groups = addressToPass.split(":");                                                                         // 833
                                                                                                                       //
        // Strip extra empty group in the case of a leading or trailing '::'.                                          //
        if (groups[0] === "") {                                                                                        // 829
          groups.shift();                                                                                              // 837
        }                                                                                                              //
                                                                                                                       //
        if (groups[groups.length - 1] === "") {                                                                        // 840
          groups.pop();                                                                                                // 841
        }                                                                                                              //
                                                                                                                       //
        var lastGroup = groups[groups.length - 1];                                                                     // 844
        // Handle IPv4-mapped IPv6 addresses.  These end in a dotted-quad IPv4 address, which we                       //
        // should expand into two groups of 4-character hex strings, like the rest of the address.                     //
        if (Net.isIPv4(lastGroup)) {                                                                                   // 829
          groups.pop();                                                                                                // 848
          var _quad = lastGroup.split(".").map(function (x) {                                                          // 849
            return parseInt(x, 10);                                                                                    // 849
          });                                                                                                          //
          groups.push((_quad[0] * 256 + _quad[1]).toString(16));                                                       // 850
          groups.push((_quad[2] * 256 + _quad[3]).toString(16));                                                       // 851
        }                                                                                                              //
                                                                                                                       //
        var groupsToAdd = 8 - groups.length;                                                                           // 854
        var emptyGroupIndex = groups.indexOf("");                                                                      // 855
        var cleanGroups = void 0;                                                                                      // 856
        if (emptyGroupIndex !== -1) {                                                                                  // 857
          var head = groups.slice(0, emptyGroupIndex);                                                                 // 858
          // groupsToAdd + 1 because we sliced out the empty element                                                   //
          var mid = Array(groupsToAdd + 1);                                                                            // 857
          for (var i = 0; i < groupsToAdd + 1; i++) {                                                                  // 861
            mid[i] = "0";                                                                                              // 862
          }                                                                                                            //
                                                                                                                       //
          var tail = groups.slice(emptyGroupIndex + 1, groups.length);                                                 // 865
          cleanGroups = [].concat(head, mid, tail);                                                                    // 866
        } else {                                                                                                       //
          cleanGroups = groups;                                                                                        // 868
        }                                                                                                              //
                                                                                                                       //
        var ints = cleanGroups.map(function (x) {                                                                      // 871
          return parseInt(x, 16);                                                                                      // 871
        });                                                                                                            //
        // We use strings because we'd lose data from loss of precision casting the 64-bit uints                       //
        // into 53-bit-mantissa doubles.                                                                               //
        params.remoteAddress = {                                                                                       // 829
          upper64: quadToIntString(ints.slice(0, 4)),                                                                  // 875
          lower64: quadToIntString(ints.slice(4, 8))                                                                   // 876
        };                                                                                                             //
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return Capnp.serialize(ApiSession.Params, params);                                                                   // 882
}                                                                                                                      //
                                                                                                                       //
// Used by server/drivers/external-ui/view.js                                                                          //
getProxyForApiToken = function getProxyForApiToken(token, request) {                                                   // 886
  check(token, String);                                                                                                // 887
  var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                        // 888
  var tabId = Crypto.createHash("sha256").update("tab:").update(hashedToken).digest("hex").slice(0, 32);               // 889
  var serializedParams = getApiSessionParams(request);                                                                 // 891
  var hashedParams = Crypto.createHash("sha256").update(serializedParams).digest("base64");                            // 892
  return Promise.resolve(undefined).then(function () {                                                                 // 893
    var proxy = apiSessionProxies.get(hashedToken, hashedParams);                                                      // 894
    if (proxy) {                                                                                                       // 895
      if (proxy.expires && proxy.expires.getTime() <= Date.now()) {                                                    // 896
        throw new Meteor.Error(403, "Authorization token expired");                                                    // 897
      }                                                                                                                //
                                                                                                                       //
      return proxy;                                                                                                    // 900
    } else {                                                                                                           //
      return inMeteor(function () {                                                                                    // 902
        var tokenInfo = ApiTokens.findOne(hashedToken);                                                                // 903
        validateWebkey(tokenInfo);                                                                                     // 904
                                                                                                                       //
        var grain = Grains.findOne(tokenInfo.grainId);                                                                 // 906
        if (!grain) {                                                                                                  // 907
          // Grain was deleted, I guess.                                                                               //
          throw new Meteor.Error(410, "Resource has been deleted");                                                    // 909
        }                                                                                                              //
                                                                                                                       //
        var proxy = void 0;                                                                                            // 912
        if (tokenInfo.userInfo) {                                                                                      // 913
          throw new Error("API tokens created with arbitrary userInfo no longer supported");                           // 914
        } else {                                                                                                       //
          var identityId = null;                                                                                       // 916
          if (tokenInfo.identityId && !tokenInfo.forSharing) {                                                         // 917
            identityId = tokenInfo.identityId;                                                                         // 918
          }                                                                                                            //
                                                                                                                       //
          proxy = new Proxy(tokenInfo.grainId, grain.userId, null, null, tabId, identityId, true);                     // 921
          proxy.apiToken = tokenInfo;                                                                                  // 922
          proxy.apiSessionParams = serializedParams;                                                                   // 923
        }                                                                                                              //
                                                                                                                       //
        if (!SandstormPermissions.mayOpenGrain(globalDb, { token: tokenInfo })) {                                      // 926
          // Note that only public grains may be opened without a user ID.                                             //
          throw new Meteor.Error(403, "Unauthorized.");                                                                // 928
        }                                                                                                              //
                                                                                                                       //
        if (tokenInfo.expires) {                                                                                       // 931
          proxy.expires = tokenInfo.expires;                                                                           // 932
        }                                                                                                              //
                                                                                                                       //
        apiSessionProxies.put(hashedToken, hashedParams, proxy);                                                       // 935
                                                                                                                       //
        return proxy;                                                                                                  // 937
      });                                                                                                              //
    }                                                                                                                  //
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
var apiUseBasicAuth = function apiUseBasicAuth(req, hostId) {                                                          // 943
  // If the request was to a token-specific host *and* the request has no Origin header (meaning                       //
  // it is not an XHR from a web site), then we permit the use of HTTP basic auth. The reason we                       //
  // prohibit XHRs is because we want to discourage people from using basic auth in a browser,                         //
  // because the browser will cache the credentials, which exposes the hostname to XSRF attack                         //
  // (which is mostly, but not completely, mitigated by the unguessable hostname). The reason we                       //
  // want to allow basic auth at all is because a lot of existing client apps support only basic                       //
  // auth. New clients and web-based clients should use `Authorization: bearer <token>` instead.                       //
  if (globalDb.isTokenSpecificHostId(hostId) && !req.headers.origin) {                                                 // 951
    return true;                                                                                                       // 952
  }                                                                                                                    //
                                                                                                                       //
  // Historically, all API tokens were served from the same host rather than have token-specific                       //
  // hosts. In this model, basic auth in browsers was far more dangerous since the hostname was                        //
  // not a secret -- in fact, even benign attempts to use two APIs on the same server from the same                    //
  // browser could interfere if using basic auth. Hence, basic auth was prohibited except when                         //
  // coming from certain whitelisted clients known not to be browsers, e.g. Mirall, the ownCloud                       //
  // client app.                                                                                                       //
  //                                                                                                                   //
  // Since many clients in the wild have already been configured to use the shared API host, we                        //
  // must continue to support them, so this logic remains.                                                             //
  var agent = req.headers["user-agent"];                                                                               // 943
  return agent.match(BASIC_AUTH_USER_AGENTS_REGEX);                                                                    // 965
};                                                                                                                     //
                                                                                                                       //
var apiTokenForRequest = function apiTokenForRequest(req, hostId) {                                                    // 968
  // Extract the API token from the request.                                                                           //
                                                                                                                       //
  var auth = req.headers.authorization;                                                                                // 971
  var token = void 0;                                                                                                  // 972
  if (auth && auth.slice(0, 7).toLowerCase() === "bearer ") {                                                          // 973
    token = auth.slice(7).trim();                                                                                      // 974
  } else if (auth && auth.slice(0, 6).toLowerCase() === "basic " && apiUseBasicAuth(req, hostId)) {                    //
    token = new Buffer(auth.slice(6).trim(), "base64").toString().split(":")[1];                                       // 977
  } else {                                                                                                             //
    token = undefined;                                                                                                 // 979
  }                                                                                                                    //
                                                                                                                       //
  if (token && hostId !== "api") {                                                                                     // 982
    // Verify that the token matches the specific host.                                                                //
    if (hostId !== globalDb.apiHostIdForToken(token)) {                                                                // 984
      token = undefined;                                                                                               // 985
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return token;                                                                                                        // 989
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// Routing to proxies.                                                                                                 //
//                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyUpgrade = function tryProxyUpgrade(hostId, req, socket, head) {                                                // 997
  // Attempt to handle a WebSocket upgrade by dispatching it to a grain. Returns a promise that                        //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  if (globalDb.isApiHostId(hostId)) {                                                                                  // 1003
    var token = apiTokenForRequest(req, hostId);                                                                       // 1004
    if (token) {                                                                                                       // 1005
      return getProxyForApiToken(token).then(function (proxy) {                                                        // 1006
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 1009
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 1011
        return true;                                                                                                   // 1012
      });                                                                                                              //
    } else {                                                                                                           //
      return Promise.resolve(false);                                                                                   // 1015
    }                                                                                                                  //
  } else {                                                                                                             //
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1018
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1019
      if (proxy) {                                                                                                     // 1020
        // Cross-origin requests are not allowed on UI session hosts.                                                  //
        var origin = req.headers.origin;                                                                               // 1022
        if (origin !== PROTOCOL + "//" + req.headers.host) {                                                           // 1023
          throw new Meteor.Error(403, "Detected illegal cross-origin WebSocket from: " + origin);                      // 1024
        }                                                                                                              //
                                                                                                                       //
        // Meteor sets the timeout to five seconds. Change that back to two                                            //
        // minutes, which is the default value.                                                                        //
        socket.setTimeout(120000);                                                                                     // 1020
                                                                                                                       //
        proxy.upgradeHandler(req, socket, head);                                                                       // 1031
        return true;                                                                                                   // 1032
      } else {                                                                                                         //
        return false;                                                                                                  // 1034
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
// pre-meteor.js calls this                                                                                            //
tryProxyRequest = function tryProxyRequest(hostId, req, res) {                                                         // 1041
  // Attempt to handle an HTTP request by dispatching it to a grain. Returns a promise that                            //
  // resolves true if an appropriate grain is found, false if there was no match (but the caller                       //
  // should consider other host types, like static web publishing), or throws an error if the                          //
  // request is definitely invalid.                                                                                    //
                                                                                                                       //
  var hostIdHash = globalDb.isApiHostId(hostId);                                                                       // 1047
  if (hostIdHash) {                                                                                                    // 1048
    var _ret = function () {                                                                                           //
      // This is a request for the API host.                                                                           //
                                                                                                                       //
      res.setHeader("Access-Control-Allow-Origin", "*");                                                               // 1051
                                                                                                                       //
      if (req.method === "OPTIONS") {                                                                                  // 1053
        // Reply to CORS preflight request.                                                                            //
                                                                                                                       //
        // All we want to do is permit APIs to be accessed from arbitrary origins. Since clients                       //
        // must send a valid Authorization header, and since cookies are not used for                                  //
        // authorization, this is perfectly safe. In a sane world, we would only need to send back                     //
        // 'Access-Control-Allow-Origin: *' and be done with it.                                                       //
        //                                                                                                             //
        // However, CORS demands that we explicitly whitelist individual methods and headers for                       //
        // use cross-origin, as if this is somehow useful for implementing any practical security                      //
        // policy (it isn't). To make matters worse, we are REQUIRED to enumerate each one                             //
        // individually. We cannot just write '*' for these lists. WTF, CORS?                                          //
        //                                                                                                             //
        // Luckily, the request tells us exactly what method and headers are being requested, so we                    //
        // only need to copy those over, rather than create an exhaustive list. But this is still                      //
        // overly complicated.                                                                                         //
                                                                                                                       //
        var accessControlHeaders = {                                                                                   // 1070
          "Access-Control-Allow-Methods": "GET, HEAD, POST, PUT, PATCH, DELETE",                                       // 1071
          "Access-Control-Max-Age": "3600"                                                                             // 1072
        };                                                                                                             //
                                                                                                                       //
        // Copy all requested headers to the allowed headers list.                                                     //
        var requestedHeaders = req.headers["access-control-request-headers"];                                          // 1053
        if (requestedHeaders) {                                                                                        // 1077
          accessControlHeaders["Access-Control-Allow-Headers"] = requestedHeaders;                                     // 1078
        }                                                                                                              //
                                                                                                                       //
        // Add the requested method to the allowed methods list, if it's not there already.                            //
        var requestedMethod = req.headers["access-control-request-method"];                                            // 1053
        if (requestedMethod && !_.contains(["GET", "HEAD", "POST", "PUT", "PATCH", "DELETE"], requestedMethod)) {      // 1083
          accessControlHeaders["Access-Control-Allow-Methods"] += ", " + requestedMethod;                              // 1085
        }                                                                                                              //
                                                                                                                       //
        for (header in meteorBabelHelpers.sanitizeForInObject(accessControlHeaders)) {                                 // 1088
          res.setHeader(header, accessControlHeaders[header]);                                                         // 1089
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      var errorHandler = function errorHandler(err) {                                                                  // 1093
        if (err instanceof Meteor.Error) {                                                                             // 1094
          console.log("error: " + err);                                                                                // 1095
          res.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                                      // 1096
        } else {                                                                                                       //
          res.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                               // 1098
        }                                                                                                              //
                                                                                                                       //
        res.end(err.stack);                                                                                            // 1101
      };                                                                                                               //
                                                                                                                       //
      var token = apiTokenForRequest(req, hostId);                                                                     // 1104
      if (token && req.headers["x-sandstorm-token-keepalive"]) {                                                       // 1105
        inMeteor(function () {                                                                                         // 1106
          var keepaliveDuration = parseInt(req.headers["x-sandstorm-token-keepalive"]);                                // 1107
          check(keepaliveDuration, Match.Integer);                                                                     // 1108
          var hashedToken = Crypto.createHash("sha256").update(token).digest("base64");                                // 1109
          validateWebkey(ApiTokens.findOne(hashedToken), new Date(Date.now() + keepaliveDuration));                    // 1110
        }).then(function () {                                                                                          //
          res.writeHead(200, {});                                                                                      // 1112
          res.end();                                                                                                   // 1113
        }, errorHandler);                                                                                              //
      } else if (token) {                                                                                              //
        getProxyForApiToken(token, req).then(function (proxy) {                                                        // 1116
          proxy.requestHandler(req, res);                                                                              // 1117
        }, errorHandler);                                                                                              //
      } else {                                                                                                         //
        // No token. Look up static API host info.                                                                     //
        inMeteor(function () {                                                                                         // 1121
          var apiHost = globalDb.collections.apiHosts.findOne(hostIdHash);                                             // 1122
                                                                                                                       //
          if (req.method === "OPTIONS") {                                                                              // 1124
            // OPTIONS request with no authorization token.                                                            //
                                                                                                                       //
            var dav = ((apiHost || {}).options || {}).dav || [];                                                       // 1127
            if (dav.length > 0) {                                                                                      // 1128
              res.setHeader("DAV", dav.join(", "));                                                                    // 1129
              res.setHeader("Access-Control-Expose-Headers", "DAV");                                                   // 1130
            }                                                                                                          //
                                                                                                                       //
            res.writeHead(200, {});                                                                                    // 1133
            res.end();                                                                                                 // 1134
          } else {                                                                                                     //
            var resources = (apiHost || {}).resources || {};                                                           // 1136
            var path = SandstormDb.escapeMongoKey(req.url.split("?")[0]);                                              // 1137
            if (path in resources) {                                                                                   // 1138
              // Serve a static resource.                                                                              //
              var resource = resources[path];                                                                          // 1140
              console.log(path, resources, resource);                                                                  // 1141
              if (resource.language) res.setHeader("Content-Language", resource.language);                             // 1142
              if (resource.encoding) res.setHeader("Content-Encoding", resource.encoding);                             // 1143
              res.writeHead(200, {                                                                                     // 1144
                "Content-Type": resource.type                                                                          // 1145
              });                                                                                                      //
              res.end(resource.body);                                                                                  // 1147
            } else {                                                                                                   //
              if (apiUseBasicAuth(req, hostId)) {                                                                      // 1149
                res.writeHead(401, {                                                                                   // 1150
                  "Content-Type": "text/plain",                                                                        // 1151
                  "WWW-Authenticate": "Basic realm='Sandstorm API'"                                                    // 1152
                });                                                                                                    //
              } else {                                                                                                 //
                // TODO(someday): Display some sort of nifty API browser.                                              //
                res.writeHead(403, { "Content-Type": "text/plain" });                                                  // 1156
              }                                                                                                        //
                                                                                                                       //
              res.end("Missing or invalid authorization header.\n\n" + "This address serves APIs, which allow external apps (such as a phone app) to\n" + "access data on your Sandstorm server. This address is not meant to be opened\n" + "in a regular browser.");
            }                                                                                                          //
          }                                                                                                            //
        }).then(function () {}, errorHandler);                                                                         //
      }                                                                                                                //
                                                                                                                       //
      return {                                                                                                         // 1168
        v: Promise.resolve(true)                                                                                       //
      };                                                                                                               //
    }();                                                                                                               //
                                                                                                                       //
    if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret)) === "object") return _ret.v;      //
  } else {                                                                                                             //
    var isAlreadyOpened = req.headers.cookie && req.headers.cookie.indexOf("sandstorm-sid=") !== -1;                   // 1170
    return getProxyForHostId(hostId, isAlreadyOpened).then(function (proxy) {                                          // 1171
      if (proxy) {                                                                                                     // 1172
        proxy.requestHandler(req, res);                                                                                // 1173
        return true;                                                                                                   // 1174
      } else {                                                                                                         //
        return false;                                                                                                  // 1176
      }                                                                                                                //
    });                                                                                                                //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// Proxy class                                                                                                         //
//                                                                                                                     //
// Connects to a grain and exports it on a wildcard host.                                                              //
//                                                                                                                     //
                                                                                                                       //
var Proxy = function () {                                                                                              //
  function Proxy(grainId, ownerId, sessionId, hostId, tabId, identityId, isApi, supervisor) {                          // 1189
    var _this3 = this;                                                                                                 //
                                                                                                                       //
    (0, _classCallCheck3["default"])(this, Proxy);                                                                     //
                                                                                                                       //
    this.grainId = grainId;                                                                                            // 1190
    this.ownerId = ownerId;                                                                                            // 1191
    this.identityId = identityId;                                                                                      // 1192
    this.supervisor = supervisor; // note: optional parameter; we can reconnect                                        // 1193
    this.sessionId = sessionId;                                                                                        // 1189
    this.tabId = tabId;                                                                                                // 1195
    this.isApi = isApi;                                                                                                // 1196
    this.hasLoaded = false;                                                                                            // 1197
    this.websockets = {};                                                                                              // 1198
    this.websocketCounter = 0; // Used for generating unique socket IDs.                                               // 1199
    if (sessionId) {                                                                                                   // 1189
      if (!hostId) throw new Error("sessionId must come with hostId");                                                 // 1201
      if (isApi) throw new Error("API proxy shouldn't have sessionId");                                                // 1202
      this.hostId = hostId;                                                                                            // 1203
    } else {                                                                                                           //
      if (!isApi) throw new Error("non-API proxy requires sessionId");                                                 // 1205
      if (hostId) throw new Error("API proxy sholudn't have hostId");                                                  // 1206
    }                                                                                                                  //
                                                                                                                       //
    if (this.identityId) {                                                                                             // 1209
      var identity = globalDb.getIdentity(this.identityId);                                                            // 1210
      if (!identity) {                                                                                                 // 1211
        throw new Error("identity not found: " + this.identityId);                                                     // 1212
      }                                                                                                                //
                                                                                                                       //
      this.userInfo = {                                                                                                // 1215
        displayName: { defaultText: identity.profile.name },                                                           // 1216
        preferredHandle: identity.profile.handle,                                                                      // 1217
        identityId: new Buffer(identity._id, "hex")                                                                    // 1218
      };                                                                                                               //
      if (identity.profile.pictureUrl) this.userInfo.pictureUrl = identity.profile.pictureUrl;                         // 1220
      if (identity.profile.pronoun) this.userInfo.pronouns = identity.profile.pronoun;                                 // 1221
    } else {                                                                                                           //
      this.userInfo = {                                                                                                // 1223
        displayName: { defaultText: "Anonymous User" },                                                                // 1224
        preferredHandle: "anonymous"                                                                                   // 1225
      };                                                                                                               //
    }                                                                                                                  //
                                                                                                                       //
    var _this = this;                                                                                                  // 1229
                                                                                                                       //
    this.requestHandler = function (request, response) {                                                               // 1231
      if (_this3.sessionId) {                                                                                          // 1232
        // Implement /_sandstorm-init for setting the session cookie.                                                  //
        var url = Url.parse(request.url, true);                                                                        // 1234
        if (url.pathname === "/_sandstorm-init" && url.query.sessionid === _this.sessionId) {                          // 1235
          _this.doSessionInit(request, response, url.query.path);                                                      // 1236
          return;                                                                                                      // 1237
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      Promise.resolve(undefined).then(function () {                                                                    // 1241
        var contentLength = request.headers["content-length"];                                                         // 1242
        if ((request.method === "POST" || request.method === "PUT") && (contentLength === undefined || contentLength > 1024 * 1024)) {
          // The input is either very long, or we don't know how long it is, so use streaming mode.                    //
          return _this.handleRequestStreaming(request, response, contentLength, 0);                                    // 1246
        } else {                                                                                                       //
          return readAll(request).then(function (data) {                                                               // 1248
            return _this.handleRequest(request, data, response, 0);                                                    // 1249
          });                                                                                                          //
        }                                                                                                              //
      })["catch"](function (err) {                                                                                     //
        _this.setHasLoaded();                                                                                          // 1253
                                                                                                                       //
        var body = err.stack;                                                                                          // 1255
        if (err.cppFile) {                                                                                             // 1256
          body += "\nC++ location:" + err.cppFile + ":" + (err.line || "??");                                          // 1257
        }                                                                                                              //
                                                                                                                       //
        if (err.kjType) {                                                                                              // 1260
          body += "\ntype: " + err.kjType;                                                                             // 1261
        }                                                                                                              //
                                                                                                                       //
        if (response.headersSent) {                                                                                    // 1264
          // Unfortunately, it's too late to tell the client what happened.                                            //
          console.error("HTTP request failed after response already sent:", body);                                     // 1266
          response.end();                                                                                              // 1267
        } else {                                                                                                       //
          if (err instanceof Meteor.Error) {                                                                           // 1269
            response.writeHead(err.error, err.reason, { "Content-Type": "text/plain" });                               // 1270
          } else {                                                                                                     //
            response.writeHead(500, "Internal Server Error", { "Content-Type": "text/plain" });                        // 1272
          }                                                                                                            //
                                                                                                                       //
          response.end(body);                                                                                          // 1275
        }                                                                                                              //
      });                                                                                                              //
    };                                                                                                                 //
                                                                                                                       //
    this.upgradeHandler = function (request, socket, head) {                                                           // 1280
      _this.handleWebSocket(request, socket, head, 0)["catch"](function (err) {                                        // 1281
        console.error("WebSocket setup failed:", err.stack);                                                           // 1282
        // TODO(cleanup):  Manually send back a 500 response?                                                          //
        socket.destroy();                                                                                              // 1281
      });                                                                                                              //
    };                                                                                                                 //
  }                                                                                                                    //
                                                                                                                       //
  Proxy.prototype.close = function () {                                                                                // 1188
    function close() {                                                                                                 //
      for (var socketIdx in meteorBabelHelpers.sanitizeForInObject(this.websockets)) {                                 // 1290
        this.websockets[socketIdx].destroy();                                                                          // 1291
      };                                                                                                               //
                                                                                                                       //
      this.websockets = {};                                                                                            // 1294
                                                                                                                       //
      if (this.session) {                                                                                              // 1296
        this.session.close();                                                                                          // 1297
        delete this.session;                                                                                           // 1298
      }                                                                                                                //
                                                                                                                       //
      if (this.uiView) {                                                                                               // 1301
        this.uiView.close();                                                                                           // 1302
        delete this.uiView;                                                                                            // 1303
      }                                                                                                                //
                                                                                                                       //
      if (this.supervisor) {                                                                                           // 1306
        this.supervisor.close();                                                                                       // 1307
        delete this.supervisor;                                                                                        // 1308
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.getConnection = function () {                                                                        // 1188
    function getConnection() {                                                                                         //
      if (!this.supervisor) {                                                                                          // 1313
        this.supervisor = globalBackend.cap().getGrain(this.ownerId, this.grainId).supervisor;                         // 1314
        this.uiView = null;                                                                                            // 1315
      }                                                                                                                //
                                                                                                                       //
      if (!this.uiView) {                                                                                              // 1318
        this.uiView = this.supervisor.getMainView().view;                                                              // 1319
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return getConnection;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewWebSession = function () {                                                                   // 1188
    function _callNewWebSession(request, userInfo) {                                                                   //
      var params = Capnp.serialize(WebSession.Params, {                                                                // 1324
        basePath: PROTOCOL + "//" + request.headers.host,                                                              // 1325
        userAgent: "user-agent" in request.headers ? request.headers["user-agent"] : "UnknownAgent/0.0",               // 1326
        acceptableLanguages: "accept-language" in request.headers ? request.headers["accept-language"].split(",").map(function (s) {
          return s.trim();                                                                                             // 1330
        }) : ["en-US", "en"]                                                                                           //
      });                                                                                                              //
      return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), WebSession.typeId, params, new Buffer(this.tabId, "hex")).session;
    }                                                                                                                  //
                                                                                                                       //
    return _callNewWebSession;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewApiSession = function () {                                                                   // 1188
    function _callNewApiSession(request, userInfo) {                                                                   //
      var _this4 = this;                                                                                               //
                                                                                                                       //
      var serializedParams = this.apiSessionParams;                                                                    // 1339
      if (!serializedParams) {                                                                                         // 1340
        throw new Meteor.Error(500, "Should have already computed apiSessionParams.");                                 // 1341
      }                                                                                                                //
                                                                                                                       //
      // TODO(someday): We are currently falling back to WebSession if we get any kind of error upon                   //
      // calling newSession with an ApiSession._id.                                                                    //
      // Eventually we'll remove this logic once we're sure apps have updated.                                         //
      return this.uiView.newSession(userInfo, makeHackSessionContext(this.grainId, this.sessionId, this.identityId, this.tabId), ApiSession.typeId, serializedParams, new Buffer(this.tabId, "hex")).then(function (session) {
        return session.session;                                                                                        // 1351
      }, function (err) {                                                                                              //
        return _this4._callNewWebSession(request, userInfo);                                                           // 1353
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return _callNewApiSession;                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype._callNewSession = function () {                                                                      // 1188
    function _callNewSession(request, viewInfo) {                                                                      //
      var userInfo = _.clone(this.userInfo);                                                                           // 1358
      var _this = this;                                                                                                // 1359
      var promise = inMeteor(function () {                                                                             // 1360
        var vertex = void 0;                                                                                           // 1361
        if (_this.apiToken) {                                                                                          // 1362
          vertex = { token: _this.apiToken };                                                                          // 1363
        } else {                                                                                                       //
          // (_this.identityId might be null; this is fine)                                                            //
          vertex = { grain: { _id: _this.grainId, identityId: _this.identityId } };                                    // 1366
        }                                                                                                              //
                                                                                                                       //
        var permissions = SandstormPermissions.grainPermissions(globalDb, vertex, viewInfo);                           // 1369
        if (!permissions) {                                                                                            // 1370
          throw new Meteor.Error(403, "Unauthorized", "User is not authorized to open this grain.");                   // 1371
        }                                                                                                              //
                                                                                                                       //
        Sessions.update({                                                                                              // 1374
          _id: _this.sessionId                                                                                         // 1375
        }, {                                                                                                           //
          $set: {                                                                                                      // 1377
            viewInfo: viewInfo,                                                                                        // 1378
            permissions: permissions                                                                                   // 1379
          }                                                                                                            //
        });                                                                                                            //
                                                                                                                       //
        return permissions;                                                                                            // 1383
      });                                                                                                              //
                                                                                                                       //
      return promise.then(function (permissions) {                                                                     // 1386
        userInfo.permissions = permissions;                                                                            // 1387
                                                                                                                       //
        var numBytes = Math.ceil(permissions.length / 8);                                                              // 1389
        var buf = new Buffer(numBytes);                                                                                // 1390
        for (var ii = 0; ii < numBytes; ++ii) {                                                                        // 1391
          buf[ii] = 0;                                                                                                 // 1392
        }                                                                                                              //
                                                                                                                       //
        for (var _ii = 0; _ii < permissions.length; ++_ii) {                                                           // 1395
          var byteNum = Math.floor(_ii / 8);                                                                           // 1396
          var bitNum = _ii % 8;                                                                                        // 1397
          if (permissions[_ii]) {                                                                                      // 1398
            buf[byteNum] = buf[byteNum] | 1 << bitNum;                                                                 // 1399
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        userInfo.deprecatedPermissionsBlob = buf;                                                                      // 1403
                                                                                                                       //
        if (_this.isApi) {                                                                                             // 1405
          return _this._callNewApiSession(request, userInfo);                                                          // 1406
        } else {                                                                                                       //
          return _this._callNewWebSession(request, userInfo);                                                          // 1408
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return _callNewSession;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.getSession = function () {                                                                           // 1188
    function getSession(request) {                                                                                     //
      var _this5 = this;                                                                                               //
                                                                                                                       //
      if (!this.session) {                                                                                             // 1414
        (function () {                                                                                                 //
          _this5.getConnection(); // make sure we're connected                                                         // 1415
          var _this = _this5;                                                                                          // 1416
          var promise = _this5.uiView.getViewInfo().then(function (viewInfo) {                                         // 1417
            return inMeteor(function () {                                                                              // 1418
              Grains.update(_this.grainId, { $set: { cachedViewInfo: viewInfo } });                                    // 1419
            }).then(function () {                                                                                      //
              return _this._callNewSession(request, viewInfo);                                                         // 1421
            });                                                                                                        //
          }, function (error) {                                                                                        //
            if (error.kjType === "failed" || error.kjType === "unimplemented") {                                       // 1424
              // Method not implemented.                                                                               //
              // TODO(apibump): Don't treat 'failed' as 'unimplemented'. Unfortunately, old apps built                 //
              //   with old versions of Cap'n Proto don't throw 'unimplemented' exceptions, so we have                 //
              //   to accept 'failed' here at least until the next API bump.                                           //
              return _this._callNewSession(request, {});                                                               // 1429
            } else {                                                                                                   //
              return Promise.reject(error);                                                                            // 1431
            }                                                                                                          //
          });                                                                                                          //
          _this5.session = new Capnp.Capability(promise, WebSession);                                                  // 1434
        })();                                                                                                          //
      }                                                                                                                //
                                                                                                                       //
      return this.session;                                                                                             // 1437
    }                                                                                                                  //
                                                                                                                       //
    return getSession;                                                                                                 //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.keepAlive = function () {                                                                            // 1188
    function keepAlive() {                                                                                             //
      this.getConnection();                                                                                            // 1441
      return this.supervisor.keepAlive();                                                                              // 1442
    }                                                                                                                  //
                                                                                                                       //
    return keepAlive;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.resetConnection = function () {                                                                      // 1188
    function resetConnection() {                                                                                       //
      if (this.session) {                                                                                              // 1446
        this.session.close();                                                                                          // 1447
        delete this.session;                                                                                           // 1448
      }                                                                                                                //
                                                                                                                       //
      if (this.uiView) {                                                                                               // 1451
        this.uiView.close();                                                                                           // 1452
        delete this.uiView;                                                                                            // 1453
      }                                                                                                                //
                                                                                                                       //
      if (this.supervisor) {                                                                                           // 1456
        this.supervisor.close();                                                                                       // 1457
        delete this.supervisor;                                                                                        // 1458
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return resetConnection;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.maybeRetryAfterError = function () {                                                                 // 1188
    function maybeRetryAfterError(error, retryCount) {                                                                 //
      // If the error may be caused by the grain dying or a network failure, try to restart it,                        //
      // returning a promise that resolves once restarted. Otherwise, just rethrow the error.                          //
      // `retryCount` should be incremented for every successful retry as part of the same request;                    //
      // we only want to retry once.                                                                                   //
      var _this = this;                                                                                                // 1467
      if (SandstormBackend.shouldRestartGrain(error, retryCount)) {                                                    // 1468
        this.resetConnection();                                                                                        // 1469
        return inMeteor(function () {                                                                                  // 1470
          _this.supervisor = globalBackend.continueGrain(_this.grainId).supervisor;                                    // 1471
        });                                                                                                            //
      } else {                                                                                                         //
        throw error;                                                                                                   // 1474
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return maybeRetryAfterError;                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.doSessionInit = function () {                                                                        // 1188
    function doSessionInit(request, response, requestPath) {                                                           //
      // jscs:disable disallowQuotedKeysInObjects                                                                      //
      var path = requestPath || "/";                                                                                   // 1480
                                                                                                                       //
      // Check that the path is relative (ie. starts with a /).                                                        //
      // Also ensure that it doesn't start with 2 /, because that is interpreted as non-relative                       //
      if (path.lastIndexOf("/", 0) !== 0 || path.lastIndexOf("//", 0) === 0) {                                         // 1478
        response.writeHead(400, "Invalid path supplied", { "Content-Type": "text/plain" });                            // 1485
        response.end("Invalid path supplied.");                                                                        // 1486
        return;                                                                                                        // 1487
      }                                                                                                                //
                                                                                                                       //
      // Set the session ID.                                                                                           //
      response.setHeader("Set-Cookie", ["sandstorm-sid=", this.sessionId, "; Max-Age=31536000; HttpOnly"].join(""));   // 1478
                                                                                                                       //
      response.setHeader("Cache-Control", "no-cache, private");                                                        // 1493
                                                                                                                       //
      // Redirect to the app's root URL.                                                                               //
      // Note:  All browsers support relative locations and the next update to HTTP/1.1 will officially                //
      //   make them valid.  http://tools.ietf.org/html/draft-ietf-httpbis-p2-semantics-26#page-67                     //
      response.writeHead(303, "See Other", { "Location": encodeURI(path) });                                           // 1478
      response.end();                                                                                                  // 1499
    }                                                                                                                  //
                                                                                                                       //
    return doSessionInit;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.makeContext = function () {                                                                          // 1188
    function makeContext(request, response) {                                                                          //
      // Parses the cookies from the request, checks that the session ID is present and valid, then                    //
      // returns the request context which contains the other cookies.  Throws an exception if the                     //
      // session ID is missing or invalid.                                                                             //
                                                                                                                       //
      var context = {};                                                                                                // 1507
                                                                                                                       //
      if (this.hostId) {                                                                                               // 1509
        var parseResult = parseCookies(request);                                                                       // 1510
        if (!parseResult.sessionId || parseResult.sessionId !== this.sessionId) {                                      // 1511
          throw new Meteor.Error(403, "Unauthorized");                                                                 // 1512
        }                                                                                                              //
                                                                                                                       //
        if (parseResult.cookies.length > 0) {                                                                          // 1515
          context.cookies = parseResult.cookies;                                                                       // 1516
        }                                                                                                              //
      } else {                                                                                                         //
        // jscs:disable disallowEmptyBlocks                                                                            //
        // This is an API request. Cookies are not supported.                                                          //
      }                                                                                                                //
                                                                                                                       //
      context.accept = parseAcceptHeader(request);                                                                     // 1523
                                                                                                                       //
      context.eTagPrecondition = parsePreconditionHeader(request);                                                     // 1525
                                                                                                                       //
      context.additionalHeaders = [];                                                                                  // 1527
      WebSession.Context.headerWhitelist.forEach(function (headerName) {                                               // 1528
        if (request.headers[headerName]) {                                                                             // 1529
          context.additionalHeaders.push({                                                                             // 1530
            name: headerName,                                                                                          // 1531
            value: request.headers[headerName]                                                                         // 1532
          });                                                                                                          //
        };                                                                                                             //
      });                                                                                                              //
                                                                                                                       //
      var promise = new Promise(function (resolve, reject) {                                                           // 1537
        response.resolveResponseStream = resolve;                                                                      // 1538
        response.rejectResponseStream = reject;                                                                        // 1539
      });                                                                                                              //
                                                                                                                       //
      context.responseStream = new Capnp.Capability(promise, ByteStream);                                              // 1542
                                                                                                                       //
      return context;                                                                                                  // 1544
    }                                                                                                                  //
                                                                                                                       //
    return makeContext;                                                                                                //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.translateResponse = function () {                                                                    // 1188
    function translateResponse(rpcResponse, response, request) {                                                       //
      if (this.hostId) {                                                                                               // 1548
        if (rpcResponse.setCookies && rpcResponse.setCookies.length > 0) {                                             // 1549
          response.setHeader("Set-Cookie", rpcResponse.setCookies.map(makeSetCookieHeader));                           // 1550
        }                                                                                                              //
                                                                                                                       //
        // TODO(security): Add a Content-Security-Policy header which:                                                 //
        // (1) Prevents the app from initiating HTTP requests to third parties.                                        //
        // (2) Prevents the app from navigating the parent frame.                                                      //
        // (3) Prevents the app from opening popups.                                                                   //
        // (4) Prohibits anyone other than the Sandstorm shell from framing the app (as a backup                       //
        //   defense vs. clickjacking, though unguessable hostnames already mostly prevent this).                      //
      } else {                                                                                                         // 1548
          // jscs:disable validateQuoteMarks                                                                           //
          // This is an API request. Cookies are not supported.                                                        //
                                                                                                                       //
          // We need to make sure caches know that different bearer tokens get totally different results.              //
          response.setHeader('Vary', 'Authorization');                                                                 // 1564
                                                                                                                       //
          // APIs can be called from any origin. Because we ignore cookies, there is no security problem.              //
          response.setHeader('Access-Control-Allow-Origin', '*');                                                      // 1559
                                                                                                                       //
          // Add a Content-Security-Policy as a backup in case someone finds a way to load this resource               //
          // in a browser context. This policy should thoroughly neuter it.                                            //
          response.setHeader('Content-Security-Policy', "default-src 'none'; sandbox");                                // 1559
        }                                                                                                              //
                                                                                                                       //
      // On first response, update the session to have hasLoaded=true                                                  //
      this.setHasLoaded();                                                                                             // 1547
                                                                                                                       //
      // TODO(security): Set X-Content-Type-Options: nosniff?                                                          //
                                                                                                                       //
      if ('content' in rpcResponse) {                                                                                  // 1547
        var content = rpcResponse.content;                                                                             // 1580
        var code = successCodes[content.statusCode];                                                                   // 1581
        if (!code) {                                                                                                   // 1582
          throw new Error('Unknown status code: ', content.statusCode);                                                // 1583
        }                                                                                                              //
                                                                                                                       //
        if (content.mimeType) {                                                                                        // 1586
          response.setHeader('Content-Type', content.mimeType);                                                        // 1587
        }                                                                                                              //
                                                                                                                       //
        if (content.encoding) {                                                                                        // 1590
          response.setHeader('Content-Encoding', content.encoding);                                                    // 1591
        }                                                                                                              //
                                                                                                                       //
        if (content.language) {                                                                                        // 1594
          response.setHeader('Content-Language', content.language);                                                    // 1595
        }                                                                                                              //
                                                                                                                       //
        if (content.eTag) {                                                                                            // 1598
          response.setHeader('ETag', composeETag(content.eTag));                                                       // 1599
        }                                                                                                              //
                                                                                                                       //
        if ('disposition' in content && 'download' in content.disposition) {                                           // 1602
          response.setHeader('Content-Disposition', 'attachment; filename="' + content.disposition.download.replace(/([\\"\n])/g, "\\$1") + '"');
        }                                                                                                              //
                                                                                                                       //
        if ('stream' in content.body) {                                                                                // 1607
          if (request.method === 'HEAD') {                                                                             // 1608
            content.body.stream.close();                                                                               // 1609
            response.rejectResponseStream(new Error('HEAD request; content doesn\'t matter.'));                        // 1610
          } else {                                                                                                     //
            var _ret3 = function () {                                                                                  //
              var streamHandle = content.body.stream;                                                                  // 1612
              response.writeHead(code.id, code.title);                                                                 // 1613
              var promise = new Promise(function (resolve, reject) {                                                   // 1614
                response.resolveResponseStream(new Capnp.Capability(new ResponseStream(response, streamHandle, resolve, reject), ByteStream));
              });                                                                                                      //
              promise.streamHandle = streamHandle;                                                                     // 1618
              return {                                                                                                 // 1619
                v: promise                                                                                             //
              };                                                                                                       //
            }();                                                                                                       //
                                                                                                                       //
            if ((typeof _ret3 === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret3)) === "object") return _ret3.v;
          }                                                                                                            //
        } else {                                                                                                       //
          response.rejectResponseStream(new Error('Response content body was not a stream.'));                         // 1622
                                                                                                                       //
          if ('bytes' in content.body) {                                                                               // 1625
            response.setHeader('Content-Length', content.body.bytes.length);                                           // 1626
          } else {                                                                                                     //
            throw new Error('Unknown content body type.');                                                             // 1628
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        response.writeHead(code.id, code.title);                                                                       // 1632
                                                                                                                       //
        if ('bytes' in content.body && request.method !== 'HEAD') {                                                    // 1634
          response.write(content.body.bytes);                                                                          // 1635
        }                                                                                                              //
                                                                                                                       //
        response.end();                                                                                                // 1638
      } else if ('noContent' in rpcResponse) {                                                                         //
        var noContent = rpcResponse.noContent;                                                                         // 1640
        var noContentCode = noContentSuccessCodes[noContent.shouldResetForm * 1];                                      // 1641
        response.writeHead(noContentCode.id, noContentCode.title);                                                     // 1642
        response.end();                                                                                                // 1643
      } else if ('preconditionFailed' in rpcResponse) {                                                                //
        var preconditionFailed = rpcResponse.preconditionFailed;                                                       // 1645
        if (request.method === 'GET' && 'if-none-match' in request.headers) {                                          // 1646
          if (preconditionFailed.matchingETag) {                                                                       // 1647
            response.setHeader('ETag', composeETag(preconditionFailed.matchingETag));                                  // 1648
          }                                                                                                            //
                                                                                                                       //
          response.writeHead(304, 'Not Modified');                                                                     // 1651
        } else {                                                                                                       //
          response.writeHead(412, 'Precondition Failed');                                                              // 1653
        }                                                                                                              //
                                                                                                                       //
        response.end();                                                                                                // 1656
      } else if ('redirect' in rpcResponse) {                                                                          //
        var redirect = rpcResponse.redirect;                                                                           // 1658
        var redirectCode = redirectCodes[redirect.switchToGet * 2 + redirect.isPermanent];                             // 1659
        response.writeHead(redirectCode.id, redirectCode.title, {                                                      // 1660
          'Location': redirect.location                                                                                // 1661
        });                                                                                                            //
        response.end();                                                                                                // 1663
      } else if ('clientError' in rpcResponse) {                                                                       //
        var clientError = rpcResponse.clientError;                                                                     // 1665
        var errorCode = errorCodes[clientError.statusCode];                                                            // 1666
        if (!errorCode) {                                                                                              // 1667
          throw new Error('Unknown status code: ', clientError.statusCode);                                            // 1668
        }                                                                                                              //
                                                                                                                       //
        response.writeHead(errorCode.id, errorCode.title, {                                                            // 1671
          'Content-Type': 'text/html'                                                                                  // 1672
        });                                                                                                            //
                                                                                                                       //
        if (request.method !== 'HEAD') {                                                                               // 1675
          if (clientError.descriptionHtml) {                                                                           // 1676
            response.write(clientError.descriptionHtml);                                                               // 1677
          } else {                                                                                                     //
            // TODO(someday):  Better default error page.                                                              //
            response.write('<html><body><h1>' + errorCode.id + ': ' + errorCode.title + '</h1></body></html>');        // 1680
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        response.end();                                                                                                // 1685
      } else if ('serverError' in rpcResponse) {                                                                       //
        response.writeHead(500, 'Internal Server Error', {                                                             // 1687
          'Content-Type': 'text/html'                                                                                  // 1688
        });                                                                                                            //
                                                                                                                       //
        if (request.method !== 'HEAD') {                                                                               // 1691
          if (rpcResponse.serverError.descriptionHtml) {                                                               // 1692
            response.write(rpcResponse.serverError.descriptionHtml);                                                   // 1693
          } else {                                                                                                     //
            // TODO(someday):  Better default error page.                                                              //
            response.write('<html><body><h1>500: Internal Server Error</h1></body></html>');                           // 1696
          }                                                                                                            //
        }                                                                                                              //
                                                                                                                       //
        response.end();                                                                                                // 1700
      } else {                                                                                                         //
        throw new Error('Unknown HTTP response type:\n' + JSON.stringify(rpcResponse));                                // 1702
      }                                                                                                                //
                                                                                                                       //
      return Promise.resolve(undefined);                                                                               // 1705
    }                                                                                                                  //
                                                                                                                       //
    return translateResponse;                                                                                          //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.handleRequest = function () {                                                                        // 1188
    function handleRequest(request, data, response, retryCount) {                                                      //
      var _this = this;                                                                                                // 1709
      return Promise.resolve(undefined).then(function () {                                                             // 1710
        return _this.makeContext(request, response);                                                                   // 1711
      }).then(function (context) {                                                                                     //
        // jscs:disable requireDotNotation                                                                             //
        // Send the RPC.                                                                                               //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1715
        var session = _this.getSession(request);                                                                       // 1712
                                                                                                                       //
        var requestContent = function () {                                                                             // 1718
          function requestContent() {                                                                                  // 1718
            return {                                                                                                   // 1719
              content: data,                                                                                           // 1720
              encoding: request.headers['content-encoding'],                                                           // 1721
              mimeType: request.headers['content-type']                                                                // 1722
            };                                                                                                         //
          }                                                                                                            //
                                                                                                                       //
          return requestContent;                                                                                       //
        }();                                                                                                           //
                                                                                                                       //
        var xmlContent = function () {                                                                                 // 1726
          function xmlContent() {                                                                                      // 1726
            var type = request.headers['content-type'] || 'application/xml;charset=utf-8';                             // 1727
            var match = type.match(/[^/]*\/xml(; *charset *= *([^ ;]*))?/);                                            // 1728
            if (!match) {                                                                                              // 1729
              response.writeHead(415, 'Unsupported media type.', {                                                     // 1730
                'Content-Type': 'text/plain'                                                                           // 1731
              });                                                                                                      //
              response.end('expected XML request body');                                                               // 1733
              throw new Error('expected XML request body');                                                            // 1734
            }                                                                                                          //
                                                                                                                       //
            var charset = match[2] || 'ISO-8859-1';                                                                    // 1737
                                                                                                                       //
            var encoding = request.headers['content-encoding'];                                                        // 1739
            if (encoding && encoding !== 'identity') {                                                                 // 1740
              if (encoding !== 'gzip') throw new Error('unknown Content-Encoding: ' + encoding);                       // 1741
              data = gunzipSync(data);                                                                                 // 1742
            }                                                                                                          //
                                                                                                                       //
            return data.toString(charset.toLowerCase() === 'utf-8' ? 'utf8' : 'binary');                               // 1745
          }                                                                                                            //
                                                                                                                       //
          return xmlContent;                                                                                           //
        }();                                                                                                           //
                                                                                                                       //
        var propfindDepth = function () {                                                                              // 1748
          function propfindDepth() {                                                                                   // 1748
            var depth = request.headers['depth'];                                                                      // 1749
            return depth === '0' ? 'zero' : depth === '1' ? 'one' : 'infinity';                                        // 1750
          }                                                                                                            //
                                                                                                                       //
          return propfindDepth;                                                                                        //
        }();                                                                                                           //
                                                                                                                       //
        var shallow = function () {                                                                                    // 1755
          function shallow() {                                                                                         // 1755
            return request.headers['depth'] === '0';                                                                   // 1756
          }                                                                                                            //
                                                                                                                       //
          return shallow;                                                                                              //
        }();                                                                                                           //
                                                                                                                       //
        var noOverwrite = function () {                                                                                // 1759
          function noOverwrite() {                                                                                     // 1759
            return (request.headers['overwrite'] || '').toLowerCase() === 'f';                                         // 1760
          }                                                                                                            //
                                                                                                                       //
          return noOverwrite;                                                                                          //
        }();                                                                                                           //
                                                                                                                       //
        var destination = function () {                                                                                // 1763
          function destination() {                                                                                     // 1763
            var result = request.headers['destination'];                                                               // 1764
            if (!result) throw new Error('missing destination');                                                       // 1765
            return Url.parse(result).path.slice(1); // remove leading '/'                                              // 1766
          }                                                                                                            // 1763
                                                                                                                       //
          return destination;                                                                                          //
        }();                                                                                                           //
                                                                                                                       //
        if (request.method === 'GET' || request.method === 'HEAD') {                                                   // 1769
          return session.get(path, context, request.method === 'HEAD');                                                // 1770
        } else if (request.method === 'POST') {                                                                        //
          return session.post(path, requestContent(), context);                                                        // 1772
        } else if (request.method === 'PUT') {                                                                         //
          return session.put(path, requestContent(), context);                                                         // 1774
        } else if (request.method === 'PATCH') {                                                                       //
          return session.patch(path, requestContent(), context);                                                       // 1776
        } else if (request.method === 'DELETE') {                                                                      //
          return session["delete"](path, context);                                                                     // 1778
        } else if (request.method === 'PROPFIND') {                                                                    //
          return session.propfind(path, xmlContent(), propfindDepth(), context);                                       // 1780
        } else if (request.method === 'PROPPATCH') {                                                                   //
          return session.proppatch(path, xmlContent(), context);                                                       // 1782
        } else if (request.method === 'MKCOL') {                                                                       //
          return session.mkcol(path, requestContent(), context);                                                       // 1784
        } else if (request.method === 'COPY') {                                                                        //
          return session.copy(path, destination(), noOverwrite(), shallow(), context);                                 // 1786
        } else if (request.method === 'MOVE') {                                                                        //
          return session.move(path, destination(), noOverwrite(), context);                                            // 1788
        } else if (request.method === 'LOCK') {                                                                        //
          return session.lock(path, xmlContent(), shallow(), context);                                                 // 1790
        } else if (request.method === 'UNLOCK') {                                                                      //
          return session.unlock(path, request.headers['lock-token'], context);                                         // 1792
        } else if (request.method === 'ACL') {                                                                         //
          return session.acl(path, xmlContent(), context);                                                             // 1794
        } else if (request.method === 'REPORT') {                                                                      //
          return session.report(path, requestContent(), context);                                                      // 1796
        } else if (request.method === 'OPTIONS') {                                                                     //
          return session.options(path, context).then(function (options) {                                              // 1798
            var dav = [];                                                                                              // 1799
            if (options.davClass1) dav.push('1');                                                                      // 1800
            if (options.davClass2) dav.push('2');                                                                      // 1801
            if (options.davClass3) dav.push('3');                                                                      // 1802
            if (options.davExtensions) {                                                                               // 1803
              options.davExtensions.forEach(function (token) {                                                         // 1804
                if (token.match(/^([a-zA-Z0-9!#$%&'*+.^_`|~-]+|<[\x21-\x7E]*>)$/)) {                                   // 1805
                  dav.push(token);                                                                                     // 1806
                }                                                                                                      //
              });                                                                                                      //
            }                                                                                                          //
                                                                                                                       //
            if (dav.length > 0) {                                                                                      // 1811
              response.setHeader("DAV", dav.join(", "));                                                               // 1812
              response.setHeader("Access-Control-Expose-Headers", "DAV");                                              // 1813
            }                                                                                                          //
                                                                                                                       //
            response.end();                                                                                            // 1816
            // Return no response; we already handled everything.                                                      //
          }, function (err) {                                                                                          // 1798
            if (err.kjType !== 'unimplemented') throw err;                                                             // 1819
            response.end();                                                                                            // 1820
            // Return no response; we already handled everything.                                                      //
          });                                                                                                          // 1818
        } else {                                                                                                       //
            throw new Error('Sandstorm only supports the following methods: GET, POST, PUT, PATCH, DELETE, HEAD, PROPFIND, PROPPATCH, MKCOL, COPY, MOVE, LOCK, UNLOCK, ACL, REPORT, and OPTIONS.');
          }                                                                                                            //
      }).then(function (rpcResponse) {                                                                                 //
        if (rpcResponse !== undefined) {                                                                               // 1827
          // Will be undefined for OPTIONS request.                                                                    //
          return _this.translateResponse(rpcResponse, response, request);                                              // 1828
        }                                                                                                              //
      })["catch"](function (error) {                                                                                   //
        return _this.maybeRetryAfterError(error, retryCount).then(function () {                                        // 1831
          return _this.handleRequest(request, data, response, retryCount + 1);                                         // 1832
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return handleRequest;                                                                                              //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.handleRequestStreaming = function () {                                                               // 1188
    function handleRequestStreaming(request, response, contentLength, retryCount) {                                    //
      var _this = this;                                                                                                // 1838
      var context = this.makeContext(request, response);                                                               // 1839
      var path = request.url.slice(1); // remove leading '/'                                                           // 1840
      var session = this.getSession(request);                                                                          // 1837
                                                                                                                       //
      var mimeType = request.headers['content-type'] || 'application/octet-stream';                                    // 1843
      var encoding = request.headers['content-encoding'];                                                              // 1844
                                                                                                                       //
      var requestStreamPromise = void 0;                                                                               // 1846
      if (request.method === 'POST') {                                                                                 // 1847
        requestStreamPromise = session.postStreaming(path, mimeType, context, encoding);                               // 1848
      } else if (request.method === 'PUT') {                                                                           //
        requestStreamPromise = session.putStreaming(path, mimeType, context, encoding);                                // 1850
      } else {                                                                                                         //
        throw new Error('Sandstorm only supports streaming POST and PUT requests.');                                   // 1852
      }                                                                                                                //
                                                                                                                       //
      // TODO(perf): We ought to be pipelining the body, but we can't currently, because we have to                    //
      //   handle the case where the app doesn't actually support streaming. We could pipeline while                   //
      //   also buffering the data on the side in case we need it again later, but that's kind of                      //
      //   complicated. We should fix the whole protocol to make streaming the standard.                               //
      return requestStreamPromise.then(function (requestStreamResult) {                                                // 1837
        var requestStream = requestStreamResult.stream;                                                                // 1860
                                                                                                                       //
        // Initialized when getResponse() returns, if the response is streaming.                                       //
        var downloadStreamHandle = void 0;                                                                             // 1859
                                                                                                                       //
        // Initialized if an upload-stream method throws.                                                              //
        var uploadStreamError = void 0;                                                                                // 1859
                                                                                                                       //
        // We call `getResponse()` immediately so that the app can start streaming data down even while                //
        // data is still being streamed up. This theoretically allows apps to perform bidirectional                    //
        // streaming, though probably very few actually do that.                                                       //
        //                                                                                                             //
        // Note that we need to be able to cancel `responsePromise` below, so it's important that it is                //
        // the raw Cap'n Proto promise. Hence `translateResponsePromise` is a separate variable.                       //
        var responsePromise = requestStream.getResponse();                                                             // 1859
                                                                                                                       //
        var reportUploadStreamError = function () {                                                                    // 1876
          function reportUploadStreamError(err) {                                                                      // 1876
            // Called when an upload-stream method throws.                                                             //
                                                                                                                       //
            if (!uploadStreamError) {                                                                                  // 1879
              uploadStreamError = err;                                                                                 // 1880
                                                                                                                       //
              // If we're still waiting on any response stuff, cancel it.                                              //
              responsePromise.cancel();                                                                                // 1879
              requestStream.close();                                                                                   // 1884
              if (downloadStreamHandle) {                                                                              // 1885
                downloadStreamHandle.close();                                                                          // 1886
              }                                                                                                        //
            }                                                                                                          //
          }                                                                                                            //
                                                                                                                       //
          return reportUploadStreamError;                                                                              //
        }();                                                                                                           //
                                                                                                                       //
        // If we have a Content-Length, pass it along to the app by calling `expectSize()`.                            //
        if (contentLength !== undefined) {                                                                             // 1859
          requestStream.expectSize(contentLength)["catch"](function (err) {                                            // 1893
            // expectSize() is allowed to be unimplemented.                                                            //
            if (err.kjType !== 'unimplemented') {                                                                      // 1895
              reportUploadStreamError(err);                                                                            // 1896
            }                                                                                                          //
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        // Pipe the input stream to the app.                                                                           //
        request.on('data', function (buf) {                                                                            // 1859
          // TODO(soon): Only allow a small number of write()s to be in-flight at once,                                //
          //   pausing the input stream if we hit that limit, so that we block the TCP socket all the                  //
          //   way back to the source. May want to also coalesce small writes for this purpose.                        //
          // TODO(security): The above problem may allow a DoS attack on the front-end.                                //
          if (!uploadStreamError) requestStream.write(buf)["catch"](reportUploadStreamError);                          // 1907
        });                                                                                                            //
                                                                                                                       //
        request.on('end', function () {                                                                                // 1910
          if (!uploadStreamError) requestStream.done()["catch"](reportUploadStreamError);                              // 1911
                                                                                                                       //
          // We're all done making calls to requestStream.                                                             //
          requestStream.close();                                                                                       // 1910
        });                                                                                                            //
                                                                                                                       //
        request.on('close', function () {                                                                              // 1917
          reportUploadStreamError(new Error('HTTP connection unexpectedly closed during request.'));                   // 1918
        });                                                                                                            //
                                                                                                                       //
        request.on('error', function (err) {                                                                           // 1921
          reportUploadStreamError(err);                                                                                // 1922
        });                                                                                                            //
                                                                                                                       //
        return responsePromise.then(function (rpcResponse) {                                                           // 1925
          // Stop here if the upload stream has already failed.                                                        //
          if (uploadStreamError) throw uploadStreamError;                                                              // 1927
          var promise = _this.translateResponse(rpcResponse, response, request);                                       // 1928
          downloadStreamHandle = promise.streamHandle;                                                                 // 1929
          return promise;                                                                                              // 1930
        });                                                                                                            //
      }, function (err) {                                                                                              //
        if (err.kjType === 'failed' && err.message.indexOf('not implemented') !== -1) {                                // 1933
          // Hack to work around old apps using an old version of Cap'n Proto, before the                              //
          // 'unimplemented' exception type was introduced. :(                                                         //
          // TODO(cleanup): When we transition to API version 2, we can move this into the                             //
          //   compatibility layer.                                                                                    //
          err.kjType = 'unimplemented';                                                                                // 1938
        }                                                                                                              //
                                                                                                                       //
        if (SandstormBackend.shouldRestartGrain(err, 0)) {                                                             // 1941
          // This is the kind of error that indicates we should retry. Note that we passed 0 for the                   //
          // retry count above because we were just checking if this is a retriable error (vs. possibly                //
          // a method-not-implemented error); maybeRetryAfterError() will check again with the proper                  //
          // retry count.                                                                                              //
          return _this.maybeRetryAfterError(err, retryCount).then(function () {                                        // 1946
            return _this.handleRequestStreaming(request, response, contentLength, retryCount + 1);                     // 1947
          });                                                                                                          //
        } else if (err.kjType === 'unimplemented') {                                                                   //
          // Streaming is not implemented. Fall back to non-streaming version.                                         //
          return readAll(request).then(function (data) {                                                               // 1951
            return _this.handleRequest(request, data, response, 0);                                                    // 1952
          });                                                                                                          //
        } else {                                                                                                       //
          throw err;                                                                                                   // 1955
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return handleRequestStreaming;                                                                                     //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.handleWebSocket = function () {                                                                      // 1188
    function handleWebSocket(request, socket, head, retryCount) {                                                      //
      var _this = this;                                                                                                // 1961
                                                                                                                       //
      return Promise.resolve(undefined).then(function () {                                                             // 1963
        return _this.makeContext(request);                                                                             // 1964
      }).then(function (context) {                                                                                     //
        var path = request.url.slice(1); // remove leading '/'                                                         // 1966
        var session = _this.getSession(request);                                                                       // 1965
                                                                                                                       //
        if (!('sec-websocket-key' in request.headers)) {                                                               // 1969
          throw new Error('Missing Sec-WebSocket-Accept header.');                                                     // 1970
        }                                                                                                              //
                                                                                                                       //
        var magic = request.headers['sec-websocket-key'] + '258EAFA5-E914-47DA-95CA-C5AB0DC85B11';                     // 1973
        var acceptKey = Crypto.createHash('sha1').update(magic).digest('base64');                                      // 1974
                                                                                                                       //
        var protocols = [];                                                                                            // 1976
        if ('sec-websocket-protocol' in request.headers) {                                                             // 1977
          protocols = request.headers['sec-websocket-protocol'].split(',').map(function (s) {                          // 1978
            return s.trim();                                                                                           // 1979
          });                                                                                                          //
        }                                                                                                              //
                                                                                                                       //
        var receiver = new WebSocketReceiver(socket);                                                                  // 1982
                                                                                                                       //
        var promise = session.openWebSocket(path, context, protocols, receiver);                                       // 1984
                                                                                                                       //
        if (head.length > 0) {                                                                                         // 1986
          promise.serverStream.sendBytes(head);                                                                        // 1987
        }                                                                                                              //
                                                                                                                       //
        var socketIdx = _this.websocketCounter.toString();                                                             // 1990
        _this.websockets[socketIdx] = socket;                                                                          // 1991
        _this.websocketCounter += 1;                                                                                   // 1992
        pumpWebSocket(socket, promise.serverStream, function () {                                                      // 1993
          delete _this.websockets[socketIdx];                                                                          // 1993
        });                                                                                                            //
                                                                                                                       //
        return promise.then(function (response) {                                                                      // 1995
          var headers = ['HTTP/1.1 101 Switching Protocols', 'Upgrade: websocket', 'Connection: Upgrade', 'Sec-WebSocket-Accept: ' + acceptKey];
          if (response.protocol && response.protocol.length > 0) {                                                     // 2002
            headers.push('Sec-WebSocket-Protocol: ' + response.protocol.join(', '));                                   // 2003
          }                                                                                                            //
                                                                                                                       //
          headers.push('');                                                                                            // 2006
          headers.push('');                                                                                            // 2007
                                                                                                                       //
          socket.write(headers.join('\r\n'));                                                                          // 2009
          receiver.go();                                                                                               // 2010
                                                                                                                       //
          // Note:  At this point errors are out of our hands.                                                         //
        });                                                                                                            // 1995
      })["catch"](function (error) {                                                                                   //
        return _this.maybeRetryAfterError(error, retryCount).then(function () {                                        // 2015
          return _this.handleWebSocket(request, socket, head, retryCount + 1);                                         // 2016
        });                                                                                                            //
      });                                                                                                              //
    }                                                                                                                  //
                                                                                                                       //
    return handleWebSocket;                                                                                            //
  }();                                                                                                                 //
                                                                                                                       //
  Proxy.prototype.setHasLoaded = function () {                                                                         // 1188
    function setHasLoaded() {                                                                                          //
      var _this6 = this;                                                                                               //
                                                                                                                       //
      if (!this.hasLoaded) {                                                                                           // 2022
        (function () {                                                                                                 //
          _this6.hasLoaded = true;                                                                                     // 2023
          var sessionId = _this6.sessionId;                                                                            // 2024
          inMeteor(function () {                                                                                       // 2025
            Sessions.update({ _id: sessionId }, { $set: { hasLoaded: true } });                                        // 2026
          });                                                                                                          //
        })();                                                                                                          //
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return setHasLoaded;                                                                                               //
  }();                                                                                                                 //
                                                                                                                       //
  return Proxy;                                                                                                        //
}();                                                                                                                   //
                                                                                                                       //
;                                                                                                                      // 2030
                                                                                                                       //
var PROTOCOL = Url.parse(process.env.ROOT_URL).protocol;                                                               // 2032
                                                                                                                       //
var isRfc1918OrLocal = function isRfc1918OrLocal(address) {                                                            // 2034
  if (Net.isIPv4(address)) {                                                                                           // 2035
    quad = address.split('.').map(function (x) {                                                                       // 2036
      return parseInt(x, 10);                                                                                          // 2036
    });                                                                                                                //
    return quad[0] === 127 || quad[0] === 10 || quad[0] === 192 && quad[1] === 168 || quad[0] === 172 && quad[1] >= 16 && quad[1] < 32;
  } else if (Net.isIPv6(address)) {                                                                                    //
    // IPv6 specifies ::1 as localhost and fd:: as reserved for private networks                                       //
    return address === '::1' || address.lastIndexOf('fd', 0) === 0;                                                    // 2042
  } else {                                                                                                             //
    // Ignore things that are neither IPv4 nor IPv6                                                                    //
    return false;                                                                                                      // 2045
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
var quadToIntString = function quadToIntString(quad) {                                                                 // 2049
  var num = Bignum(quad[0]).shiftLeft(16).add(quad[1]).shiftLeft(16).add(quad[2]).shiftLeft(16).add(quad[3]);          // 2050
  return num.toString();                                                                                               // 2054
};                                                                                                                     //
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Session cookie management                                                                                           //
                                                                                                                       //
var parseCookies = function parseCookies(request) {                                                                    // 2060
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers['cookie'];                                                                              // 2062
                                                                                                                       //
  var result = { cookies: [] };                                                                                        // 2064
  if (header) {                                                                                                        // 2065
    var reqCookies = header.split(';');                                                                                // 2066
    for (var i in meteorBabelHelpers.sanitizeForInObject(reqCookies)) {                                                // 2067
      var reqCookie = reqCookies[i];                                                                                   // 2068
      var equalsPos = reqCookie.indexOf('=');                                                                          // 2069
      var cookie = void 0;                                                                                             // 2070
      if (equalsPos === -1) {                                                                                          // 2071
        cookie = { key: reqCookie.trim(), value: '' };                                                                 // 2072
      } else {                                                                                                         //
        cookie = { key: reqCookie.slice(0, equalsPos).trim(), value: reqCookie.slice(equalsPos + 1) };                 // 2074
      }                                                                                                                //
                                                                                                                       //
      if (cookie.key === 'sandstorm-sid') {                                                                            // 2077
        if (result.sessionId) {                                                                                        // 2078
          throw new Error('Multiple sandstorm session IDs?');                                                          // 2079
        }                                                                                                              //
                                                                                                                       //
        result.sessionId = cookie.value;                                                                               // 2082
      } else {                                                                                                         //
        result.cookies.push(cookie);                                                                                   // 2084
      }                                                                                                                //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return result;                                                                                                       // 2089
};                                                                                                                     //
                                                                                                                       //
var parsePreconditionHeader = function parsePreconditionHeader(request) {                                              // 2092
  if (request.headers['if-match']) {                                                                                   // 2093
    if (request.headers['if-match'].trim() === '*') {                                                                  // 2094
      return { exists: null };                                                                                         // 2095
    }                                                                                                                  //
                                                                                                                       //
    var matches = parseETagList(request.headers['if-match']);                                                          // 2098
    if (matches.length > 0) {                                                                                          // 2099
      return { matchesOneOf: matches };                                                                                // 2100
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  if (request.headers['if-none-match']) {                                                                              // 2104
    if (request.headers['if-none-match'].trim() === '*') {                                                             // 2105
      return { doesntExist: null };                                                                                    // 2106
    }                                                                                                                  //
                                                                                                                       //
    var noneMatches = parseETagList(request.headers['if-none-match']);                                                 // 2109
    if (noneMatches.length > 0) {                                                                                      // 2110
      return { matchesNoneOf: noneMatches };                                                                           // 2111
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return { none: null };                                                                                               // 2115
};                                                                                                                     //
                                                                                                                       //
var parseETagList = function parseETagList(input) {                                                                    // 2118
  // An ETag is a quoted, \-escaped string, possibly prefixed with W/ (outside the quotes) to                          //
  // indicate that it is weak. We are parsing a list of comma-delimited etags.                                         //
                                                                                                                       //
  input = input.trim();                                                                                                // 2122
  var results = [];                                                                                                    // 2123
                                                                                                                       //
  while (input.length > 0) {                                                                                           // 2125
    var match = input.match(/^\s*(W\/)?"(([^"\\]|\\.)*)"\s*($|,)/);                                                    // 2126
    if (!match) throw new Meteor.Error(400, 'invalid etag');                                                           // 2127
                                                                                                                       //
    input = input.slice(match[0].length).trim();                                                                       // 2129
    results.push({ weak: !!match[1], value: match[2].replace(/\\(.)/g, '$1') });                                       // 2130
  }                                                                                                                    //
                                                                                                                       //
  return results;                                                                                                      // 2133
};                                                                                                                     //
                                                                                                                       //
var composeETag = function composeETag(tag) {                                                                          // 2136
  var result = '"' + (tag.value || '').replace(/([\\"])/g, '\\$1') + '"';                                              // 2137
  if (tag.weak) result = 'W/' + result;                                                                                // 2138
  return result;                                                                                                       // 2139
};                                                                                                                     //
                                                                                                                       //
var parseAcceptHeader = function parseAcceptHeader(request) {                                                          // 2142
  // jscs:disable requireDotNotation                                                                                   //
  var header = request.headers['accept'];                                                                              // 2144
                                                                                                                       //
  var result = [];                                                                                                     // 2146
  if (header) {                                                                                                        // 2147
    var acceptList = header.split(',');                                                                                // 2148
    for (var i in meteorBabelHelpers.sanitizeForInObject(acceptList)) {                                                // 2149
      var acceptStr = acceptList[i];                                                                                   // 2150
      var tokensList = acceptStr.split(';');                                                                           // 2151
                                                                                                                       //
      var temp = { mimeType: tokensList[0].trim() };                                                                   // 2153
                                                                                                                       //
      var tokensListRest = tokensList.slice(1);                                                                        // 2155
      for (var j in meteorBabelHelpers.sanitizeForInObject(tokensListRest)) {                                          // 2156
        var token = tokensListRest[j];                                                                                 // 2157
        var equalsPos = token.indexOf('=');                                                                            // 2158
        if (equalsPos) {                                                                                               // 2159
          var key = token.slice(0, equalsPos).trim();                                                                  // 2160
          var value = token.slice(equalsPos + 1).trim();                                                               // 2161
                                                                                                                       //
          if (key === 'q') {                                                                                           // 2163
            temp.qValue = +value;                                                                                      // 2164
          }                                                                                                            //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      result.push(temp);                                                                                               // 2169
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  return result;                                                                                                       // 2173
};                                                                                                                     //
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// Regular HTTP request handling                                                                                       //
                                                                                                                       //
var readAll = function readAll(stream) {                                                                               // 2179
  return new Promise(function (resolve, reject) {                                                                      // 2180
    var buffers = [];                                                                                                  // 2181
    stream.on('data', function (buf) {                                                                                 // 2182
      buffers.push(buf);                                                                                               // 2183
    });                                                                                                                //
                                                                                                                       //
    stream.on('end', function () {                                                                                     // 2186
      resolve(Buffer.concat(buffers));                                                                                 // 2187
    });                                                                                                                //
                                                                                                                       //
    stream.on('error', reject);                                                                                        // 2190
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
var makeSetCookieHeader = function makeSetCookieHeader(cookie) {                                                       // 2194
  var result = [cookie.name, '=', cookie.value];                                                                       // 2195
                                                                                                                       //
  if ('absolute' in cookie.expires) {                                                                                  // 2197
    result.push('; Expires=');                                                                                         // 2198
    result.push(new Date(cookie.expires.absolute * 1000).toUTCString());                                               // 2199
  } else if ('relative' in cookie.expires) {                                                                           //
    result.push('; Max-Age=' + cookie.expires.relative);                                                               // 2201
  }                                                                                                                    //
                                                                                                                       //
  if (cookie.path) {                                                                                                   // 2204
    result.push('; Path=' + cookie.path);                                                                              // 2205
  }                                                                                                                    //
                                                                                                                       //
  if (cookie.httpOnly) {                                                                                               // 2208
    result.push('; HttpOnly');                                                                                         // 2209
  }                                                                                                                    //
                                                                                                                       //
  return result.join('');                                                                                              // 2212
};                                                                                                                     //
                                                                                                                       //
// TODO(cleanup):  Auto-generate based on annotations in web-session.capnp.                                            //
var successCodes = {                                                                                                   // 2216
  ok: { id: 200, title: 'OK' },                                                                                        // 2217
  created: { id: 201, title: 'Created' },                                                                              // 2218
  accepted: { id: 202, title: 'Accepted' },                                                                            // 2219
  multiStatus: { id: 207, title: 'Multi-Status' }                                                                      // 2220
};                                                                                                                     //
var noContentSuccessCodes = [                                                                                          // 2222
// Indexed by shouldResetForm * 1                                                                                      //
{ id: 204, title: 'No Content' }, { id: 205, title: 'Reset Content' }];                                                // 2224
var redirectCodes = [                                                                                                  // 2227
// Indexed by switchToGet * 2 + isPermanent                                                                            //
{ id: 307, title: 'Temporary Redirect' }, { id: 308, title: 'Permanent Redirect' }, { id: 303, title: 'See Other' }, { id: 301, title: 'Moved Permanently' }];
var errorCodes = {                                                                                                     // 2234
  badRequest: { id: 400, title: 'Bad Request' },                                                                       // 2235
  forbidden: { id: 403, title: 'Forbidden' },                                                                          // 2236
  notFound: { id: 404, title: 'Not Found' },                                                                           // 2237
  methodNotAllowed: { id: 405, title: 'Method Not Allowed' },                                                          // 2238
  notAcceptable: { id: 406, title: 'Not Acceptable' },                                                                 // 2239
  conflict: { id: 409, title: 'Conflict' },                                                                            // 2240
  gone: { id: 410, title: 'Gone' },                                                                                    // 2241
  requestEntityTooLarge: { id: 413, title: 'Request Entity Too Large' },                                               // 2242
  requestUriTooLong: { id: 414, title: 'Request-URI Too Long' },                                                       // 2243
  unsupportedMediaType: { id: 415, title: 'Unsupported Media Type' },                                                  // 2244
  imATeapot: { id: 418, title: 'I\'m a teapot' },                                                                      // 2245
  unprocessableEntity: { id: 422, title: 'Unprocessable Entity' }                                                      // 2246
};                                                                                                                     //
                                                                                                                       //
ResponseStream = function () {                                                                                         // 2249
  function ResponseStream(response, streamHandle, resolve, reject) {                                                   // 2250
    (0, _classCallCheck3["default"])(this, ResponseStream);                                                            //
                                                                                                                       //
    this.response = response;                                                                                          // 2251
    this.streamHandle = streamHandle;                                                                                  // 2252
    this.resolve = resolve;                                                                                            // 2253
    this.reject = reject;                                                                                              // 2254
    this.ended = false;                                                                                                // 2255
  }                                                                                                                    //
                                                                                                                       //
  ResponseStream.prototype.write = function () {                                                                       // 2249
    function write(data) {                                                                                             //
      this.response.write(data);                                                                                       // 2259
    }                                                                                                                  //
                                                                                                                       //
    return write;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  ResponseStream.prototype.done = function () {                                                                        // 2249
    function done() {                                                                                                  //
      this.response.end();                                                                                             // 2263
      this.streamHandle.close();                                                                                       // 2264
      this.ended = true;                                                                                               // 2265
    }                                                                                                                  //
                                                                                                                       //
    return done;                                                                                                       //
  }();                                                                                                                 //
                                                                                                                       //
  ResponseStream.prototype.close = function () {                                                                       // 2249
    function close() {                                                                                                 //
      if (this.ended) {                                                                                                // 2269
        this.resolve();                                                                                                // 2270
      } else {                                                                                                         //
        this.streamHandle.close();                                                                                     // 2272
        this.reject(new Error('done() was never called on outbound stream.'));                                         // 2273
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  return ResponseStream;                                                                                               //
}();                                                                                                                   //
                                                                                                                       //
// TODO(cleanup): Node 0.12 has a `gunzipSync` but 0.10 (which Meteor still uses) does not.                            //
var Zlib = Npm.require('zlib');                                                                                        // 2279
var gunzipSync = Meteor.wrapAsync(Zlib.gunzip, Zlib);                                                                  // 2280
                                                                                                                       //
// -----------------------------------------------------------------------------                                       //
// WebSocket handling                                                                                                  //
                                                                                                                       //
WebSocketReceiver = function () {                                                                                      // 2285
  function WebSocketReceiver(socket) {                                                                                 // 2286
    (0, _classCallCheck3["default"])(this, WebSocketReceiver);                                                         //
                                                                                                                       //
    this.socket = socket;                                                                                              // 2287
    this.queue = [];                                                                                                   // 2288
  }                                                                                                                    //
                                                                                                                       //
  WebSocketReceiver.prototype.go = function () {                                                                       // 2285
    function go() {                                                                                                    //
      for (var i in meteorBabelHelpers.sanitizeForInObject(this.queue)) {                                              // 2292
        this.socket.write(this.queue[i]);                                                                              // 2293
      }                                                                                                                //
                                                                                                                       //
      this.queue = null;                                                                                               // 2296
    }                                                                                                                  //
                                                                                                                       //
    return go;                                                                                                         //
  }();                                                                                                                 //
                                                                                                                       //
  WebSocketReceiver.prototype.sendBytes = function () {                                                                // 2285
    function sendBytes(message) {                                                                                      //
      // TODO(someday):  Flow control of some sort?                                                                    //
      if (this.queue === null) {                                                                                       // 2301
        this.socket.write(message);                                                                                    // 2302
      } else {                                                                                                         //
        this.queue.push(message);                                                                                      // 2304
      }                                                                                                                //
    }                                                                                                                  //
                                                                                                                       //
    return sendBytes;                                                                                                  //
  }();                                                                                                                 //
                                                                                                                       //
  WebSocketReceiver.prototype.close = function () {                                                                    // 2285
    function close() {                                                                                                 //
      this.socket.end();                                                                                               // 2309
    }                                                                                                                  //
                                                                                                                       //
    return close;                                                                                                      //
  }();                                                                                                                 //
                                                                                                                       //
  return WebSocketReceiver;                                                                                            //
}();                                                                                                                   //
                                                                                                                       //
pumpWebSocket = function pumpWebSocket(socket, rpcStream, destructor) {                                                // 2313
  socket.on('data', function (chunk) {                                                                                 // 2314
    rpcStream.sendBytes(chunk)["catch"](function (err) {                                                               // 2315
      if (err.kjType !== 'disconnected') {                                                                             // 2316
        console.error('WebSocket sendBytes failed: ' + err.stack);                                                     // 2317
      }                                                                                                                //
                                                                                                                       //
      socket.destroy();                                                                                                // 2320
    });                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  socket.on('end', function (chunk) {                                                                                  // 2324
    rpcStream.close();                                                                                                 // 2325
  });                                                                                                                  //
                                                                                                                       //
  socket.on("close", function () {                                                                                     // 2328
    destructor();                                                                                                      // 2329
  });                                                                                                                  //
};                                                                                                                     //
                                                                                                                       //
// =======================================================================================                             //
// Debug log access                                                                                                    //
                                                                                                                       //
Meteor.publish('grainLog', function (grainId) {                                                                        // 2336
  var _this7 = this;                                                                                                   //
                                                                                                                       //
  check(grainId, String);                                                                                              // 2337
  var id = 0;                                                                                                          // 2338
  var grain = Grains.findOne(grainId);                                                                                 // 2339
  if (!grain || !this.userId || grain.userId !== this.userId) {                                                        // 2340
    this.added('grainLog', id++, { text: 'Only the grain owner can view the debug log.' });                            // 2341
    this.ready();                                                                                                      // 2342
    return;                                                                                                            // 2343
  }                                                                                                                    //
                                                                                                                       //
  var connected = false;                                                                                               // 2346
  var _this = this;                                                                                                    // 2347
                                                                                                                       //
  var receiver = {                                                                                                     // 2349
    write: function () {                                                                                               // 2350
      function write(data) {                                                                                           //
        connected = true;                                                                                              // 2351
        _this.added('grainLog', id++, { text: data.toString('utf8') });                                                // 2352
      }                                                                                                                //
                                                                                                                       //
      return write;                                                                                                    //
    }(),                                                                                                               //
    close: function () {                                                                                               // 2355
      function close() {                                                                                               //
        if (connected) {                                                                                               // 2356
          _this.added('grainLog', id++, {                                                                              // 2357
            text: '*** lost connection to grain (probably because it shut down) ***'                                   // 2358
          });                                                                                                          //
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return close;                                                                                                    //
    }()                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  try {                                                                                                                // 2364
    (function () {                                                                                                     //
      var handle = waitPromise(globalBackend.useGrain(grainId, function (supervisor) {                                 // 2365
        return supervisor.watchLog(8192, receiver);                                                                    // 2366
      })).handle;                                                                                                      //
      connected = true;                                                                                                // 2368
      _this7.onStop(function () {                                                                                      // 2369
        handle.close();                                                                                                // 2370
      });                                                                                                              //
    })();                                                                                                              //
  } catch (err) {                                                                                                      //
    if (!connected) {                                                                                                  // 2373
      this.added('grainLog', id++, {                                                                                   // 2374
        text: '*** couldn\'t connect to grain (' + err + ') ***'                                                       // 2375
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Notify ready.                                                                                                     //
  this.ready();                                                                                                        // 2336
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"sandcats.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/sandcats.js                                                                                                  //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _this = this;                                                                                                      //
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Sandcats = {};                                                                                                         // 17
                                                                                                                       //
var querystring = Npm.require("querystring");                                                                          // 19
var https = Npm.require("https");                                                                                      // 20
var fs = Npm.require("fs");                                                                                            // 21
var dgram = Npm.require("dgram");                                                                                      // 22
var Url = Npm.require("url");                                                                                          // 23
                                                                                                                       //
var SANDCATS_HOSTNAME = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].sandcatsHostname;    // 25
var SANDCATS_VARDIR = (SANDSTORM_ALTHOME || "") + "/var/sandcats";                                                     // 27
                                                                                                                       //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                        // 29
var HOSTNAME = ROOT_URL.hostname;                                                                                      // 30
var SANDCATS_NAME = void 0; // Look at `startup` below to see where this is set                                        // 31
                                                                                                                       //
var updateSandcatsIp = function updateSandcatsIp() {                                                                   // 33
  var responseCallback = function responseCallback(res) {                                                              // 34
    if (res.statusCode === 200) {                                                                                      // 35
      console.log("Successfully updated sandcats IP");                                                                 // 36
    } else {                                                                                                           //
      console.error("Failed to update sandcats IP:", res.headers);                                                     // 38
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  var errorCallback = function errorCallback(err) {                                                                    // 42
    console.error("Couldn't send update sandcats hostname", err);                                                      // 43
  };                                                                                                                   //
                                                                                                                       //
  performSandcatsRequest("/update", SANDCATS_HOSTNAME, { rawHostname: SANDCATS_NAME }, errorCallback, responseCallback);
};                                                                                                                     //
                                                                                                                       //
var pingUdp = function pingUdp() {                                                                                     // 50
  var socket = dgram.createSocket("udp4");                                                                             // 51
  var secret = Random.secret(16);                                                                                      // 52
                                                                                                                       //
  message = new Buffer(SANDCATS_NAME + " " + secret);                                                                  // 54
  socket.on("message", function (buf) {                                                                                // 55
    if (buf.toString() === secret) {                                                                                   // 56
      updateSandcatsIp();                                                                                              // 57
    } else {                                                                                                           //
      console.error("Received unexpected response in UDP sandcats ping:", buf.toString());                             // 59
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  socket.send(message, 0, message.length, 8080, SANDCATS_HOSTNAME, function (err) {                                    // 63
    if (err) {                                                                                                         // 64
      console.error("Couldn't send UDP sandcats ping", err);                                                           // 65
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  Meteor.setTimeout(function () {                                                                                      // 69
    socket.close();                                                                                                    // 70
  }, 10 * 1000);                                                                                                       //
};                                                                                                                     //
                                                                                                                       //
var performSandcatsRequest = function performSandcatsRequest(path, hostname, postData, errorCallback, responseCallback) {
  var options = {                                                                                                      // 75
    hostname: hostname,                                                                                                // 76
    path: path,                                                                                                        // 77
    method: "POST",                                                                                                    // 78
    agent: false,                                                                                                      // 79
    key: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa"),                                                                 // 80
    cert: fs.readFileSync(SANDCATS_VARDIR + "/id_rsa.pub"),                                                            // 81
    headers: {                                                                                                         // 82
      "X-Sand": "cats",                                                                                                // 83
      "Content-Type": "application/x-www-form-urlencoded"                                                              // 84
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  if (postData.certificateSigningRequest) {                                                                            // 88
    console.log("Submitting certificate request for host", postData.rawHostname, "where the request has length", postData.certificateSigningRequest.length);
  }                                                                                                                    //
                                                                                                                       //
  var newPostData = querystring.stringify(postData);                                                                   // 94
  if (SANDCATS_HOSTNAME === "sandcats-dev.sandstorm.io" && !process.env.NODE_TLS_REJECT_UNAUTHORIZED) {                // 95
    console.log("You are using the Sandcats dev server but have full HTTPS " + "certificate checking enabled. Probably you will get an HTTPS " + "error. Proceeding anyway.");
  }                                                                                                                    //
                                                                                                                       //
  var req = https.request(options, responseCallback);                                                                  // 102
  req.write(newPostData);                                                                                              // 103
  req.end();                                                                                                           // 104
                                                                                                                       //
  if (errorCallback) {                                                                                                 // 106
    req.on("error", errorCallback);                                                                                    // 107
  }                                                                                                                    //
                                                                                                                       //
  return req;                                                                                                          // 110
};                                                                                                                     //
                                                                                                                       //
var generateKeyAndCsr = function generateKeyAndCsr(commonName) {                                                       // 113
  // This function relies on the this.forge object created by the                                                      //
  // meteor-node-forge package.                                                                                        //
  check(commonName, String);                                                                                           // 116
                                                                                                                       //
  // Generate key pair. Using Meteor.wrapAsync because forge supports                                                  //
  // a synchronous as well as an asynchronous API, and the synchronous                                                 //
  // one blocks for a while.                                                                                           //
  var wrappedGenerateKeyPair = Meteor.wrapAsync(_this.forge.pki.rsa.generateKeyPair);                                  // 113
                                                                                                                       //
  // I could pick an `e`[xponent] value for the resulting RSA key, but                                                 //
  // I will refrain.                                                                                                   //
  var keys = wrappedGenerateKeyPair({ bits: 2048 });                                                                   // 113
                                                                                                                       //
  // Create a certificate request (CSR).                                                                               //
  var csr = _this.forge.pki.createCertificationRequest();                                                              // 113
  csr.publicKey = keys.publicKey;                                                                                      // 129
  csr.setSubject([{                                                                                                    // 130
    name: "commonName",                                                                                                // 132
    value: commonName                                                                                                  // 133
  }]);                                                                                                                 //
  csr.sign(keys.privateKey);                                                                                           // 136
  console.log("generateKeyAndCsr created new key & certificate request for", commonName);                              // 137
  return {                                                                                                             // 138
    privateKeyAsPem: _this.forge.pki.privateKeyToPem(keys.privateKey),                                                 // 139
    csrAsPem: _this.forge.pki.certificationRequestToPem(csr)                                                           // 140
  };                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
Sandcats.storeNewKeyAndCsr = function (hostname, basePath) {                                                           // 144
  // We use the current JS time (like UNIX timestamp but in                                                            //
  // milliseconds) as the key number. Note that the keyNumber is                                                       //
  // intended to be an opaque identifier; the only important thing is                                                  //
  // that it increases numerically over time. We use the current time                                                  //
  // just as a simplistic way to pick a filename that probably no one                                                  //
  // else has created yet.                                                                                             //
  var keyNumber = new Date().getTime();                                                                                // 151
  var keyFilename = basePath + "/" + keyNumber;                                                                        // 152
  var csrFilename = keyFilename + ".csr";                                                                              // 153
  var responseFilename = keyFilename + ".response-json";                                                               // 154
  var withWildcard = "*." + hostname;                                                                                  // 155
  var keyAndCsr = generateKeyAndCsr(withWildcard);                                                                     // 156
  fs.writeFileSync(keyFilename, keyAndCsr.privateKeyAsPem, { mode: 0400 });                                            // 157
  fs.writeFileSync(csrFilename, keyAndCsr.csrAsPem);                                                                   // 159
  console.log("storeNewKeyAndCsr successfully saved key and certificate request to", keyFilename, "and", csrFilename, "respectively of length", keyAndCsr.privateKeyAsPem.length, "and", keyAndCsr.csrAsPem.length);
  return {                                                                                                             // 164
    csrFilename: csrFilename,                                                                                          // 165
    keyFilename: keyFilename,                                                                                          // 166
    responseFilename: responseFilename                                                                                 // 167
  };                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
Sandcats.renewHttpsCertificateIfNeeded = function () {                                                                 // 171
  var renewHttpsCertificate = function renewHttpsCertificate() {                                                       // 172
    var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                           // 173
    var basePath = "/var/sandcats/https/" + hostname;                                                                  // 174
    var filenames = Sandcats.storeNewKeyAndCsr(hostname, basePath);                                                    // 175
                                                                                                                       //
    var errorCallback = function errorCallback(err) {                                                                  // 177
      console.error("Error while renewing HTTPS certificate (will continue to retry)", err);                           // 178
    };                                                                                                                 //
                                                                                                                       //
    var responseCallback = function responseCallback(res) {                                                            // 181
      if (res.statusCode == 200) {                                                                                     // 182
        (function () {                                                                                                 //
          // Save the response, chunk by chunk, then store it on disk                                                  //
          // for later use.                                                                                            //
          var responseBody = "";                                                                                       // 185
          res.on("data", function (chunk) {                                                                            // 186
            responseBody += chunk;                                                                                     // 187
          });                                                                                                          //
                                                                                                                       //
          res.on("end", function () {                                                                                  // 190
            // For sanity, make sure it parses as JSON, since we're                                                    //
            // going to need it to do that.                                                                            //
            try {                                                                                                      // 193
              JSON.parse(responseBody);                                                                                // 194
            } catch (e) {                                                                                              //
              console.error("JSON parse error receiving new HTTPS certificate. Discarding:", responseBody, "due to exception:", e);
              // Overwrite the responseBody with the empty JSON object                                                 //
              // and continue with the process of saving it to disk.                                                   //
              responseBody = "{}";                                                                                     // 195
            }                                                                                                          //
                                                                                                                       //
            try {                                                                                                      // 205
              fs.writeFileSync(filenames.responseFilename, responseBody, "utf-8");                                     // 206
            } catch (err) {                                                                                            //
              return console.error("Failure while saveing new HTTPS certificate to", filenames.responseFilename, "will continue to retry. Exception was:", err);
            }                                                                                                          //
                                                                                                                       //
            // Tell Sandcats that now is a good time to update its info                                                //
            // about which keys are available.                                                                         //
            if (!global.sandcats) {                                                                                    // 190
              console.error("When getting new certificate, could not find callback to request re-keying! Certs will probably become invalid soon.");
            } else {                                                                                                   //
              // Call the sandcats rekeying function.                                                                  //
              global.sandcats.rekey();                                                                                 // 220
              // That's that.                                                                                          //
              console.log("Successfully renewed HTTPS certificate into", filenames.responseFilename);                  // 218
            }                                                                                                          //
          });                                                                                                          //
        })();                                                                                                          //
      } else {                                                                                                         //
        console.log("Received HTTP error while renewing certificate (will keep retrying)", res.statusCode);            // 227
        res.on("data", function (chunk) {                                                                              // 229
          console.log("Error response contained information", chunk.toString("utf-8"));                                // 230
        });                                                                                                            //
      }                                                                                                                //
    };                                                                                                                 //
                                                                                                                       //
    var wrappedReadFile = Meteor.wrapAsync(fs.readFile);                                                               // 235
                                                                                                                       //
    performSandcatsRequest("/getcertificate", SANDCATS_HOSTNAME, {                                                     // 237
      rawHostname: SANDCATS_NAME,                                                                                      // 238
      certificateSigningRequest: wrappedReadFile(filenames.csrFilename, "utf-8")                                       // 239
    }, errorCallback, responseCallback);                                                                               //
  };                                                                                                                   //
                                                                                                                       //
  if (global.sandcats.shouldGetAnotherCertificate()) {                                                                 // 243
    console.log("renewHttpsCertificateIfNeeded: Happily choosing to renew certificate.");                              // 244
    return renewHttpsCertificate();                                                                                    // 245
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Sandcats.initializeSandcats = function () {                                                                            // 249
  var i = HOSTNAME.lastIndexOf(SANDCATS_HOSTNAME);                                                                     // 250
  if (i < 0) {                                                                                                         // 251
    console.error("SANDCATS_BASE_DOMAIN is configured but your HOSTNAME doesn't appear to contain it:", SANDCATS_HOSTNAME, HOSTNAME);
  } else {                                                                                                             //
    var oneMinute = 60 * 1000;                                                                                         // 255
    var oneHour = 60 * oneMinute;                                                                                      // 256
    var randomIntervalZeroToOneHour = Math.random() * oneHour;                                                         // 257
    // All Sandcats installs need dyndns updating.                                                                     //
    SANDCATS_NAME = HOSTNAME.slice(0, i - 1);                                                                          // 254
    Meteor.setInterval(pingUdp, oneMinute);                                                                            // 260
    // If process.env.HTTPS_PORT is set, we need to auto-refresh our HTTPS certificate.                                //
    if (process.env.HTTPS_PORT) {                                                                                      // 254
      // Always do a HTTPS certificate update check on Sandstorm start.                                                //
      Sandcats.renewHttpsCertificateIfNeeded();                                                                        // 264
                                                                                                                       //
      // After that's done, schedule it for every approx 1-2 hours in                                                  //
      // the future.                                                                                                   //
      Meteor.setInterval(Sandcats.renewHttpsCertificateIfNeeded, oneHour + randomIntervalZeroToOneHour);               // 262
    }                                                                                                                  //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
if (SANDCATS_HOSTNAME) {                                                                                               // 274
  Meteor.startup(Sandcats.initializeSandcats);                                                                         // 275
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"shell-server.js":function(require){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/shell-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Set up browser policy.                                                                                              //
//                                                                                                                     //
// Note that by default (when the browser-policy package is added), Content-Security-Policy will                       //
// already be set to same-origin-only for everything except XHR and WebSocket. Eval is disabled,                       //
// but inline script are enabled.                                                                                      //
//                                                                                                                     //
// TODO(security): Consider disallowing inline scripts. Currently this forces Meteor to do an                          //
//   extra round trip on startup to fetch server settings. That seems like something that could                        //
//   be fixed in Meteor (e.g. embed the settings as JSON text rather than script). Startup time                        //
//   is incredibly important, and Meteor's templating system (which we use to render all our                           //
//   HTML) already does a good job of protecting us from script injection, so right now I think                        //
//   we should favor avoiding the round trip.                                                                          //
//                                                                                                                     //
// TODO(someday): Detect when an app tries to navigate off-site using CSP's violation reporting                        //
//   feature. Ask the user whether they want to open the link in a new tab. This is an annoying                        //
//   prompt, but if we just open the tab directly then apps can trivially leak by opening tabs                         //
//   with encoded URLs to an evil server. Although, this attack would be very detectable to the                        //
//   user, so maybe it's not a big deal...                                                                             //
                                                                                                                       //
BrowserPolicy.framing.disallow(); // Disallow framing of the UI.                                                       // 36
BrowserPolicy.content.allowFrameOrigin(getWildcardOrigin());                                                           // 37
                                                                                                                       //
// Allow anything to be loaded from the static asset host.                                                             //
var Url = Npm.require("url");                                                                                          // 40
var staticAssetHost = Url.parse(process.env.ROOT_URL).protocol + "//" + globalDb.makeWildcardHost("static");           // 41
BrowserPolicy.content.allowImageOrigin(staticAssetHost);                                                               // 43
BrowserPolicy.content.allowScriptOrigin(staticAssetHost);                                                              // 44
BrowserPolicy.content.allowFontOrigin(staticAssetHost);                                                                // 45
BrowserPolicy.content.allowConnectOrigin(staticAssetHost);                                                             // 46
                                                                                                                       //
Meteor.publish("grainsMenu", function () {                                                                             // 48
  var _this = this;                                                                                                    //
                                                                                                                       //
  if (this.userId) {                                                                                                   // 49
    if (Meteor.settings["public"].quotaEnabled) {                                                                      // 50
      (function () {                                                                                                   //
        // Hack: Fire off an asynchronous update to the user's storage usage whenever they open the                    //
        //   front page.                                                                                               //
        // TODO(someday): Implement the ability to reactively subscribe to storage usage from the                      //
        //   back-end?                                                                                                 //
        var userId = _this.userId;                                                                                     // 55
        globalBackend.cap().getUserStorageUsage(userId).then(function (results) {                                      // 56
          inMeteor(function () {                                                                                       // 57
            Meteor.users.update(userId, { $set: { storageUsage: parseInt(results.size) } });                           // 58
          });                                                                                                          //
        })["catch"](function (err) {                                                                                   //
          if (err.kjType !== "unimplemented") {                                                                        // 61
            console.error(err.stack);                                                                                  // 62
          }                                                                                                            //
        });                                                                                                            //
      })();                                                                                                            //
    }                                                                                                                  //
                                                                                                                       //
    var identityIds = SandstormDb.getUserIdentityIds(globalDb.getUser(this.userId));                                   // 67
    return [UserActions.find({ userId: this.userId }), Grains.find({ userId: this.userId }), ApiTokens.find({ "owner.user.identityId": { $in: identityIds } })];
  } else {                                                                                                             //
    return [];                                                                                                         // 74
  }                                                                                                                    //
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("sessions", function (sessionId) {                                                                      // 78
  // sessionId itself should be secret enough, but they are also not meant to be shared, so as                         //
  // a backup we only publish the session to its owner. Note that `userId` can be null if the                          //
  // user is not logged in or is using incognito mode.                                                                 //
  check(sessionId, String);                                                                                            // 82
  return Sessions.find({ _id: sessionId, $or: [{ userId: this.userId }, { userId: null }] });                          // 83
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("devPackages", function () {                                                                            // 86
  return DevPackages.find();                                                                                           // 87
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("notifications", function () {                                                                          // 90
  return Notifications.find({ userId: this.userId }, { fields: { timestamp: 1, text: 1, grainId: 1, userId: 1, isUnread: 1, appUpdates: 1,
      admin: 1, referral: 1, mailingListBonus: 1 } });                                                                 // 93
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("notificationGrains", function (notificationIds) {                                                      // 96
  // Since publishes can't be reactive, we leave it to the client to subscribe to both                                 //
  // "notifications" and "notificationGrains" reactively.                                                              //
  check(notificationIds, [String]);                                                                                    // 99
  var notifications = Notifications.find({                                                                             // 100
    _id: { $in: notificationIds },                                                                                     // 101
    userId: this.userId                                                                                                // 102
  }, {                                                                                                                 //
    fields: { grainId: 1 }                                                                                             // 104
  });                                                                                                                  //
                                                                                                                       //
  var grainIds = notifications.map(function (row) {                                                                    // 107
    return row.grainId;                                                                                                // 108
  });                                                                                                                  //
                                                                                                                       //
  return Grains.find({ _id: { $in: grainIds } }, { fields: { title: 1 } });                                            // 111
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("hasUsers", function () {                                                                               // 114
  var _this2 = this;                                                                                                   //
                                                                                                                       //
  // Publish pseudo-collection which tells the client if there are any users at all.                                   //
  //                                                                                                                   //
  // TODO(cleanup):  This seems overcomplicated.  Does Meteor have a better way?                                       //
  var cursor = Meteor.users.find();                                                                                    // 118
  if (cursor.count() > 0) {                                                                                            // 119
    this.added("hasUsers", "hasUsers", { hasUsers: true });                                                            // 120
  } else {                                                                                                             //
    (function () {                                                                                                     //
      var handle = cursor.observeChanges({                                                                             // 122
        added: function () {                                                                                           // 123
          function added(id) {                                                                                         // 123
            _this2.added("hasUsers", "hasUsers", { hasUsers: true });                                                  // 124
            handle.stop();                                                                                             // 125
            handle = null;                                                                                             // 126
          }                                                                                                            //
                                                                                                                       //
          return added;                                                                                                //
        }()                                                                                                            //
      });                                                                                                              //
      _this2.onStop(function () {                                                                                      // 129
        if (handle) handle.stop();                                                                                     // 130
      });                                                                                                              //
    })();                                                                                                              //
  }                                                                                                                    //
                                                                                                                       //
  this.ready();                                                                                                        // 134
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("referralInfoPseudo", function () {                                                                     // 137
  var _this3 = this;                                                                                                   //
                                                                                                                       //
  // This publishes a pseudo-collection called referralInfo whose documents have the following                         //
  // form:                                                                                                             //
  //                                                                                                                   //
  // - id: (String) same as the User._id of an identity this user has referred                                         //
  // - name: (String) the profile.name from that identity                                                              //
  // - completed: (Boolean) if this referral is complete                                                               //
                                                                                                                       //
  //  If the user is not logged in, then we have no referralInfo.                                                      //
  if (!this.userId) {                                                                                                  // 146
    return [];                                                                                                         // 147
  }                                                                                                                    //
                                                                                                                       //
  // Implementation note:                                                                                              //
  //                                                                                                                   //
  // This pseudo-collection is populated very differently for (1) the completed: false case versus                     //
  // the (2) completed: true case.                                                                                     //
                                                                                                                       //
  // Case 1. Publish information about not-yet-complete referrals.                                                     //
  var notCompletedReferralIdentitiesCursor = Meteor.users.find({                                                       // 137
    referredBy: this.userId,                                                                                           // 157
    "profile.name": { $exists: true }                                                                                  // 158
  }, {                                                                                                                 //
    fields: {                                                                                                          // 160
      _id: 1,                                                                                                          // 161
      referredBy: 1,                                                                                                   // 162
      "profile.name": 1                                                                                                // 163
    }                                                                                                                  //
  });                                                                                                                  //
  var notCompletedReferralIdentitiesHandle = notCompletedReferralIdentitiesCursor.observeChanges({                     // 166
    // The added function gets called with the id of Bob when Alice refers Bob.                                        //
    added: function () {                                                                                               // 168
      function added(id, fields) {                                                                                     // 168
        _this3.added("referralInfo", id, { name: fields.profile.name, completed: false });                             // 169
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
    // The removed function gets called when Bob is no longer an uncompleted referral.  Note that                      //
    // this will get more complicated once we support sending completed referrals to the client.                       //
    removed: function () {                                                                                             // 173
      function removed(id) {                                                                                           // 173
        _this3.removed("referralInfo", id);                                                                            // 174
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }(),                                                                                                               //
    // The modified function gets called when Bob's profile.name changed.                                              //
    modified: function () {                                                                                            // 177
      function modified(id, fields) {                                                                                  // 177
        _this3.modified("referralInfo", id, { name: fields.profile.name, completed: false });                          // 178
      }                                                                                                                //
                                                                                                                       //
      return modified;                                                                                                 //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  // Case 2. Handle completed referrals.                                                                               //
  //                                                                                                                   //
  // - Do a query for the current list of completed identities.                                                        //
  //                                                                                                                   //
  // - Every time we see a new such identity, we create a query that watches that one identity in                      //
  //   case its profile.name changes.                                                                                  //
  //                                                                                                                   //
  // - Also watch the first query, since the list of completed identities might change.                                //
  var handleForProfileNameByIdentityId = {};                                                                           // 137
  var stopWatchingAllIdentities = function stopWatchingAllIdentities() {                                               // 191
    Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                      // 192
      stopWatchingIdentity(identityId);                                                                                // 193
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  var stopWatchingIdentity = function stopWatchingIdentity(identityId) {                                               // 197
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 198
    if (handleForProfileName) {                                                                                        // 199
      _this3.removed("referralInfo", identityId);                                                                      // 200
      handleForProfileName.stop();                                                                                     // 201
      // delete is safe because we iterate across `Object.keys()` which returns a copy.                                //
      delete handleForProfileNameByIdentityId[identityId];                                                             // 199
    }                                                                                                                  //
  };                                                                                                                   //
                                                                                                                       //
  var watchIdentityAndPublishReferralSuccess = function watchIdentityAndPublishReferralSuccess(identityId) {           // 207
    var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                           // 208
    if (handleForProfileName) {                                                                                        // 209
      return;                                                                                                          // 210
    }                                                                                                                  //
                                                                                                                       //
    handleForProfileName = Meteor.users.find({                                                                         // 213
      _id: identityId                                                                                                  // 214
    }, {                                                                                                               //
      fields: {                                                                                                        // 216
        "profile.name": 1                                                                                              // 217
      }                                                                                                                //
    }).observeChanges({                                                                                                //
      added: function () {                                                                                             // 220
        function added(id, fields) {                                                                                   // 220
          _this3.added("referralInfo", id, { name: fields.profile.name, completed: true });                            // 221
        }                                                                                                              //
                                                                                                                       //
        return added;                                                                                                  //
      }(),                                                                                                             //
                                                                                                                       //
      changed: function () {                                                                                           // 224
        function changed(id, fields) {                                                                                 // 224
          _this3.changed("referralInfo", id, { name: fields.profile.name, completed: true });                          // 225
        }                                                                                                              //
                                                                                                                       //
        return changed;                                                                                                //
      }(),                                                                                                             //
                                                                                                                       //
      removed: function () {                                                                                           // 228
        function removed(id) {                                                                                         // 228
          stopWatchingIdentity(id);                                                                                    // 229
        }                                                                                                              //
                                                                                                                       //
        return removed;                                                                                                //
      }()                                                                                                              //
    });                                                                                                                //
                                                                                                                       //
    handleForProfileNameByIdentityId[identityId] = handleForProfileName;                                               // 233
  };                                                                                                                   //
                                                                                                                       //
  var completedIdentityIdsHandle = Meteor.users.find({                                                                 // 236
    _id: this.userId,                                                                                                  // 237
    referredIdentityIds: { $exists: true }                                                                             // 238
  }, {                                                                                                                 //
    fields: {                                                                                                          // 240
      referredIdentityIds: true                                                                                        // 241
    }                                                                                                                  //
  }).observeChanges({                                                                                                  //
    // `added` gets called when a user gets their first completed referral.                                            //
    added: function () {                                                                                               // 245
      function added(id, fields) {                                                                                     // 245
        for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                  // 246
          // Unconditionally mark these as successful referrals and start watching.                                    //
          watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                       // 248
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return added;                                                                                                    //
    }(),                                                                                                               //
    // `changed` gets called when a user adds/removes referredIdentityIds, usually when a                              //
    // referral becomes complete.                                                                                      //
    changed: function () {                                                                                             // 254
      function changed(id, fields) {                                                                                   // 254
        // Two major tasks.                                                                                            //
        //                                                                                                             //
        // 1. Look for identityIds to unsubscribe from & send removed notices to the client.                           //
        //                                                                                                             //
        // 2. Look for identityIds to subscribe to.                                                                    //
                                                                                                                       //
        // Task 1. Unsubscribe where needed.                                                                           //
        var referredIdentityIdsAsObject = {};                                                                          // 262
        fields.referredIdentityIds.forEach(function (i) {                                                              // 263
          referredIdentityIdsAsObject[i] = true;                                                                       // 263
        });                                                                                                            //
                                                                                                                       //
        Object.keys(handleForProfileNameByIdentityId).forEach(function (identityId) {                                  // 265
          // If the handle doesn't show up in the new list of referredIdentityIds, then remove                         //
          // info from the client & stop it on the server & make it null.                                              //
          var handleForProfileName = handleForProfileNameByIdentityId[identityId];                                     // 268
          if (referredIdentityIdsAsObject.hasOwnProperty(identityId)) {                                                // 269
            stopWatchingIdentity(identityId);                                                                          // 270
          }                                                                                                            //
        });                                                                                                            //
                                                                                                                       //
        // Task 2. Subscribe where needed.                                                                             //
        for (var i = 0; i < fields.referredIdentityIds.length; i++) {                                                  // 254
          // The watch... function will avoid double-creating subscriptions, so this is safe.                          //
          watchIdentityAndPublishReferralSuccess(fields.referredIdentityIds[i]);                                       // 277
        }                                                                                                              //
      }                                                                                                                //
                                                                                                                       //
      return changed;                                                                                                  //
    }(),                                                                                                               //
    // `removed` gets called when a User suddenly has no referredIdentityIds.                                          //
    removed: function () {                                                                                             // 281
      function removed() {                                                                                             // 281
        // Remove all data from client; stop all handles.                                                              //
        stopWatchingAllIdentities();                                                                                   // 283
      }                                                                                                                //
                                                                                                                       //
      return removed;                                                                                                  //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  // With cases 1 and 2 handled, register a cleanup function, then declare victory.                                    //
  this.onStop(function () {                                                                                            // 137
    stopWatchingAllIdentities();                                                                                       // 289
    notCompletedReferralIdentitiesHandle.stop();                                                                       // 290
    completedIdentityIdsHandle.stop();                                                                                 // 291
  });                                                                                                                  //
                                                                                                                       //
  this.ready();                                                                                                        // 294
});                                                                                                                    //
                                                                                                                       //
Meteor.publish("backers", function () {                                                                                // 297
  var _this4 = this;                                                                                                   //
                                                                                                                       //
  var backers = Assets.getText("backers.txt");                                                                         // 298
  var anonCount = 0;                                                                                                   // 299
  var counter = 0;                                                                                                     // 300
                                                                                                                       //
  backers.split("\n").forEach(function (name) {                                                                        // 302
    name = name.trim();                                                                                                // 303
    if (name === "") {                                                                                                 // 304
      ++anonCount;                                                                                                     // 305
    } else {                                                                                                           //
      _this4.added("backers", counter++, { name: name });                                                              // 307
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  // Text file ends in \n but that shouldn't count.                                                                    //
  --anonCount;                                                                                                         // 297
                                                                                                                       //
  this.added("backers", "anonymous", { count: anonCount - 1 });                                                        // 314
                                                                                                                       //
  this.ready();                                                                                                        // 316
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"signup-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/signup-server.js                                                                                             //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file covers creation and consumption of invite keys (i.e. to invite people to become                           //
// users of the Sandstorm server).                                                                                     //
                                                                                                                       //
Meteor.publish("signupKey", function (key) {                                                                           // 20
  check(key, String);                                                                                                  // 21
  return SignupKeys.find(key);                                                                                         // 22
});                                                                                                                    //
                                                                                                                       //
Meteor.methods({                                                                                                       // 25
  useSignupKey: function () {                                                                                          // 26
    function useSignupKey(key) {                                                                                       // 26
      check(key, String);                                                                                              // 27
                                                                                                                       //
      if (!this.userId) {                                                                                              // 29
        throw new Meteor.Error(403, "Must be signed in.");                                                             // 30
      }                                                                                                                //
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 33
      if (user.signupKey) {                                                                                            // 34
        // Don't waste it.                                                                                             //
        return;                                                                                                        // 36
      }                                                                                                                //
                                                                                                                       //
      if (isDemoUser()) {                                                                                              // 39
        throw new Meteor.Error(403, "Demo users cannot accept invite keys. Please sign in as a real user.");           // 40
      }                                                                                                                //
                                                                                                                       //
      if (!user.loginIdentities) {                                                                                     // 44
        // Don't consume signup key as identity user.                                                                  //
        return;                                                                                                        // 46
      }                                                                                                                //
                                                                                                                       //
      var keyInfo = SignupKeys.findOne(key);                                                                           // 49
      if (!keyInfo || keyInfo.used) {                                                                                  // 50
        throw new Meteor.Error(403, "Invalid key or already used.");                                                   // 51
      }                                                                                                                //
                                                                                                                       //
      if (isSignedUp() && user.payments && user.payments.id) {                                                         // 54
        // This user is already signed up with a payment account. Possibly, they signed up before                      //
        // using their invite, and then went back and clicked on the invite. As a result they                          //
        // probably now have two payment accounts. Mark this invite as used but also add a special                     //
        // flag so we can find it later and cancel the dupe payment account. Record who tried to                       //
        // use it so that we can transfer credits over if needed.                                                      //
        SignupKeys.update(key, { $set: { used: true, rejectedBy: this.userId } });                                     // 60
        return;                                                                                                        // 61
      }                                                                                                                //
                                                                                                                       //
      var userFields = {                                                                                               // 64
        signupKey: key,                                                                                                // 65
        signupNote: keyInfo.note                                                                                       // 66
      };                                                                                                               //
      if (keyInfo.email) {                                                                                             // 68
        userFields.signupEmail = keyInfo.email;                                                                        // 69
      }                                                                                                                //
                                                                                                                       //
      if ("quota" in keyInfo) {                                                                                        // 72
        userFields.quota = keyInfo.quota;                                                                              // 73
      }                                                                                                                //
                                                                                                                       //
      if (keyInfo.plan) {                                                                                              // 76
        userFields.plan = keyInfo.plan;                                                                                // 77
      }                                                                                                                //
                                                                                                                       //
      if (keyInfo.payments) {                                                                                          // 80
        userFields["payments.id"] = keyInfo.payments.id;                                                               // 81
      }                                                                                                                //
                                                                                                                       //
      Meteor.users.update(this.userId, { $set: userFields });                                                          // 84
      SignupKeys.update(key, { $set: { used: true } });                                                                // 85
    }                                                                                                                  //
                                                                                                                       //
    return useSignupKey;                                                                                               //
  }()                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"startup.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/startup.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file is for various startup code that doesn't fit neatly anywhere else                                         //
                                                                                                                       //
var ROOT_URL = process.env.ROOT_URL;                                                                                   // 19
                                                                                                                       //
Meteor.startup(function () {                                                                                           // 21
  var baseUrlRow = Misc.findOne({ _id: "BASE_URL" });                                                                  // 22
                                                                                                                       //
  if (!baseUrlRow) {                                                                                                   // 24
    // Fill data with current value in the case this is a first run                                                    //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 26
    Misc.insert(baseUrlRow);                                                                                           // 27
  } else if (baseUrlRow.value !== ROOT_URL) {                                                                          //
    console.log("resetting oauth");                                                                                    // 29
    Settings.find({ _id: { $in: ["google", "github"] } }).forEach(function (setting) {                                 // 30
      if (!!setting.value) {                                                                                           // 31
        Settings.update({ _id: setting._id }, { $set: { value: false,                                                  // 32
            automaticallyReset: { baseUrlChangedFrom: baseUrlRow.value } } });                                         // 34
      }                                                                                                                //
    });                                                                                                                //
    baseUrlRow = { _id: "BASE_URL", value: ROOT_URL };                                                                 // 37
    Misc.update({ _id: "BASE_URL" }, { $set: { value: ROOT_URL } });                                                   // 38
  }                                                                                                                    //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"stats-server.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// server/stats-server.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var DAY_MS = 24 * 60 * 60 * 1000;                                                                                      // 17
                                                                                                                       //
if (Mongo.Collection.prototype.aggregate) {                                                                            // 19
  throw new Error("Looks like Meteor wrapped the Collection.aggregate() call. Make sure it " + "works then delete our own wrapper.");
}                                                                                                                      //
                                                                                                                       //
Mongo.Collection.prototype.aggregate = function () {                                                                   // 24
  // Meteor doesn't wrapp Mongo's aggregate() method.                                                                  //
  var raw = this.rawCollection();                                                                                      // 26
  return Meteor.wrapAsync(raw.aggregate, raw).apply(raw, arguments);                                                   // 27
};                                                                                                                     //
                                                                                                                       //
computeStats = function computeStats(since) {                                                                          // 30
  // We'll need this for a variety of queries.                                                                         //
  var timeConstraint = { $gt: since };                                                                                 // 32
                                                                                                                       //
  // This calculates the number of user accounts that have been used                                                   //
  // during the requested time period.                                                                                 //
  var currentlyActiveUsersCount = Meteor.users.find({ expires: { $exists: false }, loginIdentities: { $exists: true },
    lastActive: timeConstraint }).count();                                                                             // 38
                                                                                                                       //
  // This calculates the number of grains that have been used during                                                   //
  // the requested time period.                                                                                        //
  var activeGrainsCount = Grains.find({ lastUsed: timeConstraint }).count();                                           // 30
                                                                                                                       //
  // If Meteor.settings.allowDemoAccounts is true, DeleteStats                                                         //
  // contains records of type `user` and `appDemoUser`, indicating                                                     //
  // the number of those types of accounts that were created and                                                       //
  // then auto-expired through the demo mode's auto-account-expiry.                                                    //
  var deletedDemoUsersCount = DeleteStats.find({ type: "demoUser", lastActive: timeConstraint }).count();              // 30
  var deletedAppDemoUsersCount = DeleteStats.find({ type: "appDemoUser", lastActive: timeConstraint }).count();        // 50
                                                                                                                       //
  // Similarly, if the demo is enabled, we auto-delete grains; we store that                                           //
  // fact in DeleteStats with type: "grain".                                                                           //
  var deletedGrainsCount = DeleteStats.find({ type: "grain", lastActive: timeConstraint }).count();                    // 30
                                                                                                                       //
  var apps = Grains.aggregate([{ $match: { lastUsed: timeConstraint } }, { $group: {                                   // 58
      _id: "$appId",                                                                                                   // 61
      grains: { $sum: 1 },                                                                                             // 62
      userIds: { $addToSet: "$userId" }                                                                                // 63
    }                                                                                                                  //
  }, { $project: {                                                                                                     //
      grains: 1,                                                                                                       // 67
      owners: { $size: "$userIds" }                                                                                    // 68
    }                                                                                                                  //
  }]);                                                                                                                 //
  apps = _.indexBy(apps, "_id");                                                                                       // 72
                                                                                                                       //
  for (var appId in meteorBabelHelpers.sanitizeForInObject(apps)) {                                                    // 74
    // We need to count ApiTokens, which don't have appId denormalized into them. We therefore                         //
    // have to fetch a list of grainIds first.                                                                         //
    // TODO(perf): If stats are getting slow, denormalize appId into ApiTokens. Note that it is                        //
    //   already denormalized for the specific case of apps that don't have icons, but the data                        //
    //   for that use case is NOT safe to use here because it's intended that we might allow an                        //
    //   app to mimic another app's icon by spoofing that app ID. In other words, the existing                         //
    //   denormalization of appId should be considered "app ID for identicon purposes only". We'll                     //
    //   need to add a new denormalization for stats purposes -- and make sure that it is not                          //
    //   revealed to the user.                                                                                         //
    var app = apps[appId];                                                                                             // 84
    delete app._id;                                                                                                    // 85
    var grains = Grains.find({                                                                                         // 86
      lastUsed: timeConstraint,                                                                                        // 87
      appId: appId                                                                                                     // 88
    }, {                                                                                                               //
      fields: { _id: 1 }                                                                                               // 90
    }).fetch();                                                                                                        //
    var grainIds = _.pluck(grains, "_id");                                                                             // 92
                                                                                                                       //
    var counts = ApiTokens.aggregate([{ $match: {                                                                      // 94
        "owner.user.lastUsed": timeConstraint,                                                                         // 96
        grainId: { $in: grainIds }                                                                                     // 97
      }                                                                                                                //
    }, { $group: { _id: "$owner.user.identityId" } }, { $group: {                                                      //
        _id: "count",                                                                                                  // 102
        count: { $sum: 1 }                                                                                             // 103
      }                                                                                                                //
    }]);                                                                                                               //
                                                                                                                       //
    if (counts.length > 0) {                                                                                           // 108
      if (counts.length !== 1) {                                                                                       // 109
        console.error("error: sharedUsers aggregation returned multiple rows");                                        // 110
      }                                                                                                                //
                                                                                                                       //
      app.sharedUsers = counts[0].count;                                                                               // 113
    }                                                                                                                  //
  }                                                                                                                    //
                                                                                                                       //
  // Count per-app appdemo users and deleted grains.                                                                   //
  DeleteStats.aggregate([{ $match: {                                                                                   // 30
      lastActive: timeConstraint,                                                                                      // 120
      appId: { $exists: true }                                                                                         // 121
    }                                                                                                                  //
  }, { $group: {                                                                                                       //
      _id: {                                                                                                           // 125
        appId: "$appId",                                                                                               // 126
        type: "$type"                                                                                                  // 127
      },                                                                                                               //
      count: { $sum: 1 }                                                                                               // 129
    }                                                                                                                  //
  }]).forEach(function (deletion) {                                                                                    //
    var app = apps[deletion._id.appId];                                                                                // 133
    if (!app) {                                                                                                        // 134
      app = apps[deletion.appId] = {};                                                                                 // 135
    }                                                                                                                  //
                                                                                                                       //
    if (deletion._id.type === "appDemoUser") {                                                                         // 138
      app.appDemoUsers = deletion.count;                                                                               // 139
    } else if (deletion._id.type === "grain") {                                                                        //
      app.deleted = deletion.count;                                                                                    // 141
    } else if (deletion._id.type === "demoGrain") {                                                                    //
      app.demoed = deletion.count;                                                                                     // 143
    }                                                                                                                  //
  });                                                                                                                  //
                                                                                                                       //
  return {                                                                                                             // 147
    activeUsers: currentlyActiveUsersCount,                                                                            // 148
    demoUsers: deletedDemoUsersCount,                                                                                  // 149
    appDemoUsers: deletedAppDemoUsersCount,                                                                            // 150
    activeGrains: activeGrainsCount + deletedGrainsCount,                                                              // 151
    apps: apps                                                                                                         // 152
  };                                                                                                                   //
};                                                                                                                     //
                                                                                                                       //
function recordStats() {                                                                                               // 156
  var now = new Date();                                                                                                // 157
                                                                                                                       //
  var planStats = _.countBy(Meteor.users.find({ expires: { $exists: false }, "payments.id": { $exists: true } }, { fields: { plan: 1 } }).fetch(), "plan");
                                                                                                                       //
  var record = {                                                                                                       // 165
    timestamp: now,                                                                                                    // 166
    daily: computeStats(new Date(now.getTime() - DAY_MS)),                                                             // 167
    weekly: computeStats(new Date(now.getTime() - 7 * DAY_MS)),                                                        // 168
    monthly: computeStats(new Date(now.getTime() - 30 * DAY_MS)),                                                      // 169
    forever: computeStats(new Date(0)),                                                                                // 170
    plans: planStats                                                                                                   // 171
  };                                                                                                                   //
  record.computeTime = Date.now() - now;                                                                               // 173
                                                                                                                       //
  ActivityStats.insert(record);                                                                                        // 175
  var age = ActivityStats.find().count();                                                                              // 176
  if (age > 3) {                                                                                                       // 177
    var reportSetting = Settings.findOne({ _id: "reportStats" });                                                      // 178
    if (!reportSetting) {                                                                                              // 179
      // Setting not set yet, send out notifications and set it to false                                               //
      globalDb.sendAdminNotification("You can help Sandstorm by sending us some anonymous " + "usage stats. Click here for more info.", "/admin/stats");
      Settings.insert({ _id: "reportStats", value: "unset" });                                                         // 183
    } else if (reportSetting.value === true) {                                                                         //
      // The stats page which the user agreed we can send actually displays the whole history                          //
      // of the server, but we're only sending stats from the last day. Let's also throw in the                        //
      // length of said history. This is still strictly less information than what the user said                       //
      // we're allowed to send.                                                                                        //
      record.serverAge = age;                                                                                          // 189
                                                                                                                       //
      HTTP.post("https://alpha-api.sandstorm.io/data", {                                                               // 191
        data: record,                                                                                                  // 192
        headers: {                                                                                                     // 193
          Authorization: "Bearer aT-mGyNwsgwZBbZvd5FWr0Ma79O9IehI4NiEO94y_oR",                                         // 194
          "Content-Type": "application/json"                                                                           // 195
        }                                                                                                              //
      });                                                                                                              //
    }                                                                                                                  //
  }                                                                                                                    //
}                                                                                                                      //
                                                                                                                       //
if (!Meteor.settings.replicaNumber) {                                                                                  // 202
  // Wait until 10:00 UTC (2:00 PST / 5:00 EST), then start recording stats every 24 hours.                            //
  // (Only on the first replica to avoid conflicts.)                                                                   //
  Meteor.setTimeout(function () {                                                                                      // 205
    Meteor.setInterval(function () {                                                                                   // 206
      recordStats();                                                                                                   // 207
    }, DAY_MS);                                                                                                        //
                                                                                                                       //
    recordStats();                                                                                                     // 210
  }, DAY_MS - (Date.now() - 10 * 60 * 60 * 1000) % DAY_MS);                                                            //
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 213
    if (StatsTokens.find().count() === 0) {                                                                            // 214
      StatsTokens.remove({});                                                                                          // 215
      StatsTokens.insert({ _id: Random.id(22) });                                                                      // 216
    }                                                                                                                  //
  });                                                                                                                  //
}                                                                                                                      //
                                                                                                                       //
Meteor.methods({                                                                                                       // 221
  regenerateStatsToken: function () {                                                                                  // 222
    function regenerateStatsToken() {                                                                                  // 222
      if (!isAdmin()) {                                                                                                // 223
        throw new Meteor.Error(403, "Unauthorized", "User must be admin");                                             // 224
      }                                                                                                                //
                                                                                                                       //
      StatsTokens.remove({});                                                                                          // 227
      var token = StatsTokens.insert({ _id: Random.id(22) });                                                          // 228
      return token._id;                                                                                                // 229
    }                                                                                                                  //
                                                                                                                       //
    return regenerateStatsToken;                                                                                       //
  }()                                                                                                                  //
});                                                                                                                    //
                                                                                                                       //
Router.map(function () {                                                                                               // 233
  this.route("fetchStats", {                                                                                           // 234
    where: "server",                                                                                                   // 235
    path: "/fetchStats/:tokenId",                                                                                      // 236
    action: function () {                                                                                              // 237
      function action() {                                                                                              // 237
        var token = StatsTokens.findOne({ _id: this.params.tokenId });                                                 // 238
                                                                                                                       //
        if (!token) {                                                                                                  // 240
          this.response.writeHead(404, {                                                                               // 241
            "Content-Type": "text/plain"                                                                               // 242
          });                                                                                                          //
          this.response.write("Token not found");                                                                      // 244
          return this.response.end();                                                                                  // 245
        }                                                                                                              //
                                                                                                                       //
        try {                                                                                                          // 248
          var stats = ActivityStats.find().fetch();                                                                    // 249
          var statsString = JSON.stringify(stats);                                                                     // 250
                                                                                                                       //
          this.response.writeHead(200, {                                                                               // 252
            "Content-Type": "application/json"                                                                         // 253
          });                                                                                                          //
          this.response.write(statsString);                                                                            // 255
        } catch (error) {                                                                                              //
          console.error(error.stack);                                                                                  // 257
          this.response.writeHead(500, {                                                                               // 258
            "Content-Type": "text/plain"                                                                               // 259
          });                                                                                                          //
          this.response.write(error.stack);                                                                            // 261
        }                                                                                                              //
                                                                                                                       //
        return this.response.end();                                                                                    // 264
      }                                                                                                                //
                                                                                                                       //
      return action;                                                                                                   //
    }()                                                                                                                //
  });                                                                                                                  //
});                                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"lib":{"db-deprecated.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// lib/db-deprecated.js                                                                                                //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// This file imports symbols from the sandstorm-db package. New code should use SandstormDb                            //
// directly.                                                                                                           //
                                                                                                                       //
// TODO(cleanup): Over time, eliminate the use of each of these assignments by using `globalDb`                        //
//   directly. For collections, prefer to update SandstormDb to provide methods for querying the                       //
//   collection rather than use `globalDb.collections` directly. When code is moved into packages,                     //
//   the `globalDb` global should NOT go with it; the package should expect a SandstormDb to be                        //
//   passed in, thus allowing mocking the database for unit tests.                                                     //
                                                                                                                       //
globalDb = new SandstormDb();                                                                                          // 26
                                                                                                                       //
Packages = globalDb.collections.packages;                                                                              // 28
DevPackages = globalDb.collections.devPackages;                                                                        // 29
UserActions = globalDb.collections.userActions;                                                                        // 30
Grains = globalDb.collections.grains;                                                                                  // 31
Contacts = globalDb.collections.contacts;                                                                              // 32
Sessions = globalDb.collections.sessions;                                                                              // 33
SignupKeys = globalDb.collections.signupKeys;                                                                          // 34
ActivityStats = globalDb.collections.activityStats;                                                                    // 35
DeleteStats = globalDb.collections.deleteStats;                                                                        // 36
FileTokens = globalDb.collections.fileTokens;                                                                          // 37
ApiTokens = globalDb.collections.apiTokens;                                                                            // 38
Notifications = globalDb.collections.notifications;                                                                    // 39
StatsTokens = globalDb.collections.statsTokens;                                                                        // 40
Misc = globalDb.collections.misc;                                                                                      // 41
Settings = globalDb.collections.settings;                                                                              // 42
                                                                                                                       //
currentUserGrains = globalDb.currentUserGrains.bind(globalDb);                                                         // 44
isDemoUser = globalDb.isDemoUser.bind(globalDb);                                                                       // 45
isSignedUp = globalDb.isSignedUp.bind(globalDb);                                                                       // 46
isSignedUpOrDemo = globalDb.isSignedUpOrDemo.bind(globalDb);                                                           // 47
isUserOverQuota = globalDb.isUserOverQuota.bind(globalDb);                                                             // 48
isUserExcessivelyOverQuota = globalDb.isUserExcessivelyOverQuota.bind(globalDb);                                       // 49
isAdmin = globalDb.isAdmin.bind(globalDb);                                                                             // 50
isAdminById = globalDb.isAdminById.bind(globalDb);                                                                     // 51
findAdminUserForToken = globalDb.findAdminUserForToken.bind(globalDb);                                                 // 52
matchWildcardHost = globalDb.matchWildcardHost.bind(globalDb);                                                         // 53
makeWildcardHost = globalDb.makeWildcardHost.bind(globalDb);                                                           // 54
allowDevAccounts = globalDb.allowDevAccounts.bind(globalDb);                                                           // 55
roleAssignmentPattern = globalDb.roleAssignmentPattern;                                                                // 56
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 58
  getWildcardOrigin = globalDb.getWildcardOrigin.bind(globalDb);                                                       // 59
                                                                                                                       //
  Meteor.onConnection(function (connection) {                                                                          // 61
    // TODO(cleanup): This is the best way I've thought of so far to allow methods declared in                         //
    //   packages to actually use the DB, but it's pretty sad.                                                         //
    connection.sandstormDb = globalDb;                                                                                 // 64
  });                                                                                                                  //
  SandstormDb.periodicCleanup(5 * 60 * 1000, SandstormPermissions.cleanupSelfDestructing(globalDb));                   // 66
  SandstormDb.periodicCleanup(24 * 60 * 60 * 1000, function () {                                                       // 67
    SandstormAutoupdateApps.updateAppIndex(globalDb);                                                                  // 68
  });                                                                                                                  //
                                                                                                                       //
  Meteor.startup(function () {                                                                                         // 71
    globalDb.migrateToLatest();                                                                                        // 71
  });                                                                                                                  //
  LDAP_DEFAULTS.url = globalDb.getLdapUrl();                                                                           // 72
  LDAP_DEFAULTS.base = globalDb.getLdapBase();                                                                         // 73
}                                                                                                                      //
                                                                                                                       //
if (Meteor.isClient) {                                                                                                 // 76
  Session.setDefault("shrink-navbar", false);                                                                          // 77
  globalGrains = new GrainViewList(globalDb);                                                                          // 78
                                                                                                                       //
  // If Meteor._localStorage disappears, we'll have to write our own localStorage wrapper, I guess.                    //
  // Using window.localStorage is dangerous because it throws an exception if cookies are disabled.                    //
  Session.set("shrink-navbar", Meteor._localStorage.getItem("shrink-navbar") === "true");                              // 76
  globalTopbar = new SandstormTopbar(globalDb, {                                                                       // 83
    get: function () {                                                                                                 // 85
      function get() {                                                                                                 //
        return Session.get("topbar-expanded");                                                                         // 86
      }                                                                                                                //
                                                                                                                       //
      return get;                                                                                                      //
    }(),                                                                                                               //
    set: function () {                                                                                                 // 89
      function set(value) {                                                                                            //
        Session.set("topbar-expanded", value);                                                                         // 90
      }                                                                                                                //
                                                                                                                       //
      return set;                                                                                                      //
    }()                                                                                                                //
  }, globalGrains, {                                                                                                   //
    get: function () {                                                                                                 // 95
      function get() {                                                                                                 //
        return Session.get("shrink-navbar");                                                                           // 96
      }                                                                                                                //
                                                                                                                       //
      return get;                                                                                                      //
    }(),                                                                                                               //
    set: function () {                                                                                                 // 99
      function set(value) {                                                                                            //
        Meteor._localStorage.setItem("shrink-navbar", value);                                                          // 100
        Session.set("shrink-navbar", value);                                                                           // 101
      }                                                                                                                //
                                                                                                                       //
      return set;                                                                                                      //
    }()                                                                                                                //
  });                                                                                                                  //
                                                                                                                       //
  globalAccountsUi = new AccountsUi(globalDb);                                                                         // 105
                                                                                                                       //
  Template.registerHelper("globalTopbar", function () {                                                                // 107
    return globalTopbar;                                                                                               // 107
  });                                                                                                                  //
  Template.registerHelper("globalAccountsUi", function () {                                                            // 108
    return globalAccountsUi;                                                                                           // 108
  });                                                                                                                  //
} else {                                                                                                               //
  // TODO(cleanup): Refactor accounts registration stuff so that this doesn't need to be defined                       //
  //   at all on the server.                                                                                           //
  globalAccountsUi = null;                                                                                             // 112
}                                                                                                                      //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"demo.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// lib/demo.js                                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
// Used in both client/demo.js and server/demo.js, as well as install.js                                               //
allowDemo = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDemoAccounts;               // 18
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}},"shared":{"admin.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/admin.js                                                                                                     //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
function serviceEnabled(name) {                                                                                        // 17
  var setting = Settings.findOne({ _id: name });                                                                       // 18
  return setting && !!setting.value;                                                                                   // 19
}                                                                                                                      //
                                                                                                                       //
Accounts.identityServices.github = {                                                                                   // 22
  isEnabled: function () {                                                                                             // 23
    function isEnabled() {                                                                                             // 23
      return serviceEnabled("github");                                                                                 // 24
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 27
    function getLoginId(identity) {                                                                                    // 27
      return identity.services.github.username;                                                                        // 28
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 31
    function initiateLogin(loginId) {                                                                                  // 31
      Meteor.loginWithGithub();                                                                                        // 32
      return { oneClick: true };                                                                                       // 33
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 36
    name: "oauthLoginButton",                                                                                          // 37
    priority: 1,                                                                                                       // 38
    data: {                                                                                                            // 39
      method: "loginWithGithub",                                                                                       // 40
      name: "github",                                                                                                  // 41
      displayName: "GitHub",                                                                                           // 42
      linkingNewIdentity: false                                                                                        // 43
    }                                                                                                                  //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Accounts.identityServices.google = {                                                                                   // 48
  isEnabled: function () {                                                                                             // 49
    function isEnabled() {                                                                                             // 49
      return serviceEnabled("google");                                                                                 // 50
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 53
    function getLoginId(identity) {                                                                                    // 53
      return identity.services.google.email;                                                                           // 54
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 57
    function initiateLogin(loginId) {                                                                                  // 57
      Meteor.loginWithGoogle({ loginHint: loginId });                                                                  // 58
      return { oneClick: true };                                                                                       // 59
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 62
    name: "oauthLoginButton",                                                                                          // 63
    priority: 2,                                                                                                       // 64
    data: {                                                                                                            // 65
      method: "loginWithGoogle",                                                                                       // 66
      name: "google",                                                                                                  // 67
      displayName: "Google",                                                                                           // 68
      linkingNewIdentity: false                                                                                        // 69
    }                                                                                                                  //
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Accounts.identityServices.email = {                                                                                    // 74
  isEnabled: function () {                                                                                             // 75
    function isEnabled() {                                                                                             // 75
      return serviceEnabled("emailToken");                                                                             // 76
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 79
    function getLoginId(identity) {                                                                                    // 79
      return identity.services.email.email;                                                                            // 80
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 83
    function initiateLogin(loginId) {                                                                                  // 83
      return { form: true };                                                                                           // 84
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 87
    name: "emailLoginForm",                                                                                            // 88
    priority: 10                                                                                                       // 89
  }                                                                                                                    //
};                                                                                                                     //
                                                                                                                       //
Accounts.identityServices.ldap = {                                                                                     // 93
  isEnabled: function () {                                                                                             // 94
    function isEnabled() {                                                                                             // 94
      return serviceEnabled("ldap") && globalDb.isFeatureKeyValid();                                                   // 95
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 98
    function getLoginId(identity) {                                                                                    // 98
      return identity.services.ldap.username;                                                                          // 99
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 102
    function initiateLogin(loginId) {                                                                                  // 102
      return { form: true };                                                                                           // 103
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 106
    name: "ldapLoginForm",                                                                                             // 107
    priority: 21 }                                                                                                     // 108
};                                                                                                                     //
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.saml = {                                                                                     // 112
  isEnabled: function () {                                                                                             // 113
    function isEnabled() {                                                                                             // 113
      return serviceEnabled("saml") && globalDb.isFeatureKeyValid();                                                   // 114
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 117
    function getLoginId(identity) {                                                                                    // 117
      return identity.services.saml.id;                                                                                // 118
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 121
    function initiateLogin(loginId) {                                                                                  // 121
      Meteor.loginWithSaml();                                                                                          // 122
      return { oneClick: true };                                                                                       // 123
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 126
    name: "samlLoginForm",                                                                                             // 127
    priority: 20 }                                                                                                     // 128
};                                                                                                                     //
                                                                                                                       //
// Put it at the bottom of the list.                                                                                   //
Accounts.identityServices.demo = {                                                                                     // 132
  isEnabled: function () {                                                                                             // 133
    function isEnabled() {                                                                                             // 133
      return false; // You can never authenticate as a demo user.                                                      // 134
    }                                                                                                                  // 133
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 137
    function getLoginId(identity) {                                                                                    // 137
      return identity._id;                                                                                             // 138
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 141
    function initiateLogin(loginId) {                                                                                  // 141
      return { demoCannotLogin: true };                                                                                // 142
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {}                                                                                                    // 145
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"dev-accounts.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/dev-accounts.js                                                                                              //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
Accounts.identityServices.dev = {                                                                                      // 17
  isEnabled: function () {                                                                                             // 18
    function isEnabled() {                                                                                             // 18
      return globalDb.allowDevAccounts();                                                                              // 19
    }                                                                                                                  //
                                                                                                                       //
    return isEnabled;                                                                                                  //
  }(),                                                                                                                 //
                                                                                                                       //
  getLoginId: function () {                                                                                            // 22
    function getLoginId(identity) {                                                                                    // 22
      return identity.services.dev.name;                                                                               // 23
    }                                                                                                                  //
                                                                                                                       //
    return getLoginId;                                                                                                 //
  }(),                                                                                                                 //
                                                                                                                       //
  initiateLogin: function () {                                                                                         // 26
    function initiateLogin(loginId) {                                                                                  // 26
      loginDevAccount(loginId);                                                                                        // 27
      return { oneClick: true };                                                                                       // 28
    }                                                                                                                  //
                                                                                                                       //
    return initiateLogin;                                                                                              //
  }(),                                                                                                                 //
                                                                                                                       //
  loginTemplate: {                                                                                                     // 31
    name: "devLoginForm",                                                                                              // 32
    priority: -10 }                                                                                                    // 33
};                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"install.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/install.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
isSafeDemoAppUrl = function () {                                                                                       // 17
    function isSafeDemoAppUrl(url) {                                                                                   // 17
        // For demo accounts, we allow using a bare hash with no URL (which will never upload a new app)               //
        // and we allow specifying a sandstorm.io URL.                                                                 //
        return !url || url.lastIndexOf("http://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://sandstorm.io/", 0) === 0 || url.lastIndexOf("https://alpha-j7uny7u376jnimcsx34c.sandstorm.io/", 0) === 0 || url.lastIndexOf("https://app-index.sandstorm.io/", 0) === 0;
    }                                                                                                                  //
                                                                                                                       //
    return isSafeDemoAppUrl;                                                                                           //
}();                                                                                                                   //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"testing.js":function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// shared/testing.js                                                                                                   //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                                  //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               //
// All rights reserved.                                                                                                //
//                                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                                     //
// you may not use this file except in compliance with the License.                                                    //
// You may obtain a copy of the License at                                                                             //
//                                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        //
//                                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            //
// See the License for the specific language governing permissions and                                                 //
// limitations under the License.                                                                                      //
                                                                                                                       //
var isTesting = Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].isTesting;                   // 17
                                                                                                                       //
// jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                                 //
if (isTesting) {                                                                                                       // 21
  if (Meteor.isServer) {                                                                                               // 22
    (function () {                                                                                                     //
      var clearUser = function clearUser(id) {                                                                         //
        UserActions.remove({ userId: id });                                                                            // 24
        globalDb.removeApiTokens({ userId: id });                                                                      // 25
        Grains.find({ userId: id }).forEach(function (grain) {                                                         // 26
          globalBackend.deleteGrain(grain._id);                                                                        // 27
        });                                                                                                            //
                                                                                                                       //
        Grains.remove({ userId: id });                                                                                 // 30
        Meteor.users.remove({ _id: id });                                                                              // 31
      };                                                                                                               //
                                                                                                                       //
      Meteor.methods({                                                                                                 // 34
        createMockGithubUser: function () {                                                                            // 35
          function createMockGithubUser() {                                                                            // 35
            Meteor.users.update({ _id: "Py8fwsaryQNGBuiXb" }, { $set: { createdAt: new Date("2014-08-11T21:44:04.147Z"), isAdmin: true, lastActive: new Date("2014-08-19T09:58:39.676Z"), profile: { name: "Github User" }, services: { github: { accessToken: "sometoken", id: 1595880, username: "testuser" }, resume: { loginTokens: [{ when: new Date("2099-08-13T05:16:02.356Z"), hashedToken: "GriUSDp+uN/K4HptwSl1wsdWfHEpS8c9KjjdqwKNo0k=" }] } }, signupKey: "admin" } }, { upsert: true });
          }                                                                                                            //
                                                                                                                       //
          return createMockGithubUser;                                                                                 //
        }(),                                                                                                           //
                                                                                                                       //
        clearMockGithubUser: function () {                                                                             // 41
          function clearMockGithubUser() {                                                                             // 41
            clearUser("Py8fwsaryQNGBuiXb");                                                                            // 42
          }                                                                                                            //
                                                                                                                       //
          return clearMockGithubUser;                                                                                  //
        }(),                                                                                                           //
                                                                                                                       //
        createMockGoogleUser: function () {                                                                            // 45
          function createMockGoogleUser() {                                                                            // 45
            Meteor.users.update({ _id: "6WJcRo2gg2Ysuxsok" }, { $set: { createdAt: new Date("2014-08-21T07:52:55.581Z"), profile: { name: "Google User" }, services: { google: { accessToken: "sometoken", expiresAt: 4562182723000, id: "116893057283177439912", verified_email: true, name: "Google User", given_name: "Google", family_name: "User", picture: "https://lh3.googleusercontent.com/-XdUIqdMkCWA/AAAAAAAAAAI/AAAAAAAAAAA/4252rscbv5M/photo.jpg", locale: "en", gender: "male" }, resume: { loginTokens: [{ when: new Date("2099-08-21T07:52:55.592Z"), hashedToken: "cbJGxLGKW3f0j7Ehit77hdK58W7xuPjzZhGHgKhyddo=" }] } }, signupKey: "admin" } }, { upsert: true });
          }                                                                                                            //
                                                                                                                       //
          return createMockGoogleUser;                                                                                 //
        }(),                                                                                                           //
                                                                                                                       //
        clearMockGoogleUser: function () {                                                                             // 51
          function clearMockGoogleUser() {                                                                             // 51
            clearUser("6WJcRo2gg2Ysuxsok");                                                                            // 52
          }                                                                                                            //
                                                                                                                       //
          return clearMockGoogleUser;                                                                                  //
        }()                                                                                                            //
      });                                                                                                              //
    })();                                                                                                              //
  }                                                                                                                    //
                                                                                                                       //
  mockLoginGithub = function mockLoginGithub() {                                                                       // 57
    Meteor.call("createMockGithubUser", function (err) {                                                               // 58
      if (err) {                                                                                                       // 59
        console.log(err);                                                                                              // 60
      }                                                                                                                //
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "F0S6luPxIJV--y_GAkBKOMuWMYnnqgG3UMv9M-DIs2f");                 // 63
      window.localStorage.setItem("Meteor.loginTokenExpires", "Mon Nov 10 2099 21:16:02 GMT-0800 (PST)");              // 64
      window.localStorage.setItem("Meteor.userId", "Py8fwsaryQNGBuiXb");                                               // 65
      window.location.reload();                                                                                        // 66
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  clearMockGithubUser = function clearMockGithubUser() {                                                               // 70
    Meteor.call("clearMockGithubUser", function (err) {                                                                // 71
      if (err) {                                                                                                       // 72
        console.log(err);                                                                                              // 73
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  mockLoginGoogle = function mockLoginGoogle() {                                                                       // 78
    Meteor.call("createMockGoogleUser", function (err) {                                                               // 79
      if (err) {                                                                                                       // 80
        console.log(err);                                                                                              // 81
      }                                                                                                                //
                                                                                                                       //
      window.localStorage.setItem("Meteor.loginToken", "P3ffUfVJtptyVX2IPUfNDZY0F3b-GIZ-WQf7w3GdL21");                 // 84
      window.localStorage.setItem("Meteor.loginTokenExpires", "Tue Nov 18 2099 23:52:55 GMT-0800 (PST)");              // 85
      window.localStorage.setItem("Meteor.userId", "6WJcRo2gg2Ysuxsok");                                               // 86
      window.location.reload();                                                                                        // 87
    });                                                                                                                //
  };                                                                                                                   //
                                                                                                                       //
  clearMockGoogleUser = function clearMockGoogleUser() {                                                               // 91
    Meteor.call("clearMockGoogleUser", function (err) {                                                                // 92
      if (err) {                                                                                                       // 93
        console.log(err);                                                                                              // 94
      }                                                                                                                //
    });                                                                                                                //
  };                                                                                                                   //
}                                                                                                                      //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}},{"extensions":[".js",".json"]});
require("./server/lib/constants.js");
require("./lib/db-deprecated.js");
require("./lib/demo.js");
require("./server/admin/system-status-server.js");
require("./server/drivers/external-ui-view.js");
require("./server/drivers/ip.js");
require("./server/drivers/mail.js");
require("./server/admin-server.js");
require("./server/backup.js");
require("./server/core.js");
require("./server/demo-server.js");
require("./server/dev-accounts-server.js");
require("./server/feature-key.js");
require("./server/grain-server.js");
require("./server/hack-session.js");
require("./server/install-server.js");
require("./server/installer.js");
require("./server/pre-meteor.js");
require("./server/proxy.js");
require("./server/sandcats.js");
require("./server/shell-server.js");
require("./server/signup-server.js");
require("./server/startup.js");
require("./server/stats-server.js");
require("./shared/admin.js");
require("./shared/dev-accounts.js");
require("./shared/install.js");
require("./shared/testing.js");
//# sourceMappingURL=app.js.map
