(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, ApiTokens, ApiHosts, Notifications, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, getUserQuota, isUserOverQuota, isUserExcessivelyOverQuota, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, allowDevAccounts, sendReferralProgramNotification, roleAssignmentPattern, SandstormDb, appName, addStaticAsset, userPictureUrl, fetchPicture;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-db/db.js                                                                                        //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                               //
                                                                                                                      //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                      //
                                                                                                                      //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                     //
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
// This file defines the database schema.                                                                             //
                                                                                                                      //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                        //
// query it makes, so you can see if it's doing queries too often, etc.                                               //
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                               // 21
  (function () {                                                                                                      //
    var oldFind = Mongo.Collection.prototype.find;                                                                    // 22
    Mongo.Collection.prototype.find = function () {                                                                   // 23
      console.log(this._prefix, arguments);                                                                           // 24
      return oldFind.apply(this, arguments);                                                                          // 25
    };                                                                                                                //
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                     //
if (Meteor.isServer) {                                                                                                // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                           // 31
} else {                                                                                                              //
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                    // 33
}                                                                                                                     //
                                                                                                                      //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                           //
                                                                                                                      //
// Users = new Mongo.Collection("users");                                                                             //
// The users collection is special and can be accessed through `Meteor.users`.                                        //
// See https://docs.meteor.com/#/full/meteor_users.                                                                   //
//                                                                                                                    //
// There are two distinct types of entries in the users collection: identities and accounts. An                       //
// identity contains personal profile information and typically includes some intrinsic method for                    //
// authenticating as the owner of that information.                                                                   //
//                                                                                                                    //
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                          //
// Each account can have multiple identities linked to it. To log in as an account you must first                     //
// authenticate as one of its linked identities.                                                                      //
//                                                                                                                    //
// Every user contains the following fields:                                                                          //
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                        //
//        stable SHA-256 ID of this identity, hex-encoded.                                                            //
//   createdAt: Date when this entry was added to the collection.                                                     //
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                               //
//   services: Object containing login data used by Meteor authentication services.                                   //
//   expires: Date when this user should be deleted. Only present for demo users.                                     //
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                       //
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                  //
//                     rather than as a Date object. We should fix that.                                              //
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                    //
//              link. This field contains the app ID of the app that the user started out demoing.                    //
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                     //
//              being a demo user.                                                                                    //
//                                                                                                                    //
// Identity users additionally contain the following fields:                                                          //
//   profile: Object containing the data that will be shared with users and grains that come into                     //
//            contact with this identity. Includes the following fields:                                              //
//       service: String containing the name of this identity's authentication method.                                //
//       name: String containing the chosen display name of the identity.                                             //
//       handle: String containing the identity's preferred handle.                                                   //
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                         //
//                an identicon will be used.                                                                          //
//       pronoun: One of "male", "female", "neutral", or "robot".                                                     //
//   unverifiedEmail: If present, a string containing an email address specified by the user.                         //
//   referredBy: ID of the Account that referred this Identity.                                                       //
//                                                                                                                    //
// Account users additionally contain the following fields:                                                           //
//   loginIdentities: Array of identity objects, each of which may include the following fields.                      //
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                            //
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                     //
//                       a separate array here so that we can use a Mongo index to enforce the                        //
//                       invariant that an identity only be a login identity for a single account.                    //
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                  //
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                       //
//                 to do this checking automatically.                                                                 //
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                 //
//   signupKey: If this is an invited user, then this field contains their signup key.                                //
//   signupNote: If the user was invited through a link, then this field contains the note that the                   //
//               inviter admin attached to the key.                                                                   //
//   signupEmail: If the user was invited by email, then this field contains the email address that                   //
//                the invite was sent to.                                                                             //
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                   //
//                       terms of service.                                                                            //
//   plan: _id of an entry in the Plans table which determines the user's quota.                                      //
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                      //
//              module writes data here; we merely read it. Missing fields should be treated as                       //
//              zeroes. Does not yet include referral bonus, which is calculated separately.                          //
//              TODO(cleanup): Use for referral bonus too.                                                            //
//   storageUsage: Number of bytes this user is currently storing.                                                    //
//   payments: Object defined by payments module, if loaded.                                                          //
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                //
//   accessRequests: Object containing the following fields; used to limit spam.                                      //
//       count: Number of "request access" emails during sent during the current interval.                            //
//       resetAt: Date when the count should be reset.                                                                //
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                             //
//                        stop writing new referredBy values onto Identities for this account.                        //
//   referredCompleteDate: The Date at which the completed referral occurred.                                         //
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                       //
//                        reliably determining which Identity's names are safe to display.                            //
//   experiments: Object where each field is an experiment that the user is in, and each value                        //
//           is the parameters for that experiment. Typically, the value simply names which                           //
//           experiment group which the user is in, where "control" is one group. If an experiment                    //
//           is not listed, then the user should not be considered at all for the purpose of that                     //
//           experiment. Each experiment may define a point in time where users not already in the                    //
//           experiment may be added to it and assigned to a group (for example, at user creation                     //
//           time). Current experiments:                                                                              //
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                        //
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                      //
//               test group will see a plan selection dialog and asked to make an explitic choice                     //
//               (possibly "free") before they can create grains (but not when opening someone                        //
//               else's shared grain). The goal of the experiment is to determine whether this                        //
//               prompt scares users away -- and also whether it increases paid signups.                              //
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                      //
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                             //
                                                                                                                      //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                             // 126
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                      // 127
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                   // 128
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                     // 129
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                             // 130
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                     // 131
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                     // 132
                                                                                                                      //
// TODO(cleanup): This index is obsolete; delete it.                                                                  //
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                          // 135
                                                                                                                      //
Packages = new Mongo.Collection("packages");                                                                          // 137
// Packages which are installed or downloading.                                                                       //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                   //
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                  //
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                               //
//       >1 = download byte count.                                                                                    //
//   error:  If status is "failed", error message string.                                                             //
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                         //
//   appId:  If status is "ready", the application ID string.  Packages representing different                        //
//       versions of the same app have the same appId.  The spk tool defines the app ID format                        //
//       and can cryptographically verify that a package belongs to a particular app ID.                              //
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                       //
//       collector should at some point check whether there are any other references and, if not,                     //
//       delete the package.                                                                                          //
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                        //
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                   //
//     even if it has no users.                                                                                       //
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                          //
//     packager.                                                                                                      //
                                                                                                                      //
DevPackages = new Mongo.Collection("devpackages");                                                                    // 159
// List of packages currently made available via the dev tools running on the local machine.                          //
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                    //
// on the local machine to publish an under-development app to this server. That should only ever                     //
// happen on developers' desktop machines.                                                                            //
//                                                                                                                    //
// While a dev package is published, it automatically appears as installed by every user of the                       //
// server, and it overrides all packages with the same application ID. If any instances of those                      //
// packages are currently open, they are killed and reset on publish.                                                 //
//                                                                                                                    //
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                    //
// are again killed and refreshed.                                                                                    //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  The package ID string (as with Packages._id).                                                              //
//   appId: The app ID this package is intended to override (as with Packages.appId).                                 //
//   timestamp:  Time when the package was last updated. If this changes while the package is                         //
//     published, all running instances are reset. This is used e.g. to reset the app each time                       //
//     changes are made to the source code.                                                                           //
//   manifest:  The app's manifest, as with Packages.manifest.                                                        //
                                                                                                                      //
UserActions = new Mongo.Collection("userActions");                                                                    // 180
// List of actions that each user has installed which create new grains.  Each app may install                        //
// some number of actions (usually, one).                                                                             //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  random                                                                                                     //
//   userId:  User who has installed this action.                                                                     //
//   packageId:  Package used to run this action.                                                                     //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                               //
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                //
//       that clients can access it without subscribing to the Packages collection.                                   //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                           //
//       searchability.                                                                                               //
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                              //
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                    //
//       `{defaultText: "New Spreadsheet"}`.                                                                          //
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                       //
//   command:  Manifest.Command to run this action (see package.capnp).                                               //
                                                                                                                      //
Grains = new Mongo.Collection("grains");                                                                              // 199
// Grains belonging to users.                                                                                         //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  random                                                                                                     //
//   packageId:  _id of the package of which this grain is an instance.                                               //
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                               //
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                           //
//       searchability.                                                                                               //
//   userId: The _id of the account that owns this grain.                                                             //
//   identityId: The identity with which the owning account prefers to open this grain.                               //
//   title:  Human-readable string title, as chosen by the user.                                                      //
//   lastUsed:  Date when the grain was last used by a user.                                                          //
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                   //
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                   //
//                   time a session to this grain was opened.                                                         //
//                                                                                                                    //
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                    //
// web publishing functionality without powerbox support; they will be replaced once the powerbox                     //
// is implemented.                                                                                                    //
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                    //
//       web publishing. This field is initialized when first requested by the app.                                   //
                                                                                                                      //
RoleAssignments = new Mongo.Collection("roleAssignments");                                                            // 222
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                   //
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                            //
// collection.                                                                                                        //
                                                                                                                      //
Contacts = new Mongo.Collection("contacts");                                                                          // 227
// Edges in the social graph.                                                                                         //
//                                                                                                                    //
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                        //
// will show up in her user-picker UI for actions like share-by-identity.                                             //
//                                                                                                                    //
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                       //
// Bob's.                                                                                                             //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id: random                                                                                                      //
//   ownerId: The accountId of the user account who owns this contact.                                                //
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                       //
//            the contact to the owner.                                                                               //
//   created: Date when this contact was created.                                                                     //
//   identityId: The `_id` of the user whose contact info this contains.                                              //
                                                                                                                      //
Sessions = new Mongo.Collection("sessions");                                                                          // 244
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                   //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  random                                                                                                     //
//   grainId:  _id of the grain to which this session is connected.                                                   //
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                    //
//       '*' in WILDCARD_HOST.                                                                                        //
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                        //
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                     //
//       have the same `tabId` as the outer session.                                                                  //
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                       //
//       period.                                                                                                      //
//   userId:  User ID of the user who owns this session.                                                              //
//   identityId:  Identity ID of the user who owns this session.                                                      //
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                     //
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                        //
//       anonymous users can get access without an API token and so neither userId nor hashedToken                    //
//       are present.                                                                                                 //
//   powerboxView: If present, this is a view that should be presented as part of a powerbox                          //
//       interaction.                                                                                                 //
//     offer: The webkey that corresponds to cap that was passed to the `offer` RPC.                                  //
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                    //
//       until newSession is called on the UiView.                                                                    //
//   permissions: The permissions for the current identity on this UiView. This isn't populated                       //
//       until newSession is called on the UiView.                                                                    //
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                  //
//       request                                                                                                      //
                                                                                                                      //
SignupKeys = new Mongo.Collection("signupKeys");                                                                      // 273
// Invite keys which may be used by users to get access to Sandstorm.                                                 //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:  random                                                                                                     //
//   used:  Boolean indicating whether this key has already been consumed.                                            //
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                         //
//   email: If this key was sent as an email invite, the email address to which it was sent.                          //
                                                                                                                      //
ActivityStats = new Mongo.Collection("activityStats");                                                                // 282
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                 //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   timestamp: Date when measurements were taken.                                                                    //
//   daily: Contains stats counts pertaining to the last day before the sample time.                                  //
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                          //
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                          //
//                                                                                                                    //
// Each of daily, weekly, and monthly contains:                                                                       //
//   activeUsers: The number of unique users who have used a grain on the server in the time                          //
//       interval. Only counts logged-in users.                                                                       //
//   demoUsers: Demo users.                                                                                           //
//   appDemoUsers: Users that came in through "app demo".                                                             //
//   activeGrains: The number of unique grains that have been used in the time interval.                              //
//   apps: An object indexed by app ID recording, for each app:                                                       //
//       owners: Number of unique owners of this app (counting only grains that still exist).                         //
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                   //
//         only grains that still exist).                                                                             //
//       grains: Number of active grains of this app (that still exist).                                              //
//       deleted: Number of non-demo grains of this app that were deleted.                                            //
//       demoed: Number of demo grains created and expired.                                                           //
//       appDemoUsers: Number of app demos initiated with this app.                                                   //
                                                                                                                      //
DeleteStats = new Mongo.Collection("deleteStats");                                                                    // 306
// Contains records of objects that were deleted, for stat-keeping purposes.                                          //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                            //
//   lastActive: Date of the user's or grain's last activity.                                                         //
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                    //
//     arrived to demo. For others, undefined.                                                                        //
                                                                                                                      //
FileTokens = new Mongo.Collection("fileTokens");                                                                      // 315
// Tokens corresponding to backup files that are currently stored on the server. A user receives                      //
// a token when they create a backup file (either by uploading it, or by backing up one of their                      //
// grains) and may use the token to read the file (either to download it, or to restore a new                         //
// grain from it).                                                                                                    //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       The unguessable token string.                                                                         //
//   name:      Suggested filename.                                                                                   //
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                       //
                                                                                                                      //
ApiTokens = new Mongo.Collection("apiTokens");                                                                        // 326
// Access tokens for APIs exported by apps.                                                                           //
//                                                                                                                    //
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                     //
// now they are also used to implement SturdyRefs, not just held by external users, but also when                     //
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                          //
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                        //
// `MainView`) -- the fields of type `Data` are API tokens.                                                           //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                          //
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                     //
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                      //
//              That is, the UiView's newSession() method will intersect the requested permissions                    //
//              with this identity's permissions before forwarding on to the underlying app. If                       //
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                    //
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                       //
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                    //
//              this is NOT the identity against which the `requiredPermissions` parameter of                         //
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                  //
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                   //
//              that created the token.                                                                               //
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                        //
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                   //
//              permissions will be intersected with those held by `identityId` when the view is                      //
//              opened.                                                                                               //
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                   //
//              anonymous rather than as directly associated with `identityId`. This has no effect                    //
//              on the permissions granted.                                                                           //
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                     //
//              the app or its supervisor (whereas without this it strictly represents UiView).                       //
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                     //
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                            //
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                              //
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                   //
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                   //
//              containing exactly one of the following fields:                                                       //
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                   //
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                          //
//                           `Notifications` collection.                                                              //
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                     //
//                  will be moved out of the frontend and into the backend, but we'll migrate the                     //
//                  database when that happens. This field contains the boolean true to signify that                  //
//                  it has been set.                                                                                  //
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                    //
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                          //
//                      value is an object containing the field `services`, which itself is a                         //
//                      list of names of identity providers that are trusted to verify addresses.                     //
//                      If `services` is omitted or falsy, all configured identity providers are                      //
//                      trusted. Note that a malicious user could specify invalid names in the                        //
//                      list; they should be ignored.                                                                 //
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                              //
//                      An object containing `verifierId`, `tabId`, and `address`.                                    //
//   parentToken: If present, then this token represents exactly the capability represented by                        //
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                   //
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                      //
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                      //
//              is set to the identity that shared the view, and `accountId` is set to the account                    //
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                            //
//              `parentToken` is present.                                                                             //
//   petname:   Human-readable label for this access token, useful for identifying tokens for                         //
//              revocation. This should be displayed when visualizing incoming capabilities to                        //
//              the grain identified by `grainId`.                                                                    //
//   created:   Date when this token was created.                                                                     //
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                   //
//              become un-revoked in the future.                                                                      //
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                    //
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                            //
//              as passed to the `save()` call that created this token. If not present, treat                         //
//              as `webkey` (the default for `ApiTokenOwner`).                                                        //
//   expiresIfUnused:                                                                                                 //
//              Optional Date after which the token, if it has not been used yet, expires.                            //
//              This field should be cleared on a token's first use.                                                  //
//   requirements: List of conditions which must hold for this token to be considered valid.                          //
//              Semantically, this list specifies the powers which were *used* to originally                          //
//              create the token. If any condition in the list becomes untrue, then the token must                    //
//              be considered revoked, and all live refs and sturdy refs obtained transitively                        //
//              through it must also become revoked. Each item is the JSON serialization of the                       //
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                        //
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                         //
//              cleaned up when the token is.                                                                         //
//                                                                                                                    //
// It is important to note that a token's owner and provider are independent from each other. To                      //
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                   //
//                                                                                                                    //
// struct ApiToken {                                                                                                  //
//   owner :ApiTokenOwner;                                                                                            //
//   provider :union {                                                                                                //
//     grain :group {                                                                                                 //
//       grainId :Text;                                                                                               //
//       union {                                                                                                      //
//         uiView :group {                                                                                            //
//           identityId :Text;                                                                                        //
//           roleAssignment :RoleAssignment;                                                                          //
//           forSharing :Bool;                                                                                        //
//         }                                                                                                          //
//         objectId :SupervisorObjectId;                                                                              //
//       }                                                                                                            //
//     }                                                                                                              //
//     frontendRef :union {                                                                                           //
//       notificationHandle :Text;                                                                                    //
//       ipNetwork :Bool;                                                                                             //
//       ipInterface :Bool;                                                                                           //
//       emailVerifier :group {                                                                                       //
//         services :List(String);                                                                                    //
//       }                                                                                                            //
//       verifiedEmail :group {                                                                                       //
//         verifierId :Text;                                                                                          //
//         tabId :Text;                                                                                               //
//         address :Text;                                                                                             //
//       }                                                                                                            //
//     }                                                                                                              //
//     child :group {                                                                                                 //
//       parentToken :Text;                                                                                           //
//       union {                                                                                                      //
//         uiView :group {                                                                                            //
//           grainId :Text;                                                                                           //
//           identityId :Text;                                                                                        //
//           roleAssignment :RoleAssignment = (allAccess = ());                                                       //
//         }                                                                                                          //
//         other :Void;                                                                                               //
//       }                                                                                                            //
//     }                                                                                                              //
//   }                                                                                                                //
//   requirements: List(Supervisor.MembraneRequirement);                                                              //
//   ...                                                                                                              //
// }                                                                                                                  //
                                                                                                                      //
ApiHosts = new Mongo.Collection("apiHosts");                                                                          // 454
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                   //
// mainly exists to allow backwards-compatibility with client applications that expect to be able                     //
// to probe an API host without authentication to determine capabilities such as DAV protocols                        //
// supported, before authenticating to perform real requests. An app can specify these properties                     //
// when creating an offerTemplate.                                                                                    //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                            //
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                    //
//                 up when ApiTokens are deleted.                                                                     //
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                         //
//                 This is an object containing fields:                                                               //
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                            //
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                //
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                       //
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                     //
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                         //
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                         //
//                 fields:                                                                                            //
//     type:       Content-Type.                                                                                      //
//     language:   Content-Language.                                                                                  //
//     encoding:   Content-Encoding.                                                                                  //
//     body:       Entity-body as a string or buffer.                                                                 //
                                                                                                                      //
Notifications = new Mongo.Collection("notifications");                                                                // 479
// Notifications for a user.                                                                                          //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:          random                                                                                             //
//   grainId:      The grain originating this notification, if any.                                                   //
//   userId:       The user receiving the notification.                                                               //
//   text:         The JSON-ified LocalizedText to display in the notification.                                       //
//   isUnread:     Boolean indicating if this notification is unread.                                                 //
//   timestamp:    Date when this notification was last updated                                                       //
//   ongoing:      If present, this is an ongoing notification, and this field contains an                            //
//                 ApiToken referencing the `OngoingNotification` capability.                                         //
//   admin:        If present, this is a notification intended for an admin.                                          //
//     action:     If present, this is a (string) link that the notification should direct the                        //
//                 admin to.                                                                                          //
//     type:       The type of notification (currently only "reportStats").                                           //
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                    //
//                 as keys.                                                                                           //
//     $appId:     The appId that has an outstanding update.                                                          //
//       packageId: The packageId that it will update to.                                                             //
//       name: The name of the app. (appTitle from package.manifest)                                                  //
//       version: The app's version number. (appVersion from package.manifest)                                        //
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)          //
//   referral:     If this boolean field is true, then treat this notification as a referral                          //
//                 notification. This causes text to be ignored, since we need custom logic.                          //
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                     //
//                 a one-time notification only to Oasis users who existed when the bonus program                     //
//                 was implemented.                                                                                   //
                                                                                                                      //
StatsTokens = new Mongo.Collection("statsTokens");                                                                    // 508
// Access tokens for the Stats collection                                                                             //
//                                                                                                                    //
// These tokens are used for accessing the ActivityStats collection remotely                                          //
// (ie. from a dashboard webapp)                                                                                      //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                 //
                                                                                                                      //
Misc = new Mongo.Collection("misc");                                                                                  // 517
// Miscellaneous configuration and other settings                                                                     //
//                                                                                                                    //
// This table is currently only used for persisting BASE_URL from one session to the next,                            //
// but in general any miscellaneous settings should go in here                                                        //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       The name of the setting. eg. "BASE_URL"                                                               //
//   value:     The value of the setting.                                                                             //
                                                                                                                      //
Settings = new Mongo.Collection("settings");                                                                          // 527
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                        //
// route. This collection differs from misc in that any admin user can update it through the admin                    //
// interface.                                                                                                         //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       The name of the setting. eg. "smtpConfig"                                                             //
//   value:     The value of the setting.                                                                             //
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                    //
//                       so, it will also write an object to this field indicating why the reset was                  //
//                       needed. That object can have the following variants:                                         //
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                     //
//                           with the old BASE_URL.                                                                   //
//                                                                                                                    //
//   potentially other fields that are unique to the setting                                                          //
                                                                                                                      //
Migrations = new Mongo.Collection("migrations");                                                                      // 543
// This table tracks which migrations we have applied to this instance.                                               //
// It contains a single entry:                                                                                        //
//   _id:       "migrations_applied"                                                                                  //
//   value:     The number of migrations this instance has successfully completed.                                    //
                                                                                                                      //
StaticAssets = new Mongo.Collection("staticAssets");                                                                  // 549
// Collection of static assets served up from the Sandstorm server's "static" host. We only                           //
// support relatively small assets: under 1MB each.                                                                   //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       Random ID; will be used in the URL.                                                                   //
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                           //
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                             //
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                   //
//   content:   The asset content (byte buffer).                                                                      //
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                   //
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                       //
//       to catch leaked assets, although it's probably not a big deal in practice.                                   //
                                                                                                                      //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens");                                                        // 563
// Collection of tokens representing a single-use permission to upload an asset, such as a new                        //
// profile picture.                                                                                                   //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id:       Random ID.                                                                                            //
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                //
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                         //
//           userId: User whose picture shall be replaced.                                                            //
//           identityId: Which of the user's identities shall be updated.                                             //
//   expires:   Time when this token will go away if unused.                                                          //
                                                                                                                      //
Plans = new Mongo.Collection("plans");                                                                                // 575
// Subscription plans, which determine quota.                                                                         //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                               //
//   storage: Number of bytes this user is allowed to store.                                                          //
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                         //
//   computeLabel: Label to display to the user describing this plan's compute units.                                 //
//   grains: Total number of grains this user can create (often `Infinity`).                                          //
//   price: Price per month in US cents.                                                                              //
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                          //
//       allowed to switch away.                                                                                      //
//   title: Title from display purposes. If missing, default to capitalizing _id.                                     //
                                                                                                                      //
AppIndex = new Mongo.Collection("appIndex");                                                                          // 589
// A mirror of the data from the App Market index                                                                     //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id: the appId of the app                                                                                        //
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                   //
                                                                                                                      //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles");                                                            // 596
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                    //
// by that user is installed, as well as if the keybase profile is requested and not already                          //
// present for some reason.                                                                                           //
//                                                                                                                    //
// Each contains:                                                                                                     //
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                  //
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                   //
//   handle: Keybase handle.                                                                                          //
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                     //
//     docs for details. We also add a boolean "status" field to each proof indicating whether                        //
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                         //
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                    //
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                    //
//     server is currently actively checking this proof). Note that if a check fails due to network                   //
//     errors, the status goes back to "unverified".                                                                  //
//                                                                                                                    //
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                         //
//       for now and we just trust Keybase.                                                                           //
                                                                                                                      //
FeatureKey = new Mongo.Collection("featureKey");                                                                      // 616
// Responsible for storing the current feature key that is active on the server.  Contains a single                   //
// document with two keys:                                                                                            //
//                                                                                                                    //
//   _id: "currentFeatureKey"                                                                                         //
//   value: the still-signed, binary-encoded feature key                                                              //
//          (a feature key with comments removed and base64 decoded)                                                  //
//                                                                                                                    //
// This is only intended to be visible on the server.                                                                 //
                                                                                                                      //
SetupSession = new Mongo.Collection("setupSession");                                                                  // 626
// Responsible for storing information about setup sessions.  Contains a single document with three                   //
// keys:                                                                                                              //
//                                                                                                                    //
//   _id: "current-session"                                                                                           //
//   creationDate: Date object indicating when this session was created.                                              //
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                             //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 634
  Meteor.publish("credentials", function () {                                                                         // 635
    // Data needed for isSignedUp() and isAdmin() to work.                                                            //
                                                                                                                      //
    if (this.userId) {                                                                                                // 638
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                               // 642
          referredIdentityIds: 1 } }), Plans.find()];                                                                 // 643
    } else {                                                                                                          //
      return [];                                                                                                      // 647
    }                                                                                                                 //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
var countReferrals = function countReferrals(user) {                                                                  // 652
  var referredIdentityIds = user.referredIdentityIds;                                                                 // 653
  return referredIdentityIds && referredIdentityIds.length || 0;                                                      // 654
};                                                                                                                    //
                                                                                                                      //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                  // 657
  // This function returns an object of the form:                                                                     //
  //                                                                                                                  //
  // - {grains: 0, storage: 0}                                                                                        //
  //                                                                                                                  //
  // which are extra resources this account gets as part of participating in the referral                             //
  // program. (Storage is measured in bytes, as usual for plans.)                                                     //
                                                                                                                      //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                       //
  //   payments-specific) and aggregating into `planBonus`.                                                           //
                                                                                                                      //
  // Authorization note: Only call this if accountId is the current user!                                             //
  var isPaid = user.plan && user.plan !== "free";                                                                     // 669
                                                                                                                      //
  successfulReferralsCount = countReferrals(user);                                                                    // 671
  if (isPaid) {                                                                                                       // 672
    var maxPaidStorageBonus = 30 * 1e9;                                                                               // 673
    return { grains: 0,                                                                                               // 674
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                   // 675
  } else {                                                                                                            //
    var maxFreeStorageBonus = 2 * 1e9;                                                                                // 679
    var bonus = {                                                                                                     // 680
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                     // 681
    };                                                                                                                //
    if (successfulReferralsCount > 0) {                                                                               // 685
      bonus.grains = Infinity;                                                                                        // 686
    } else {                                                                                                          //
      bonus.grains = 0;                                                                                               // 688
    }                                                                                                                 //
                                                                                                                      //
    return bonus;                                                                                                     // 691
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
getUserQuota = function getUserQuota(user) {                                                                          // 695
  var plan = Plans.findOne(user.plan || "free");                                                                      // 696
  var referralBonus = calculateReferralBonus(user);                                                                   // 697
  var bonus = user.planBonus || {};                                                                                   // 698
  var userQuota = {                                                                                                   // 699
    storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                             // 700
    grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                                 // 701
    compute: plan.compute + (bonus.compute || 0)                                                                      // 702
  };                                                                                                                  //
  return userQuota;                                                                                                   // 704
};                                                                                                                    //
                                                                                                                      //
isUserOverQuota = function isUserOverQuota(user) {                                                                    // 707
  // Return false if user has quota space remaining, true if it is full. When this returns true,                      //
  // we will not allow the user to create new grains, though they may be able to open existing ones                   //
  // which may still increase their storage usage.                                                                    //
  //                                                                                                                  //
  // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                 //
                                                                                                                      //
  if (!Meteor.settings["public"].quotaEnabled || user.isAdmin) return false;                                          // 714
                                                                                                                      //
  var plan = getUserQuota(user);                                                                                      // 716
  if (plan.grains < Infinity) {                                                                                       // 717
    var count = Grains.find({ userId: user._id }, { fields: {}, limit: plan.grains }).count();                        // 718
    if (count >= plan.grains) return "outOfGrains";                                                                   // 719
  }                                                                                                                   //
                                                                                                                      //
  return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                            // 722
};                                                                                                                    //
                                                                                                                      //
isUserExcessivelyOverQuota = function isUserExcessivelyOverQuota(user) {                                              // 725
  // Return true if user is so far over quota that we should prevent their existing grains from                       //
  // running at all.                                                                                                  //
  //                                                                                                                  //
  // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                                 //
                                                                                                                      //
  if (!Meteor.settings["public"].quotaEnabled || user.isAdmin) return false;                                          // 731
                                                                                                                      //
  var quota = getUserQuota(user);                                                                                     // 733
                                                                                                                      //
  // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                            //
  if (quota.grains < Infinity) {                                                                                      // 725
    var count = Grains.find({ userId: user._id }, { fields: {}, limit: quota.grains * 2 }).count();                   // 737
    if (count >= quota.grains * 2) return "outOfGrains";                                                              // 738
  }                                                                                                                   //
                                                                                                                      //
  return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                    // 741
};                                                                                                                    //
                                                                                                                      //
isAdmin = function isAdmin() {                                                                                        // 744
  // Returns true if the user is the administrator.                                                                   //
                                                                                                                      //
  var user = Meteor.user();                                                                                           // 747
  if (user && user.isAdmin) {                                                                                         // 748
    return true;                                                                                                      // 749
  } else {                                                                                                            //
    return false;                                                                                                     // 751
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
isAdminById = function isAdminById(id) {                                                                              // 755
  // Returns true if the user's id is the administrator.                                                              //
                                                                                                                      //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                           // 758
  if (user && user.isAdmin) {                                                                                         // 759
    return true;                                                                                                      // 760
  } else {                                                                                                            //
    return false;                                                                                                     // 762
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
findAdminUserForToken = function findAdminUserForToken(token) {                                                       // 766
  if (!token.requirements) {                                                                                          // 767
    return;                                                                                                           // 768
  }                                                                                                                   //
                                                                                                                      //
  var requirements = token.requirements.filter(function (requirement) {                                               // 771
    return "userIsAdmin" in requirement;                                                                              // 772
  });                                                                                                                 //
                                                                                                                      //
  if (requirements.length > 1) {                                                                                      // 775
    return;                                                                                                           // 776
  }                                                                                                                   //
                                                                                                                      //
  if (requirements.length === 0) {                                                                                    // 779
    return;                                                                                                           // 780
  }                                                                                                                   //
                                                                                                                      //
  return requirements[0].userIsAdmin;                                                                                 // 783
};                                                                                                                    //
                                                                                                                      //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                   // 786
                                                                                                                      //
if (wildcardHost.length != 2) {                                                                                       // 788
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                // 789
}                                                                                                                     //
                                                                                                                      //
matchWildcardHost = function matchWildcardHost(host) {                                                                // 792
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                          //
                                                                                                                      //
  // We remove everything after the first ":" character so that our                                                   //
  // comparison logic ignores port numbers.                                                                           //
  var prefix = wildcardHost[0];                                                                                       // 797
  var suffix = wildcardHost[1].split(":")[0];                                                                         // 798
  var hostSansPort = host.split(":")[0];                                                                              // 799
                                                                                                                      //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                       // 804
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                   // 805
      return id;                                                                                                      // 806
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  return null;                                                                                                        // 810
};                                                                                                                    //
                                                                                                                      //
makeWildcardHost = function makeWildcardHost(id) {                                                                    // 813
  return wildcardHost[0] + id + wildcardHost[1];                                                                      // 814
};                                                                                                                    //
                                                                                                                      //
var isApiHostId = function isApiHostId(hostId) {                                                                      // 817
  if (hostId) {                                                                                                       // 818
    var split = hostId.split("-");                                                                                    // 819
    if (split[0] === "api") return split[1] || "*";                                                                   // 820
  }                                                                                                                   //
                                                                                                                      //
  return false;                                                                                                       // 823
};                                                                                                                    //
                                                                                                                      //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                  // 826
  return hostId.lastIndexOf("api-", 0) === 0;                                                                         // 827
};                                                                                                                    //
                                                                                                                      //
var apiHostIdHashForToken = void 0;                                                                                   // 830
if (Meteor.isServer) {                                                                                                // 831
  (function () {                                                                                                      //
    var Crypto = Npm.require("crypto");                                                                               // 832
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                   // 833
      // Given an API token, compute the host ID that must be used when requesting this token.                        //
                                                                                                                      //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                     //
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                    //
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                    //
      // any bugs which would allow someone who knows only the hostname to access the app API.                        //
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                              // 840
    };                                                                                                                //
  })();                                                                                                               //
} else {                                                                                                              //
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                     // 843
    // Given an API token, compute the host ID that must be used when requesting this token.                          //
                                                                                                                      //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                       //
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                      //
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                      //
    // any bugs which would allow someone who knows only the hostname to access the app API.                          //
    return SHA256("x" + token).slice(0, 32);                                                                          // 850
  };                                                                                                                  //
}                                                                                                                     //
                                                                                                                      //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                           // 854
  return "api-" + apiHostIdHashForToken(token);                                                                       // 855
};                                                                                                                    //
                                                                                                                      //
var makeApiHost = function makeApiHost(token) {                                                                       // 858
  return makeWildcardHost(apiHostIdForToken(token));                                                                  // 859
};                                                                                                                    //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 862
  (function () {                                                                                                      //
    var Url = Npm.require("url");                                                                                     // 863
    getWildcardOrigin = function getWildcardOrigin() {                                                                // 864
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                     //
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                   //
      // an astrisk is only allowed as the first character and must be followed by a period. So we need               //
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                  //
      // really do. We also add the protocol to the front (again, that's what CSP wants).                             //
                                                                                                                      //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                //
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                        // 872
                                                                                                                      //
      var dotPos = wildcardHost[1].indexOf(".");                                                                      // 874
      if (dotPos < 0) {                                                                                               // 875
        return protocol + "//*";                                                                                      // 876
      } else {                                                                                                        //
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                      // 878
      }                                                                                                               //
    };                                                                                                                //
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
allowDevAccounts = function allowDevAccounts() {                                                                      // 883
  var setting = Settings.findOne({ _id: "devAccounts" });                                                             // 884
  if (setting) {                                                                                                      // 885
    return setting.value;                                                                                             // 886
  } else {                                                                                                            //
    return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;                // 888
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
sendReferralProgramNotification = function sendReferralProgramNotification(userId) {                                  // 893
  Notifications.upsert({                                                                                              // 894
    userId: userId,                                                                                                   // 895
    referral: true                                                                                                    // 896
  }, {                                                                                                                //
    userId: userId,                                                                                                   // 898
    referral: true,                                                                                                   // 899
    timestamp: new Date(),                                                                                            // 900
    isUnread: true                                                                                                    // 901
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
roleAssignmentPattern = {                                                                                             // 905
  none: Match.Optional(null),                                                                                         // 906
  allAccess: Match.Optional(null),                                                                                    // 907
  roleId: Match.Optional(Match.Integer),                                                                              // 908
  addPermissions: Match.Optional([Boolean]),                                                                          // 909
  removePermissions: Match.Optional([Boolean])                                                                        // 910
};                                                                                                                    //
                                                                                                                      //
SandstormDb = function SandstormDb() {                                                                                // 913
  this.collections = {                                                                                                // 914
    // Direct access to underlying collections. DEPRECATED.                                                           //
    //                                                                                                                //
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                     //
    //   direct access to the collections.                                                                            //
                                                                                                                      //
    packages: Packages,                                                                                               // 920
    devPackages: DevPackages,                                                                                         // 921
    userActions: UserActions,                                                                                         // 922
    grains: Grains,                                                                                                   // 923
    contacts: Contacts,                                                                                               // 924
    sessions: Sessions,                                                                                               // 925
    signupKeys: SignupKeys,                                                                                           // 926
    activityStats: ActivityStats,                                                                                     // 927
    deleteStats: DeleteStats,                                                                                         // 928
    fileTokens: FileTokens,                                                                                           // 929
    apiTokens: ApiTokens,                                                                                             // 930
    apiHosts: ApiHosts,                                                                                               // 931
    notifications: Notifications,                                                                                     // 932
    statsTokens: StatsTokens,                                                                                         // 933
    misc: Misc,                                                                                                       // 934
    settings: Settings,                                                                                               // 935
    appIndex: AppIndex,                                                                                               // 936
    keybaseProfiles: KeybaseProfiles,                                                                                 // 937
    featureKey: FeatureKey,                                                                                           // 938
    setupSession: SetupSession,                                                                                       // 939
    users: Meteor.users                                                                                               // 940
                                                                                                                      //
  };                                                                                                                  //
};                                                                                                                    //
                                                                                                                      //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                          //
//   objects created in SandstormDb's constructor rather than globals.                                                //
                                                                                                                      //
// Intentionally omitted:                                                                                             //
// - Migrations, since it's used only within this package.                                                            //
// - RoleAssignments, since it is deprecated and only used by the migration that eliminated it.                       //
_.extend(SandstormDb.prototype, {                                                                                     // 951
  getUserQuota: getUserQuota,                                                                                         // 952
  isUserOverQuota: isUserOverQuota,                                                                                   // 953
  isUserExcessivelyOverQuota: isUserExcessivelyOverQuota,                                                             // 954
  isAdmin: isAdmin,                                                                                                   // 955
  isAdminById: isAdminById,                                                                                           // 956
  findAdminUserForToken: findAdminUserForToken,                                                                       // 957
  matchWildcardHost: matchWildcardHost,                                                                               // 958
  makeWildcardHost: makeWildcardHost,                                                                                 // 959
  isApiHostId: isApiHostId,                                                                                           // 960
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                       // 961
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                       // 962
  apiHostIdForToken: apiHostIdForToken,                                                                               // 963
  makeApiHost: makeApiHost,                                                                                           // 964
  allowDevAccounts: allowDevAccounts,                                                                                 // 965
  roleAssignmentPattern: roleAssignmentPattern,                                                                       // 966
                                                                                                                      //
  isDemoUser: function () {                                                                                           // 968
    function isDemoUser() {                                                                                           // 968
      // Returns true if this is a demo user.                                                                         //
                                                                                                                      //
      var user = Meteor.user();                                                                                       // 971
      if (user && user.expires) {                                                                                     // 972
        return true;                                                                                                  // 973
      } else {                                                                                                        //
        return false;                                                                                                 // 975
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return isDemoUser;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  isSignedUp: function () {                                                                                           // 979
    function isSignedUp() {                                                                                           // 979
      // Returns true if the user has presented an invite key.                                                        //
                                                                                                                      //
      var user = Meteor.user();                                                                                       // 982
                                                                                                                      //
      if (!user) return false; // not signed in                                                                       // 984
                                                                                                                      //
      if (!user.loginIdentities) return false; // not an account                                                      // 979
                                                                                                                      //
      if (user.expires) return false; // demo user.                                                                   // 979
                                                                                                                      //
      if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                              // 979
                                                                                                                      //
      if (user.signupKey) return true; // user is invited                                                             // 979
                                                                                                                      //
      if (this.isUserInOrganization(user)) return true;                                                               // 979
                                                                                                                      //
      return false;                                                                                                   // 996
    }                                                                                                                 //
                                                                                                                      //
    return isSignedUp;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  isSignedUpOrDemo: function () {                                                                                     // 999
    function isSignedUpOrDemo() {                                                                                     // 999
      var user = Meteor.user();                                                                                       // 1000
                                                                                                                      //
      if (!user) return false; // not signed in                                                                       // 1002
                                                                                                                      //
      if (!user.loginIdentities) return false; // not an account                                                      // 999
                                                                                                                      //
      if (user.expires) return true; // demo user.                                                                    // 999
                                                                                                                      //
      if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                              // 999
                                                                                                                      //
      if (user.signupKey) return true; // user is invited                                                             // 999
                                                                                                                      //
      if (this.isUserInOrganization(user)) return true;                                                               // 999
                                                                                                                      //
      return false;                                                                                                   // 1014
    }                                                                                                                 //
                                                                                                                      //
    return isSignedUpOrDemo;                                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  isIdentityInOrganization: function () {                                                                             // 1017
    function isIdentityInOrganization(identity) {                                                                     // 1017
      if (!identity || !identity.services) {                                                                          // 1018
        return false;                                                                                                 // 1019
      }                                                                                                               //
                                                                                                                      //
      var orgMembership = this.getOrganizationMembership();                                                           // 1022
      var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                      // 1023
      var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                        // 1024
      var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;               // 1025
      var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                 // 1026
      var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                            // 1027
      var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                            // 1028
      if (emailEnabled && emailDomain && identity.services.email) {                                                   // 1029
        if (identity.services.email.email.toLowerCase().split("@").pop() === emailDomain) {                           // 1030
          return true;                                                                                                // 1031
        }                                                                                                             //
      } else if (ldapEnabled && identity.services.ldap) {                                                             //
        return true;                                                                                                  // 1034
      } else if (samlEnabled && identity.services.saml) {                                                             //
        return true;                                                                                                  // 1036
      } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {          //
        if (identity.services.google.hd.toLowerCase() === googleDomain) {                                             // 1038
          return true;                                                                                                // 1039
        }                                                                                                             //
      }                                                                                                               //
                                                                                                                      //
      return false;                                                                                                   // 1043
    }                                                                                                                 //
                                                                                                                      //
    return isIdentityInOrganization;                                                                                  //
  }(),                                                                                                                //
                                                                                                                      //
  isUserInOrganization: function () {                                                                                 // 1046
    function isUserInOrganization(user) {                                                                             // 1046
      if (!this.isFeatureKeyValid()) {                                                                                // 1047
        return false;                                                                                                 // 1048
      }                                                                                                               //
                                                                                                                      //
      for (var i = 0; i < user.loginIdentities.length; i++) {                                                         // 1051
        var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                     // 1052
        if (this.isIdentityInOrganization(identity)) {                                                                // 1053
          return true;                                                                                                // 1054
        }                                                                                                             //
      }                                                                                                               //
                                                                                                                      //
      return false;                                                                                                   // 1058
    }                                                                                                                 //
                                                                                                                      //
    return isUserInOrganization;                                                                                      //
  }()                                                                                                                 //
});                                                                                                                   //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 1062
  (function () {                                                                                                      //
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                      // 1063
                                                                                                                      //
    var Crypto = Npm.require("crypto");                                                                               // 1065
    SandstormDb.prototype.removeApiTokens = function (query) {                                                        // 1066
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                          //
                                                                                                                      //
      this.collections.apiTokens.find(query).forEach(function (token) {                                               // 1069
        // Clean up ApiHosts for webkey tokens.                                                                       //
        if (token.hasApiHost) {                                                                                       // 1071
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                 // 1072
          ApiHosts.remove({ hash2: hash2 });                                                                          // 1073
        }                                                                                                             //
      });                                                                                                             //
                                                                                                                      //
      this.collections.apiTokens.remove(query);                                                                       // 1077
    };                                                                                                                //
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
// =======================================================================================                            //
// Below this point are newly-written or refactored functions.                                                        //
                                                                                                                      //
_.extend(SandstormDb.prototype, {                                                                                     // 1084
  getUser: function () {                                                                                              // 1085
    function getUser(userId) {                                                                                        // 1085
      check(userId, Match.OneOf(String, undefined, null));                                                            // 1086
      if (userId) {                                                                                                   // 1087
        return Meteor.users.findOne(userId);                                                                          // 1088
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return getUser;                                                                                                   //
  }(),                                                                                                                //
                                                                                                                      //
  getIdentity: function () {                                                                                          // 1092
    function getIdentity(identityId) {                                                                                // 1092
      check(identityId, String);                                                                                      // 1093
      var identity = Meteor.users.findOne({ _id: identityId });                                                       // 1094
      if (identity) {                                                                                                 // 1095
        SandstormDb.fillInProfileDefaults(identity);                                                                  // 1096
        SandstormDb.fillInIntrinsicName(identity);                                                                    // 1097
        SandstormDb.fillInPictureUrl(identity);                                                                       // 1098
        return identity;                                                                                              // 1099
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return getIdentity;                                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  userHasIdentity: function () {                                                                                      // 1103
    function userHasIdentity(userId, identityId) {                                                                    // 1103
      check(userId, String);                                                                                          // 1104
      check(identityId, String);                                                                                      // 1105
                                                                                                                      //
      if (userId === identityId) return true;                                                                         // 1107
                                                                                                                      //
      var user = Meteor.users.findOne(userId);                                                                        // 1109
      return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                          // 1110
    }                                                                                                                 //
                                                                                                                      //
    return userHasIdentity;                                                                                           //
  }(),                                                                                                                //
                                                                                                                      //
  userGrains: function () {                                                                                           // 1113
    function userGrains(userId) {                                                                                     // 1113
      check(userId, Match.OneOf(String, undefined, null));                                                            // 1114
      return this.collections.grains.find({ userId: userId });                                                        // 1115
    }                                                                                                                 //
                                                                                                                      //
    return userGrains;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  currentUserGrains: function () {                                                                                    // 1118
    function currentUserGrains() {                                                                                    // 1118
      return this.userGrains(Meteor.userId());                                                                        // 1119
    }                                                                                                                 //
                                                                                                                      //
    return currentUserGrains;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getGrain: function () {                                                                                             // 1122
    function getGrain(grainId) {                                                                                      // 1122
      check(grainId, String);                                                                                         // 1123
      return this.collections.grains.findOne(grainId);                                                                // 1124
    }                                                                                                                 //
                                                                                                                      //
    return getGrain;                                                                                                  //
  }(),                                                                                                                //
                                                                                                                      //
  userApiTokens: function () {                                                                                        // 1127
    function userApiTokens(userId) {                                                                                  // 1127
      check(userId, Match.OneOf(String, undefined, null));                                                            // 1128
      var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                         // 1129
      return this.collections.apiTokens.find({ "owner.user.identityId": { $in: identityIds } });                      // 1130
    }                                                                                                                 //
                                                                                                                      //
    return userApiTokens;                                                                                             //
  }(),                                                                                                                //
                                                                                                                      //
  currentUserApiTokens: function () {                                                                                 // 1133
    function currentUserApiTokens() {                                                                                 // 1133
      return this.userApiTokens(Meteor.userId());                                                                     // 1134
    }                                                                                                                 //
                                                                                                                      //
    return currentUserApiTokens;                                                                                      //
  }(),                                                                                                                //
                                                                                                                      //
  userActions: function () {                                                                                          // 1137
    function userActions(user) {                                                                                      // 1137
      return this.collections.userActions.find({ userId: user });                                                     // 1138
    }                                                                                                                 //
                                                                                                                      //
    return userActions;                                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  currentUserActions: function () {                                                                                   // 1141
    function currentUserActions() {                                                                                   // 1141
      return this.userActions(Meteor.userId());                                                                       // 1142
    }                                                                                                                 //
                                                                                                                      //
    return currentUserActions;                                                                                        //
  }(),                                                                                                                //
                                                                                                                      //
  iconSrcForPackage: function () {                                                                                    // 1145
    function iconSrcForPackage(pkg, usage) {                                                                          // 1145
      return Identicon.iconSrcForPackage(pkg, usage, this.makeWildcardHost("static"));                                // 1146
    }                                                                                                                 //
                                                                                                                      //
    return iconSrcForPackage;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getDenormalizedGrainInfo: function () {                                                                             // 1149
    function getDenormalizedGrainInfo(grainId) {                                                                      // 1149
      var grain = this.getGrain(grainId);                                                                             // 1150
      var pkg = this.collections.packages.findOne(grain.packageId);                                                   // 1151
                                                                                                                      //
      if (!pkg) {                                                                                                     // 1153
        pkg = this.collections.devPackages.findOne(grain.packageId);                                                  // 1154
      }                                                                                                               //
                                                                                                                      //
      var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                             // 1157
      var grainInfo = { appTitle: appTitle };                                                                         // 1158
                                                                                                                      //
      if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                              // 1160
        var icons = pkg.manifest.metadata.icons;                                                                      // 1161
        grainInfo.icon = icons.grain || icons.appGrid;                                                                // 1162
      }                                                                                                               //
                                                                                                                      //
      // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                   //
      if (!grainInfo.icon && pkg) {                                                                                   // 1149
        grainInfo.appId = pkg.appId;                                                                                  // 1167
      }                                                                                                               //
                                                                                                                      //
      return grainInfo;                                                                                               // 1170
    }                                                                                                                 //
                                                                                                                      //
    return getDenormalizedGrainInfo;                                                                                  //
  }(),                                                                                                                //
                                                                                                                      //
  getPlan: function () {                                                                                              // 1173
    function getPlan(id) {                                                                                            // 1173
      check(id, String);                                                                                              // 1174
      var plan = Plans.findOne(id);                                                                                   // 1175
      if (!plan) {                                                                                                    // 1176
        throw new Error("no such plan: " + id);                                                                       // 1177
      }                                                                                                               //
                                                                                                                      //
      return plan;                                                                                                    // 1180
    }                                                                                                                 //
                                                                                                                      //
    return getPlan;                                                                                                   //
  }(),                                                                                                                //
                                                                                                                      //
  listPlans: function () {                                                                                            // 1183
    function listPlans() {                                                                                            // 1183
      return Plans.find({}, { sort: { price: 1 } });                                                                  // 1184
    }                                                                                                                 //
                                                                                                                      //
    return listPlans;                                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getMyPlan: function () {                                                                                            // 1187
    function getMyPlan() {                                                                                            // 1187
      var user = Meteor.user();                                                                                       // 1188
      return user && Plans.findOne(user.plan || "free");                                                              // 1189
    }                                                                                                                 //
                                                                                                                      //
    return getMyPlan;                                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getMyReferralBonus: function () {                                                                                   // 1192
    function getMyReferralBonus(user) {                                                                               // 1192
      // This function is called from the server and from the client, similar to getMyPlan().                         //
      //                                                                                                              //
      // The parameter may be omitted in which case the current user is assumed.                                      //
                                                                                                                      //
      return calculateReferralBonus(user || Meteor.user());                                                           // 1197
    }                                                                                                                 //
                                                                                                                      //
    return getMyReferralBonus;                                                                                        //
  }(),                                                                                                                //
                                                                                                                      //
  getMyUsage: function () {                                                                                           // 1200
    function getMyUsage(user) {                                                                                       // 1200
      user = user || Meteor.user();                                                                                   // 1201
      if (user && (Meteor.isServer || user.pseudoUsage)) {                                                            // 1202
        if (Meteor.isClient) {                                                                                        // 1203
          // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currenly                     //
          // not reactive.                                                                                            //
          return user.pseudoUsage;                                                                                    // 1206
        } else {                                                                                                      //
          return {                                                                                                    // 1208
            grains: Grains.find({ userId: user._id }).count(),                                                        // 1209
            storage: user.storageUsage || 0,                                                                          // 1210
            compute: 0 };                                                                                             // 1211
        }                                                                                                             //
      } else // not tracked yet                                                                                       //
        {                                                                                                             // 1214
          return { grains: 0, storage: 0, compute: 0 };                                                               // 1215
        }                                                                                                             //
    }                                                                                                                 //
                                                                                                                      //
    return getMyUsage;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  isUninvitedFreeUser: function () {                                                                                  // 1219
    function isUninvitedFreeUser() {                                                                                  // 1219
      if (!Meteor.settings["public"].allowUninvited) return false;                                                    // 1220
                                                                                                                      //
      var user = Meteor.user();                                                                                       // 1222
      return user && !user.expires && (!user.plan || user.plan === "free");                                           // 1223
    }                                                                                                                 //
                                                                                                                      //
    return isUninvitedFreeUser;                                                                                       //
  }(),                                                                                                                //
                                                                                                                      //
  getSetting: function () {                                                                                           // 1226
    function getSetting(name) {                                                                                       // 1226
      var setting = Settings.findOne(name);                                                                           // 1227
      return setting && setting.value;                                                                                // 1228
    }                                                                                                                 //
                                                                                                                      //
    return getSetting;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getSettingWithFallback: function () {                                                                               // 1231
    function getSettingWithFallback(name, fallbackValue) {                                                            // 1231
      var value = this.getSetting(name);                                                                              // 1232
      if (value === undefined) {                                                                                      // 1233
        return fallbackValue;                                                                                         // 1234
      }                                                                                                               //
                                                                                                                      //
      return value;                                                                                                   // 1237
    }                                                                                                                 //
                                                                                                                      //
    return getSettingWithFallback;                                                                                    //
  }(),                                                                                                                //
                                                                                                                      //
  addUserActions: function () {                                                                                       // 1240
    function addUserActions(packageId) {                                                                              // 1240
      //TODO(cleanup): implement this with meteor methods rather than client-side inserts/removes.                    //
      var pack = Packages.findOne(packageId);                                                                         // 1242
      if (pack) {                                                                                                     // 1243
        // Remove old versions.                                                                                       //
        UserActions.find({ userId: Meteor.userId(), appId: pack.appId }).forEach(function (action) {                  // 1245
          UserActions.remove(action._id);                                                                             // 1247
        });                                                                                                           //
                                                                                                                      //
        // Install new.                                                                                               //
        var actions = pack.manifest.actions;                                                                          // 1243
        for (var i in meteorBabelHelpers.sanitizeForInObject(actions)) {                                              // 1252
          var action = actions[i];                                                                                    // 1253
          if ("none" in action.input) {                                                                               // 1254
            var userAction = {                                                                                        // 1255
              userId: Meteor.userId(),                                                                                // 1256
              packageId: pack._id,                                                                                    // 1257
              appId: pack.appId,                                                                                      // 1258
              appTitle: pack.manifest.appTitle,                                                                       // 1259
              appMarketingVersion: pack.manifest.appMarketingVersion,                                                 // 1260
              appVersion: pack.manifest.appVersion,                                                                   // 1261
              title: action.title,                                                                                    // 1262
              nounPhrase: action.nounPhrase,                                                                          // 1263
              command: action.command                                                                                 // 1264
            };                                                                                                        //
            UserActions.insert(userAction);                                                                           // 1266
          } else {}                                                                                                   //
          // TODO(someday):  Implement actions with capability inputs.                                                //
          //jscs:ignore disallowEmptyBlocks                                                                           //
        }                                                                                                             // 1254
                                                                                                                      //
        Meteor.call("deleteUnusedPackages", pack.appId);                                                              // 1272
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return addUserActions;                                                                                            //
  }(),                                                                                                                //
                                                                                                                      //
  sendAdminNotification: function () {                                                                                // 1276
    function sendAdminNotification(message, link) {                                                                   // 1276
      Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                          // 1277
        Notifications.insert({                                                                                        // 1278
          admin: {                                                                                                    // 1279
            action: link,                                                                                             // 1280
            type: "reportStats"                                                                                       // 1281
          },                                                                                                          //
          userId: user._id,                                                                                           // 1283
          text: { defaultText: message },                                                                             // 1284
          timestamp: new Date(),                                                                                      // 1285
          isUnread: true                                                                                              // 1286
        });                                                                                                           //
      });                                                                                                             //
    }                                                                                                                 //
                                                                                                                      //
    return sendAdminNotification;                                                                                     //
  }(),                                                                                                                //
                                                                                                                      //
  getKeybaseProfile: function () {                                                                                    // 1291
    function getKeybaseProfile(keyFingerprint) {                                                                      // 1291
      return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                          // 1292
    }                                                                                                                 //
                                                                                                                      //
    return getKeybaseProfile;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getServerTitle: function () {                                                                                       // 1295
    function getServerTitle() {                                                                                       // 1295
      var setting = Settings.findOne({ _id: "serverTitle" });                                                         // 1296
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1297
    }                                                                                                                 // 1295
                                                                                                                      //
    return getServerTitle;                                                                                            //
  }(),                                                                                                                //
                                                                                                                      //
  getSmtpConfig: function () {                                                                                        // 1300
    function getSmtpConfig() {                                                                                        //
      var setting = Settings.findOne({ _id: "smtpConfig" });                                                          // 1301
      return setting ? setting.value : undefined; // undefined if subscription is not ready.                          // 1302
    }                                                                                                                 // 1300
                                                                                                                      //
    return getSmtpConfig;                                                                                             //
  }(),                                                                                                                //
                                                                                                                      //
                                                                                                                      //
  getReturnAddress: function () {                                                                                     // 1305
    function getReturnAddress() {                                                                                     // 1305
      var config = this.getSmtpConfig();                                                                              // 1306
      return config && config.returnAddress || ""; // empty if subscription is not ready.                             // 1307
    }                                                                                                                 // 1305
                                                                                                                      //
    return getReturnAddress;                                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  getReturnAddressWithDisplayName: function () {                                                                      // 1310
    function getReturnAddressWithDisplayName(identityId) {                                                            // 1310
      check(identityId, String);                                                                                      // 1311
      var identity = this.getIdentity(identityId);                                                                    // 1312
      var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                               // 1313
                                                                                                                      //
      // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                         //
      // we could escape such characters with a backslash, but that does not seem to help here.                       //
      var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                        // 1310
                                                                                                                      //
      return "\"" + sanitized + "\" <" + this.getReturnAddress() + ">";                                               // 1319
    }                                                                                                                 //
                                                                                                                      //
    return getReturnAddressWithDisplayName;                                                                           //
  }(),                                                                                                                //
                                                                                                                      //
  getPrimaryEmail: function () {                                                                                      // 1322
    function getPrimaryEmail(accountId, identityId) {                                                                 // 1322
      check(accountId, String);                                                                                       // 1323
      check(identityId, String);                                                                                      // 1324
                                                                                                                      //
      var identity = this.getIdentity(identityId);                                                                    // 1326
      var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                     // 1327
      var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                          // 1328
      var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                          // 1329
      if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                         // 1330
        return accountPrimaryEmailAddress;                                                                            // 1331
      } else if (senderPrimaryEmail) {                                                                                //
        return senderPrimaryEmail.email;                                                                              // 1333
      } else {                                                                                                        //
        return null;                                                                                                  // 1335
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return getPrimaryEmail;                                                                                           //
  }(),                                                                                                                //
                                                                                                                      //
  isFeatureKeyValid: function () {                                                                                    // 1339
    function isFeatureKeyValid() {                                                                                    // 1339
      var featureKey = this.currentFeatureKey();                                                                      // 1340
      return !!featureKey;                                                                                            // 1341
    }                                                                                                                 //
                                                                                                                      //
    return isFeatureKeyValid;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  isFeatureKeyValidAndNotExpired: function () {                                                                       // 1344
    function isFeatureKeyValidAndNotExpired() {                                                                       // 1344
      var featureKey = this.currentFeatureKey();                                                                      // 1345
      return featureKey && parseInt(featureKey.expires) > Date.now() / 1000;                                          // 1346
    }                                                                                                                 //
                                                                                                                      //
    return isFeatureKeyValidAndNotExpired;                                                                            //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapUrl: function () {                                                                                           // 1349
    function getLdapUrl() {                                                                                           // 1349
      var setting = Settings.findOne({ _id: "ldapUrl" });                                                             // 1350
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1351
    }                                                                                                                 // 1349
                                                                                                                      //
    return getLdapUrl;                                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapBase: function () {                                                                                          // 1354
    function getLdapBase() {                                                                                          // 1354
      var setting = Settings.findOne({ _id: "ldapBase" });                                                            // 1355
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1356
    }                                                                                                                 // 1354
                                                                                                                      //
    return getLdapBase;                                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapDnPattern: function () {                                                                                     // 1359
    function getLdapDnPattern() {                                                                                     // 1359
      var setting = Settings.findOne({ _id: "ldapDnPattern" });                                                       // 1360
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1361
    }                                                                                                                 // 1359
                                                                                                                      //
    return getLdapDnPattern;                                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapSearchUsername: function () {                                                                                // 1364
    function getLdapSearchUsername() {                                                                                // 1364
      var setting = Settings.findOne({ _id: "ldapSearchUsername" });                                                  // 1365
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1366
    }                                                                                                                 // 1364
                                                                                                                      //
    return getLdapSearchUsername;                                                                                     //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapNameField: function () {                                                                                     // 1369
    function getLdapNameField() {                                                                                     // 1369
      var setting = Settings.findOne({ _id: "ldapNameField" });                                                       // 1370
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1371
    }                                                                                                                 // 1369
                                                                                                                      //
    return getLdapNameField;                                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapEmailField: function () {                                                                                    // 1374
    function getLdapEmailField() {                                                                                    // 1374
      var setting = Settings.findOne({ _id: "ldapEmailField" });                                                      // 1375
      return setting ? setting.value : "mail";                                                                        // 1376
      // default to "mail". This setting was added later, and so could potentially be unset.                          //
    }                                                                                                                 // 1374
                                                                                                                      //
    return getLdapEmailField;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapExplicitDnSelected: function () {                                                                            // 1380
    function getLdapExplicitDnSelected() {                                                                            // 1380
      var setting = Settings.findOne({ _id: "ldapExplicitDnSelected" });                                              // 1381
      return setting && setting.value;                                                                                // 1382
    }                                                                                                                 //
                                                                                                                      //
    return getLdapExplicitDnSelected;                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapFilter: function () {                                                                                        // 1385
    function getLdapFilter() {                                                                                        // 1385
      var setting = Settings.findOne({ _id: "ldapFilter" });                                                          // 1386
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1387
    }                                                                                                                 // 1385
                                                                                                                      //
    return getLdapFilter;                                                                                             //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapSearchBindDn: function () {                                                                                  // 1390
    function getLdapSearchBindDn() {                                                                                  // 1390
      var setting = Settings.findOne({ _id: "ldapSearchBindDn" });                                                    // 1391
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1392
    }                                                                                                                 // 1390
                                                                                                                      //
    return getLdapSearchBindDn;                                                                                       //
  }(),                                                                                                                //
                                                                                                                      //
  getLdapSearchBindPassword: function () {                                                                            // 1395
    function getLdapSearchBindPassword() {                                                                            // 1395
      var setting = Settings.findOne({ _id: "ldapSearchBindPassword" });                                              // 1396
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1397
    }                                                                                                                 // 1395
                                                                                                                      //
    return getLdapSearchBindPassword;                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationMembership: function () {                                                                            // 1400
    function getOrganizationMembership() {                                                                            // 1400
      var setting = Settings.findOne({ _id: "organizationMembership" });                                              // 1401
      return setting && setting.value;                                                                                // 1402
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationMembership;                                                                                 //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationEmailEnabled: function () {                                                                          // 1405
    function getOrganizationEmailEnabled() {                                                                          // 1405
      var membership = this.getOrganizationMembership();                                                              // 1406
      return membership && membership.emailToken && membership.emailToken.enabled;                                    // 1407
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationEmailEnabled;                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationEmailDomain: function () {                                                                           // 1410
    function getOrganizationEmailDomain() {                                                                           // 1410
      var membership = this.getOrganizationMembership();                                                              // 1411
      return membership && membership.emailToken && membership.emailToken.domain;                                     // 1412
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationEmailDomain;                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationGoogleEnabled: function () {                                                                         // 1415
    function getOrganizationGoogleEnabled() {                                                                         // 1415
      var membership = this.getOrganizationMembership();                                                              // 1416
      return membership && membership.google && membership.google.enabled;                                            // 1417
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationGoogleEnabled;                                                                              //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationGoogleDomain: function () {                                                                          // 1420
    function getOrganizationGoogleDomain() {                                                                          // 1420
      var membership = this.getOrganizationMembership();                                                              // 1421
      return membership && membership.google && membership.google.domain;                                             // 1422
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationGoogleDomain;                                                                               //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationLdapEnabled: function () {                                                                           // 1425
    function getOrganizationLdapEnabled() {                                                                           // 1425
      var membership = this.getOrganizationMembership();                                                              // 1426
      return membership && membership.ldap && membership.ldap.enabled;                                                // 1427
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationLdapEnabled;                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationSamlEnabled: function () {                                                                           // 1430
    function getOrganizationSamlEnabled() {                                                                           // 1430
      var membership = this.getOrganizationMembership();                                                              // 1431
      return membership && membership.saml && membership.saml.enabled;                                                // 1432
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationSamlEnabled;                                                                                //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationDisallowGuests: function () {                                                                        // 1435
    function getOrganizationDisallowGuests() {                                                                        // 1435
      return this.getOrganizationDisallowGuestsRaw() && this.isFeatureKeyValid();                                     // 1436
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationDisallowGuests;                                                                             //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationDisallowGuestsRaw: function () {                                                                     // 1439
    function getOrganizationDisallowGuestsRaw() {                                                                     // 1439
      var setting = Settings.findOne({ _id: "organizationSettings" });                                                // 1440
      return setting && setting.value && setting.value.disallowGuests;                                                // 1441
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationDisallowGuestsRaw;                                                                          //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationShareContacts: function () {                                                                         // 1444
    function getOrganizationShareContacts() {                                                                         // 1444
      return this.getOrganizationShareContactsRaw() && this.isFeatureKeyValid();                                      // 1445
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationShareContacts;                                                                              //
  }(),                                                                                                                //
                                                                                                                      //
  getOrganizationShareContactsRaw: function () {                                                                      // 1448
    function getOrganizationShareContactsRaw() {                                                                      // 1448
      var setting = Settings.findOne({ _id: "organizationSettings" });                                                // 1449
      if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                  // 1450
        // default to true if undefined                                                                               //
        return true;                                                                                                  // 1452
      } else {                                                                                                        //
        return setting.value.shareContacts;                                                                           // 1454
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return getOrganizationShareContactsRaw;                                                                           //
  }(),                                                                                                                //
                                                                                                                      //
  getSamlEntryPoint: function () {                                                                                    // 1458
    function getSamlEntryPoint() {                                                                                    // 1458
      var setting = Settings.findOne({ _id: "samlEntryPoint" });                                                      // 1459
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1460
    }                                                                                                                 // 1458
                                                                                                                      //
    return getSamlEntryPoint;                                                                                         //
  }(),                                                                                                                //
                                                                                                                      //
  getSamlPublicCert: function () {                                                                                    // 1463
    function getSamlPublicCert() {                                                                                    // 1463
      var setting = Settings.findOne({ _id: "samlPublicCert" });                                                      // 1464
      return setting ? setting.value : ""; // empty if subscription is not ready.                                     // 1465
    }                                                                                                                 // 1463
                                                                                                                      //
    return getSamlPublicCert;                                                                                         //
  }()                                                                                                                 //
});                                                                                                                   //
                                                                                                                      //
SandstormDb.escapeMongoKey = function (key) {                                                                         // 1469
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                    //
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                  //
  // and seems to be a de facto standard, for example:                                                                //
  //   https://www.npmjs.com/package/mongo-key-escape                                                                 //
  return key.replace(".", "．").replace("$", "＄");                                                                     // 1474
};                                                                                                                    //
                                                                                                                      //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                    // 1477
  // This function takes a Package object from Mongo and returns an                                                   //
  // app title.                                                                                                       //
  var manifest = packageObj.manifest;                                                                                 // 1480
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                              // 1481
  var action = manifest.actions[0];                                                                                   // 1482
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);    // 1483
  return appName;                                                                                                     // 1485
};                                                                                                                    //
                                                                                                                      //
var appNameFromActionName = function appNameFromActionName(name) {                                                    // 1488
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                              //
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                 //
  //   derive the app title from the action title.                                                                    //
  // TODO(cleanup): Get rid of this once apps have real titles.                                                       //
  if (!name) {                                                                                                        // 1493
    return "(unnamed)";                                                                                               // 1494
  }                                                                                                                   //
                                                                                                                      //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                            // 1497
    name = name.slice(4);                                                                                             // 1498
  }                                                                                                                   //
                                                                                                                      //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                      // 1501
    name = "Hacker CMS";                                                                                              // 1502
  } else {                                                                                                            //
    var space = name.indexOf(" ");                                                                                    // 1504
    if (space > 0) {                                                                                                  // 1505
      name = name.slice(0, space);                                                                                    // 1506
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  return name;                                                                                                        // 1510
};                                                                                                                    //
                                                                                                                      //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                   // 1513
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                    //
                                                                                                                      //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                      // 1519
  // A hack to deal with legacy apps not including fields in their manifests.                                         //
  // I look forward to the day I can remove most of this code.                                                        //
  // Attempt to figure out the appropriate noun that this action will create.                                         //
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                           //
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                        // 1524
  // Otherwise, try to guess one from the structure of the action title field                                         //
  if (action.title && action.title.defaultText) {                                                                     // 1519
    var text = action.title.defaultText;                                                                              // 1527
    // Strip a leading "New "                                                                                         //
    if (text.lastIndexOf("New ", 0) === 0) {                                                                          // 1526
      var candidate = text.slice(4);                                                                                  // 1530
      // Strip a leading appname too, if provided                                                                     //
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                 // 1529
        var newCandidate = candidate.slice(appTitle.length);                                                          // 1533
        // Unless that leaves you with no noun, in which case, use "grain"                                            //
        if (newCandidate.length > 0) {                                                                                // 1532
          return newCandidate.toLowerCase();                                                                          // 1536
        } else {                                                                                                      //
          return "grain";                                                                                             // 1538
        }                                                                                                             //
      }                                                                                                               //
                                                                                                                      //
      return candidate.toLowerCase();                                                                                 // 1542
    }                                                                                                                 //
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                       //
    // the package soon.                                                                                              //
    return text;                                                                                                      // 1526
  } else {                                                                                                            //
    return "grain";                                                                                                   // 1548
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
// Static methods on SandstormDb that don't need an instance.                                                         //
// Largely things that deal with backwards-compatibility.                                                             //
_.extend(SandstormDb, {                                                                                               // 1554
  appNameFromActionName: appNameFromActionName,                                                                       // 1555
  appNameFromPackage: appNameFromPackage,                                                                             // 1556
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                     // 1557
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                      // 1558
});                                                                                                                   //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 1561
  (function () {                                                                                                      //
    var cleanupExpiredAssetUploads = function cleanupExpiredAssetUploads() {                                          //
      AssetUploadTokens.remove({ expires: { $lt: Date.now() } });                                                     // 1759
    };                                                                                                                //
                                                                                                                      //
    // Cleanup tokens every hour.                                                                                     //
                                                                                                                      //
                                                                                                                      //
    var Crypto = Npm.require("crypto");                                                                               // 1562
    var ContentType = Npm.require("content-type");                                                                    // 1563
    var Zlib = Npm.require("zlib");                                                                                   // 1564
                                                                                                                      //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                           // 1566
                                                                                                                      //
    var computeStagger = function computeStagger(n) {                                                                 // 1568
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                       //
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                        //
      // The sequence looks like:                                                                                     //
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                            //
      //                                                                                                              //
      // We use this to determine how we'll stagger periodic events performed by this replica.                        //
      // Notice that this allows us to compute a stagger which is independent of the number of                        //
      // front-end replicas present; we can add more replicas to the end without affecting how the                    //
      // earlier ones schedule their events.                                                                          //
      var denom = 1;                                                                                                  // 1578
      while (denom <= n) {                                                                                            // 1579
        denom <<= 1;                                                                                                  // 1579
      }var num = n * 2 - denom + 1;                                                                                   //
      return num / denom;                                                                                             // 1581
    };                                                                                                                //
                                                                                                                      //
    var stagger = computeStagger(replicaNumber);                                                                      // 1584
                                                                                                                      //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                   // 1586
      // Register a database cleanup function than should run periodically, roughly once every                        //
      // interval of the given length.                                                                                //
      //                                                                                                              //
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                     //
      // scaled appropriately on the assumption that more data is being generated demanding more                      //
      // frequent cleanups.                                                                                           //
                                                                                                                      //
      check(intervalMs, Number);                                                                                      // 1594
      check(callback, Function);                                                                                      // 1595
                                                                                                                      //
      if (intervalMs < 120000) {                                                                                      // 1597
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");   // 1598
      }                                                                                                               //
                                                                                                                      //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                     //
      // the schedule is independent of the exact startup time.                                                       //
      var first = intervalMs - Date.now() % intervalMs;                                                               // 1586
                                                                                                                      //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                      //
      // same data at the same time.                                                                                  //
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                // 1586
                                                                                                                      //
      // If the stagger put us more than an interval away from now, back up.                                          //
      if (first > intervalMs) first -= intervalMs;                                                                    // 1586
                                                                                                                      //
      Meteor.setTimeout(function () {                                                                                 // 1613
        callback();                                                                                                   // 1614
        Meteor.setInterval(callback, intervalMs);                                                                     // 1615
      }, first);                                                                                                      //
    };                                                                                                                //
                                                                                                                      //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                         //
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                 // 1620
                                                                                                                      //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                       // 1622
      return Match.Where(function (buf) {                                                                             // 1623
        check(buf, Buffer);                                                                                           // 1624
        return buf.length < limit;                                                                                    // 1625
      });                                                                                                             //
    };                                                                                                                //
                                                                                                                      //
    var DatabaseId = Match.Where(function (s) {                                                                       // 1629
      check(s, String);                                                                                               // 1630
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                            // 1631
    });                                                                                                               //
                                                                                                                      //
    addStaticAsset = function addStaticAsset(metadata, content) {                                                     // 1634
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                    //
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                 //
                                                                                                                      //
      if (typeof content === "string" && !metadata.encoding) {                                                        // 1638
        content = gzipSync(new Buffer(content, "utf8"));                                                              // 1639
        metadata.encoding = "gzip";                                                                                   // 1640
      }                                                                                                               //
                                                                                                                      //
      check(metadata, {                                                                                               // 1643
        mimeType: String,                                                                                             // 1644
        encoding: Match.Optional("gzip")                                                                              // 1645
      });                                                                                                             //
      check(content, BufferSmallerThan(1 << 20));                                                                     // 1647
                                                                                                                      //
      // Validate content type.                                                                                       //
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                   // 1634
                                                                                                                      //
      var hasher = Crypto.createHash("sha256");                                                                       // 1652
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                     // 1653
      hasher.update(content);                                                                                         // 1654
      var hash = hasher.digest("base64");                                                                             // 1655
                                                                                                                      //
      var existing = StaticAssets.findAndModify({                                                                     // 1657
        query: { hash: hash, refcount: { $gte: 1 } },                                                                 // 1658
        update: { $inc: { refcount: 1 } },                                                                            // 1659
        fields: { _id: 1, refcount: 1 }                                                                               // 1660
      });                                                                                                             //
      if (existing) {                                                                                                 // 1662
        return existing._id;                                                                                          // 1663
      }                                                                                                               //
                                                                                                                      //
      return StaticAssets.insert(_.extend({                                                                           // 1666
        hash: hash,                                                                                                   // 1667
        content: content,                                                                                             // 1668
        refcount: 1                                                                                                   // 1669
      }, metadata));                                                                                                  //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.addStaticAsset = addStaticAsset;                                                            // 1673
                                                                                                                      //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                            // 1675
      // Increment the refcount on an existing static asset.                                                          //
      //                                                                                                              //
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                     //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                    //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                      //
                                                                                                                      //
      check(id, String);                                                                                              // 1682
                                                                                                                      //
      var existing = StaticAssets.findAndModify({                                                                     // 1684
        query: { hash: hash },                                                                                        // 1685
        update: { $inc: { refcount: 1 } },                                                                            // 1686
        fields: { _id: 1, refcount: 1 }                                                                               // 1687
      });                                                                                                             //
      if (!existing) {                                                                                                // 1689
        throw new Error("refStaticAsset() called on asset that doesn't exist");                                       // 1690
      }                                                                                                               //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                          // 1694
      // Decrement refcount on a static asset and delete if it has reached zero.                                      //
      //                                                                                                              //
      // You must call this AFTER removing the reference from the DB, in case of failure between                      //
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                    //
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                      //
                                                                                                                      //
      check(id, String);                                                                                              // 1701
                                                                                                                      //
      var existing = StaticAssets.findAndModify({                                                                     // 1703
        query: { _id: id },                                                                                           // 1704
        update: { $inc: { refcount: -1 } },                                                                           // 1705
        fields: { _id: 1, refcount: 1 },                                                                              // 1706
        "new": true                                                                                                   // 1707
      });                                                                                                             //
      if (!existing) {                                                                                                // 1709
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                      // 1710
      } else if (existing.refcount <= 0) {                                                                            //
        StaticAssets.remove({ _id: existing._id });                                                                   // 1712
      }                                                                                                               //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                            // 1716
      // Get a static asset's mimeType, encoding, and raw content.                                                    //
                                                                                                                      //
      check(id, String);                                                                                              // 1719
                                                                                                                      //
      var asset = StaticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });             // 1721
      if (asset) {                                                                                                    // 1722
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                     //
        //   here.                                                                                                    //
        asset.content = new Buffer(asset.content);                                                                    // 1725
      }                                                                                                               //
                                                                                                                      //
      return asset;                                                                                                   // 1728
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                       // 1731
      check(purpose, { profilePicture: { userId: DatabaseId, identityId: DatabaseId } });                             // 1732
                                                                                                                      //
      return AssetUploadTokens.insert({                                                                               // 1734
        purpose: purpose,                                                                                             // 1735
        expires: new Date(Date.now() + 300000) });                                                                    // 1736
    };                                                                                                                //
                                                                                                                      //
    // in 5 minutes                                                                                                   //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                        // 1740
      // Indicates that the given asset upload has completed. It will be removed and its purpose                      //
      // returned. If no matching upload exists, returns undefined.                                                   //
                                                                                                                      //
      check(id, String);                                                                                              // 1744
                                                                                                                      //
      var upload = AssetUploadTokens.findAndModify({                                                                  // 1746
        query: { _id: id },                                                                                           // 1747
        remove: true                                                                                                  // 1748
      });                                                                                                             //
                                                                                                                      //
      if (upload.expires.valueOf() < Date.now()) {                                                                    // 1751
        return undefined; // already expired                                                                          // 1752
      } else {                                                                                                        // 1751
          return upload.purpose;                                                                                      // 1754
        }                                                                                                             //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.periodicCleanup(3600000, cleanupExpiredAssetUploads);                                                 // 1763
                                                                                                                      //
    var packageCache = {};                                                                                            // 1765
    // Package info is immutable. Let's cache to save on mongo queries.                                               //
                                                                                                                      //
    SandstormDb.prototype.getPackage = function (packageId) {                                                         // 1768
      // Get the given package record. Since package info is immutable, cache the data in the server                  //
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                      //
      // lot.                                                                                                         //
                                                                                                                      //
      if (packageId in packageCache) {                                                                                // 1773
        return packageCache[packageId];                                                                               // 1774
      }                                                                                                               //
                                                                                                                      //
      var pkg = Packages.findOne(packageId);                                                                          // 1777
      if (pkg && pkg.status === "ready") {                                                                            // 1778
        packageCache[packageId] = pkg;                                                                                // 1779
      }                                                                                                               //
                                                                                                                      //
      return pkg;                                                                                                     // 1782
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this = this;                                                                                               // 1787
      var actions = _this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                             // 1790
        var userId = action.userId;                                                                                   // 1791
        var updater = {                                                                                               // 1792
          userId: userId,                                                                                             // 1793
          timestamp: new Date(),                                                                                      // 1794
          isUnread: true                                                                                              // 1795
        };                                                                                                            //
                                                                                                                      //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                   //
        // field inside of an object to update                                                                        //
        updater["appUpdates." + appId] = {                                                                            // 1790
          marketingVersion: marketingVersion,                                                                         // 1801
          packageId: packageId,                                                                                       // 1802
          name: name,                                                                                                 // 1803
          version: versionNumber                                                                                      // 1804
        };                                                                                                            //
        _this.collections.notifications.upsert({ userId: userId }, { $set: updater });                                // 1806
      });                                                                                                             //
                                                                                                                      //
      _this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                    // 1809
                                                                                                                      //
      // In the case where we replaced a previous notification and that was the only reference to the                 //
      // package, we need to clean it up                                                                              //
      Meteor.call("deleteUnusedPackages", appId);                                                                     // 1786
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.sendReferralProgramNotification = sendReferralProgramNotification;                          // 1816
                                                                                                                      //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                             // 1818
      check(appId, String);                                                                                           // 1819
      check(version, Match.Integer);                                                                                  // 1820
      check(packageId, String);                                                                                       // 1821
                                                                                                                      //
      var selector = {                                                                                                // 1823
        userId: Meteor.userId(),                                                                                      // 1824
        appId: appId,                                                                                                 // 1825
        appVersion: { $lte: version },                                                                                // 1826
        packageId: { $ne: packageId }                                                                                 // 1827
      };                                                                                                              //
                                                                                                                      //
      if (!this.isSimulation) {                                                                                       // 1830
        Grains.find(selector).forEach(function (grain) {                                                              // 1831
          backend.shutdownGrain(grain._id, grain.userId);                                                             // 1832
        });                                                                                                           //
      }                                                                                                               //
                                                                                                                      //
      Grains.update(selector, { $set: { appVersion: version, packageId: packageId } }, { multi: true });              // 1836
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                      // 1839
      // Mark package for possible installation.                                                                      //
                                                                                                                      //
      var fields = {                                                                                                  // 1842
        status: "download",                                                                                           // 1843
        progress: 0,                                                                                                  // 1844
        url: url,                                                                                                     // 1845
        isAutoUpdated: !!isAutoUpdated                                                                                // 1846
      };                                                                                                              //
                                                                                                                      //
      if (retryFailed) {                                                                                              // 1849
        Packages.update({ _id: packageId, status: "failed" }, { $set: fields });                                      // 1850
      } else {                                                                                                        //
        try {                                                                                                         // 1852
          fields._id = packageId;                                                                                     // 1853
          Packages.insert(fields);                                                                                    // 1854
        } catch (err) {                                                                                               //
          console.error("Simultaneous startInstall()s?", err.stack);                                                  // 1856
        }                                                                                                             //
      }                                                                                                               //
    };                                                                                                                //
                                                                                                                      //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                 // 1861
      check(keyFingerprint, String);                                                                                  // 1862
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                // 1863
    });                                                                                                               //
                                                                                                                      //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                     // 1866
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                  //
                                                                                                                      //
      check(keyFingerprint, ValidKeyFingerprint);                                                                     // 1869
                                                                                                                      //
      console.log("fetching keybase", keyFingerprint);                                                                // 1871
                                                                                                                      //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                 // 1876
      }, function (err, keybaseResponse) {                                                                            //
        if (err) {                                                                                                    // 1878
          console.log("keybase lookup error:", err.stack);                                                            // 1879
          return;                                                                                                     // 1880
        }                                                                                                             //
                                                                                                                      //
        if (!keybaseResponse.data) {                                                                                  // 1883
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                               // 1884
          return;                                                                                                     // 1885
        }                                                                                                             //
                                                                                                                      //
        var profile = (keybaseResponse.data.them || [])[0];                                                           // 1888
                                                                                                                      //
        if (profile) {                                                                                                // 1890
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                      //
          var record = {                                                                                              // 1892
            displayName: (profile.profile || {}).full_name,                                                           // 1893
            handle: (profile.basics || {}).username,                                                                  // 1894
            proofs: (profile.proofs_summary || {}).all || []                                                          // 1895
          };                                                                                                          //
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                       //
                                                                                                                      //
          record.proofs.forEach(function (proof) {                                                                    // 1890
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                   //
            // this would filter.)                                                                                    //
            for (var field in meteorBabelHelpers.sanitizeForInObject(proof)) {                                        // 1902
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                   //
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                       //
              // return any objects anyway).                                                                          //
              if (field.match(/[.$]/) || (0, _typeof3["default"])(proof[field]) === "object") {                       // 1906
                delete proof[field];                                                                                  // 1907
              }                                                                                                       //
            }                                                                                                         //
                                                                                                                      //
            // Indicate not verified.                                                                                 //
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                   //
            //   Keybase node-based CLI.                                                                              //
            proof.status = "unverified";                                                                              // 1899
          });                                                                                                         //
                                                                                                                      //
          KeybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });                                 // 1917
        } else {                                                                                                      //
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                   //
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                   //
          // from Keybase.                                                                                            //
          //                                                                                                          //
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                    //
          //   but at present we don't have the ability to verify proofs.                                             //
          KeybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                             //
      });                                                                                                             //
    };                                                                                                                //
                                                                                                                      //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                      // 1931
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                       //
                                                                                                                      //
      check(identityId, String);                                                                                      // 1934
      var account = Meteor.users.findOne({ "loginIdentities.id": identityId });                                       // 1935
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !Grains.findOne({ userId: account._id }) && !ApiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !Contacts.findOne({ ownerId: account._id })) {
        Meteor.users.remove({ _id: account._id });                                                                    // 1944
        backend.deleteUser(account._id);                                                                              // 1945
      }                                                                                                               //
    };                                                                                                                //
                                                                                                                      //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                      // 1949
      check(keyFingerprint, ValidKeyFingerprint);                                                                     // 1950
      var db = this.connection.sandstormDb;                                                                           // 1951
                                                                                                                      //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                               // 1953
      if (cursor.count() === 0) {                                                                                     // 1954
        // Fire off async update.                                                                                     //
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                 // 1956
      }                                                                                                               //
                                                                                                                      //
      return cursor;                                                                                                  // 1959
    });                                                                                                               //
                                                                                                                      //
    Meteor.publish("appIndex", function (appId) {                                                                     // 1962
      check(appId, String);                                                                                           // 1963
      var db = this.connection.sandstormDb;                                                                           // 1964
      var cursor = db.collections.appIndex.find({ _id: appId });                                                      // 1965
      return cursor;                                                                                                  // 1966
    });                                                                                                               //
                                                                                                                      //
    Meteor.publish("userPackages", function () {                                                                      // 1969
      var _this2 = this;                                                                                              //
                                                                                                                      //
      // Users should be able to see packages that are either:                                                        //
      // 1. referenced by one of their userActions                                                                    //
      // 2. referenced by one of their grains                                                                         //
      var db = this.connection.sandstormDb;                                                                           // 1973
                                                                                                                      //
      // Note that package information, once it is in the database, is static. There's no need to                     //
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                   //
      // to reactively remove a package from the client side when it is removed on the server, or                     //
      // when the client stops using it, because the worst case is the client has a small amount                      //
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                       //
      // So, we implement this as a cache: the first time each package ID shows up among the user's                   //
      // stuff, we push the package info to the client, and then we never update it.                                  //
      //                                                                                                              //
      // Alternatively, we could subscribe to each individual package query, but this would waste                     //
      // lots of server-side resources watching for events that will never happen or don't matter.                    //
      var hasPackage = {};                                                                                            // 1969
      var refPackage = function refPackage(packageId) {                                                               // 1986
        // Ignore dev apps.                                                                                           //
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                           // 1988
                                                                                                                      //
        if (!hasPackage[packageId]) {                                                                                 // 1990
          hasPackage[packageId] = true;                                                                               // 1991
          var pkg = db.getPackage(packageId);                                                                         // 1992
          if (pkg) {                                                                                                  // 1993
            _this2.added("packages", packageId, pkg);                                                                 // 1994
          } else {                                                                                                    //
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                // 1996
          }                                                                                                           //
        }                                                                                                             //
      };                                                                                                              //
                                                                                                                      //
      // package source 1: packages referred to by actions                                                            //
      var actions = db.userActions(this.userId);                                                                      // 1969
      var actionsHandle = actions.observe({                                                                           // 2004
        added: function () {                                                                                          // 2005
          function added(newAction) {                                                                                 // 2005
            refPackage(newAction.packageId);                                                                          // 2006
          }                                                                                                           //
                                                                                                                      //
          return added;                                                                                               //
        }(),                                                                                                          //
                                                                                                                      //
        changed: function () {                                                                                        // 2009
          function changed(oldAction, newAction) {                                                                    // 2009
            refPackage(newAction.packageId);                                                                          // 2010
          }                                                                                                           //
                                                                                                                      //
          return changed;                                                                                             //
        }()                                                                                                           //
      });                                                                                                             //
                                                                                                                      //
      // package source 2: packages referred to by grains directly                                                    //
      var grains = db.userGrains(this.userId);                                                                        // 1969
      var grainsHandle = grains.observe({                                                                             // 2016
        added: function () {                                                                                          // 2017
          function added(newGrain) {                                                                                  // 2017
            refPackage(newGrain.packageId);                                                                           // 2018
          }                                                                                                           //
                                                                                                                      //
          return added;                                                                                               //
        }(),                                                                                                          //
                                                                                                                      //
        changed: function () {                                                                                        // 2021
          function changed(oldGrain, newGrain) {                                                                      // 2021
            refPackage(newGrain.packageId);                                                                           // 2022
          }                                                                                                           //
                                                                                                                      //
          return changed;                                                                                             //
        }()                                                                                                           //
      });                                                                                                             //
                                                                                                                      //
      this.onStop(function () {                                                                                       // 2026
        actionsHandle.stop();                                                                                         // 2027
        grainsHandle.stop();                                                                                          // 2028
      });                                                                                                             //
                                                                                                                      //
      this.ready();                                                                                                   // 2031
    });                                                                                                               //
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 2035
  SandstormDb.prototype.currentFeatureKey = function () {                                                             // 2036
    // Returns an object with all of the current signed feature key properties,                                       //
    // or undefined, if the feature key is missing or not correctly signed.                                           //
    var doc = this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                      // 2039
    if (!doc) return undefined;                                                                                       // 2040
    var buf = new Buffer(doc.value);                                                                                  // 2041
    // We use loadSignedFeatureKey from server/feature-key.js.  This should probably get refactored                   //
    // once we can use ES6 modules.                                                                                   //
    return loadSignedFeatureKey(buf);                                                                                 // 2036
  };                                                                                                                  //
} else {                                                                                                              //
  SandstormDb.prototype.currentFeatureKey = function () {                                                             // 2047
    return this.collections.featureKey.findOne({ _id: "currentFeatureKey" });                                         // 2048
  };                                                                                                                  //
}                                                                                                                     //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-db/profile.js                                                                                   //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
var _typeof2 = require("babel-runtime/helpers/typeof");                                                               //
                                                                                                                      //
var _typeof3 = _interopRequireDefault(_typeof2);                                                                      //
                                                                                                                      //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                     //
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
var makeIdenticon = void 0;                                                                                           // 17
var httpProtocol = void 0;                                                                                            // 18
                                                                                                                      //
if (Meteor.isServer) {                                                                                                // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                   // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                      //
    // has a given identity linked. Automatically stops the subscription if the user loses the                        //
    // identity. Returns a boolean indicating whether the user initially has the identity.                            //
                                                                                                                      //
    var userId = publishHandler.userId;                                                                               // 26
    if (userId === identityId) {                                                                                      // 27
      return true;                                                                                                    // 28
    } else {                                                                                                          //
      var _ret = function () {                                                                                        //
        var hasIdentityCursor = Meteor.users.find({                                                                   // 30
          $or: [{                                                                                                     // 31
            _id: userId,                                                                                              // 33
            "loginIdentities.id": identityId                                                                          // 34
          }, {                                                                                                        //
            _id: userId,                                                                                              // 37
            "nonloginIdentities.id": identityId                                                                       // 38
          }]                                                                                                          //
        });                                                                                                           //
        if (hasIdentityCursor.count() == 0) {                                                                         // 42
          publishHandler.stop();                                                                                      // 43
          return {                                                                                                    // 44
            v: false                                                                                                  //
          };                                                                                                          //
        }                                                                                                             //
                                                                                                                      //
        var handle = hasIdentityCursor.observe({ removed: function () {                                               // 47
            function removed() {                                                                                      // 47
              publishHandler.stop();                                                                                  // 47
            }                                                                                                         //
                                                                                                                      //
            return removed;                                                                                           //
          }() });                                                                                                     //
                                                                                                                      //
        publishHandler.onStop(function () {                                                                           // 49
          handle.stop();                                                                                              // 49
        });                                                                                                           //
                                                                                                                      //
        return {                                                                                                      // 51
          v: true                                                                                                     //
        };                                                                                                            //
      }();                                                                                                            //
                                                                                                                      //
      if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3["default"])(_ret)) === "object") return _ret.v;   //
    }                                                                                                                 //
  };                                                                                                                  //
                                                                                                                      //
  Meteor.publish("identityProfile", function (identityId) {                                                           // 55
    check(identityId, String);                                                                                        // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                           // 57
                                                                                                                      //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                         // 59
        profile: 1,                                                                                                   // 61
        unverifiedEmail: 1,                                                                                           // 62
        expires: 1,                                                                                                   // 63
        createdAt: 1,                                                                                                 // 64
                                                                                                                      //
        "services.dev.name": 1,                                                                                       // 66
                                                                                                                      //
        "services.google.id": 1,                                                                                      // 68
        "services.google.email": 1,                                                                                   // 69
        "services.google.verified_email": 1,                                                                          // 70
        "services.google.name": 1,                                                                                    // 71
        "services.google.picture": 1,                                                                                 // 72
        "services.google.gender": 1,                                                                                  // 73
        "services.google.hd": 1,                                                                                      // 74
                                                                                                                      //
        "services.github.id": 1,                                                                                      // 76
        "services.github.email": 1,                                                                                   // 77
        "services.github.emails": 1,                                                                                  // 78
        "services.github.username": 1,                                                                                // 79
                                                                                                                      //
        "services.email.email": 1,                                                                                    // 81
                                                                                                                      //
        "services.ldap.id": 1,                                                                                        // 83
        "services.ldap.username": 1,                                                                                  // 84
        "services.ldap.rawAttrs": 1,                                                                                  // 85
                                                                                                                      //
        "services.saml.id": 1,                                                                                        // 87
        "services.saml.email": 1,                                                                                     // 88
        "services.saml.displayName": 1                                                                                // 89
      } });                                                                                                           //
  }), Meteor.publish("accountIdentities", function () {                                                               //
    // Maybe this should be folded into the "credentials" subscription?                                               //
                                                                                                                      //
    if (!this.userId) return [];                                                                                      // 96
                                                                                                                      //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                        // 98
        profile: 1,                                                                                                   // 101
        verifiedEmail: 1,                                                                                             // 102
        loginIdentities: 1,                                                                                           // 103
        nonloginIdentities: 1,                                                                                        // 104
        expires: 1,                                                                                                   // 105
        primaryEmail: 1                                                                                               // 106
      } });                                                                                                           //
  });                                                                                                                 //
                                                                                                                      //
  makeIdenticon = function makeIdenticon(id) {                                                                        // 110
    // We only make identicons client-side.                                                                           //
    return undefined;                                                                                                 // 112
  };                                                                                                                  //
                                                                                                                      //
  var Url = Npm.require("url");                                                                                       // 115
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                            // 116
} else {                                                                                                              //
  (function () {                                                                                                      //
    var identiconCache = {};                                                                                          // 118
                                                                                                                      //
    makeIdenticon = function makeIdenticon(id) {                                                                      // 120
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                         //
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                //
                                                                                                                      //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                      //
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                  //
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                     //
      // anyway to be safe.                                                                                           //
      id = id.slice(0, 32);                                                                                           // 128
                                                                                                                      //
      if (id in identiconCache) {                                                                                     // 130
        return identiconCache[id];                                                                                    // 131
      }                                                                                                               //
                                                                                                                      //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                    //
      var data = new Identicon(id, 512).toString();                                                                   // 120
      var result = "data:image/png;base64," + data;                                                                   // 136
      identiconCache[id] = result;                                                                                    // 137
      return result;                                                                                                  // 138
    };                                                                                                                //
                                                                                                                      //
    httpProtocol = window.location.protocol;                                                                          // 141
  })();                                                                                                               //
}                                                                                                                     //
                                                                                                                      //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                 // 144
                                                                                                                      //
function staticAssetUrl(id, staticHost) {                                                                             // 146
  if (id) {                                                                                                           // 147
    return staticHost + "/" + id;                                                                                     // 148
  } else {                                                                                                            //
    return undefined;                                                                                                 // 150
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function filterHandle(handle) {                                                                                       // 154
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                           //
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                              // 156
}                                                                                                                     //
                                                                                                                      //
function emailToHandle(email) {                                                                                       // 159
  // Turn an email address into a handle.                                                                             //
                                                                                                                      //
  if (!email) return undefined;                                                                                       // 162
                                                                                                                      //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                        //
  // on the same account.                                                                                             //
  var parts = email.split("@");                                                                                       // 159
  var base = filterHandle(parts[0].split("+")[0]);                                                                    // 167
                                                                                                                      //
  var domain = (parts[1] || "").split(".");                                                                           // 169
  if (domain[domain.length - 1] === "name") {                                                                         // 170
    // Oh, a .name domain. Let's use                                                                                  //
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                // 172
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                           //
    base = filterHandle(domain[0]);                                                                                   // 180
  }                                                                                                                   //
                                                                                                                      //
  return filterHandle(base);                                                                                          // 183
}                                                                                                                     //
                                                                                                                      //
SandstormDb.fillInProfileDefaults = function (user) {                                                                 // 186
  var profile = user.profile;                                                                                         // 187
  if (profile.service === "github") {                                                                                 // 188
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                   // 189
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);     // 190
  } else if (profile.service === "google") {                                                                          //
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                       // 193
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);       // 194
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                           // 196
  } else if (profile.service === "email") {                                                                           //
    var email = user.services.email.email;                                                                            // 198
    profile.name = profile.name || emailToHandle(email);                                                              // 199
    profile.handle = profile.handle || emailToHandle(email);                                                          // 200
  } else if (profile.service === "dev") {                                                                             //
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                           // 202
    profile.name = profile.name || user.services.dev.name;                                                            // 203
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                   // 204
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                            //
    profile.name = profile.name || "Demo User";                                                                       // 209
    profile.handle = profile.handle || "demo";                                                                        // 210
  } else if (profile.service === "ldap") {                                                                            //
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                         // 212
    var key = setting ? setting.value : "";                                                                           // 213
    profile.handle = profile.handle || user.services.ldap.username;                                                   // 214
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                // 215
  } else if (profile.service === "saml") {                                                                            //
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                       // 217
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                  // 218
  } else {                                                                                                            //
    throw new Error("unrecognized identity service: ", profile.service);                                              // 220
  }                                                                                                                   //
                                                                                                                      //
  profile.pronoun = profile.pronoun || "neutral";                                                                     // 223
};                                                                                                                    //
                                                                                                                      //
SandstormDb.fillInIntrinsicName = function (user) {                                                                   // 226
  var profile = user.profile;                                                                                         // 227
  if (profile.service === "github") {                                                                                 // 228
    profile.intrinsicName = user.services.github.username;                                                            // 229
  } else if (profile.service === "google") {                                                                          //
    profile.intrinsicName = user.services.google.name;                                                                // 231
    user.privateIntrinsicName = user.services.google.email;                                                           // 232
  } else if (profile.service === "email") {                                                                           //
    profile.intrinsicName = user.services.email.email;                                                                // 234
  } else if (profile.service === "dev") {                                                                             //
    profile.intrinsicName = user.services.dev.name;                                                                   // 236
  } else if (profile.service === "demo") {                                                                            //
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                               // 238
  } else if (profile.service === "ldap") {                                                                            //
    profile.intrinsicName = user.services.ldap.username;                                                              // 240
  } else if (profile.service === "saml") {                                                                            //
    profile.intrinsicName = user.services.saml.id;                                                                    // 242
  } else {                                                                                                            //
    throw new Error("unrecognized identity service: ", profile.service);                                              // 244
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
SandstormDb.fillInLoginId = function (identity) {                                                                     // 248
  var service = identity.profile.service;                                                                             // 249
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                         // 250
};                                                                                                                    //
                                                                                                                      //
SandstormDb.getVerifiedEmails = function (identity) {                                                                 // 253
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {        // 254
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                             //
    return [{ email: identity.services.google.email, primary: true }];                                                // 256
  } else if (identity.services.email) {                                                                               //
    return [{ email: identity.services.email.email, primary: true }];                                                 // 258
  } else if (identity.services.github && identity.services.github.emails) {                                           //
    return _.chain(identity.services.github.emails).filter(function (email) {                                         // 260
      return email.verified;                                                                                          // 261
    }).map(function (email) {                                                                                         //
      return _.pick(email, "email", "primary");                                                                       //
    }).value();                                                                                                       //
  } else if (identity.services.ldap) {                                                                                //
    var email = identity.services.ldap.rawAttrs[SandstormDb.prototype.getLdapEmailField()];                           // 265
    if (email) {                                                                                                      // 266
      return [{ email: email, primary: true }];                                                                       // 267
    }                                                                                                                 //
  } else if (identity.services.saml && identity.services.saml.email) {                                                //
    return [{ email: identity.services.saml.email, primary: true }];                                                  // 270
  }                                                                                                                   //
                                                                                                                      //
  return [];                                                                                                          // 273
};                                                                                                                    //
                                                                                                                      //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                      // 276
  // Returns an array of identities which have the given email address as one of their verified                       //
  // addresses.                                                                                                       //
                                                                                                                      //
  check(email, String);                                                                                               // 280
                                                                                                                      //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                //
    return !!_findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                   // 289
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                        // 293
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                // 294
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                    //
                                                                                                                      //
SandstormDb.fillInPictureUrl = function (user) {                                                                      // 301
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                  // 302
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);              // 303
};                                                                                                                    //
                                                                                                                      //
SandstormDb.getUserIdentityIds = function (user) {                                                                    // 307
  // Given an account user object, returns an array containing the ID of each identity linked to the                  //
  // account. Always returns the most recently added login identity first.                                            //
  if (user && user.loginIdentities) {                                                                                 // 310
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                             // 311
  } else {                                                                                                            //
    return [];                                                                                                        // 313
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
SandstormDb.getUserEmails = function (user) {                                                                         // 317
  // Given a user object, returns an array containing all email addresses associated with that user.                  //
  // Each entry in the array is an object of the form:                                                                //
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                   //
  //                                                                                                                  //
  // At most one entry in the result has `primary = true`.                                                            //
  //                                                                                                                  //
  // TODO(cleanup): This actually does need to query the database to fetch profile information                        //
  //   for linked identities, so it probably makes more sense for it to be a non-static method                        //
  //   on SandstormDb.                                                                                                //
                                                                                                                      //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                             // 328
  var verifiedEmails = {};                                                                                            // 329
  var unverifiedEmails = {};                                                                                          // 330
                                                                                                                      //
  identityIds.forEach(function (id) {                                                                                 // 332
    var identity = Meteor.users.findOne({ _id: id });                                                                 // 333
    if (identity && identity.services) {                                                                              // 334
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                      // 335
        if (verifiedEmail) {                                                                                          // 336
          verifiedEmails[verifiedEmail.email] = true;                                                                 // 337
        }                                                                                                             //
      });                                                                                                             //
    }                                                                                                                 //
                                                                                                                      //
    if (identity && identity.unverifiedEmail) {                                                                       // 342
      unverifiedEmails[identity.unverifiedEmail] = true;                                                              // 343
    }                                                                                                                 //
  });                                                                                                                 //
                                                                                                                      //
  var result = [];                                                                                                    // 347
  _.keys(verifiedEmails).map(function (email) {                                                                       // 348
    result.push({ email: email,                                                                                       // 349
      verified: true,                                                                                                 // 350
      primary: email === user.primaryEmail });                                                                        // 351
  });                                                                                                                 //
                                                                                                                      //
  _.keys(unverifiedEmails).map(function (email) {                                                                     // 354
    if (!(email in verifiedEmails)) {                                                                                 // 355
      result.push({ email: email, verified: false });                                                                 // 355
    }                                                                                                                 //
  });                                                                                                                 //
                                                                                                                      //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                              //
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                  // 317
    result[0].primary = true;                                                                                         // 360
  }                                                                                                                   //
                                                                                                                      //
  return result;                                                                                                      // 363
};                                                                                                                    //
                                                                                                                      //
SandstormDb.prototype.addContact = function () {                                                                      // 366
  function addContact(ownerId, identityId) {                                                                          // 366
    check(ownerId, String);                                                                                           // 367
    check(identityId, String);                                                                                        // 368
    var profile = this.getIdentity(identityId).profile;                                                               // 369
    this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                  // 370
      ownerId: ownerId,                                                                                               // 371
      petname: profile && profile.name,                                                                               // 372
      created: new Date(),                                                                                            // 373
      identityId: identityId                                                                                          // 374
    });                                                                                                               //
  }                                                                                                                   //
                                                                                                                      //
  return addContact;                                                                                                  //
}();                                                                                                                  //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"user.js":function(require){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-db/user.js                                                                                      //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
// Sandstorm - Personal Cloud Sandbox                                                                                 //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                              //
// All rights reserved.                                                                                               //
//                                                                                                                    //
// Licensed under the Apache License, Version 2.0 (the "License");                                                    //
// you may not use this file except in compliance with the License.                                                   //
// You may obtain a copy of the License at                                                                            //
//                                                                                                                    //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                       //
//                                                                                                                    //
// Unless required by applicable law or agreed to in writing, software                                                //
// distributed under the License is distributed on an "AS IS" BASIS,                                                  //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                           //
// See the License for the specific language governing permissions and                                                //
// limitations under the License.                                                                                     //
                                                                                                                      //
var Crypto = Npm.require("crypto");                                                                                   // 17
var Future = Npm.require("fibers/future");                                                                            // 18
                                                                                                                      //
userPictureUrl = function userPictureUrl(user) {                                                                      // 20
  if (user.services && !(user.profile && user.profile.picture)) {                                                     // 21
    // Try to determine user's avatar URL from login service.                                                         //
                                                                                                                      //
    var google = user.services.google;                                                                                // 24
    if (google && google.picture) {                                                                                   // 25
      return google.picture;                                                                                          // 26
    }                                                                                                                 //
                                                                                                                      //
    var github = user.services.github;                                                                                // 29
    if (github && github.id) {                                                                                        // 30
      return "https://avatars.githubusercontent.com/u/" + github.id;                                                  // 31
    }                                                                                                                 //
                                                                                                                      //
    // Note that we do NOT support Gravatar for email addresses because pinging Gravatar would be                     //
    // a data leak, revealing that the user has logged into this Sandstorm server. Google and                         //
    // Github are different because they are actually the identity providers, so they already know                    //
    // the user logged in.                                                                                            //
  }                                                                                                                   // 21
};                                                                                                                    //
                                                                                                                      //
fetchPicture = function fetchPicture(url) {                                                                           // 41
  try {                                                                                                               // 42
    var result = HTTP.get(url, {                                                                                      // 43
      npmRequestOptions: { encoding: null },                                                                          // 44
      timeout: 5000                                                                                                   // 45
    });                                                                                                               //
                                                                                                                      //
    var metadata = {};                                                                                                // 48
                                                                                                                      //
    metadata.mimeType = result.headers["content-type"];                                                               // 50
    if (metadata.mimeType.lastIndexOf("image/png", 0) === -1 && metadata.mimeType.lastIndexOf("image/jpeg", 0) === -1) {
      throw new Error("unexpected Content-Type:", metadata.mimeType);                                                 // 53
    }                                                                                                                 //
                                                                                                                      //
    var enc = result.headers["content-encoding"];                                                                     // 56
    if (enc && enc !== "identity") {                                                                                  // 57
      metadata.encoding = enc;                                                                                        // 58
    }                                                                                                                 //
                                                                                                                      //
    return addStaticAsset(metadata, result.content);                                                                  // 61
  } catch (err) {                                                                                                     //
    console.error("failed to fetch user profile picture:", url, err.stack);                                           // 63
  }                                                                                                                   //
};                                                                                                                    //
                                                                                                                      //
var ValidHandle = Match.Where(function (handle) {                                                                     // 67
  check(handle, String);                                                                                              // 68
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                                        // 69
});                                                                                                                   //
                                                                                                                      //
var localSandstormDb = new SandstormDb();                                                                             // 72
// TODO(someday): fix this when SandstormDb actually stores meaningful state on the object.                           //
// Unfortunately, onCreateUser doesn't pass along the connection object.                                              //
                                                                                                                      //
Accounts.onCreateUser(function (options, user) {                                                                      // 76
  if (user.loginIdentities) {                                                                                         // 77
    // it's an account                                                                                                //
    check(user, { _id: String,                                                                                        // 79
      createdAt: Date,                                                                                                // 80
      isAdmin: Match.Optional(Boolean),                                                                               // 81
      hasCompletedSignup: Match.Optional(Boolean),                                                                    // 82
      signupKey: Match.Optional(String),                                                                              // 83
      signupNote: Match.Optional(String),                                                                             // 84
      signupEmail: Match.Optional(String),                                                                            // 85
      expires: Match.Optional(Date),                                                                                  // 86
      appDemoId: Match.Optional(String),                                                                              // 87
      loginIdentities: [{ id: String }],                                                                              // 88
      nonloginIdentities: [{ id: String }] });                                                                        // 89
                                                                                                                      //
    if (Meteor.settings["public"].quotaEnabled) {                                                                     // 91
      user.experiments = user.experiments || {};                                                                      // 92
      user.experiments = {                                                                                            // 93
        firstTimeBillingPrompt: Math.random() < 0.5 ? "control" : "test"                                              // 94
      };                                                                                                              //
      if (!("expires" in user)) {                                                                                     // 96
        sendReferralProgramNotification(user._id);                                                                    // 97
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    return user;                                                                                                      // 101
  }                                                                                                                   //
                                                                                                                      //
  if (localSandstormDb.getOrganizationDisallowGuests() && !localSandstormDb.isIdentityInOrganization(user)) {         // 104
    throw new Meteor.Error(400, "User not in organization.");                                                         // 106
  }                                                                                                                   //
                                                                                                                      //
  // Check profile.                                                                                                   //
  if (options.profile) {                                                                                              // 76
    // TODO(cleanup): This check also appears in accounts-ui-methods.js.                                              //
    check(options.profile, Match.ObjectIncluding({                                                                    // 112
      name: Match.OneOf(null, Match.Optional(String)),                                                                // 113
      handle: Match.Optional(ValidHandle),                                                                            // 114
      pronoun: Match.Optional(Match.OneOf("male", "female", "neutral", "robot"))                                      // 115
    }));                                                                                                              //
  }                                                                                                                   //
                                                                                                                      //
  check(options.unverifiedEmail, Match.Optional(String));                                                             // 119
                                                                                                                      //
  if (options.unverifiedEmail) {                                                                                      // 121
    user.unverifiedEmail = options.unverifiedEmail;                                                                   // 122
  }                                                                                                                   //
                                                                                                                      //
  user.profile = _.pick(options.profile || {}, "name", "handle", "pronouns");                                         // 125
                                                                                                                      //
  // Try downloading avatar.                                                                                          //
  var url = userPictureUrl(user);                                                                                     // 76
  if (url) {                                                                                                          // 129
    var assetId = fetchPicture(url);                                                                                  // 130
    if (assetId) {                                                                                                    // 131
      user.profile.picture = assetId;                                                                                 // 132
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  var serviceUserId = void 0;                                                                                         // 136
  if (user.services && user.services.dev) {                                                                           // 137
    check(user.services.dev, { name: String, isAdmin: Boolean, hasCompletedSignup: Boolean });                        // 138
    serviceUserId = user.services.dev.name;                                                                           // 139
    user.profile.service = "dev";                                                                                     // 140
  } else if ("expires" in user) {                                                                                     //
    serviceUserId = user._id;                                                                                         // 142
    user.profile.service = "demo";                                                                                    // 143
  } else if (user.services && user.services.email) {                                                                  //
    check(user.services.email, { email: String,                                                                       // 145
      tokens: [{ digest: String, algorithm: String, createdAt: Date }] });                                            // 147
    serviceUserId = user.services.email.email;                                                                        // 148
    user.profile.service = "email";                                                                                   // 149
  } else if (user.services && "google" in user.services) {                                                            //
    serviceUserId = user.services.google.id;                                                                          // 151
    user.profile.service = "google";                                                                                  // 152
  } else if (user.services && "github" in user.services) {                                                            //
    serviceUserId = user.services.github.id;                                                                          // 154
    user.profile.service = "github";                                                                                  // 155
  } else if (user.services && "ldap" in user.services) {                                                              //
    serviceUserId = user.services.ldap.id;                                                                            // 157
    user.profile.service = "ldap";                                                                                    // 158
  } else if (user.services && "saml" in user.services) {                                                              //
    serviceUserId = user.services.saml.id;                                                                            // 160
    user.profile.service = "saml";                                                                                    // 161
  } else {                                                                                                            //
    throw new Meteor.Error(400, "user does not have a recognized identity provider: " + JSON.stringify(user));        // 163
  }                                                                                                                   //
                                                                                                                      //
  user._id = Crypto.createHash("sha256").update(user.profile.service + ":" + serviceUserId).digest("hex");            // 167
                                                                                                                      //
  return user;                                                                                                        // 170
});                                                                                                                   //
                                                                                                                      //
Accounts.validateLoginAttempt(function (attempt) {                                                                    // 173
  if (!attempt.allowed) {                                                                                             // 174
    return false;                                                                                                     // 175
  }                                                                                                                   //
                                                                                                                      //
  var db = attempt.connection.sandstormDb;                                                                            // 178
  var user = attempt.user;                                                                                            // 179
  if (user.loginIdentities) {                                                                                         // 180
    // it's an account                                                                                                //
    if (db.getOrganizationDisallowGuests() && !db.isUserInOrganization(user)) {                                       // 182
      throw new Meteor.Error(403, "User not in organization.");                                                       // 184
    }                                                                                                                 //
  } else {                                                                                                            //
    if (db.getOrganizationDisallowGuests() && !db.isIdentityInOrganization(user)) {                                   // 187
      throw new Meteor.Error(403, "User not in organization.");                                                       // 189
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  return true;                                                                                                        // 193
});                                                                                                                   //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"migrations.js":function(require){

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                    //
// packages/sandstorm-db/migrations.js                                                                                //
//                                                                                                                    //
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                      //
// Minimal tooling for doing run-at-least-once, ordered migrations.                                                   //
//                                                                                                                    //
// Because migrations can experience partial failure and likely have                                                  //
// side-effects, we should be careful to make sure all migrations are                                                 //
// idempotent and safe to accidentally run multiple times.                                                            //
                                                                                                                      //
var Future = Npm.require("fibers/future");                                                                            // 7
var Url = Npm.require("url");                                                                                         // 8
var Crypto = Npm.require("crypto");                                                                                   // 9
                                                                                                                      //
var updateLoginStyleToRedirect = function updateLoginStyleToRedirect() {                                              // 11
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                          // 12
  ["google", "github"].forEach(function (serviceName) {                                                               // 13
    var config = configurations.findOne({ service: serviceName });                                                    // 14
    if (config && config.loginStyle !== "redirect") {                                                                 // 15
      configurations.update({ service: serviceName }, { $set: { loginStyle: "redirect" } });                          // 16
    }                                                                                                                 //
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
var enableLegacyOAuthProvidersIfNotInSettings = function enableLegacyOAuthProvidersIfNotInSettings() {                // 21
  // In the before time, Google and Github login were enabled by default.                                             //
  //                                                                                                                  //
  // This actually didn't make much sense, required the first user to configure                                       //
  // OAuth, and had some trust-the-first-user properties that weren't totally                                         //
  // secure.                                                                                                          //
  //                                                                                                                  //
  // Now, we have admin-token, so we wish to disable all logins by default                                            //
  // (since they need to be configured anyway) but since users may have never                                         //
  // explicitly told Sandstorm that Google or Github login should be enabled,                                         //
  // we can't just use the value in the Settings collection, since it might                                           //
  // never have been set.                                                                                             //
  //                                                                                                                  //
  // Thus, if the service is configured but absent from Settings, we should                                           //
  // explicitly enable it in Settings, and then the rest of the logic can just                                        //
  // depend on what value is in Settings and default to false without breaking                                        //
  // user installations.                                                                                              //
  var configurations = Package["service-configuration"].ServiceConfiguration.configurations;                          // 38
  ["google", "github"].forEach(function (serviceName) {                                                               // 39
    var config = configurations.findOne({ service: serviceName });                                                    // 40
    var serviceConfig = Settings.findOne({ _id: serviceName });                                                       // 41
    if (config && !serviceConfig) {                                                                                   // 42
      // Only explicitly enable the login service if:                                                                 //
      // 1) the service is already configured                                                                         //
      // 2) there is no sandstorm configuration already present (the user was                                         //
      //    using the previous default behavior).                                                                     //
      Settings.insert({ _id: serviceName, value: true });                                                             // 47
    }                                                                                                                 //
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
var denormalizeInviteInfo = function denormalizeInviteInfo() {                                                        // 52
  // When a user is invited via a signup token, the `signupKey` field of their user table entry                       //
  // has always been populated to indicate the key they used. This points into the SignupKeys table                   //
  // which has more information about the key, namely a freeform note entered by the admin when                       //
  // they created the key. In the case that the email invite form was used, the note has the form                     //
  // "E-mail invite to <address>".                                                                                    //
  //                                                                                                                  //
  // Later, we decided it was useful to indicate in the users table visible to the admin                              //
  // information about the invite terms. Namely, for email invites we want to show the address                        //
  // and for others we want to show the note. To make this efficient, fields `signupNote` and                         //
  // `signupEmail` were added to the users table. We can backfill these values by denormalizing                       //
  // from the SignupKeys table.                                                                                       //
                                                                                                                      //
  Meteor.users.find().forEach(function (user) {                                                                       // 65
    if (user.signupKey && typeof user.signupKey === "string" && user.signupKey !== "admin") {                         // 66
      var signupInfo = SignupKeys.findOne(user.signupKey);                                                            // 67
      if (signupInfo && signupInfo.note) {                                                                            // 68
        var newFields = { signupNote: signupInfo.note };                                                              // 69
                                                                                                                      //
        var prefix = "E-mail invite to ";                                                                             // 71
        if (signupInfo.note.lastIndexOf(prefix) === 0) {                                                              // 72
          newFields.signupEmail = signupInfo.note.slice(prefix.length);                                               // 73
        }                                                                                                             //
                                                                                                                      //
        Meteor.users.update(user._id, { $set: newFields });                                                           // 76
      }                                                                                                               //
    }                                                                                                                 //
  });                                                                                                                 //
};                                                                                                                    //
                                                                                                                      //
function mergeRoleAssignmentsIntoApiTokens() {                                                                        // 82
  RoleAssignments.find().forEach(function (roleAssignment) {                                                          // 83
    ApiTokens.insert({                                                                                                // 84
      grainId: roleAssignment.grainId,                                                                                // 85
      userId: roleAssignment.sharer,                                                                                  // 86
      roleAssignment: roleAssignment.roleAssignment,                                                                  // 87
      petname: roleAssignment.petname,                                                                                // 88
      created: roleAssignment.created,                                                                                // 89
      owner: { user: { userId: roleAssignment.recipient,                                                              // 90
          title: roleAssignment.title } }                                                                             // 91
    });                                                                                                               //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function fixOasisStorageUsageStats() {}                                                                               // 96
// This migration only pertained to Oasis and it was successfully applied there. Since it referred                    //
// to some global variables that we later wanted to remove and/or rename, we've since replaced it                     //
// with a no-op.                                                                                                      //
                                                                                                                      //
function fetchProfilePictures() {                                                                                     // 101
  Meteor.users.find({}).forEach(function (user) {                                                                     // 102
    var url = userPictureUrl(user);                                                                                   // 103
    if (url) {                                                                                                        // 104
      console.log("Fetching user picture:", url);                                                                     // 105
      var assetId = fetchPicture(url);                                                                                // 106
      if (assetId) {                                                                                                  // 107
        Meteor.users.update(user._id, { $set: { "profile.picture": assetId } });                                      // 108
      }                                                                                                               //
    }                                                                                                                 //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function assignPlans() {                                                                                              // 114
  if (Meteor.settings["public"].quotaEnabled && SandstormDb.paymentsMigrationHook) {                                  // 115
    SandstormDb.paymentsMigrationHook(SignupKeys, Plans.find().fetch());                                              // 116
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function removeKeyrings() {                                                                                           // 120
  // These blobs full of public keys were not intended to find their way into mongo and while                         //
  // harmless they slow things down because they're huge. Remove them.                                                //
  Packages.update({ "manifest.metadata.pgpKeyring": { $exists: true } }, { $unset: { "manifest.metadata.pgpKeyring": "" } }, { multi: true });
}                                                                                                                     //
                                                                                                                      //
function useLocalizedTextInUserActions() {                                                                            // 128
  function toLocalizedText(newObj, oldObj, field) {                                                                   // 129
    if (field in oldObj) {                                                                                            // 130
      if (typeof oldObj[field] === "string") {                                                                        // 131
        newObj[field] = { defaultText: oldObj[field] };                                                               // 132
      } else {                                                                                                        //
        newObj[field] = oldObj[field];                                                                                // 134
      }                                                                                                               //
    }                                                                                                                 //
  }                                                                                                                   //
                                                                                                                      //
  UserActions.find({}).forEach(function (userAction) {                                                                // 139
    var fields = {};                                                                                                  // 140
    toLocalizedText(fields, userAction, "appTitle");                                                                  // 141
    toLocalizedText(fields, userAction, "title");                                                                     // 142
    toLocalizedText(fields, userAction, "nounPhrase");                                                                // 143
    UserActions.update(userAction._id, { $set: fields });                                                             // 144
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function verifyAllPgpSignatures() {                                                                                   // 148
  Packages.find({}).forEach(function (pkg) {                                                                          // 149
    try {                                                                                                             // 150
      console.log("checking PGP signature for package:", pkg._id);                                                    // 151
      var info = waitPromise(globalBackend.cap().tryGetPackage(pkg._id));                                             // 152
      if (info.authorPgpKeyFingerprint) {                                                                             // 153
        console.log("  " + info.authorPgpKeyFingerprint);                                                             // 154
        Packages.update(pkg._id, { $set: { authorPgpKeyFingerprint: info.authorPgpKeyFingerprint } });                // 155
      } else {                                                                                                        //
        console.log("  no signature");                                                                                // 158
      }                                                                                                               //
    } catch (err) {                                                                                                   //
      console.error(err.stack);                                                                                       // 161
    }                                                                                                                 //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function splitUserIdsIntoAccountIdsAndIdentityIds() {                                                                 // 166
  Meteor.users.find().forEach(function (user) {                                                                       // 167
    var identity = {};                                                                                                // 168
    var serviceUserId = void 0;                                                                                       // 169
    if ("devName" in user) {                                                                                          // 170
      identity.service = "dev";                                                                                       // 171
      serviceUserId = user.devName;                                                                                   // 172
    } else if ("expires" in user) {                                                                                   //
      identity.service = "demo";                                                                                      // 174
      serviceUserId = user._id;                                                                                       // 175
    } else if (user.services && "google" in user.services) {                                                          //
      identity.service = "google";                                                                                    // 177
      if (user.services.google.email && user.services.google.verified_email) {                                        // 178
        // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                         //
        identity.verifiedEmail = user.services.google.email;                                                          // 179
      }                                                                                                               //
                                                                                                                      //
      serviceUserId = user.services.google.id;                                                                        // 182
    } else if (user.services && "github" in user.services) {                                                          //
      identity.service = "github";                                                                                    // 184
      identity.unverifiedEmail = user.services.github.email;                                                          // 185
      serviceUserId = user.services.github.id;                                                                        // 186
    } else if (user.services && "emailToken" in user.services) {                                                      //
      identity.service = "emailToken";                                                                                // 188
      identity.verifiedEmail = user.services.emailToken.email;                                                        // 189
      serviceUserId = user.services.emailToken.email;                                                                 // 190
    }                                                                                                                 //
                                                                                                                      //
    identity.id = Crypto.createHash("sha256").update(identity.service + ":" + serviceUserId).digest("hex");           // 193
                                                                                                                      //
    if (user.profile) {                                                                                               // 196
      if (user.profile.name) {                                                                                        // 197
        identity.name = user.profile.name;                                                                            // 198
      }                                                                                                               //
                                                                                                                      //
      if (user.profile.handle) {                                                                                      // 201
        identity.handle = user.profile.handle;                                                                        // 202
      }                                                                                                               //
                                                                                                                      //
      if (user.profile.picture) {                                                                                     // 205
        identity.picture = user.profile.picture;                                                                      // 206
      }                                                                                                               //
                                                                                                                      //
      if (user.profile.pronoun) {                                                                                     // 209
        identity.pronoun = user.profile.pronoun;                                                                      // 210
      }                                                                                                               //
                                                                                                                      //
      if (user.profile.email) {                                                                                       // 213
        identity.unverifiedEmail = user.profile.email;                                                                // 214
      }                                                                                                               //
    }                                                                                                                 //
                                                                                                                      //
    identity.main = true;                                                                                             // 218
                                                                                                                      //
    Meteor.users.update(user._id, { $set: { identities: [identity] } });                                              // 220
                                                                                                                      //
    Grains.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                      // 222
    Sessions.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                    // 223
    ApiTokens.update({ userId: user._id }, { $set: { identityId: identity.id } }, { multi: true });                   // 224
    ApiTokens.update({ "owner.user.userId": user._id }, { $set: { "owner.user.identityId": identity.id } }, { multi: true });
    ApiTokens.update({ "owner.grain.introducerUser": user._id }, { $set: { "owner.grain.introducerIdentity": identity.id } }, { multi: true });
                                                                                                                      //
    while (ApiTokens.update({ "requirements.permissionsHeld.userId": user._id }, { $set: { "requirements.$.permissionsHeld.identityId": identity.id },
      $unset: { "requirements.$.permissionsHeld.userId": 1 } }, { multi: true }) > 0) {}                              // 236
    // The `$` operatorer modifies the first element in the array that matches the query. Since                       //
    // there may be many matches, we need to repeat until no documents are modified.                                  //
  });                                                                                                                 //
                                                                                                                      // 167
  ApiTokens.remove({ userInfo: { $exists: true } });                                                                  // 243
  // We've renamed `Grain.UserInfo.userId` to `Grain.userInfo.identityId`. The only place                             //
  // that this field could show up in the database was in this deprecated, no-longer-functional                       //
  // form of API token.                                                                                               //
}                                                                                                                     // 166
                                                                                                                      //
function appUpdateSettings() {                                                                                        // 249
  Settings.insert({ _id: "appMarketUrl", value: "https://apps.sandstorm.io" });                                       // 250
  Settings.insert({ _id: "appIndexUrl", value: "https://app-index.sandstorm.io" });                                   // 251
  Settings.insert({ _id: "appUpdatesEnabled", value: true });                                                         // 252
}                                                                                                                     //
                                                                                                                      //
function moveDevAndEmailLoginDataIntoIdentities() {                                                                   // 255
  Meteor.users.find().forEach(function (user) {                                                                       // 256
    if (user.identities.length != 1) {                                                                                // 257
      throw new Error("User does not have exactly one identity: ", user);                                             // 258
    }                                                                                                                 //
                                                                                                                      //
    var identity = user.identities[0];                                                                                // 261
    if (Match.test(identity.service, Object)) {                                                                       // 262
      return;                                                                                                         // 262
    } // Already migrated.                                                                                            //
                                                                                                                      //
    var newIdentity = _.pick(identity, "id", "main", "noLogin", "verifiedEmail", "unverifiedEmail");                  // 256
    newIdentity.profile = _.pick(identity, "name", "handle", "picture", "pronoun");                                   // 265
                                                                                                                      //
    var serviceObject = {};                                                                                           // 267
    var fieldsToUnset = {};                                                                                           // 268
                                                                                                                      //
    if (identity.service === "dev") {                                                                                 // 270
      serviceObject.name = user.devName;                                                                              // 271
      fieldsToUnset.devName = 1;                                                                                      // 272
    } else if (identity.service === "emailToken") {                                                                   //
      serviceObject.tokens = user.services.emailToken.tokens;                                                         // 274
      serviceObject.email = user.services.emailToken.email;                                                           // 275
      fieldsToUnset["services.emailToken"] = 1;                                                                       // 276
    }                                                                                                                 //
                                                                                                                      //
    newIdentity.service = {};                                                                                         // 279
    newIdentity.service[identity.service] = serviceObject;                                                            // 280
                                                                                                                      //
    var modifier = { $set: { identities: [newIdentity] } };                                                           // 282
    if (Object.keys(fieldsToUnset).length > 0) {                                                                      // 283
      modifier.$unset = fieldsToUnset;                                                                                // 284
    }                                                                                                                 //
                                                                                                                      //
    Meteor.users.update({ _id: user._id }, modifier);                                                                 // 287
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function repairEmailIdentityIds() {                                                                                   // 291
  Meteor.users.find({ "identities.service.emailToken": { $exists: 1 } }).forEach(function (user) {                    // 292
    if (user.identities.length != 1) {                                                                                // 293
      throw new Error("User does not have exactly one identity: ", user);                                             // 294
    }                                                                                                                 //
                                                                                                                      //
    var identity = user.identities[0];                                                                                // 297
    var newIdentity = _.pick(identity, "main", "noLogin", "verifiedEmail", "unverifiedMail", "profile");              // 298
    newIdentity.service = { email: identity.service.emailToken };                                                     // 300
    newIdentity.id = Crypto.createHash("sha256").update("email:" + identity.service.emailToken.email).digest("hex");  // 301
                                                                                                                      //
    Grains.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });            // 304
    Sessions.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });          // 305
    ApiTokens.update({ identityId: identity.id }, { $set: { identityId: newIdentity.id } }, { multi: true });         // 306
    ApiTokens.update({ "owner.user.identityId": identity.id }, { $set: { "owner.user.identityId": newIdentity.id } }, { multi: true });
    ApiTokens.update({ "owner.grain.introducerIdentity": identity.id }, { $set: { "owner.grain.introducerIdentity": newIdentity.id } }, { multi: true });
                                                                                                                      //
    while (ApiTokens.update({ "requirements.permissionsHeld.identityId": identity.id }, { $set: { "requirements.$.permissionsHeld.identityId": newIdentity.id } }, { multi: true }) > 0) {}
                                                                                                                      //
    Meteor.users.update({ _id: user._id }, { $set: { identities: [newIdentity] } });                                  // 320
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function splitAccountUsersAndIdentityUsers() {                                                                        // 324
  Meteor.users.find({ identities: { $exists: true } }).forEach(function (user) {                                      // 325
    if (user.identities.length != 1) {                                                                                // 326
      throw new Error("User does not have exactly one identity: ", user);                                             // 327
    }                                                                                                                 //
                                                                                                                      //
    var identity = user.identities[0];                                                                                // 330
    var identityUser = _.pick(user, "createdAt", "lastActive", "expires");                                            // 331
    identityUser._id = identity.id;                                                                                   // 332
    identityUser.profile = identity.profile;                                                                          // 333
    _.extend(identityUser, _.pick(identity, "unverifiedEmail"));                                                      // 334
    identityUser.profile.service = Object.keys(identity.service)[0];                                                  // 335
                                                                                                                      //
    // Updating this user needs to be a two step process because the `services` field typically                       //
    // contains subfields that are constrained to be unique by Mongo indices.                                         //
    identityUser.stagedServices = _.omit(user.services, "resume");                                                    // 325
    if (identity.service.dev) {                                                                                       // 340
      identityUser.stagedServices.dev = identity.service.dev;                                                         // 341
    } else if (identity.service.email) {                                                                              //
      identityUser.stagedServices.email = identity.service.email;                                                     // 343
    }                                                                                                                 //
                                                                                                                      //
    var accountUser = _.pick(user, "_id", "createdAt", "lastActive", "expires", "isAdmin", "signupKey", "signupNote", "signupEmail", "plan", "storageUsage", "isAppDemoUser", "appDemoId", "payments", "dailySentMailCount", "hasCompletedSignup");
    accountUser.loginIdentities = [_.pick(identity, "id")];                                                           // 350
    accountUser.nonloginIdentities = [];                                                                              // 351
    if (user.services && user.services.resume) {                                                                      // 352
      accountUser.services = { resume: user.services.resume };                                                        // 353
    }                                                                                                                 //
                                                                                                                      //
    accountUser.stashedOldUser = user;                                                                                // 356
                                                                                                                      //
    ApiTokens.update({ identityId: identityUser._id }, { $set: { accountId: user._id } }, { multi: true });           // 358
                                                                                                                      //
    Meteor.users.upsert({ _id: identityUser._id }, identityUser);                                                     // 361
    Meteor.users.update({ _id: user._id }, accountUser);                                                              // 362
  });                                                                                                                 //
                                                                                                                      //
  Meteor.users.find({ stagedServices: { $exists: true } }).forEach(function (identity) {                              // 365
    Meteor.users.update({ _id: identity._id }, { $unset: { stagedServices: 1 },                                       // 366
      $set: { services: identity.stagedServices } });                                                                 // 367
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function populateContactsFromApiTokens() {                                                                            // 371
  ApiTokens.find({ "owner.user.identityId": { $exists: 1 },                                                           // 372
    accountId: { $exists: 1 } }).forEach(function (token) {                                                           // 373
    var identityId = token.owner.user.identityId;                                                                     // 374
    var identity = SandstormDb.prototype.getIdentity(identityId);                                                     // 375
    if (identity) {                                                                                                   // 376
      var profile = identity.profile;                                                                                 // 377
      Contacts.upsert({ ownerId: token.accountId, identityId: identityId }, {                                         // 378
        ownerId: token.accountId,                                                                                     // 379
        petname: profile && profile.name,                                                                             // 380
        created: new Date(),                                                                                          // 381
        identityId: identityId,                                                                                       // 382
        profile: profile                                                                                              // 383
      });                                                                                                             //
    }                                                                                                                 //
  });                                                                                                                 //
}                                                                                                                     //
                                                                                                                      //
function cleanUpApiTokens() {                                                                                         // 389
  // The `splitUserIdsIntoAccountIdsAndIdentityIds()` migration only added `identityId` in cases                      //
  // where the user still existed in the database.                                                                    //
  ApiTokens.remove({ userId: { $exists: true }, identityId: { $exists: false } });                                    // 392
  ApiTokens.remove({ "owner.user.userId": { $exists: true },                                                          // 393
    "owner.user.identityId": { $exists: false } });                                                                   // 394
                                                                                                                      //
  // For a while we were accidentally setting `appIcon` instead of `icon`.                                            //
  ApiTokens.find({ "owner.user.denormalizedGrainMetadata.appIcon": { $exists: true } }).forEach(function (apiToken) {
    var icon = apiToken.owner.user.denormalizedGrainMetadata.appIcon;                                                 // 399
    ApiTokens.update({ _id: apiToken._id }, { $set: { "owner.user.denormalizedGrainMetadata.icon": icon },            // 400
      $unset: { "owner.user.denormalizedGrainMetadata.appIcon": true } });                                            // 402
  });                                                                                                                 //
                                                                                                                      //
  // For a while the `identityId` field of child UiView tokens was not getting set.                                   //
  function repairChain(parentToken) {                                                                                 // 389
    ApiTokens.find({ parentToken: parentToken._id, grainId: { $exists: true },                                        // 407
      identityId: { $exists: false } }).forEach(function (childToken) {                                               // 408
      ApiTokens.update({ _id: childToken._id }, { $set: { identityId: parentToken.identityId } });                    // 409
      repairChain(childToken);                                                                                        // 410
    });                                                                                                               //
  }                                                                                                                   //
                                                                                                                      //
  ApiTokens.find({ grainId: { $exists: true }, identityId: { $exists: true },                                         // 414
    parentToken: { $exists: false } }).forEach(repairChain);                                                          // 415
}                                                                                                                     //
                                                                                                                      //
function initServerTitleAndReturnAddress() {                                                                          // 418
  var hostname = Url.parse(process.env.ROOT_URL).hostname;                                                            // 419
  Settings.insert({ _id: "serverTitle", value: hostname });                                                           // 420
  Settings.insert({ _id: "returnAddress", value: "no-reply@" + hostname });                                           // 421
}                                                                                                                     //
                                                                                                                      //
function sendReferralNotifications() {                                                                                // 424
  if (Meteor.settings["public"].quotaEnabled) {                                                                       // 425
    Meteor.users.find({                                                                                               // 426
      loginIdentities: { $exists: true },                                                                             // 427
      expires: { $exists: false }                                                                                     // 428
    }, { fields: { _id: 1 } }).forEach(function (user) {                                                              //
      sendReferralProgramNotification(user._id);                                                                      // 430
    });                                                                                                               //
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function assignBonuses() {                                                                                            // 435
  if (Meteor.settings["public"].quotaEnabled && SandstormDb.bonusesMigrationHook) {                                   // 436
    SandstormDb.bonusesMigrationHook();                                                                               // 437
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function splitSmtpUrl() {                                                                                             // 441
  var smtpUrlSetting = Settings.findOne({ _id: "smtpUrl" });                                                          // 442
  var smtpUrl = smtpUrlSetting ? smtpUrlSetting.value : process.env.MAIL_URL;                                         // 443
  var returnAddress = Settings.findOne({ _id: "returnAddress" });                                                     // 444
                                                                                                                      //
  // Default values.                                                                                                  //
  var smtpConfig = {                                                                                                  // 441
    hostname: "localhost",                                                                                            // 448
    port: "25",                                                                                                       // 449
    auth: undefined,                                                                                                  // 450
    returnAddress: returnAddress.value                                                                                // 451
  };                                                                                                                  //
                                                                                                                      //
  var parsed = void 0;                                                                                                // 454
  try {                                                                                                               // 455
    parsed = smtpUrl && Url.parse(smtpUrl);                                                                           // 456
  } catch (e) {}                                                                                                      //
                                                                                                                      //
  if (parsed) {                                                                                                       // 459
    // If there was a SMTP URL previously defined, import its data.                                                   //
    var auth = undefined;                                                                                             // 461
    if (parsed.auth) {                                                                                                // 462
      var colonIndex = parsed.auth.indexOf(":");                                                                      // 463
      var user = undefined;                                                                                           // 464
      var pass = undefined;                                                                                           // 465
      if (colonIndex !== -1) {                                                                                        // 466
        user = parsed.auth.slice(0, colonIndex);                                                                      // 467
        pass = parsed.auth.slice(colonIndex + 1);                                                                     // 468
      }                                                                                                               //
                                                                                                                      //
      auth = {                                                                                                        // 471
        user: user,                                                                                                   // 472
        pass: pass                                                                                                    // 473
      };                                                                                                              //
    }                                                                                                                 //
                                                                                                                      //
    // Override defaults with previous config's values.                                                               //
    smtpConfig.hostname = parsed.hostname || "localhost";                                                             // 459
    smtpConfig.port = parsed.port || "25";                                                                            // 479
    smtpConfig.auth = auth;                                                                                           // 480
  }                                                                                                                   //
                                                                                                                      //
  Settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                                      // 483
  Settings.remove({ _id: "returnAddress" });                                                                          // 484
  Settings.remove({ _id: "smtpUrl" });                                                                                // 485
}                                                                                                                     //
                                                                                                                      //
function smtpPortShouldBeNumber() {                                                                                   // 488
  var entry = Settings.findOne({ _id: "smtpConfig" });                                                                // 489
  if (entry) {                                                                                                        // 490
    var setting = entry.value;                                                                                        // 491
    if (setting.port) {                                                                                               // 492
      setting.port = _.isNumber(setting.port) ? setting.port : parseInt(setting.port);                                // 493
      Settings.upsert({ _id: "smtpConfig" }, { value: setting });                                                     // 494
    }                                                                                                                 //
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
function consolidateOrgSettings() {                                                                                   // 499
  var orgGoogleDomain = Settings.findOne({ _id: "organizationGoogle" });                                              // 500
  var orgEmailDomain = Settings.findOne({ _id: "organizationEmail" });                                                // 501
  var orgLdap = Settings.findOne({ _id: "organizationLdap" });                                                        // 502
  var orgSaml = Settings.findOne({ _id: "organizationSaml" });                                                        // 503
                                                                                                                      //
  var orgMembership = {                                                                                               // 505
    google: {                                                                                                         // 506
      enabled: orgGoogleDomain ? !!orgGoogleDomain.value : false,                                                     // 507
      domain: orgGoogleDomain ? orgGoogleDomain.value : ""                                                            // 508
    },                                                                                                                //
    email: {                                                                                                          // 510
      enabled: orgEmailDomain ? !!orgEmailDomain.value : false,                                                       // 511
      domain: orgEmailDomain ? orgEmailDomain.value : ""                                                              // 512
    },                                                                                                                //
    ldap: {                                                                                                           // 514
      enabled: orgLdap ? orgLdap.value : false                                                                        // 515
    },                                                                                                                //
    saml: {                                                                                                           // 517
      enabled: orgSaml ? orgSaml.value : false                                                                        // 518
    }                                                                                                                 //
  };                                                                                                                  //
                                                                                                                      //
  Settings.upsert({ _id: "organizationMembership" }, { value: orgMembership });                                       // 522
  Settings.remove({ _id: "organizationGoogle" });                                                                     // 523
  Settings.remove({ _id: "organizationEmail" });                                                                      // 524
  Settings.remove({ _id: "organizationLdap" });                                                                       // 525
  Settings.remove({ _id: "organizationSaml" });                                                                       // 526
}                                                                                                                     //
                                                                                                                      //
function unsetSmtpDefaultHostnameIfNoUsersExist() {                                                                   // 529
  // We don't actually want to have the default hostname "localhost" set.                                             //
  // If the user has already finished configuring their server, then this migration should do                         //
  // nothing (since we might break their deployment), but for new installs (which will have no users                  //
  // at the time this migration runs) we'll unset the hostname if it's still the previously-filled                    //
  // default value.                                                                                                   //
  var hasUsers = Meteor.users.findOne();                                                                              // 535
  if (!hasUsers) {                                                                                                    // 536
    var entry = Settings.findOne({ _id: "smtpConfig" });                                                              // 537
    var smtpConfig = entry.value;                                                                                     // 538
    if (smtpConfig.hostname === "localhost") {                                                                        // 539
      smtpConfig.hostname = "";                                                                                       // 540
      Settings.upsert({ _id: "smtpConfig" }, { value: smtpConfig });                                                  // 541
    }                                                                                                                 //
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
// This must come after all the functions named within are defined.                                                   //
// Only append to this list!  Do not modify or remove list entries;                                                   //
// doing so is likely change the meaning and semantics of user databases.                                             //
var MIGRATIONS = [updateLoginStyleToRedirect, enableLegacyOAuthProvidersIfNotInSettings, denormalizeInviteInfo, mergeRoleAssignmentsIntoApiTokens, fixOasisStorageUsageStats, fetchProfilePictures, assignPlans, removeKeyrings, useLocalizedTextInUserActions, verifyAllPgpSignatures, splitUserIdsIntoAccountIdsAndIdentityIds, appUpdateSettings, moveDevAndEmailLoginDataIntoIdentities, repairEmailIdentityIds, splitAccountUsersAndIdentityUsers, populateContactsFromApiTokens, cleanUpApiTokens, initServerTitleAndReturnAddress, sendReferralNotifications, assignBonuses, splitSmtpUrl, smtpPortShouldBeNumber, consolidateOrgSettings, unsetSmtpDefaultHostnameIfNoUsersExist];
                                                                                                                      //
function migrateToLatest() {                                                                                          // 576
  if (Meteor.settings.replicaNumber) {                                                                                // 577
    (function () {                                                                                                    //
      // This is a replica. Wait for the first replica to perform migrations.                                         //
                                                                                                                      //
      console.log("Waiting for migrations on replica zero...");                                                       // 580
                                                                                                                      //
      var done = new Future();                                                                                        // 582
      var change = function change(doc) {                                                                             // 583
        console.log("Migrations applied elsewhere: " + doc.value + "/" + MIGRATIONS.length);                          // 584
        if (doc.value >= MIGRATIONS.length) done["return"]();                                                         // 585
      };                                                                                                              //
                                                                                                                      //
      var observer = Migrations.find({ _id: "migrations_applied" }).observe({                                         // 588
        added: change,                                                                                                // 589
        changed: change                                                                                               // 590
      });                                                                                                             //
                                                                                                                      //
      done.wait();                                                                                                    // 593
      observer.stop();                                                                                                // 594
      console.log("Migrations have completed on replica zero.");                                                      // 595
    })();                                                                                                             //
  } else {                                                                                                            //
    var applied = Migrations.findOne({ _id: "migrations_applied" });                                                  // 598
    var start = void 0;                                                                                               // 599
    if (!applied) {                                                                                                   // 600
      // Migrations table is not yet seeded with a value.  This means it has                                          //
      // applied 0 migrations.  Persist this.                                                                         //
      Migrations.insert({ _id: "migrations_applied", value: 0 });                                                     // 603
      start = 0;                                                                                                      // 604
    } else {                                                                                                          //
      start = applied.value;                                                                                          // 606
    }                                                                                                                 //
                                                                                                                      //
    console.log("Migrations already applied: " + start + "/" + MIGRATIONS.length);                                    // 609
                                                                                                                      //
    for (var i = start; i < MIGRATIONS.length; i++) {                                                                 // 611
      // Apply migration i, then record that migration i was successfully run.                                        //
      console.log("Applying migration " + (i + 1));                                                                   // 613
      MIGRATIONS[i]();                                                                                                // 614
      Migrations.update({ _id: "migrations_applied" }, { $set: { value: i + 1 } });                                   // 615
      console.log("Applied migration " + (i + 1));                                                                    // 616
    }                                                                                                                 //
  }                                                                                                                   //
}                                                                                                                     //
                                                                                                                      //
SandstormDb.prototype.migrateToLatest = migrateToLatest;                                                              // 621
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");
require("./node_modules/meteor/sandstorm-db/user.js");
require("./node_modules/meteor/sandstorm-db/migrations.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
